function _typeof(o) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
    return typeof o;
  } : function (o) {
    return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, _typeof(o);
}

function toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}

function toPropertyKey(t) {
  var i = toPrimitive(t, "string");
  return "symbol" == _typeof(i) ? i : String(i);
}

function _defineProperty(obj, key, value) {
  key = toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

var SET_SUGGESTIONS_SEARCH_VALUE = 'SET_SUGGESTIONS_SEARCH_VALUE';
var CLEAR_SUGGESTIONS_SEARCH_VALUE = 'CLEAR_SUGGESTIONS_SEARCH_VALUE';
var UPDATE_ANALYTICS_CONFIG = 'UPDATE_ANALYTICS_CONFIG';
var RECENT_SEARCHES_SUCCESS = 'RECENT_SEARCHES_SUCCESS';
var RECENT_SEARCHES_ERROR = 'RECENT_SEARCHES_ERROR';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

/**
 * Sets the suggestionsSearchValue in analytics
 * @param {String} value
 */
function setSuggestionsSearchValue(value) {
  return {
    type: SET_SUGGESTIONS_SEARCH_VALUE,
    value: value
  };
}

/**
 * Clears the suggestionsSearchValue in analytics
 * @param {String} value
 */
function clearSuggestionsSearchValue() {
  return {
    type: CLEAR_SUGGESTIONS_SEARCH_VALUE
  };
}

/**
 * Updates the analytics config object
 * @param {Object} analyticsConfig
 */
function updateAnalyticsConfig(analyticsConfig) {
  return {
    type: UPDATE_ANALYTICS_CONFIG,
    analyticsConfig: analyticsConfig
  };
}
function getRecentSearches() {
  var queryOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    size: 5,
    minChars: 3
  };
  return function (dispatch, getState) {
    var _getState = getState(),
      config = _getState.config,
      headers = _getState.headers,
      _getState$appbaseRef = _getState.appbaseRef,
      url = _getState$appbaseRef.url,
      protocol = _getState$appbaseRef.protocol,
      credentials = _getState$appbaseRef.credentials;
    var app = config.app,
      mongodb = config.mongodb;
    var esURL = "".concat(protocol, "://").concat(url);
    var parsedURL = (esURL || '').replace(/\/+$/, '');
    var requestOptions = {
      headers: _objectSpread(_objectSpread({}, headers), {}, {
        'Content-Type': 'application/json',
        Authorization: "Basic ".concat(btoa(credentials))
      })
    };
    var queryString = '';
    var addParam = function addParam(key, value) {
      if (queryString) {
        queryString += "&".concat(key, "=").concat(value);
      } else {
        queryString += "".concat(key, "=").concat(value);
      }
    };
    // Add user id in query param if defined
    if (config.analyticsConfig && config.analyticsConfig.userId) {
      addParam('user_id', config.analyticsConfig.userId);
    }
    if (queryOptions) {
      if (queryOptions.size) {
        addParam('size', String(queryOptions.size));
      }
      if (queryOptions.from) {
        addParam('from', queryOptions.from);
      }
      if (queryOptions.to) {
        addParam('to', queryOptions.to);
      }
      if (queryOptions.minChars) {
        addParam('min_chars', String(queryOptions.minChars));
      }
      if (queryOptions.customEvents) {
        Object.keys(queryOptions.customEvents).forEach(function (key) {
          addParam(key, queryOptions.customEvents[key]);
        });
      }
    }
    if (mongodb) {
      return dispatch({
        type: RECENT_SEARCHES_SUCCESS,
        data: []
      });
    }
    return fetch("".concat(parsedURL, "/_analytics/").concat(app, "/recent-searches?").concat(queryString), requestOptions).then(function (res) {
      if (res.status >= 500 || res.status >= 400) {
        return dispatch({
          type: RECENT_SEARCHES_ERROR,
          error: res
        });
      }
      return res.json().then(function (recentSearches) {
        return dispatch({
          type: RECENT_SEARCHES_SUCCESS,
          data: recentSearches
        });
      })["catch"](function (e) {
        return dispatch({
          type: RECENT_SEARCHES_ERROR,
          error: e
        });
      });
    })["catch"](function (e) {
      return dispatch({
        type: RECENT_SEARCHES_ERROR,
        error: e
      });
    });
  };
}
function recordClick(_ref) {
  var documentId = _ref.documentId,
    clickPosition = _ref.clickPosition,
    analyticsInstance = _ref.analyticsInstance,
    isSuggestionClick = _ref.isSuggestionClick;
  if (!documentId) {
    console.warn('ReactiveSearch: document id is required to record the click analytics');
  } else {
    analyticsInstance.click({
      queryID: analyticsInstance.getQueryID(),
      objects: _defineProperty({}, documentId, clickPosition + 1),
      isSuggestionClick: isSuggestionClick
    });
  }
}
function recordResultClick(searchPosition, documentId) {
  return function (dispatch, getState) {
    var _getState2 = getState(),
      config = _getState2.config,
      searchId = _getState2.analytics.searchId,
      headers = _getState2.headers,
      _getState2$appbaseRef = _getState2.appbaseRef,
      url = _getState2$appbaseRef.url,
      protocol = _getState2$appbaseRef.protocol,
      credentials = _getState2$appbaseRef.credentials,
      analyticsInstance = _getState2.analyticsRef;
    var app = config.app;
    var esURL = "".concat(protocol, "://").concat(url);
    if (config.analytics && searchId) {
      var parsedHeaders = headers;
      delete parsedHeaders['X-Search-Query'];
      var parsedURL = (esURL || '').replace(/\/+$/, '');
      if (parsedURL.includes('scalr.api.appbase.io')) {
        fetch("".concat(parsedURL, "/").concat(app, "/_analytics"), {
          method: 'POST',
          headers: _objectSpread(_objectSpread({}, parsedHeaders), {}, {
            'Content-Type': 'application/json',
            Authorization: "Basic ".concat(btoa(credentials)),
            'X-Search-Id': searchId,
            'X-Search-Click': true,
            'X-Search-ClickPosition': searchPosition + 1
          })
        });
      } else {
        recordClick({
          documentId: documentId,
          clickPosition: searchPosition,
          analyticsInstance: analyticsInstance
        });
      }
    }
  };
}
function recordSuggestionClick(searchPosition, documentId) {
  return function (dispatch, getState) {
    var _getState3 = getState(),
      config = _getState3.config,
      suggestionsSearchId = _getState3.analytics.suggestionsSearchId,
      headers = _getState3.headers,
      _getState3$appbaseRef = _getState3.appbaseRef,
      url = _getState3$appbaseRef.url,
      protocol = _getState3$appbaseRef.protocol,
      credentials = _getState3$appbaseRef.credentials,
      analyticsInstance = _getState3.analyticsRef;
    var app = config.app;
    var esURL = "".concat(protocol, "://").concat(url);
    if (config.analytics && (config.analyticsConfig === undefined || config.analyticsConfig.suggestionAnalytics === undefined || config.analyticsConfig.suggestionAnalytics)) {
      var parsedHeaders = headers;
      delete parsedHeaders['X-Search-Query'];
      var parsedURL = (esURL || '').replace(/\/+$/, '');
      if (parsedURL.includes('scalr.api.appbase.io') && searchPosition !== undefined && suggestionsSearchId) {
        fetch("".concat(parsedURL, "/").concat(app, "/_analytics"), {
          method: 'POST',
          headers: _objectSpread(_objectSpread({}, parsedHeaders), {}, {
            'Content-Type': 'application/json',
            Authorization: "Basic ".concat(btoa(credentials)),
            'X-Search-Id': suggestionsSearchId,
            'X-Search-Suggestions-Click': true,
            'X-Search-Suggestions-ClickPosition': searchPosition + 1
          })
        });
      } else if (searchPosition !== undefined) {
        recordClick({
          documentId: documentId,
          clickPosition: searchPosition,
          analyticsInstance: analyticsInstance,
          isSuggestionClick: true
        });
      }
    }
  };
}

// impressions represents an array of impression objects, for e.g {"index": "test", "id": 1213}
function recordImpressions(queryId) {
  var impressions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return function (dispatch, getState) {
    var _getState4 = getState(),
      _getState4$appbaseRef = _getState4.appbaseRef,
      url = _getState4$appbaseRef.url,
      protocol = _getState4$appbaseRef.protocol,
      analyticsInstance = _getState4.analyticsRef,
      config = _getState4.config;
    var esURL = "".concat(protocol, "://").concat(url);
    var parsedURL = esURL.replace(/\/+$/, '');
    if (config.analytics && !parsedURL.includes('scalr.api.appbase.io') && queryId && impressions.length) {
      analyticsInstance.search({
        queryID: analyticsInstance.getQueryID(),
        impressions: impressions
      });
    }
  };
}
function recordAISessionUsefulness(sessionId, otherInfo) {
  return function (dispatch, getState) {
    var _getState5 = getState(),
      analyticsInstance = _getState5.analyticsRef,
      config = _getState5.config;
    if (!config || !config.analyticsConfig || !config.analyticsConfig.recordAnalytics) {
      console.warn('ReactiveSearch: Unable to record usefulness of session. To enable analytics, make sure to include the following prop on your <ReactiveBase> component: reactivesearchAPIConfig={{ recordAnalytics: true }}');
      return;
    }
    var userID = config && config.analyticsConfig && config.analyticsConfig.userId;
    if (!sessionId) {
      console.warn('ReactiveSearch: AI sessionID is required to record the usefulness of session.');
      return;
    }
    // Save session usefulness
    analyticsInstance.saveSessionUsefulness(sessionId, _objectSpread(_objectSpread({}, otherInfo), {}, {
      userID: userID
    }), function (err, res) {
      // eslint-disable-next-line no-console

      res._bodyBlob.text().then(function (textData) {
        try {
          var parsedErrorRes = JSON.parse(textData);
          if (parsedErrorRes.error) {
            var errorCode = parsedErrorRes.error.code;
            var errorMessage = parsedErrorRes.error.message;
            var finalErrorMessage = 'There was an error recording the usefulness of the session. \n\n';
            if (errorCode) {
              finalErrorMessage += errorCode;
            }
            if (errorMessage) {
              finalErrorMessage += "".concat(errorCode ? ': ' : '').concat(errorMessage);
            }
            console.error(finalErrorMessage);
          }
        } catch (error) {
          console.error('There was an error recording the usefulness of the session. \n\n');
        }
      })["catch"](function (error) {
        console.error('Error reading  component error text data:', error);
      });
    });
  };
}

export { clearSuggestionsSearchValue, getRecentSearches, recordAISessionUsefulness, recordImpressions, recordResultClick, recordSuggestionClick, setSuggestionsSearchValue, updateAnalyticsConfig };
