var SET_APPBASE_QUERY = 'SET_APPBASE_QUERY';
var UPDATE_HITS = 'UPDATE_HITS';
var UPDATE_AGGS = 'UPDATE_AGGS';
var UPDATE_COMPOSITE_AGGS = 'UPDATE_COMPOSITE_AGGS';
var UPDATE_CONFIG = 'UPDATE_CONFIG';
var LOG_QUERY = 'LOG_QUERY';
var LOG_COMBINED_QUERY = 'LOG_COMBINED_QUERY';
var SET_INTERNAL_VALUE = 'SET_INTERNAL_VALUE';
var SET_LOADING = 'SET_LOADING';
var SET_ERROR = 'SET_ERROR';
var SET_TIMESTAMP = 'SET_TIMESTAMP';
var SET_MAP_DATA = 'SET_MAP_DATA';
var SET_MAP_RESULTS = 'SET_MAP_RESULTS';
var SET_SEARCH_ID = 'SET_SEARCH_ID';
var SET_PROMOTED_RESULTS = 'SET_PROMOTED_RESULTS';
var SET_CUSTOM_DATA = 'SET_CUSTOM_DATA';
var SET_APPLIED_SETTINGS = 'SET_APPLIED_SETTINGS';
var SET_SUGGESTIONS_SEARCH_ID = 'SET_SUGGESTIONS_SEARCH_ID';
var SET_RAW_DATA = 'SET_RAW_DATA';
var SET_POPULAR_SUGGESTIONS = 'SET_POPULAR_SUGGESTIONS';
var SET_DEFAULT_POPULAR_SUGGESTIONS = 'SET_DEFAULT_POPULAR_SUGGESTIONS';
var SET_AI_RESPONSE = 'SET_AI_RESPONSE';
var SET_AI_RESPONSE_DELAYED = 'SET_AI_RESPONSE_DELAYED';
var REMOVE_AI_RESPONSE = 'REMOVE_AI_RESPONSE';
var SET_AI_RESPONSE_ERROR = 'SET_AI_RESPONSE_ERROR';
var SET_AI_RESPONSE_LOADING = 'SET_AI_RESPONSE_LOADING';

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _typeof(o) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
    return typeof o;
  } : function (o) {
    return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, _typeof(o);
}

function toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}

function toPropertyKey(t) {
  var i = toPrimitive(t, "string");
  return "symbol" == _typeof(i) ? i : String(i);
}

function _defineProperty(obj, key, value) {
  key = toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

var componentTypes = {
  reactiveList: 'REACTIVELIST',
  // search components
  dataSearch: 'DATASEARCH',
  categorySearch: 'CATEGORYSEARCH',
  searchBox: 'SEARCHBOX',
  // list components
  singleList: 'SINGLELIST',
  multiList: 'MULTILIST',
  singleDataList: 'SINGLEDATALIST',
  tabDataList: 'TABDATALIST',
  singleDropdownList: 'SINGLEDROPDOWNLIST',
  multiDataList: 'MULTIDATALIST',
  multiDropdownList: 'MULTIDROPDOWNLIST',
  singleDropdownRange: 'SINGLEDROPDOWNRANGE',
  treeList: 'TREELIST',
  // basic components
  numberBox: 'NUMBERBOX',
  tagCloud: 'TAGCLOUD',
  toggleButton: 'TOGGLEBUTTON',
  reactiveComponent: 'REACTIVECOMPONENT',
  // range components
  datePicker: 'DATEPICKER',
  dateRange: 'DATERANGE',
  dynamicRangeSlider: 'DYNAMICRANGESLIDER',
  multiDropdownRange: 'MULTIDROPDOWNRANGE',
  singleRange: 'SINGLERANGE',
  multiRange: 'MULTIRANGE',
  rangeSlider: 'RANGESLIDER',
  ratingsFilter: 'RATINGSFILTER',
  rangeInput: 'RANGEINPUT',
  // map components
  geoDistanceDropdown: 'GEO_DISTANCE_DROPDOWN',
  geoDistanceSlider: 'GEO_DISTANCE_SLIDER',
  reactiveMap: 'REACTIVE_MAP',
  // chart components
  reactiveChart: 'REACTIVE_CHART',
  // ai component
  AIAnswer: 'AI_ANSWER'
};
var queryTypes = {
  search: 'search',
  term: 'term',
  range: 'range',
  geo: 'geo',
  suggestion: 'suggestion'
};
var AI_ROLES = {
  USER: 'user',
  SYSTEM: 'system',
  ASSISTANT: 'assistant'
};
var AI_LOCAL_CACHE_KEY = 'AISessions';

var dateFormats = {
  date: 'YYYY-MM-DD',
  basic_date: 'YYYYMMDD',
  basic_date_time: 'YYYYMMDD[T]HHmmss.SSSZ',
  basic_date_time_no_millis: 'YYYYMMDD[T]HHmmssZ',
  date_time_no_millis: 'YYYY-MM-DD[T]HH:mm:ssZ',
  basic_time: 'HHmmss.SSSZ',
  basic_time_no_millis: 'HHmmssZ',
  epoch_millis: 'epoch_millis',
  epoch_second: 'epoch_second'
};

var _componentTypeToDefau;
function ownKeys$3(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$3(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$3(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$3(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function isEqual(x, y) {
  if (x === y) return true;
  if (!(x instanceof Object) || !(y instanceof Object)) return false;
  if (x.constructor !== y.constructor) return false;

  /* eslint-disable */
  for (var p in x) {
    if (!x.hasOwnProperty(p)) continue;
    if (!y.hasOwnProperty(p)) return false;
    if (x[p] === y[p]) continue;
    if (_typeof(x[p]) !== 'object') return false;
    if (!isEqual(x[p], y[p])) return false;
  }
  for (var _p in y) {
    if (y.hasOwnProperty(_p) && !x.hasOwnProperty(_p)) return false;
  }
  /* eslint-enable */
  return true;
}
/* eslint-enable */

function compareQueries(x, y) {
  try {
    // de-reference objects then compare
    return isEqual(JSON.parse(JSON.stringify(x)), JSON.parse(JSON.stringify(y)));
  } catch (e) {
    return false;
  }
}
function getOperation(conjunction) {
  if (conjunction === 'and') {
    return 'must';
  }
  if (conjunction === 'or') {
    return 'should';
  }
  return 'must_not';
}
function createBoolQuery(operation, query) {
  var resultQuery = null;
  if (Array.isArray(query) && query.length || !Array.isArray(query) && query) {
    resultQuery = {
      bool: _defineProperty({}, operation, query)
    };
  }
  if (operation === 'should' && resultQuery) {
    resultQuery = {
      bool: _objectSpread$3(_objectSpread$3({}, resultQuery.bool), {}, {
        minimum_should_match: 1
      })
    };
  }
  return resultQuery;
}
function getQuery(react, queryList) {
  var query = [];
  Object.keys(react).forEach(function (conjunction) {
    if (Array.isArray(react[conjunction])) {
      var operation = getOperation(conjunction);
      var queryArr = react[conjunction].map(function (comp) {
        if (typeof comp !== 'string') {
          // in this case, we have { <conjunction>: <> } objects inside the array
          return getQuery(comp, queryList);
        } else if (comp in queryList) {
          if (queryList[comp] && Object.keys(queryList[comp]).length) {
            return queryList[comp];
          }
        }
        return null;
      }).filter(function (item) {
        return !!item;
      });
      var boolQuery = createBoolQuery(operation, queryArr);
      if (boolQuery && Object.keys(boolQuery).length) {
        query = [].concat(_toConsumableArray(query), [boolQuery]);
      }
    } else if (typeof react[conjunction] === 'string') {
      var _operation = getOperation(conjunction);
      var _boolQuery = createBoolQuery(_operation, queryList[react[conjunction]]);
      if (_boolQuery && Object.keys(_boolQuery).length) {
        query = [].concat(_toConsumableArray(query), [_boolQuery]);
      }
    } else if (_typeof(react[conjunction]) === 'object' && react[conjunction] !== null) {
      var _boolQuery2 = getQuery(react[conjunction], queryList);
      if (_boolQuery2 && Object.keys(_boolQuery2).length) {
        query = [].concat(_toConsumableArray(query), [_boolQuery2]);
      }
    }
  });
  if (Array.isArray(query) && query.length) {
    return {
      bool: {
        must: query
      }
    };
  }
  if (query && Object.keys(query).length) {
    return query;
  }
  return null;
}
function getExternalQueryOptions(react, options, component) {
  var queryOptions = {};
  Object.keys(react).forEach(function (conjunction) {
    if (Array.isArray(react[conjunction])) {
      react[conjunction].forEach(function (comp) {
        if (options[comp]) {
          queryOptions = _objectSpread$3(_objectSpread$3({}, queryOptions), options[comp]);
        }
      });
    } else if (typeof react[conjunction] === 'string') {
      if (options[react[conjunction]]) {
        queryOptions = _objectSpread$3(_objectSpread$3({}, queryOptions), options[react[conjunction]]);
      }
    } else if (_typeof(react[conjunction]) === 'object' && react[conjunction] !== null && !Array.isArray(react[conjunction])) {
      queryOptions = _objectSpread$3(_objectSpread$3({}, queryOptions), getExternalQueryOptions(react[conjunction], options));
    }
  });
  if (options[component]) {
    queryOptions = _objectSpread$3(_objectSpread$3({}, queryOptions), options[component]);
  }
  return queryOptions;
}
function buildQuery(component, dependencyTree, queryList, queryOptions) {
  var queryObj = null;
  var options = null;
  if (component in dependencyTree) {
    queryObj = getQuery(dependencyTree[component], queryList);
    options = getExternalQueryOptions(dependencyTree[component], queryOptions, component);
  }
  return {
    queryObj: queryObj,
    options: options
  };
}
function formatDate(date, props) {
  if (props.parseDate) {
    // We would be passing an instance of dayjs instead of xdate below. Users need to know.
    return props.parseDate(date, props);
  }
  switch (props.queryFormat) {
    case 'epoch_millis':
      return date.valueOf();
    case 'epoch_second':
      return Math.floor(date.valueOf() / 1000);
    default:
      {
        if (dateFormats[props.queryFormat]) {
          return date.format(dateFormats[props.queryFormat]);
        }
        return date.valueOf();
      }
  }
}
(_componentTypeToDefau = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleList, ''), componentTypes.multiList, []), componentTypes.singleDataList, ''), componentTypes.singleDropdownList, ''), componentTypes.multiDataList, []), componentTypes.multiDropdownList, []), componentTypes.tagCloud, ''), componentTypes.toggleButton, ''), componentTypes.singleDropdownRange, ''), componentTypes.multiDropdownRange, []), _defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleRange, ''), componentTypes.multiRange, []));

/* isValidDateRangeQueryFormat() checks if the queryFormat is one of the dateFormats
	accepted by the elasticsearch or not. */
function isValidDateRangeQueryFormat(queryFormat) {
  return Object.keys(dateFormats).includes(queryFormat);
}

// utils/localStorage.js

var setObjectInLocalStorage = function setObjectInLocalStorage(key, value) {
  if (typeof localStorage !== 'undefined') {
    if (!key || !value) {
      throw new Error('Key and value are required for setObject');
    }
    try {
      var serializedValue = JSON.stringify(value);
      localStorage.setItem(key, serializedValue);
    } catch (error) {
      console.error('Error saving object to localStorage:', error);
    }
  } else {
    console.warn('localstorage not available');
  }
};
var getObjectFromLocalStorage = function getObjectFromLocalStorage(key) {
  if (!key) {
    throw new Error('Key is required for getObject');
  }
  try {
    var serializedValue = localStorage.getItem(key);
    if (serializedValue === null) {
      return null;
    }
    return JSON.parse(serializedValue);
  } catch (error) {
    console.error('Error retrieving object from localStorage:', error);
    return null;
  }
};

// Just for debuggin
// Call this function inside the function for which
// a stack trace is needed
function getStackTrace() {
  var error = new Error();
  // eslint-disable-next-line no-console
  console.log(error.stack);
}

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var dayjs_min = {exports: {}};

(function (module, exports) {
  !function (t, e) {
    module.exports = e() ;
  }(commonjsGlobal, function () {

    var t = 1e3,
      e = 6e4,
      n = 36e5,
      r = "millisecond",
      i = "second",
      s = "minute",
      u = "hour",
      a = "day",
      o = "week",
      c = "month",
      f = "quarter",
      h = "year",
      d = "date",
      l = "Invalid Date",
      $ = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/,
      y = /\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g,
      M = {
        name: "en",
        weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),
        months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_"),
        ordinal: function ordinal(t) {
          var e = ["th", "st", "nd", "rd"],
            n = t % 100;
          return "[" + t + (e[(n - 20) % 10] || e[n] || e[0]) + "]";
        }
      },
      m = function m(t, e, n) {
        var r = String(t);
        return !r || r.length >= e ? t : "" + Array(e + 1 - r.length).join(n) + t;
      },
      v = {
        s: m,
        z: function z(t) {
          var e = -t.utcOffset(),
            n = Math.abs(e),
            r = Math.floor(n / 60),
            i = n % 60;
          return (e <= 0 ? "+" : "-") + m(r, 2, "0") + ":" + m(i, 2, "0");
        },
        m: function t(e, n) {
          if (e.date() < n.date()) return -t(n, e);
          var r = 12 * (n.year() - e.year()) + (n.month() - e.month()),
            i = e.clone().add(r, c),
            s = n - i < 0,
            u = e.clone().add(r + (s ? -1 : 1), c);
          return +(-(r + (n - i) / (s ? i - u : u - i)) || 0);
        },
        a: function a(t) {
          return t < 0 ? Math.ceil(t) || 0 : Math.floor(t);
        },
        p: function p(t) {
          return {
            M: c,
            y: h,
            w: o,
            d: a,
            D: d,
            h: u,
            m: s,
            s: i,
            ms: r,
            Q: f
          }[t] || String(t || "").toLowerCase().replace(/s$/, "");
        },
        u: function u(t) {
          return void 0 === t;
        }
      },
      g = "en",
      D = {};
    D[g] = M;
    var p = "$isDayjsObject",
      S = function S(t) {
        return t instanceof _ || !(!t || !t[p]);
      },
      w = function t(e, n, r) {
        var i;
        if (!e) return g;
        if ("string" == typeof e) {
          var s = e.toLowerCase();
          D[s] && (i = s), n && (D[s] = n, i = s);
          var u = e.split("-");
          if (!i && u.length > 1) return t(u[0]);
        } else {
          var a = e.name;
          D[a] = e, i = a;
        }
        return !r && i && (g = i), i || !r && g;
      },
      O = function O(t, e) {
        if (S(t)) return t.clone();
        var n = "object" == _typeof(e) ? e : {};
        return n.date = t, n.args = arguments, new _(n);
      },
      b = v;
    b.l = w, b.i = S, b.w = function (t, e) {
      return O(t, {
        locale: e.$L,
        utc: e.$u,
        x: e.$x,
        $offset: e.$offset
      });
    };
    var _ = function () {
        function M(t) {
          this.$L = w(t.locale, null, !0), this.parse(t), this.$x = this.$x || t.x || {}, this[p] = !0;
        }
        var m = M.prototype;
        return m.parse = function (t) {
          this.$d = function (t) {
            var e = t.date,
              n = t.utc;
            if (null === e) return new Date(NaN);
            if (b.u(e)) return new Date();
            if (e instanceof Date) return new Date(e);
            if ("string" == typeof e && !/Z$/i.test(e)) {
              var r = e.match($);
              if (r) {
                var i = r[2] - 1 || 0,
                  s = (r[7] || "0").substring(0, 3);
                return n ? new Date(Date.UTC(r[1], i, r[3] || 1, r[4] || 0, r[5] || 0, r[6] || 0, s)) : new Date(r[1], i, r[3] || 1, r[4] || 0, r[5] || 0, r[6] || 0, s);
              }
            }
            return new Date(e);
          }(t), this.init();
        }, m.init = function () {
          var t = this.$d;
          this.$y = t.getFullYear(), this.$M = t.getMonth(), this.$D = t.getDate(), this.$W = t.getDay(), this.$H = t.getHours(), this.$m = t.getMinutes(), this.$s = t.getSeconds(), this.$ms = t.getMilliseconds();
        }, m.$utils = function () {
          return b;
        }, m.isValid = function () {
          return !(this.$d.toString() === l);
        }, m.isSame = function (t, e) {
          var n = O(t);
          return this.startOf(e) <= n && n <= this.endOf(e);
        }, m.isAfter = function (t, e) {
          return O(t) < this.startOf(e);
        }, m.isBefore = function (t, e) {
          return this.endOf(e) < O(t);
        }, m.$g = function (t, e, n) {
          return b.u(t) ? this[e] : this.set(n, t);
        }, m.unix = function () {
          return Math.floor(this.valueOf() / 1e3);
        }, m.valueOf = function () {
          return this.$d.getTime();
        }, m.startOf = function (t, e) {
          var n = this,
            r = !!b.u(e) || e,
            f = b.p(t),
            l = function l(t, e) {
              var i = b.w(n.$u ? Date.UTC(n.$y, e, t) : new Date(n.$y, e, t), n);
              return r ? i : i.endOf(a);
            },
            $ = function $(t, e) {
              return b.w(n.toDate()[t].apply(n.toDate("s"), (r ? [0, 0, 0, 0] : [23, 59, 59, 999]).slice(e)), n);
            },
            y = this.$W,
            M = this.$M,
            m = this.$D,
            v = "set" + (this.$u ? "UTC" : "");
          switch (f) {
            case h:
              return r ? l(1, 0) : l(31, 11);
            case c:
              return r ? l(1, M) : l(0, M + 1);
            case o:
              var g = this.$locale().weekStart || 0,
                D = (y < g ? y + 7 : y) - g;
              return l(r ? m - D : m + (6 - D), M);
            case a:
            case d:
              return $(v + "Hours", 0);
            case u:
              return $(v + "Minutes", 1);
            case s:
              return $(v + "Seconds", 2);
            case i:
              return $(v + "Milliseconds", 3);
            default:
              return this.clone();
          }
        }, m.endOf = function (t) {
          return this.startOf(t, !1);
        }, m.$set = function (t, e) {
          var n,
            o = b.p(t),
            f = "set" + (this.$u ? "UTC" : ""),
            l = (n = {}, n[a] = f + "Date", n[d] = f + "Date", n[c] = f + "Month", n[h] = f + "FullYear", n[u] = f + "Hours", n[s] = f + "Minutes", n[i] = f + "Seconds", n[r] = f + "Milliseconds", n)[o],
            $ = o === a ? this.$D + (e - this.$W) : e;
          if (o === c || o === h) {
            var y = this.clone().set(d, 1);
            y.$d[l]($), y.init(), this.$d = y.set(d, Math.min(this.$D, y.daysInMonth())).$d;
          } else l && this.$d[l]($);
          return this.init(), this;
        }, m.set = function (t, e) {
          return this.clone().$set(t, e);
        }, m.get = function (t) {
          return this[b.p(t)]();
        }, m.add = function (r, f) {
          var d,
            l = this;
          r = Number(r);
          var $ = b.p(f),
            y = function y(t) {
              var e = O(l);
              return b.w(e.date(e.date() + Math.round(t * r)), l);
            };
          if ($ === c) return this.set(c, this.$M + r);
          if ($ === h) return this.set(h, this.$y + r);
          if ($ === a) return y(1);
          if ($ === o) return y(7);
          var M = (d = {}, d[s] = e, d[u] = n, d[i] = t, d)[$] || 1,
            m = this.$d.getTime() + r * M;
          return b.w(m, this);
        }, m.subtract = function (t, e) {
          return this.add(-1 * t, e);
        }, m.format = function (t) {
          var e = this,
            n = this.$locale();
          if (!this.isValid()) return n.invalidDate || l;
          var r = t || "YYYY-MM-DDTHH:mm:ssZ",
            i = b.z(this),
            s = this.$H,
            u = this.$m,
            a = this.$M,
            o = n.weekdays,
            c = n.months,
            f = n.meridiem,
            h = function h(t, n, i, s) {
              return t && (t[n] || t(e, r)) || i[n].slice(0, s);
            },
            d = function d(t) {
              return b.s(s % 12 || 12, t, "0");
            },
            $ = f || function (t, e, n) {
              var r = t < 12 ? "AM" : "PM";
              return n ? r.toLowerCase() : r;
            };
          return r.replace(y, function (t, r) {
            return r || function (t) {
              switch (t) {
                case "YY":
                  return String(e.$y).slice(-2);
                case "YYYY":
                  return b.s(e.$y, 4, "0");
                case "M":
                  return a + 1;
                case "MM":
                  return b.s(a + 1, 2, "0");
                case "MMM":
                  return h(n.monthsShort, a, c, 3);
                case "MMMM":
                  return h(c, a);
                case "D":
                  return e.$D;
                case "DD":
                  return b.s(e.$D, 2, "0");
                case "d":
                  return String(e.$W);
                case "dd":
                  return h(n.weekdaysMin, e.$W, o, 2);
                case "ddd":
                  return h(n.weekdaysShort, e.$W, o, 3);
                case "dddd":
                  return o[e.$W];
                case "H":
                  return String(s);
                case "HH":
                  return b.s(s, 2, "0");
                case "h":
                  return d(1);
                case "hh":
                  return d(2);
                case "a":
                  return $(s, u, !0);
                case "A":
                  return $(s, u, !1);
                case "m":
                  return String(u);
                case "mm":
                  return b.s(u, 2, "0");
                case "s":
                  return String(e.$s);
                case "ss":
                  return b.s(e.$s, 2, "0");
                case "SSS":
                  return b.s(e.$ms, 3, "0");
                case "Z":
                  return i;
              }
              return null;
            }(t) || i.replace(":", "");
          });
        }, m.utcOffset = function () {
          return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
        }, m.diff = function (r, d, l) {
          var $,
            y = this,
            M = b.p(d),
            m = O(r),
            v = (m.utcOffset() - this.utcOffset()) * e,
            g = this - m,
            D = function D() {
              return b.m(y, m);
            };
          switch (M) {
            case h:
              $ = D() / 12;
              break;
            case c:
              $ = D();
              break;
            case f:
              $ = D() / 3;
              break;
            case o:
              $ = (g - v) / 6048e5;
              break;
            case a:
              $ = (g - v) / 864e5;
              break;
            case u:
              $ = g / n;
              break;
            case s:
              $ = g / e;
              break;
            case i:
              $ = g / t;
              break;
            default:
              $ = g;
          }
          return l ? $ : b.a($);
        }, m.daysInMonth = function () {
          return this.endOf(c).$D;
        }, m.$locale = function () {
          return D[this.$L];
        }, m.locale = function (t, e) {
          if (!t) return this.$L;
          var n = this.clone(),
            r = w(t, e, !0);
          return r && (n.$L = r), n;
        }, m.clone = function () {
          return b.w(this.$d, this);
        }, m.toDate = function () {
          return new Date(this.valueOf());
        }, m.toJSON = function () {
          return this.isValid() ? this.toISOString() : null;
        }, m.toISOString = function () {
          return this.$d.toISOString();
        }, m.toString = function () {
          return this.$d.toUTCString();
        }, M;
      }(),
      k = _.prototype;
    return O.prototype = k, [["$ms", r], ["$s", i], ["$m", s], ["$H", u], ["$W", a], ["$M", c], ["$y", h], ["$D", d]].forEach(function (t) {
      k[t[1]] = function (e) {
        return this.$g(e, t[0], t[1]);
      };
    }), O.extend = function (t, e) {
      return t.$i || (t(e, _, O), t.$i = !0), O;
    }, O.locale = w, O.isDayjs = S, O.unix = function (t) {
      return O(1e3 * t);
    }, O.en = D[g], O.Ls = D, O.p = {}, O;
  });
})(dayjs_min);
var dayjs_minExports = dayjs_min.exports;
var dayjs = /*@__PURE__*/getDefaultExportFromCjs(dayjs_minExports);

var _componentToTypeMap;
function ownKeys$2(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$2(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$2(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$2(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var componentToTypeMap = (_componentToTypeMap = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.reactiveList, queryTypes.search), componentTypes.dataSearch, queryTypes.search), componentTypes.categorySearch, queryTypes.search), componentTypes.searchBox, queryTypes.suggestion), componentTypes.AIAnswer, queryTypes.search), componentTypes.singleList, queryTypes.term), componentTypes.multiList, queryTypes.term), componentTypes.singleDataList, queryTypes.term), componentTypes.singleDropdownList, queryTypes.term), componentTypes.multiDataList, queryTypes.term), _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.multiDropdownList, queryTypes.term), componentTypes.tagCloud, queryTypes.term), componentTypes.toggleButton, queryTypes.term), componentTypes.reactiveChart, queryTypes.term), componentTypes.treeList, queryTypes.term), componentTypes.numberBox, queryTypes.term), componentTypes.datePicker, queryTypes.range), componentTypes.dateRange, queryTypes.range), componentTypes.dynamicRangeSlider, queryTypes.range), componentTypes.singleDropdownRange, queryTypes.range), _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.multiDropdownRange, queryTypes.range), componentTypes.singleRange, queryTypes.range), componentTypes.multiRange, queryTypes.range), componentTypes.rangeSlider, queryTypes.range), componentTypes.ratingsFilter, queryTypes.range), componentTypes.rangeInput, queryTypes.range), componentTypes.geoDistanceDropdown, queryTypes.geo), componentTypes.geoDistanceSlider, queryTypes.geo), componentTypes.reactiveMap, queryTypes.geo));
var multiRangeComponents = [componentTypes.multiRange, componentTypes.multiDropdownRange];
var dateRangeComponents = [componentTypes.dateRange, componentTypes.datePicker];
var searchComponents = [componentTypes.categorySearch, componentTypes.dataSearch, componentTypes.searchBox];
var listComponentsWithPagination = [componentTypes.singleList, componentTypes.multiList, componentTypes.singleDropdownList, componentTypes.multiDropdownList];
var getNormalizedField = function getNormalizedField(field) {
  if (field && !Array.isArray(field)) {
    return [field];
  }
  return field;
};
var isInternalComponent = function isInternalComponent() {
  var componentID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return componentID.endsWith('__internal');
};
var getInternalComponentID = function getInternalComponentID() {
  var componentID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return "".concat(componentID, "__internal");
};
var getHistogramComponentID = function getHistogramComponentID() {
  var componentID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return "".concat(componentID, "__histogram__internal");
};
var isDRSRangeComponent = function isDRSRangeComponent() {
  var componentID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return componentID.endsWith('__range__internal');
};
var isSearchComponent = function isSearchComponent() {
  var componentType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return searchComponents.includes(componentType);
};
var isComponentUsesLabelAsValue = function isComponentUsesLabelAsValue() {
  var componentType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return componentType === componentTypes.multiDataList || componentType === componentTypes.singleDataList || componentType === componentTypes.tabDataList;
};
var hasPaginationSupport = function hasPaginationSupport() {
  var componentType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return listComponentsWithPagination.includes(componentType);
};
var getRSQuery = function getRSQuery(componentId, props) {
  var execute = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  if (props && componentId) {
    var queryType = props.type ? props.type : componentToTypeMap[props.componentType];
    // dataField is a required field for components other than search
    // TODO: Revisit this logic based on the Appbase version
    // dataField is no longer a required field in RS API
    if (props.componentType !== componentTypes.AIAnswer && !isSearchComponent(props.componentType) && !props.dataField && !props.vectorDataField) {
      return null;
    }
    var endpoint;
    var compoundClause = props.compoundClause;
    if (props.endpoint instanceof Object) {
      endpoint = props.endpoint;
    }
    var featuredSuggestionsProps = {
      enableFeaturedSuggestions: props.enableFeaturedSuggestions,
      featuredSuggestionsConfig: props.featuredSuggestionsConfig
    };
    var faqSuggestionsProps = {
      enableFAQSuggestions: props.enableFAQSuggestions,
      FAQSuggestionsConfig: props.FAQSuggestionsConfig
    };
    if (props.enableFAQSuggestions && !props.searchboxId) {
      faqSuggestionsProps = {};
      console.error('Reactivesearch Error: You should also pass a searchboxId when passing enableFAQSuggestions as true.\nRefer to Searchbox component documentation specific to frontend frameworks.\n\nReact(https://docs.reactivesearch.io/docs/reactivesearch/react/search/searchbox/)\n\nVue(https://docs.reactivesearch.io/docs/reactivesearch/vue/search/SearchBox/).');
    }
    if (props.enableFeaturedSuggestions && !props.searchboxId) {
      featuredSuggestionsProps = {};
      console.error('Reactivesearch Error: You should also pass a searchboxId when passing enableFeaturedSuggestions.\nRefer to Searchbox component documentation specific to frontend frameworks.\n\nReact(https://docs.reactivesearch.io/docs/reactivesearch/react/search/searchbox/)\n\nVue(https://docs.reactivesearch.io/docs/reactivesearch/vue/search/SearchBox/).');
    }
    if (compoundClause && !['filter', 'must'].includes(compoundClause)) {
      console.error("Reactivesearch Error: Invalid prop supplied - compoundClause. Prop can be one of ['filter', 'must']");
      compoundClause = undefined;
    }
    return _objectSpread$2(_objectSpread$2(_objectSpread$2({
      id: componentId,
      type: queryType || queryTypes.search,
      dataField: getNormalizedField(props.dataField),
      execute: execute,
      react: props.react,
      highlight: props.highlight,
      highlightField: getNormalizedField(props.highlightField),
      fuzziness: props.fuzziness,
      searchOperators: props.searchOperators,
      includeFields: props.includeFields,
      excludeFields: props.excludeFields,
      size: props.size,
      aggregationSize: props.aggregationSize,
      from: props.from || undefined,
      // Need to maintain for RL
      queryFormat: props.queryFormat,
      sortBy: props.sortBy,
      fieldWeights: getNormalizedField(props.fieldWeights),
      includeNullValues: props.includeNullValues,
      aggregationField: props.aggregationField || undefined,
      categoryField: props.categoryField || undefined,
      missingLabel: props.missingLabel || undefined,
      showMissing: props.showMissing,
      nestedField: props.nestedField || undefined,
      interval: props.interval,
      highlightConfig: props.customHighlight || props.highlightConfig,
      customQuery: props.customQuery,
      defaultQuery: props.defaultQuery,
      value: props.value,
      categoryValue: props.categoryValue || undefined,
      after: props.after || undefined,
      aggregations: props.aggregations || undefined,
      enableSynonyms: props.enableSynonyms,
      selectAllLabel: props.selectAllLabel,
      pagination: props.pagination,
      queryString: props.queryString,
      distinctField: props.distinctField,
      distinctFieldConfig: props.distinctFieldConfig,
      index: props.index,
      compoundClause: compoundClause
    }, queryType === queryTypes.suggestion ? _objectSpread$2(_objectSpread$2(_objectSpread$2({
      enablePopularSuggestions: props.enablePopularSuggestions,
      enableEndpointSuggestions: props.enableEndpointSuggestions,
      enableRecentSuggestions: props.enableRecentSuggestions,
      popularSuggestionsConfig: props.popularSuggestionsConfig,
      recentSuggestionsConfig: props.recentSuggestionsConfig,
      applyStopwords: props.applyStopwords,
      customStopwords: props.customStopwords,
      enablePredictiveSuggestions: props.enablePredictiveSuggestions,
      indexSuggestionsConfig: props.indexSuggestionsConfig,
      enableDocumentSuggestions: props.enableDocumentSuggestions,
      showDistinctSuggestions: props.showDistinctSuggestions,
      documentSuggestionsConfig: props.enableDocumentSuggestions ? props.documentSuggestionsConfig : undefined
    }, featuredSuggestionsProps), faqSuggestionsProps), {}, {
      enableIndexSuggestions: props.enableIndexSuggestions
    }, props.searchboxId ? {
      searchboxId: props.searchboxId
    } : {}) : {}), {}, {
      calendarInterval: props.calendarInterval,
      endpoint: endpoint,
      range: props.range
    }, queryType !== queryTypes.suggestion && props.enableAI && execute ? _objectSpread$2(_objectSpread$2({
      enableAI: true
    }, props.AIConfig ? {
      AIConfig: props.AIConfig
    } : {}), {}, {
      execute: true
    }) : {}), queryType !== queryTypes.suggestion ? {
      vectorDataField: props.vectorDataField || undefined,
      imageValue: props.imageValue || undefined,
      candidates: props.candidates || props.size || undefined
    } : {});
  }
  return null;
};
var extractPropsFromState = function extractPropsFromState(store, component, customOptions) {
  var componentProps = store.props[component];
  if (!componentProps) {
    return null;
  }
  var queryType = componentProps.type ? componentProps.type : componentToTypeMap[componentProps.componentType];
  var calcValues = store.selectedValues[component];
  var value = calcValues !== undefined && calcValues !== null ? calcValues.value : undefined;
  var queryFormat = componentProps.queryFormat;
  // calendarInterval only supported when using date types
  var calendarInterval;
  var interval = componentProps.interval;
  var type = queryType;
  var dataField = componentProps.dataField;
  var aggregations = componentProps.aggregations;
  var pagination; // pagination for `term` type of queries
  var from = componentProps.from; // offset for RL
  var range; // applicable for range components supporting histogram

  // For term queries i.e list component `dataField` will be treated as aggregationField
  if (queryType === queryTypes.term) {
    // Only apply pagination prop for the components which supports it otherwise it can break the UI
    if (componentProps.showLoadMore && hasPaginationSupport(componentProps.componentType)) {
      pagination = true;
    }
    // Extract values from components that are type of objects
    // This code handles the controlled behavior in list components for e.g ToggleButton
    if (value != null && _typeof(value) === 'object' && value.value) {
      value = value.value;
    } else if (Array.isArray(value)) {
      var parsedValue = [];
      value.forEach(function (val) {
        if (val != null && _typeof(val) === 'object' && val.value) {
          parsedValue.push(val.value);
        } else {
          parsedValue.push(val);
        }
      });
      value = parsedValue;
    }
  }
  if (queryType === queryTypes.range) {
    if (Array.isArray(value)) {
      if (multiRangeComponents.includes(componentProps.componentType)) {
        value = value.map(function (_ref) {
          var start = _ref.start,
            end = _ref.end;
          return {
            start: start,
            end: end
          };
        });
      } else {
        value = {
          start: value[0],
          end: value[1]
        };
      }
    } else if (componentProps.showHistogram) {
      var internalComponentID = getInternalComponentID(component);
      var internalComponentValue = store.internalValues[internalComponentID];
      if (!internalComponentValue) {
        // Handle dynamic range slider
        var histogramComponentID = getHistogramComponentID(component);
        internalComponentValue = store.internalValues[histogramComponentID];
      }
      if (internalComponentValue && Array.isArray(internalComponentValue.value)) {
        value = {
          start: internalComponentValue.value[0],
          end: internalComponentValue.value[1]
        };
      }
    }
    if (isDRSRangeComponent(component)) {
      aggregations = ['min', 'max'];
    } else if (componentProps.showHistogram) {
      aggregations = ['histogram'];
    }

    // handle number box, number box query changes based on the `queryFormat` value
    if (componentProps.componentType === componentTypes.dynamicRangeSlider || componentProps.componentType === componentTypes.rangeSlider) {
      calendarInterval = Object.keys(dateFormats).includes(queryFormat) ? componentProps.calendarInterval : undefined;

      // Set value
      if (value) {
        if (isValidDateRangeQueryFormat(componentProps.queryFormat)) {
          // check if date types are dealt with
          value = {
            start: formatDate(dayjs(new Date(value.start)), componentProps),
            end: formatDate(dayjs(new Date(value.end)), componentProps)
          };
        } else {
          value = {
            start: parseFloat(value.start),
            end: parseFloat(value.end)
          };
        }
      }
      var rangeValue;
      if (componentProps.componentType === componentTypes.dynamicRangeSlider) {
        rangeValue = store.aggregations["".concat(component, "__range__internal")];
        if (componentProps.nestedField) {
          rangeValue = rangeValue && store.aggregations["".concat(component, "__range__internal")][componentProps.nestedField].min ? {
            start: store.aggregations["".concat(component, "__range__internal")][componentProps.nestedField].min.value,
            end: store.aggregations["".concat(component, "__range__internal")][componentProps.nestedField].max.value
          } // prettier-ignore
          : null;
        } else {
          rangeValue = rangeValue && store.aggregations["".concat(component, "__range__internal")].min && store.aggregations["".concat(component, "__range__internal")].min.value ? {
            start: store.aggregations["".concat(component, "__range__internal")].min.value,
            end: store.aggregations["".concat(component, "__range__internal")].max.value
          } // prettier-ignore
          : null;
        }
      } else {
        rangeValue = componentProps.range;
      }
      if (rangeValue) {
        if (isValidDateRangeQueryFormat(componentProps.queryFormat)) {
          // check if date types are dealt with
          range = {
            start: formatDate(dayjs(rangeValue.start), componentProps),
            end: formatDate(dayjs(rangeValue.end), componentProps)
          };
        } else {
          range = {
            start: parseFloat(rangeValue.start),
            end: parseFloat(rangeValue.end)
          };
        }
      }
    }

    // handle date components
    if (dateRangeComponents.includes(componentProps.componentType)) {
      // Set value
      if (value) {
        if (isValidDateRangeQueryFormat(componentProps.queryFormat)) {
          if (typeof value === 'string') {
            value = {
              // value would be an ISO Date string
              start: formatDate(dayjs(value).subtract(24, 'hour'), componentProps),
              end: formatDate(dayjs(value), componentProps)
            };
          } else if (Array.isArray(value)) {
            value = value.map(function (val) {
              return {
                // value would be one of ISO Date string, number, native date
                start: formatDate(dayjs(val).subtract(24, 'hour'), componentProps),
                end: formatDate(dayjs(val), componentProps)
              };
            });
          } else {
            value = {
              start: formatDate(dayjs(value.start).subtract(24, 'hour'), componentProps),
              end: formatDate(dayjs(value.end), componentProps)
            };
          }
        }
      }
    }
  }
  if (queryType === queryTypes.geo) {
    // override the value extracted from selectedValues reducer
    value = undefined;
    var geoCalcValues = store.selectedValues[component] || store.internalValues[component] || store.internalValues[getInternalComponentID(component)];
    if (geoCalcValues && geoCalcValues.meta) {
      if (geoCalcValues.meta.distance && geoCalcValues.meta.coordinates) {
        value = {
          distance: geoCalcValues.meta.distance,
          location: geoCalcValues.meta.coordinates
        };
        if (componentProps.unit) {
          value.unit = componentProps.unit;
        }
      }
      if (geoCalcValues.meta.mapBoxBounds && geoCalcValues.meta.mapBoxBounds.top_left && geoCalcValues.meta.mapBoxBounds.bottom_right) {
        value = {
          // Note: format will be reverse of what we're using now
          geoBoundingBox: {
            topLeft: "".concat(geoCalcValues.meta.mapBoxBounds.top_left[1], ", ").concat(geoCalcValues.meta.mapBoxBounds.top_left[0]),
            bottomRight: "".concat(geoCalcValues.meta.mapBoxBounds.bottom_right[1], ", ").concat(geoCalcValues.meta.mapBoxBounds.bottom_right[0])
          }
        };
      }
    }
  }
  // handle number box, number box query changes based on the `queryFormat` value
  if (componentProps.componentType === componentTypes.numberBox) {
    if (queryFormat === 'exact') {
      type = 'term';
    } else {
      type = 'range';
      if (queryFormat === 'lte') {
        value = {
          end: value,
          boost: 2.0
        };
      } else {
        value = {
          start: value,
          boost: 2.0
        };
      }
    }
    // Remove query format
    queryFormat = 'or';
  }
  // Fake dataField for ReactiveComponent
  // TODO: Remove it after some time. The `dataField` is no longer required
  if (componentProps.componentType === componentTypes.reactiveComponent) {
    // Set the type to `term`
    type = 'term';
    dataField = 'reactive_component_field';
    // Don't set value property for ReactiveComponent
    // since it is driven by `defaultQuery` and `customQuery`
    value = undefined;
  }
  // Assign default value as an empty string for search components so search relevancy can work
  if (isSearchComponent(componentProps.componentType) && !value) {
    value = '';
  }

  // Handle components which uses label instead of value as the selected value
  if (isComponentUsesLabelAsValue(componentProps.componentType)) {
    var data = componentProps.data,
      selectAllLabel = componentProps.selectAllLabel;
    var absValue = [];
    if (value && Array.isArray(value)) {
      absValue = value;
    } else if (value && typeof value === 'string') {
      absValue = [value];
    }
    var normalizedValue = [];
    if (absValue.length) {
      if (data && Array.isArray(data)) {
        absValue.forEach(function (val) {
          var dataItem = data.find(function (o) {
            return o.label === val;
          });
          if (dataItem && dataItem.value) {
            normalizedValue.push(dataItem.value);
          }
        });
      }
    }
    if (selectAllLabel && absValue.length && absValue.includes(selectAllLabel)) {
      normalizedValue = absValue;
    }
    if (normalizedValue.length) {
      value = normalizedValue;
    } else {
      value = undefined;
    }
  }
  if (componentProps.componentType === componentTypes.reactiveList) {
    // We set selected page as the value in the redux store for RL.
    // It's complex to change this logic in the component so changed it here.
    if (value > 0) {
      from = (value - 1) * (componentProps.size || 10);
    }
    value = undefined;
  }
  var queryValue = value || undefined;
  if (componentProps.componentType === componentTypes.searchBox) {
    if (Array.isArray(queryValue)) {
      queryValue = undefined;
    }
  }
  var endpoint;
  if (componentProps.endpoint instanceof Object) {
    endpoint = _objectSpread$2(_objectSpread$2({}, endpoint || {}), componentProps.endpoint);
  }
  return _objectSpread$2(_objectSpread$2({}, componentProps), {}, {
    endpoint: endpoint,
    calendarInterval: calendarInterval,
    dataField: dataField,
    queryFormat: queryFormat,
    type: type,
    aggregations: aggregations,
    interval: interval,
    react: store.dependencyTree ? store.dependencyTree[component] : undefined,
    customQuery: store.customQueries ? store.customQueries[component] : undefined,
    defaultQuery: store.defaultQueries ? store.defaultQueries[component] : undefined,
    customHighlight: store.customHighlightOptions ? store.customHighlightOptions[component] : undefined,
    categoryValue: store.internalValues[component] ? store.internalValues[component].category : undefined,
    value: queryValue,
    pagination: pagination,
    from: from,
    range: range
  }, customOptions);
};
function flatReactProp(reactProp, componentID) {
  var flattenReact = [];
  var flatReact = function flatReact(react) {
    if (react && Object.keys(react)) {
      Object.keys(react).forEach(function (r) {
        if (react[r]) {
          if (typeof react[r] === 'string') {
            flattenReact = [].concat(_toConsumableArray(flattenReact), [react[r]]);
          } else if (Array.isArray(react[r])) {
            flattenReact = [].concat(_toConsumableArray(flattenReact), _toConsumableArray(react[r]));
          } else if (_typeof(react[r]) === 'object') {
            flatReact(react[r]);
          }
        }
      });
    }
  };
  flatReact(reactProp);
  // Remove cyclic dependencies
  flattenReact = flattenReact.filter(function (react) {
    return react !== componentID;
  });
  return flattenReact;
}
var getDependentQueries = function getDependentQueries(store, componentID) {
  var orderOfQueries = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var finalQuery = {};
  var react = flatReactProp(store.dependencyTree[componentID], componentID);
  react.forEach(function (componentObject) {
    var component = componentObject;
    var customQuery = store.customQueries[component];
    if (!isInternalComponent(component)) {
      var calcValues = store.selectedValues[component] || store.internalValues[component];
      var imageValue = calcValues && calcValues.meta && calcValues.meta.imageValue;
      // Only include queries for that component that has `customQuery` or `value` or
      // `imageValue` incase of searchbox defined
      if ((calcValues && (calcValues.value || imageValue) || customQuery) && !finalQuery[component]) {
        var execute = false;
        var componentProps = store.props[component];
        if (Array.isArray(orderOfQueries) && orderOfQueries.includes(component) && !(componentProps.componentType === componentTypes.searchBox
        /**
         * We want to fire a search query,
         * 	when enableAI
         * 	OR
         * 	when autosuggest is false
         */ && (componentProps.enableAI || componentProps.autosuggest === false))) {
          execute = true;
        }
        // build query
        var dependentQuery = getRSQuery(component, extractPropsFromState(store, component, _objectSpread$2({}, componentProps && _objectSpread$2(_objectSpread$2({}, componentProps.componentType === componentTypes.searchBox ? _objectSpread$2(_objectSpread$2(_objectSpread$2(_objectSpread$2({}, execute === false ? {
          type: queryTypes.search
        } : {}), calcValues.category ? {
          categoryValue: calcValues.category
        } : {
          categoryValue: undefined
        }), calcValues.value ? {
          value: calcValues.value
        } : {}), imageValue ? {
          imageValue: imageValue
        } : {}) : {}), componentProps.componentType === componentTypes.categorySearch ? _objectSpread$2({}, calcValues.category ? {
          categoryValue: calcValues.category
        } : {
          categoryValue: undefined
        }) : {}))), execute);
        if (dependentQuery) {
          finalQuery[component] = dependentQuery;
        }
      }
    }
  });
  return finalQuery;
};

var SET_QUERY_TO_HITS = 'SET_QUERY_TO_HITS';

function updateAggs(component, aggregations) {
  var append = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return {
    type: UPDATE_AGGS,
    component: component,
    aggregations: aggregations,
    append: append
  };
}
function updateCompositeAggs(component, aggregations) {
  var append = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return {
    type: UPDATE_COMPOSITE_AGGS,
    component: component,
    aggregations: aggregations,
    append: append
  };
}
function updateHits(component, hits, time, hidden) {
  var append = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  return {
    type: UPDATE_HITS,
    component: component,
    hits: hits.hits,
    // make compatible with es7
    total: _typeof(hits.total) === 'object' ? hits.total.value : hits.total,
    hidden: hidden,
    time: time,
    append: append
  };
}
function saveQueryToHits(component, query) {
  return {
    type: SET_QUERY_TO_HITS,
    component: component,
    query: query
  };
}

function setRawData(component, response) {
  return {
    type: SET_RAW_DATA,
    component: component,
    response: response
  };
}
function setLoading(component, isLoading) {
  return {
    type: SET_LOADING,
    component: component,
    isLoading: isLoading
  };
}
function setError(component, error) {
  return {
    type: SET_ERROR,
    component: component,
    error: error
  };
}
function setTimestamp(component, timestamp) {
  return {
    type: SET_TIMESTAMP,
    component: component,
    timestamp: timestamp
  };
}
function setSearchId() {
  var searchId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  return {
    type: SET_SEARCH_ID,
    searchId: searchId
  };
}
function setSuggestionsSearchId() {
  var searchId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  return {
    type: SET_SUGGESTIONS_SEARCH_ID,
    searchId: searchId
  };
}

// gatekeeping for normal queries
function logQuery(component, query) {
  return {
    type: LOG_QUERY,
    component: component,
    query: query
  };
}

// gatekeeping for queries combined with map queries
function logCombinedQuery(component, query) {
  return {
    type: LOG_COMBINED_QUERY,
    component: component,
    query: query
  };
}
function setPromotedResults() {
  var results = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_PROMOTED_RESULTS,
    results: results,
    component: component
  };
}
function setPopularSuggestions() {
  var suggestions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_POPULAR_SUGGESTIONS,
    suggestions: suggestions,
    component: component
  };
}
function setDefaultPopularSuggestions() {
  var suggestions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_DEFAULT_POPULAR_SUGGESTIONS,
    suggestions: suggestions,
    component: component
  };
}
function setCustomData() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_CUSTOM_DATA,
    data: data,
    component: component
  };
}
function setAppliedSettings() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_APPLIED_SETTINGS,
    data: data,
    component: component
  };
}
function setLastUsedAppbaseQuery(query) {
  return {
    type: SET_APPBASE_QUERY,
    query: query
  };
}
function setAIResponse(component, payload) {
  return {
    type: SET_AI_RESPONSE,
    component: component,
    payload: payload
  };
}
function setAIResponseDelayed(component, payload) {
  return {
    type: SET_AI_RESPONSE_DELAYED,
    component: component,
    payload: payload
  };
}
function removeAIResponse(component) {
  return {
    type: REMOVE_AI_RESPONSE,
    component: component
  };
}
function setAIResponseError(component, error) {
  var meta = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return {
    type: SET_AI_RESPONSE_ERROR,
    component: component,
    error: error,
    meta: meta
  };
}
function setAIResponseLoading(component, isLoading) {
  return {
    type: SET_AI_RESPONSE_LOADING,
    component: component,
    isLoading: isLoading
  };
}

function ownKeys$1(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$1(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$1(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$1(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var handleTransformResponse = function handleTransformResponse() {
  var res = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var component = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  if (config.transformResponse && typeof config.transformResponse === 'function') {
    return config.transformResponse(res, component);
  }
  return new Promise(function (resolve) {
    return resolve(res);
  });
};

// Checks if a component is active or not at a particular time
var isComponentActive = function isComponentActive() {
  var getState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
  var componentId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var _getState = getState(),
    components = _getState.components;
  if (components.includes(componentId)) {
    return true;
  }
  return false;
};
var getQuerySuggestionsId = function getQuerySuggestionsId() {
  var componentId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return "".concat(componentId, "__suggestions");
};
var handleError = function handleError() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    _ref$orderOfQueries = _ref.orderOfQueries,
    orderOfQueries = _ref$orderOfQueries === void 0 ? [] : _ref$orderOfQueries,
    _ref$error = _ref.error,
    error = _ref$error === void 0 ? null : _ref$error;
  var getState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
  var dispatch = arguments.length > 2 ? arguments[2] : undefined;
  var _getState2 = getState(),
    queryListener = _getState2.queryListener;
  try {
    console.error(JSON.stringify(error));
  } catch (e) {
    console.error(error);
  }
  orderOfQueries.forEach(function (component) {
    if (isComponentActive(getState, component)) {
      // Only update state for active components
      if (queryListener[component] && queryListener[component].onError) {
        queryListener[component].onError(error);
      }
      dispatch(setError(component, error));
      dispatch(setLoading(component, false));
    }
  });
};
var handleResponse = function handleResponse() {
  var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    res = _ref2.res,
    _ref2$orderOfQueries = _ref2.orderOfQueries,
    orderOfQueries = _ref2$orderOfQueries === void 0 ? [] : _ref2$orderOfQueries,
    _ref2$appendToHits = _ref2.appendToHits,
    appendToHits = _ref2$appendToHits === void 0 ? false : _ref2$appendToHits,
    _ref2$appendToAggs = _ref2.appendToAggs,
    appendToAggs = _ref2$appendToAggs === void 0 ? false : _ref2$appendToAggs,
    _ref2$isSuggestionsQu = _ref2.isSuggestionsQuery,
    isSuggestionsQuery = _ref2$isSuggestionsQu === void 0 ? false : _ref2$isSuggestionsQu,
    query = _ref2.query,
    queryId = _ref2.queryId;
  var getState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
  var dispatch = arguments.length > 2 ? arguments[2] : undefined;
  var _getState3 = getState(),
    config = _getState3.config,
    internalValues = _getState3.internalValues,
    lastUsedAppbaseQuery = _getState3.lastUsedAppbaseQuery,
    analyticsRef = _getState3.analyticsRef;
  var searchId = res._headers ? res._headers.get('X-Search-Id') : null;
  if (searchId) {
    if (isSuggestionsQuery) {
      // set suggestions search id for internal request of search components
      dispatch(setSuggestionsSearchId(searchId));
    } else {
      // if search id was updated set it in store
      dispatch(setSearchId(searchId));
      if (analyticsRef) {
        analyticsRef.queryID = searchId;
      }
    }
  }

  // handle promoted results
  orderOfQueries.forEach(function (component) {
    // Only update state for active components
    if (isComponentActive(getState, component)) {
      // Avoid settings stale results
      if (lastUsedAppbaseQuery[component] && lastUsedAppbaseQuery[component].queryId && queryId && lastUsedAppbaseQuery[component].queryId !== queryId) {
        return;
      }
      // Update applied settings
      if (res.settings) {
        dispatch(setAppliedSettings(res.settings, component));
      }
      handleTransformResponse(res[component], config, component).then(function (response) {
        if (response) {
          var _getState4 = getState(),
            timestamp = _getState4.timestamp,
            props = _getState4.props;
          if (timestamp[component] === undefined || timestamp[component] < res._timestamp || response.AISessionId && props[component].enableAI && props[component].componentType === componentTypes.searchBox) {
            var promotedResults = response.promoted;
            if (promotedResults) {
              var parsedPromotedResults = promotedResults.map(function (promoted) {
                return _objectSpread$1(_objectSpread$1({}, promoted.doc), {}, {
                  _position: promoted.position
                });
              });
              dispatch(setPromotedResults(parsedPromotedResults, component));
            } else {
              dispatch(setPromotedResults([], component));
            }
            // set raw response in rawData
            dispatch(setRawData(component, response));
            if (response.AIAnswer) {
              if (response.AIAnswer.error) {
                dispatch(setAIResponseError(component, {
                  message: response.AIAnswer.error
                }));
                dispatch(setLoading(component, false));
                return;
              }
              var input = response.AIAnswer;
              // store direct answer returned from API call
              var finalResponse = {
                answer: {
                  documentIds: input.documentIds,
                  model: input.model,
                  text: input.choices[0].message.content
                }
              };
              var finalResponseObj = {
                response: finalResponse,
                meta: response.hits,
                isTyping: false
              };
              if (response.AISessionId) {
                finalResponseObj.sessionId = response.AISessionId;
              }
              dispatch(setAIResponse(component, finalResponseObj));
            } else if (response.AISessionId) {
              var localCache = (getObjectFromLocalStorage(AI_LOCAL_CACHE_KEY) || {})[props.componentId];
              if (localCache && localCache.sessionId && localCache.sessionId === response.AISessionId) {
                // hydrate the store from cache
                dispatch(setAIResponse(component, localCache));
              } else {
                // delete localCache
                setObjectInLocalStorage('AISessions', _defineProperty({}, component, {}));

                // rely on trigger from within the component
                // to fetch initial result for AIAnswer component
                if (props[component].componentType === componentTypes.AIAnswer) {
                  dispatch(setAIResponse(component, {
                    sessionId: response.AISessionId,
                    meta: {
                      hits: response.hits || {}
                    }
                  }));
                } else {
                  // fetch initial AIResponse
                  dispatch(fetchAIResponse(response.AISessionId, component, '', {
                    hits: response.hits || {}
                  }, props[component].componentType === componentTypes.searchBox || props[component].componentType === componentTypes.AIAnswer // make extra GET call to fetch meta info
                  ));
                }
              }
            }

            // Update custom data
            dispatch(setCustomData(response.customData, component));
            if (response.hits && !((response.AIAnswer || response.AISessionId) && props[component].componentType === componentTypes.searchBox)) {
              dispatch(setTimestamp(component, res._timestamp));
              // store last used query for REACTIVE_LIST only

              if (props[component].componentType === componentTypes.reactiveList && query.find(function (queryItem) {
                return queryItem.id === component;
              }).execute) {
                dispatch(setLastUsedAppbaseQuery(_defineProperty({}, component, query)));
              }
              dispatch(updateHits(component, response.hits, response.took, response.hits && response.hits.hidden, appendToHits));
              // get query value
              var internalComponentID = getInternalComponentID(component);
              // Store the last query value associated with `hits`
              if (internalValues[internalComponentID]) {
                dispatch(saveQueryToHits(component, internalValues[internalComponentID].value));
              }
            }
            if (response.aggregations) {
              dispatch(updateAggs(component, response.aggregations, appendToAggs));
              dispatch(updateCompositeAggs(component, response.aggregations, appendToAggs));
            }
          }
          dispatch(setLoading(component, false));
        }
      })["catch"](function (err) {
        handleError({
          orderOfQueries: orderOfQueries,
          error: err
        }, getState, dispatch);
      });
    }
    // }
  });
};
var isPropertyDefined = function isPropertyDefined(property) {
  return property !== undefined && property !== null;
};
var getSuggestionQuery = function getSuggestionQuery() {
  var getState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
  var componentId = arguments.length > 1 ? arguments[1] : undefined;
  var _getState5 = getState(),
    internalValues = _getState5.internalValues;
  var internalValue = internalValues[componentId];
  var value = internalValue && internalValue.value || '';
  return [{
    id: getQuerySuggestionsId(componentId),
    dataField: ['key', 'key.autosuggest'],
    size: 5,
    value: value,
    defaultQuery: {
      query: {
        bool: {
          minimum_should_match: 1,
          should: [{
            function_score: {
              field_value_factor: {
                field: 'count',
                modifier: 'sqrt',
                missing: 1
              }
            }
          }, {
            multi_match: {
              fields: ['key^9', 'key.autosuggest^1', 'key.keyword^10'],
              fuzziness: 0,
              operator: 'or',
              query: value,
              type: 'best_fields'
            }
          }, {
            multi_match: {
              fields: ['key^9', 'key.autosuggest^1', 'key.keyword^10'],
              operator: 'or',
              query: value,
              type: 'phrase'
            }
          }, {
            multi_match: {
              fields: ['key^9'],
              operator: 'or',
              query: value,
              type: 'phrase_prefix'
            }
          }]
        }
      }
    }
  }];
};
function executeQueryListener(listener, oldQuery, newQuery) {
  if (listener && listener.onQueryChange) {
    listener.onQueryChange(oldQuery, newQuery);
  }
}
function updateStoreConfig(payload) {
  return function (dispatch) {
    dispatch({
      type: UPDATE_CONFIG,
      config: payload
    });
  };
}

function setInternalValue(component, value, componentType, category, meta) {
  return {
    type: SET_INTERNAL_VALUE,
    component: component,
    value: value,
    componentType: componentType,
    category: category,
    meta: meta
  };
}

var _excluded = ["value"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function loadPopularSuggestions(componentId) {
  return function (dispatch, getState) {
    var _getState = getState(),
      config = _getState.config,
      appbaseRef = _getState.appbaseRef,
      props = _getState.props,
      internalValues = _getState.internalValues;
    var componentProps = props[componentId] || {};
    var internalValue = internalValues[componentId];
    var value = internalValue && internalValue.value || '';
    if (componentProps.enablePopularSuggestions) {
      if (config.mongodb) {
        dispatch(setDefaultPopularSuggestions([], componentId.split('__internal')[0]));
        return;
      }
      var suggQuery = getSuggestionQuery(getState, componentId);
      appbaseRef.getQuerySuggestions(suggQuery).then(function (suggestions) {
        var querySuggestion = suggestions[getQuerySuggestionsId(componentId)];
        if (value) {
          // update query suggestions for search components
          dispatch(setPopularSuggestions(querySuggestion && querySuggestion.hits && querySuggestion.hits.hits, componentId.split('__internal')[0]));
        } else {
          dispatch(setDefaultPopularSuggestions(querySuggestion && querySuggestion.hits && querySuggestion.hits.hits, componentId.split('__internal')[0]));
          // dispatch default popular suggestions
        }
      })["catch"](function (e) {
        handleError({
          orderOfQueries: [componentId],
          error: e
        }, getState, dispatch);
      });
    }
  };
}
function appbaseSearch() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    queryId = _ref.queryId,
    query = _ref.query,
    orderOfQueries = _ref.orderOfQueries,
    _ref$appendToHits = _ref.appendToHits,
    appendToHits = _ref$appendToHits === void 0 ? false : _ref$appendToHits,
    _ref$isSuggestionsQue = _ref.isSuggestionsQuery,
    isSuggestionsQuery = _ref$isSuggestionsQue === void 0 ? false : _ref$isSuggestionsQue,
    searchComponentID = _ref.searchComponentID,
    _ref$appendToAggs = _ref.appendToAggs,
    appendToAggs = _ref$appendToAggs === void 0 ? false : _ref$appendToAggs;
  return function (dispatch, getState) {
    var _getState2 = getState(),
      appbaseRef = _getState2.appbaseRef,
      config = _getState2.config,
      headers = _getState2.headers,
      props = _getState2.props;
    var isAnalyticsEnabled = false;
    if (config) {
      if (isPropertyDefined(config.analytics)) {
        isAnalyticsEnabled = config.analytics;
      } else if (config.analyticsConfig) {
        if (isPropertyDefined(config.analyticsConfig.recordAnalytics)) {
          isAnalyticsEnabled = config.analyticsConfig.recordAnalytics;
        } else if (isPropertyDefined(config.analyticsConfig.analytics)) {
          isAnalyticsEnabled = config.analyticsConfig.analytics;
        }
      }
    }
    var settings = {
      recordAnalytics: isAnalyticsEnabled
    };
    if (config.analyticsConfig) {
      settings.userId = isPropertyDefined(config.analyticsConfig.userId) ? config.analyticsConfig.userId : undefined;
      settings.enableQueryRules = isPropertyDefined(config.analyticsConfig.enableQueryRules) ? config.analyticsConfig.enableQueryRules : undefined;
      settings.customEvents = isPropertyDefined(config.analyticsConfig.customEvents) ? config.analyticsConfig.customEvents : undefined;
      settings.emptyQuery = isPropertyDefined(config.analyticsConfig.emptyQuery) ? config.analyticsConfig.emptyQuery : undefined;
      var searchRelevancy = config.analyticsConfig.enableSearchRelevancy;
      settings.enableSearchRelevancy = isPropertyDefined(searchRelevancy) ? searchRelevancy : undefined;
      settings.suggestionAnalytics = isPropertyDefined(config.analyticsConfig.suggestionAnalytics) ? config.analyticsConfig.suggestionAnalytics : undefined;
      settings.useCache = isPropertyDefined(config.analyticsConfig.useCache) ? config.analyticsConfig.useCache : undefined;
      settings.queryParams = isPropertyDefined(config.analyticsConfig.queryParams) ? config.analyticsConfig.queryParams : undefined;
    }

    // set loading as active for the given component
    orderOfQueries.forEach(function (component) {
      dispatch(setLoading(component, true));
      if (props[component] && props[component].enableAI) {
        dispatch(removeAIResponse(component));
      }
      // reset error
      dispatch(setError(component, null));
    });
    appbaseRef.setHeaders(_objectSpread({}, headers));
    if (isSuggestionsQuery && searchComponentID) {
      dispatch(loadPopularSuggestions(searchComponentID));
    }
    appbaseRef.reactiveSearch(query, settings, settings.queryParams).then(function (res) {
      handleResponse({
        res: res,
        orderOfQueries: orderOfQueries,
        appendToHits: appendToHits,
        appendToAggs: appendToAggs,
        query: query,
        queryId: queryId
      }, getState, dispatch);
    })["catch"](function (err) {
      handleError({
        orderOfQueries: orderOfQueries,
        error: err,
        queryId: queryId
      }, getState, dispatch);
    });
  };
}

// latest request would be at the end
var requestStack = [];
function executeQuery(componentId) {
  var executeWatchList = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  var mustExecuteMapQuery = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var componentType = arguments.length > 3 ? arguments[3] : undefined;
  var metaOptions = arguments.length > 4 ? arguments[4] : undefined;
  var
  // A unique identifier for map query to recognize
  // the results for latest requests
  requestId = arguments.length > 5 ? arguments[5] : undefined;
  return function (dispatch, getState) {
    var _getState3 = getState(),
      queryLog = _getState3.queryLog,
      config = _getState3.config,
      mapData = _getState3.mapData,
      watchMan = _getState3.watchMan,
      queryListener = _getState3.queryListener,
      props = _getState3.props,
      internalValues = _getState3.internalValues,
      lock = _getState3.lock,
      dependencyTree = _getState3.dependencyTree,
      queryList = _getState3.queryList,
      queryOptions = _getState3.queryOptions;
    var lockTime = config.initialQueriesSyncTime || 100;
    var initialTimestamp = config.initialTimestamp;
    var queryId = requestId || new Date().getTime();

    // override logic for locking queries for a period of time
    // The block only runs when setSearchState method of StateProvider sets the
    // queryLockConfig property in then store
    if (config.queryLockConfig instanceof Object) {
      lockTime = config.queryLockConfig.lockTime;
      initialTimestamp = config.queryLockConfig.initialTimestamp;
    }
    var componentList = [componentId];
    var finalQuery = [];
    var appbaseQuery = {}; // Use object to prevent duplicate query added by react prop
    var orderOfQueries = [];
    if (executeWatchList) {
      var watchList = watchMan[componentId] || [];
      componentList = [].concat(_toConsumableArray(componentList), _toConsumableArray(watchList));
    }

    // console.log('EXECUTE QUERY FOR COMPONENT', componentId);

    componentList.forEach(function (component) {
      // Just to wait for the `react` dependencies
      var _buildQuery = buildQuery(component, dependencyTree, queryList, queryOptions),
        queryObj = _buildQuery.queryObj,
        options = _buildQuery.options;
      if (!queryObj && !options) {
        return;
      }
      // use internal value for suggestions query
      var value;
      var isInternalComponent = componentId.endsWith('__internal');
      var mainComponentProps = props[componentId];
      if (isInternalComponent && mainComponentProps && isSearchComponent(mainComponentProps.componentType)) {
        value = internalValues[componentId] && internalValues[componentId].value;
      }
      // build query
      var query = getRSQuery(component, extractPropsFromState(getState(), component, _objectSpread(_objectSpread({}, value ? {
        value: value
      } : null), metaOptions ? _objectSpread({
        from: metaOptions.from
      }, value && metaOptions.enableAI === true ? _objectSpread(_objectSpread({}, metaOptions), {}, {
        enableAI: true,
        type: 'search'
      }) : {}) : null)));
      // check if query or options are non-empty
      if (query && !!Object.keys(query).length) {
        var currentQuery = query;
        var oldQuery = queryLog[component];
        var componentProps = props[component];
        var dependentQueries = getDependentQueries(getState(), component, orderOfQueries);
        var queryToLog = _objectSpread(_objectSpread({}, _defineProperty({}, component, currentQuery)), Object.keys(dependentQueries).reduce(function (acc, q) {
          return _objectSpread(_objectSpread({}, acc), {}, _defineProperty({}, q, _objectSpread(_objectSpread({}, dependentQueries[q]), {}, {
            execute: false
          }, dependentQueries[q].type === queryTypes.suggestion ? {
            type: 'search'
          } : {})));
        }, {}));
        var queryType = componentToTypeMap[componentProps && componentProps.componentType];
        if ([queryTypes.range, queryTypes.term].includes(queryType)) {
          // Avoid logging `value` for term type of components
          // eslint-disable-next-line
          currentQuery.value;
            var rest = _objectWithoutProperties(currentQuery, _excluded);
          queryToLog = _objectSpread(_objectSpread({}, _defineProperty({}, component, rest)), Object.keys(dependentQueries).reduce(function (acc, q) {
            return _objectSpread(_objectSpread({}, acc), {}, _defineProperty({}, q, _objectSpread(_objectSpread(_objectSpread({}, dependentQueries[q]), {
              execute: false
            }), dependentQueries[q].type === queryTypes.suggestion ? {
              type: 'search'
            } : {})));
          }, {}));
        }
        if (mustExecuteMapQuery || !compareQueries(queryToLog, oldQuery)) {
          orderOfQueries = [].concat(_toConsumableArray(orderOfQueries), [component]);
          var isMapComponent = Object.keys(mapData).includes(component);
          if (isMapComponent) {
            dispatch(setLastUsedAppbaseQuery(_defineProperty({}, component, {
              queryId: queryId
            })));
          }

          // log query before adding the map query,
          // since we don't do gatekeeping on the map query in the `queryLog`
          dispatch(logQuery(component, queryToLog));
          if (isMapComponent && mapData[component].query) {
            // attach mapQuery to exisiting query via "must" type
            var existingQuery = currentQuery.query;
            // TODO: Check
            currentQuery.query = {
              bool: {
                must: [existingQuery, mapData[component].query]
              }
            };
            if (!mapData[component].persistMapQuery) {
              // clear mapQuery if we don't want it to persist
              dispatch(updateMapData(componentId, null, false));
            }

            // skip the query execution if the combined query [component + map Query]
            // matches the logged combined query
            var _getState4 = getState(),
              combinedLog = _getState4.combinedLog;
            if (compareQueries(combinedLog[component], currentQuery)) {
              return;
            }

            // log query after adding the map query,
            // to separately support gatekeeping for combined map queries
            dispatch(logCombinedQuery(component, currentQuery));
          }
          executeQueryListener(queryListener[component], oldQuery, currentQuery);
          if (query) {
            // Apply dependent queries
            appbaseQuery = _objectSpread(_objectSpread(_objectSpread({}, appbaseQuery), _defineProperty({}, component, query)), getDependentQueries(getState(), component, orderOfQueries));
          }
          if (isMapComponent) {
            var internalComponent = getInternalComponentID(component);
            var internalQuery = getRSQuery(internalComponent, extractPropsFromState(getState(), internalComponent, metaOptions ? {
              from: metaOptions.from
            } : null));
            if (internalQuery) {
              appbaseQuery[internalComponent] = _objectSpread(_objectSpread({}, internalQuery), {}, {
                execute: false
              });
            }
          }
        }
      }
    });
    finalQuery = Object.keys(appbaseQuery).map(function (component) {
      return appbaseQuery[component];
    });
    if (finalQuery.length) {
      var suggestionsComponents = [componentTypes.dataSearch, componentTypes.categorySearch];
      var isInternalComponent = componentId.endsWith('__internal');
      var isSuggestionsQuery = isInternalComponent && suggestionsComponents.indexOf(componentType) !== -1;
      var currentTime = new Date().getTime();
      if (currentTime - initialTimestamp < lockTime) {
        // set timeout if lock is not false
        if (!lock || config.queryLockConfig) {
          setTimeout(function () {
            var finalOrderOfQueries = [];
            var finalIsSuggestionsQuery = false;
            var finalSearchComponentID = '';
            var orderOfQueriesMap = {};
            var processedQueriesMap = {};
            var queryExecutionMap = {};

            // construct the request body with latest requests
            // dispatch the `appbaseSearch` action with a single request
            requestStack.forEach(function (request) {
              if (!finalIsSuggestionsQuery) {
                finalIsSuggestionsQuery = request.isSuggestionsQuery;
              }
              if (!finalSearchComponentID) {
                finalSearchComponentID = request.searchComponentID;
              }
              if (Array.isArray(request.query)) {
                request.query.forEach(function (query) {
                  if (query.execute) {
                    queryExecutionMap[query.id] = query.execute;
                  }
                  var newQuery = query;
                  // override by the latest query
                  // set the query execution to true if map has value
                  if (queryExecutionMap[query.id]) {
                    newQuery.execute = true;
                  }
                  if (processedQueriesMap[query.id] && processedQueriesMap[query.id].type === queryTypes.suggestion && newQuery.type !== queryTypes.suggestion) {
                    processedQueriesMap["".concat(query.id, "__suggestion_type")] = _objectSpread({}, processedQueriesMap[query.id]);
                    processedQueriesMap[query.id] = _objectSpread(_objectSpread({}, newQuery), {}, {
                      execute: false
                    });
                    return;
                  }
                  processedQueriesMap[query.id] = newQuery;
                });
              }
              if (Array.isArray(request.orderOfQueries)) {
                request.orderOfQueries.forEach(function (query) {
                  if (!orderOfQueriesMap[query.id]) {
                    finalOrderOfQueries = [query].concat(_toConsumableArray(finalOrderOfQueries));
                  } else {
                    orderOfQueriesMap[query.id] = true;
                  }
                });
              }
            });
            var finalCombinedQuery = Object.values(processedQueriesMap);
            if (finalCombinedQuery.length) {
              dispatch(appbaseSearch({
                query: finalCombinedQuery,
                orderOfQueries: finalOrderOfQueries,
                isSuggestionsQuery: finalIsSuggestionsQuery,
                searchComponentID: finalSearchComponentID
              }));
            }
            // empty the request stack
            requestStack = [];
            dispatch(updateStoreConfig({
              queryLockConfig: undefined
            }));
          }, lockTime);
        }
        dispatch(updateStoreConfig({
          lock: true
        }));
        requestStack.push({
          query: finalQuery,
          orderOfQueries: orderOfQueries,
          isSuggestionsQuery: isSuggestionsQuery,
          searchComponentID: componentId
        });
      } else {
        dispatch(appbaseSearch({
          queryId: queryId,
          query: finalQuery,
          orderOfQueries: orderOfQueries,
          isSuggestionsQuery: isSuggestionsQuery,
          searchComponentID: componentId
        }));
      }
    }
  };
}
function processJSONResponse(dispatch, componentId, AIAnswerKey, localCache, parsedRes) {
  var meta = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
  try {
    var finalResponse = _objectSpread({}, parsedRes);
    if (finalResponse.answer) {
      finalResponse.answer.role = AI_ROLES.ASSISTANT;
    }
    dispatch(setAIResponse(componentId, {
      meta: meta,
      sessionId: AIAnswerKey,
      messages: [].concat(_toConsumableArray(localCache && localCache.messages || []), _toConsumableArray(finalResponse.question ? [{
        content: finalResponse.question,
        role: AI_ROLES.USER
      }] : []), _toConsumableArray(finalResponse.answer ? [{
        content: finalResponse.answer.text,
        role: AI_ROLES.ASSISTANT
      }] : [])),
      response: _objectSpread({}, finalResponse)
    }));
  } catch (e) {
    getStackTrace();
    dispatch(setAIResponseError(componentId, e, {
      sessionId: AIAnswerKey
    }));
  }
}
function processStream(res, dispatch, componentId, AIAnswerKey) {
  var meta = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
  var question = arguments.length > 5 ? arguments[5] : undefined;
  var metaInfoPromise = arguments.length > 6 ? arguments[6] : undefined;
  var reader = res.body.getReader();
  var decoder = new TextDecoder();
  var responseText = '';
  var answerIndex;
  var questionMessage = question ? {
    content: question,
    role: AI_ROLES.USER
  } : null;
  var updateMessage = function updateMessage(content) {
    responseText += content;
    var localCache = (getObjectFromLocalStorage(AI_LOCAL_CACHE_KEY) || {})[componentId];
    var messages = _toConsumableArray(localCache && localCache.messages || localCache && localCache.response && localCache.response.messages || []);
    if (questionMessage && messages.findIndex(function (msg) {
      return msg.content === questionMessage.content && msg.role === questionMessage.role;
    }) === -1) {
      messages.push(questionMessage);
    }
    if (answerIndex === undefined) {
      answerIndex = messages.length;
      messages.push({
        content: responseText,
        role: AI_ROLES.ASSISTANT
      });
    } else {
      messages[answerIndex] = {
        content: responseText,
        role: AI_ROLES.ASSISTANT
      };
    }
    dispatch(setAIResponseDelayed(componentId, {
      meta: meta,
      sessionId: AIAnswerKey,
      isTyping: true,
      messages: messages,
      response: {
        answer: {
          text: responseText,
          role: AI_ROLES.ASSISTANT
        }
      }
    }));
  };
  function readStream() {
    reader.read().then(function (_ref3) {
      var value = _ref3.value,
        done = _ref3.done;
      if (done) {
        reader.releaseLock();
        return;
      }
      var chunk = decoder.decode(value, {
        stream: true
      });
      var regex = /\n\n(?=data:|$)/;
      var lines = chunk.split(regex);
      var shouldStop = false;
      for (var i = 0; i < lines.length; i++) {
        var line = lines[i];
        if (line.startsWith('data: ')) {
          var content = line.slice(6);
          if (content === '[DONE]') {
            shouldStop = true;
            if (Promise.resolve(metaInfoPromise) === metaInfoPromise) {
              metaInfoPromise.then(function (resMeta) {
                return resMeta.json();
              })
              // eslint-disable-next-line no-loop-func
              .then(function (parsedRes) {
                var messagesArr = [];
                if (parsedRes.question && parsedRes.answer) {
                  messagesArr.push.apply(messagesArr, [{
                    content: parsedRes.question,
                    role: AI_ROLES.USER
                  }, {
                    content: parsedRes.answer.text,
                    role: AI_ROLES.ASSISTANT
                  }]);
                }
                dispatch(setAIResponseDelayed(componentId, {
                  meta: meta,
                  sessionId: AIAnswerKey,
                  response: _objectSpread({}, parsedRes),
                  messages: messagesArr,
                  isTyping: false
                }));
              })["catch"](function (e) {
                console.error("Error fetching meta details for sessionId: ".concat(AIAnswerKey), e);
              });
            } else {
              dispatch(setAIResponseDelayed(componentId, {
                isTyping: false
              }));
            }
            break;
          }
          updateMessage(content);
        }
      }
      if (shouldStop) {
        reader.releaseLock();
      } else {
        readStream();
      }
    })["catch"](function (e) {
      reader.releaseLock();
      dispatch(setAIResponseError(componentId, e, {
        sessionId: AIAnswerKey,
        isTyping: false
      }));
    });
  }
  readStream();
}
var cancellationTokens = {}; // initialize cancellationTokens map

function fetchAIResponse(AIAnswerKey, componentId, question) {
  var meta = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  var shouldFetchMetaInfoUsingGET = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  return function (dispatch, getState) {
    var isPostRequest = !!question;
    dispatch(setAIResponseLoading(componentId, true));
    var _getState6 = getState(),
      _getState6$config = _getState6.config,
      url = _getState6$config.url,
      configCredentials = _getState6$config.credentials,
      endpoint = _getState6$config.endpoint;
    var regex = /https:\/\/[^/]+/;
    var urlObj = new URL(url.match(regex)[0]);
    var credentials = configCredentials;
    if (urlObj.username && urlObj.password) {
      credentials = "".concat(urlObj.username, ":").concat(urlObj.password);
      urlObj.username = '';
      urlObj.password = '';
    }
    var fetchUrl = "".concat(urlObj.toString(), "_ai/").concat(AIAnswerKey);
    var ssefetchUrl = "".concat(fetchUrl, "/sse");
    var headers = new Headers();
    if (credentials) {
      var encodedCredentials = btoa(credentials);
      headers.append('Authorization', "Basic ".concat(encodedCredentials));
    } else if (endpoint && endpoint.headers && endpoint.headers.Authorization) {
      headers.append('Authorization', endpoint.headers.Authorization);
    }
    var method = isPostRequest ? 'POST' : 'GET';
    var localCache = (getObjectFromLocalStorage(AI_LOCAL_CACHE_KEY) || {})[componentId];
    var requestOptions = {
      headers: headers,
      method: method,
      body: isPostRequest ? JSON.stringify({
        question: question
      }) : undefined
    };
    var attempt = 1; // initialize attempt number
    var maxAttempts = 2; // set max number of attempts

    var doFetch = function doFetch() {
      // Create a new cancellation token for this componentId
      // and abort any previous requests for this componentId
      var controller = new AbortController();
      if (cancellationTokens[componentId]) {
        cancellationTokens[componentId].abort();
      }
      cancellationTokens[componentId] = controller;
      fetch(ssefetchUrl, _objectSpread(_objectSpread({}, requestOptions), {}, {
        signal: controller.signal
      })).then(function (res) {
        if (!res.ok) {
          if (attempt < maxAttempts) {
            // retry on 400 error, up to maxAttempts times
            attempt++;
            setTimeout(doFetch, 1000); // retry
            return;
          }
        }
        var contentType = res.headers.get('content-type');
        if (contentType && contentType.startsWith('application/json')) {
          res.json().then(function (parsedRes) {
            if (parsedRes.error) {
              dispatch(setAIResponseError(componentId, parsedRes.error));
            } else {
              processJSONResponse(dispatch, componentId, AIAnswerKey, localCache, parsedRes, meta);
            }
          });
        } else {
          var metaInfoPromise;
          if (shouldFetchMetaInfoUsingGET) {
            metaInfoPromise = fetch(fetchUrl, _objectSpread(_objectSpread({}, requestOptions.headers ? {
              headers: requestOptions.headers
            } : {}), {}, {
              method: 'GET'
            }));
          }
          processStream(res, dispatch, componentId, AIAnswerKey, meta, question, metaInfoPromise);
        }
      })["catch"](function (e) {
        // Ignore abort errors
        if (e.name === 'AbortError') {
          return;
        }
        dispatch(setAIResponseError(componentId, e, {
          sessionId: AIAnswerKey
        }));
      });
    };
    doFetch();
  };
}

function updateMapData(componentId, query, persistMapQuery) {
  return {
    type: SET_MAP_DATA,
    componentId: componentId,
    query: query,
    persistMapQuery: persistMapQuery
  };
}
function setMapData(componentId, query, persistMapQuery, forceExecute) {
  var meta = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
  var queryId = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : '';
  return function (dispatch) {
    dispatch(updateMapData(componentId, query, persistMapQuery));
    // Set meta properties for internal component to make geo bounding box work
    dispatch(setInternalValue(getInternalComponentID(componentId), undefined, undefined, undefined, meta));
    if (forceExecute) {
      var executeWatchList = false;
      // force execute the map query
      var mustExecuteMapQuery = true;
      dispatch(executeQuery(componentId, executeWatchList, mustExecuteMapQuery, componentTypes.reactiveMap, {}, queryId));
    }
  };
}
function setMapResults(componentId, _ref) {
  var center = _ref.center,
    zoom = _ref.zoom,
    markers = _ref.markers;
  return {
    type: SET_MAP_RESULTS,
    componentId: componentId,
    payload: {
      center: center,
      zoom: zoom,
      markers: markers
    }
  };
}

export { setMapData, setMapResults, updateMapData };
