function _typeof(o) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
    return typeof o;
  } : function (o) {
    return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, _typeof(o);
}

function toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}

function toPropertyKey(t) {
  var i = toPrimitive(t, "string");
  return "symbol" == _typeof(i) ? i : String(i);
}

function _defineProperty(obj, key, value) {
  key = toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

var SET_PROPS = 'SET_PROPS';
var UPDATE_PROPS = 'UPDATE_PROPS';
var REMOVE_PROPS = 'REMOVE_PROPS';

// Props that need to be passed to the query
var validProps = [
// common
'type', 'componentType', 'aggregationField', 'aggregationSize', 'distinctField', 'distinctFieldConfig', 'index', 'aggregations', 'compoundClause',
// Specific to ReactiveList
'dataField', 'includeFields', 'excludeFields', 'size', 'candidates', 'from', 'sortBy', 'sortOptions', 'pagination',
// Specific to DataSearch
'autoFocus', 'autosuggest', 'debounce', 'defaultValue', 'defaultSuggestions', 'fieldWeights', 'filterLabel', 'fuzziness', 'highlight', 'highlightConfig', 'highlightField', 'nestedField', 'placeholder', 'queryFormat', 'searchOperators', 'enableSynonyms', 'enableQuerySuggestions', 'queryString', 'vectorDataField', 'imageValue',
// Specific to Category Search
'categoryField', 'strictSelection',
// Specific to List Components
'selectAllLabel', 'showCheckbox', 'showFilter', 'showSearch', 'showCount', 'showLoadMore', 'loadMoreLabel', 'showMissing', 'missingLabel', 'data', 'showRadio',
// TagCloud and ToggleButton
'multiSelect',
// Range Components
'includeNullValues', 'interval', 'showHistogram', 'snap', 'stepValue', 'range', 'showSlider', 'parseDate', 'calendarInterval',
// Map components
'unit',
// Specific to SearchBox
'enablePopularSuggestions', 'enableRecentSuggestions', 'popularSuggestionsConfig', 'recentSuggestionsConfig', 'indexSuggestionsConfig', 'featuredSuggestionsConfig', 'FAQSuggestionsConfig', 'documentSuggestionsConfig', 'enablePredictiveSuggestions', 'applyStopwords', 'customStopwords', 'enableIndexSuggestions', 'enableFeaturedSuggestions', 'enableFAQSuggestions', 'enableDocumentSuggestions', 'enableEndpointSuggestions', 'searchboxId', 'endpoint', 'enableAI', 'AIConfig', 'showDistinctSuggestions'];

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var getfilteredOptions = function getfilteredOptions() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var filteredOptions = {};
  Object.keys(options).forEach(function (option) {
    if (validProps.includes(option)) {
      filteredOptions[option] = options[option];
    }
  });
  return filteredOptions;
};
/**
 * Sets the external props for a component
 * @param {String} component
 * @param {Object} options
 */
function setComponentProps(component, options, componentType) {
  return {
    type: SET_PROPS,
    component: component,
    options: getfilteredOptions(_objectSpread(_objectSpread({}, options), {}, {
      componentType: componentType
    }))
  };
}

/**
 * Updates the external props for a component, overrides the duplicates
 * @param {String} component
 * @param {Object} options
 */
function updateComponentProps(component, options, componentType) {
  return {
    type: UPDATE_PROPS,
    component: component,
    options: getfilteredOptions(_objectSpread(_objectSpread({}, options), {}, {
      componentType: componentType
    }))
  };
}

/**
 * Remove the external props for a component
 * @param {String} component
 * @param {Object} options
 */
function removeComponentProps(component) {
  return {
    type: REMOVE_PROPS,
    component: component
  };
}

export { removeComponentProps, setComponentProps, updateComponentProps };
