'use strict';

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _typeof(o) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
    return typeof o;
  } : function (o) {
    return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, _typeof(o);
}

function toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}

function toPropertyKey(t) {
  var i = toPrimitive(t, "string");
  return "symbol" == _typeof(i) ? i : String(i);
}

function _defineProperty(obj, key, value) {
  key = toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

var dateFormats = {
  date: 'YYYY-MM-DD',
  basic_date: 'YYYYMMDD',
  basic_date_time: 'YYYYMMDD[T]HHmmss.SSSZ',
  basic_date_time_no_millis: 'YYYYMMDD[T]HHmmssZ',
  date_time_no_millis: 'YYYY-MM-DD[T]HH:mm:ssZ',
  basic_time: 'HHmmss.SSSZ',
  basic_time_no_millis: 'HHmmssZ',
  epoch_millis: 'epoch_millis',
  epoch_second: 'epoch_second'
};

var diacritics = {
  '«': '"',
  '²': '2',
  '³': '3',
  '¹': '1',
  '»': '"',
  À: 'A',
  Á: 'A',
  Â: 'A',
  Ã: 'A',
  Ä: 'A',
  Å: 'A',
  Æ: 'AE',
  Ç: 'C',
  È: 'E',
  É: 'E',
  Ê: 'E',
  Ë: 'E',
  Ì: 'I',
  Í: 'I',
  Î: 'I',
  Ï: 'I',
  Ð: 'D',
  Ñ: 'N',
  Ò: 'O',
  Ó: 'O',
  Ô: 'O',
  Õ: 'O',
  Ö: 'O',
  Ø: 'O',
  Ù: 'U',
  Ú: 'U',
  Û: 'U',
  Ü: 'U',
  Ý: 'Y',
  Þ: 'TH',
  ß: 'ss',
  à: 'a',
  á: 'a',
  â: 'a',
  ã: 'a',
  ä: 'a',
  å: 'a',
  æ: 'ae',
  ç: 'c',
  è: 'e',
  é: 'e',
  ê: 'e',
  ë: 'e',
  ì: 'i',
  í: 'i',
  î: 'i',
  ï: 'i',
  ð: 'd',
  ñ: 'n',
  ò: 'o',
  ó: 'o',
  ô: 'o',
  õ: 'o',
  ö: 'o',
  ø: 'o',
  ù: 'u',
  ú: 'u',
  û: 'u',
  ü: 'u',
  ý: 'y',
  þ: 'th',
  ÿ: 'y',
  Ā: 'A',
  ā: 'a',
  Ă: 'A',
  ă: 'a',
  Ą: 'A',
  ą: 'a',
  Ć: 'C',
  ć: 'c',
  Ĉ: 'C',
  ĉ: 'c',
  Ċ: 'C',
  ċ: 'c',
  Č: 'C',
  č: 'c',
  Ď: 'D',
  ď: 'd',
  Đ: 'D',
  đ: 'd',
  Ē: 'E',
  ē: 'e',
  Ĕ: 'E',
  ĕ: 'e',
  Ė: 'E',
  ė: 'e',
  Ę: 'E',
  ę: 'e',
  Ě: 'E',
  ě: 'e',
  Ĝ: 'G',
  ĝ: 'g',
  Ğ: 'G',
  ğ: 'g',
  Ġ: 'G',
  ġ: 'g',
  Ģ: 'G',
  ģ: 'g',
  Ĥ: 'H',
  ĥ: 'h',
  Ħ: 'H',
  ħ: 'h',
  Ĩ: 'I',
  ĩ: 'i',
  Ī: 'I',
  ī: 'i',
  Ĭ: 'I',
  ĭ: 'i',
  Į: 'I',
  į: 'i',
  İ: 'I',
  ı: 'i',
  Ĳ: 'IJ',
  ĳ: 'ij',
  Ĵ: 'J',
  ĵ: 'j',
  Ķ: 'K',
  ķ: 'k',
  ĸ: 'q',
  Ĺ: 'L',
  ĺ: 'l',
  Ļ: 'L',
  ļ: 'l',
  Ľ: 'L',
  ľ: 'l',
  Ŀ: 'L',
  ŀ: 'l',
  Ł: 'L',
  ł: 'l',
  Ń: 'N',
  ń: 'n',
  Ņ: 'N',
  ņ: 'n',
  Ň: 'N',
  ň: 'n',
  ŉ: 'n',
  Ŋ: 'N',
  ŋ: 'n',
  Ō: 'O',
  ō: 'o',
  Ŏ: 'O',
  ŏ: 'o',
  Ő: 'O',
  ő: 'o',
  Œ: 'OE',
  œ: 'oe',
  Ŕ: 'R',
  ŕ: 'r',
  Ŗ: 'R',
  ŗ: 'r',
  Ř: 'R',
  ř: 'r',
  Ś: 'S',
  ś: 's',
  Ŝ: 'S',
  ŝ: 's',
  Ş: 'S',
  ş: 's',
  Š: 'S',
  š: 's',
  Ţ: 'T',
  ţ: 't',
  Ť: 'T',
  ť: 't',
  Ŧ: 'T',
  ŧ: 't',
  Ũ: 'U',
  ũ: 'u',
  Ū: 'U',
  ū: 'u',
  Ŭ: 'U',
  ŭ: 'u',
  Ů: 'U',
  ů: 'u',
  Ű: 'U',
  ű: 'u',
  Ų: 'U',
  ų: 'u',
  Ŵ: 'W',
  ŵ: 'w',
  Ŷ: 'Y',
  ŷ: 'y',
  Ÿ: 'Y',
  Ź: 'Z',
  ź: 'z',
  Ż: 'Z',
  ż: 'z',
  Ž: 'Z',
  ž: 'z',
  ſ: 's',
  ƀ: 'b',
  Ɓ: 'B',
  Ƃ: 'B',
  ƃ: 'b',
  Ɔ: 'O',
  Ƈ: 'C',
  ƈ: 'c',
  Ɖ: 'D',
  Ɗ: 'D',
  Ƌ: 'D',
  ƌ: 'd',
  Ǝ: 'E',
  Ə: 'A',
  Ɛ: 'E',
  Ƒ: 'F',
  ƒ: 'f',
  Ɠ: 'G',
  ƕ: 'hv',
  Ɩ: 'I',
  Ɨ: 'I',
  Ƙ: 'K',
  ƙ: 'k',
  ƚ: 'l',
  Ɯ: 'M',
  Ɲ: 'N',
  ƞ: 'n',
  Ɵ: 'O',
  Ơ: 'O',
  ơ: 'o',
  Ƥ: 'P',
  ƥ: 'p',
  ƫ: 't',
  Ƭ: 'T',
  ƭ: 't',
  Ʈ: 'T',
  Ư: 'U',
  ư: 'u',
  Ʋ: 'V',
  Ƴ: 'Y',
  ƴ: 'y',
  Ƶ: 'Z',
  ƶ: 'z',
  ƿ: 'w',
  Ǆ: 'DZ',
  ǅ: 'Dz',
  ǆ: 'dz',
  Ǉ: 'LJ',
  ǈ: 'Lj',
  ǉ: 'lj',
  Ǌ: 'NJ',
  ǋ: 'Nj',
  ǌ: 'nj',
  Ǎ: 'A',
  ǎ: 'a',
  Ǐ: 'I',
  ǐ: 'i',
  Ǒ: 'O',
  ǒ: 'o',
  Ǔ: 'U',
  ǔ: 'u',
  Ǖ: 'U',
  ǖ: 'u',
  Ǘ: 'U',
  ǘ: 'u',
  Ǚ: 'U',
  ǚ: 'u',
  Ǜ: 'U',
  ǜ: 'u',
  ǝ: 'e',
  Ǟ: 'A',
  ǟ: 'a',
  Ǡ: 'A',
  ǡ: 'a',
  Ǣ: 'AE',
  ǣ: 'ae',
  Ǥ: 'G',
  ǥ: 'G',
  Ǧ: 'G',
  ǧ: 'G',
  Ǩ: 'K',
  ǩ: 'k',
  Ǫ: 'O',
  ǫ: 'o',
  Ǭ: 'O',
  ǭ: 'o',
  ǰ: 'j',
  Ǳ: 'DZ',
  ǲ: 'Dz',
  ǳ: 'dz',
  Ǵ: 'G',
  ǵ: 'g',
  Ƕ: 'HV',
  Ƿ: 'W',
  Ǹ: 'N',
  ǹ: 'n',
  Ǻ: 'A',
  ǻ: 'a',
  Ǽ: 'AE',
  ǽ: 'ae',
  Ǿ: 'O',
  ǿ: 'o',
  Ȁ: 'A',
  ȁ: 'a',
  Ȃ: 'A',
  ȃ: 'a',
  Ȅ: 'E',
  ȅ: 'e',
  Ȇ: 'E',
  ȇ: 'e',
  Ȉ: 'I',
  ȉ: 'i',
  Ȋ: 'I',
  ȋ: 'i',
  Ȍ: 'O',
  ȍ: 'o',
  Ȏ: 'O',
  ȏ: 'o',
  Ȑ: 'R',
  ȑ: 'r',
  Ȓ: 'R',
  ȓ: 'r',
  Ȕ: 'U',
  ȕ: 'u',
  Ȗ: 'U',
  ȗ: 'u',
  Ș: 'S',
  ș: 's',
  Ț: 'T',
  ț: 't',
  Ȝ: 'Z',
  ȝ: 'z',
  Ȟ: 'H',
  ȟ: 'h',
  Ƞ: 'N',
  ȡ: 'd',
  Ȣ: 'OU',
  ȣ: 'ou',
  Ȥ: 'Z',
  ȥ: 'z',
  Ȧ: 'A',
  ȧ: 'a',
  Ȩ: 'E',
  ȩ: 'e',
  Ȫ: 'O',
  ȫ: 'o',
  Ȭ: 'O',
  ȭ: 'o',
  Ȯ: 'O',
  ȯ: 'o',
  Ȱ: 'O',
  ȱ: 'o',
  Ȳ: 'Y',
  ȳ: 'y',
  ȴ: 'l',
  ȵ: 'n',
  ȶ: 't',
  ȷ: 'j',
  ȸ: 'db',
  ȹ: 'qp',
  Ⱥ: 'A',
  Ȼ: 'C',
  ȼ: 'c',
  Ƚ: 'L',
  Ⱦ: 'T',
  ȿ: 's',
  ɀ: 'z',
  Ƀ: 'B',
  Ʉ: 'U',
  Ʌ: 'V',
  Ɇ: 'E',
  ɇ: 'e',
  Ɉ: 'J',
  ɉ: 'j',
  Ɋ: 'Q',
  ɋ: 'q',
  Ɍ: 'R',
  ɍ: 'r',
  Ɏ: 'Y',
  ɏ: 'y',
  ɐ: 'a',
  ɓ: 'b',
  ɔ: 'o',
  ɕ: 'c',
  ɖ: 'd',
  ɗ: 'd',
  ɘ: 'e',
  ə: 'a',
  ɚ: 'a',
  ɛ: 'e',
  ɜ: 'e',
  ɝ: 'e',
  ɞ: 'e',
  ɟ: 'j',
  ɠ: 'g',
  ɡ: 'g',
  ɢ: 'G',
  ɥ: 'h',
  ɦ: 'h',
  ɨ: 'i',
  ɪ: 'I',
  ɫ: 'l',
  ɬ: 'l',
  ɭ: 'l',
  ɯ: 'm',
  ɰ: 'm',
  ɱ: 'm',
  ɲ: 'n',
  ɳ: 'n',
  ɴ: 'N',
  ɵ: 'o',
  ɶ: 'OE',
  ɼ: 'r',
  ɽ: 'r',
  ɾ: 'r',
  ɿ: 'r',
  ʀ: 'R',
  ʁ: 'R',
  ʂ: 's',
  ʄ: 'j',
  ʇ: 't',
  ʈ: 't',
  ʉ: 'u',
  ʋ: 'v',
  ʌ: 'v',
  ʍ: 'w',
  ʎ: 'y',
  ʏ: 'Y',
  ʐ: 'z',
  ʑ: 'z',
  ʗ: 'C',
  ʙ: 'B',
  ʚ: 'e',
  ʛ: 'G',
  ʜ: 'H',
  ʝ: 'j',
  ʞ: 'k',
  ʟ: 'L',
  ʠ: 'q',
  ʣ: 'dz',
  ʥ: 'dz',
  ʦ: 'ts',
  ʨ: 'tc',
  ʪ: 'ls',
  ʫ: 'lz',
  ʮ: 'h',
  ʯ: 'h',
  ᴀ: 'A',
  ᴁ: 'AE',
  ᴂ: 'ae',
  ᴃ: 'B',
  ᴄ: 'C',
  ᴅ: 'D',
  ᴆ: 'D',
  ᴇ: 'E',
  ᴈ: 'e',
  ᴉ: 'i',
  ᴊ: 'J',
  ᴋ: 'K',
  ᴌ: 'L',
  ᴍ: 'M',
  ᴎ: 'N',
  ᴏ: 'O',
  ᴐ: 'O',
  ᴔ: 'oe',
  ᴕ: 'OU',
  ᴖ: 'o',
  ᴗ: 'o',
  ᴘ: 'P',
  ᴙ: 'R',
  ᴚ: 'R',
  ᴛ: 'T',
  ᴜ: 'U',
  ᴠ: 'V',
  ᴡ: 'W',
  ᴢ: 'Z',
  ᵢ: 'i',
  ᵣ: 'r',
  ᵤ: 'u',
  ᵥ: 'v',
  ᵫ: 'ue',
  ᵬ: 'b',
  ᵭ: 'd',
  ᵮ: 'f',
  ᵯ: 'm',
  ᵰ: 'n',
  ᵱ: 'p',
  ᵲ: 'r',
  ᵳ: 'r',
  ᵴ: 's',
  ᵵ: 't',
  ᵶ: 'z',
  ᵷ: 'g',
  ᵹ: 'g',
  ᵺ: 'th',
  ᵻ: 'I',
  ᵼ: 'i',
  ᵽ: 'p',
  ᵾ: 'U',
  ᶀ: 'b',
  ᶁ: 'd',
  ᶂ: 'f',
  ᶃ: 'g',
  ᶄ: 'k',
  ᶅ: 'l',
  ᶆ: 'm',
  ᶇ: 'n',
  ᶈ: 'p',
  ᶉ: 'r',
  ᶊ: 's',
  ᶌ: 'v',
  ᶍ: 'x',
  ᶎ: 'z',
  ᶏ: 'a',
  ᶑ: 'd',
  ᶒ: 'e',
  ᶓ: 'e',
  ᶔ: 'e',
  ᶕ: 'a',
  ᶖ: 'i',
  ᶗ: 'o',
  ᶙ: 'u',
  Ḁ: 'A',
  ḁ: 'a',
  Ḃ: 'B',
  ḃ: 'b',
  Ḅ: 'B',
  ḅ: 'b',
  Ḇ: 'B',
  ḇ: 'b',
  Ḉ: 'C',
  ḉ: 'c',
  Ḋ: 'D',
  ḋ: 'd',
  Ḍ: 'D',
  ḍ: 'd',
  Ḏ: 'D',
  ḏ: 'd',
  Ḑ: 'D',
  ḑ: 'd',
  Ḓ: 'D',
  ḓ: 'd',
  Ḕ: 'E',
  ḕ: 'e',
  Ḗ: 'E',
  ḗ: 'e',
  Ḙ: 'E',
  ḙ: 'e',
  Ḛ: 'E',
  ḛ: 'e',
  Ḝ: 'E',
  ḝ: 'e',
  Ḟ: 'F',
  ḟ: 'f',
  Ḡ: 'G',
  ḡ: 'g',
  Ḣ: 'H',
  ḣ: 'h',
  Ḥ: 'H',
  ḥ: 'h',
  Ḧ: 'H',
  ḧ: 'h',
  Ḩ: 'H',
  ḩ: 'h',
  Ḫ: 'H',
  ḫ: 'h',
  Ḭ: 'I',
  ḭ: 'i',
  Ḯ: 'I',
  ḯ: 'i',
  Ḱ: 'K',
  ḱ: 'k',
  Ḳ: 'K',
  ḳ: 'k',
  Ḵ: 'K',
  ḵ: 'k',
  Ḷ: 'L',
  ḷ: 'l',
  Ḹ: 'L',
  ḹ: 'l',
  Ḻ: 'L',
  ḻ: 'l',
  Ḽ: 'L',
  ḽ: 'l',
  Ḿ: 'M',
  ḿ: 'm',
  Ṁ: 'M',
  ṁ: 'm',
  Ṃ: 'M',
  ṃ: 'm',
  Ṅ: 'N',
  ṅ: 'n',
  Ṇ: 'N',
  ṇ: 'n',
  Ṉ: 'N',
  ṉ: 'n',
  Ṋ: 'N',
  ṋ: 'n',
  Ṍ: 'O',
  ṍ: 'o',
  Ṏ: 'O',
  ṏ: 'o',
  Ṑ: 'O',
  ṑ: 'o',
  Ṓ: 'O',
  ṓ: 'o',
  Ṕ: 'P',
  ṕ: 'p',
  Ṗ: 'P',
  ṗ: 'p',
  Ṙ: 'R',
  ṙ: 'r',
  Ṛ: 'R',
  ṛ: 'r',
  Ṝ: 'R',
  ṝ: 'r',
  Ṟ: 'R',
  ṟ: 'r',
  Ṡ: 'S',
  ṡ: 's',
  Ṣ: 'S',
  ṣ: 's',
  Ṥ: 'S',
  ṥ: 's',
  Ṧ: 'S',
  ṧ: 's',
  Ṩ: 'S',
  ṩ: 's',
  Ṫ: 'T',
  ṫ: 't',
  Ṭ: 'T',
  ṭ: 't',
  Ṯ: 'T',
  ṯ: 't',
  Ṱ: 'T',
  ṱ: 't',
  Ṳ: 'U',
  ṳ: 'u',
  Ṵ: 'U',
  ṵ: 'u',
  Ṷ: 'U',
  ṷ: 'u',
  Ṹ: 'U',
  ṹ: 'u',
  Ṻ: 'U',
  ṻ: 'u',
  Ṽ: 'V',
  ṽ: 'v',
  Ṿ: 'V',
  ṿ: 'v',
  Ẁ: 'W',
  ẁ: 'w',
  Ẃ: 'W',
  ẃ: 'w',
  Ẅ: 'W',
  ẅ: 'w',
  Ẇ: 'W',
  ẇ: 'w',
  Ẉ: 'W',
  ẉ: 'w',
  Ẋ: 'X',
  ẋ: 'x',
  Ẍ: 'X',
  ẍ: 'x',
  Ẏ: 'Y',
  ẏ: 'y',
  Ẑ: 'Z',
  ẑ: 'z',
  Ẓ: 'Z',
  ẓ: 'z',
  Ẕ: 'Z',
  ẕ: 'z',
  ẖ: 'h',
  ẗ: 't',
  ẘ: 'w',
  ẙ: 'y',
  ẚ: 'a',
  ẛ: 'f',
  ẜ: 's',
  ẝ: 's',
  ẞ: 'SS',
  Ạ: 'A',
  ạ: 'a',
  Ả: 'A',
  ả: 'a',
  Ấ: 'A',
  ấ: 'a',
  Ầ: 'A',
  ầ: 'a',
  Ẩ: 'A',
  ẩ: 'a',
  Ẫ: 'A',
  ẫ: 'a',
  Ậ: 'A',
  ậ: 'a',
  Ắ: 'A',
  ắ: 'a',
  Ằ: 'A',
  ằ: 'a',
  Ẳ: 'A',
  ẳ: 'a',
  Ẵ: 'A',
  ẵ: 'a',
  Ặ: 'A',
  ặ: 'a',
  Ẹ: 'E',
  ẹ: 'e',
  Ẻ: 'E',
  ẻ: 'e',
  Ẽ: 'E',
  ẽ: 'e',
  Ế: 'E',
  ế: 'e',
  Ề: 'E',
  ề: 'e',
  Ể: 'E',
  ể: 'e',
  Ễ: 'E',
  ễ: 'e',
  Ệ: 'E',
  ệ: 'e',
  Ỉ: 'I',
  ỉ: 'i',
  Ị: 'I',
  ị: 'i',
  Ọ: 'O',
  ọ: 'o',
  Ỏ: 'O',
  ỏ: 'o',
  Ố: 'O',
  ố: 'o',
  Ồ: 'O',
  ồ: 'o',
  Ổ: 'O',
  ổ: 'o',
  Ỗ: 'O',
  ỗ: 'o',
  Ộ: 'O',
  ộ: 'o',
  Ớ: 'O',
  ớ: 'o',
  Ờ: 'O',
  ờ: 'o',
  Ở: 'O',
  ở: 'o',
  Ỡ: 'O',
  ỡ: 'o',
  Ợ: 'O',
  ợ: 'o',
  Ụ: 'U',
  ụ: 'u',
  Ủ: 'U',
  ủ: 'u',
  Ứ: 'U',
  ứ: 'u',
  Ừ: 'U',
  ừ: 'u',
  Ử: 'U',
  ử: 'u',
  Ữ: 'U',
  ữ: 'u',
  Ự: 'U',
  ự: 'u',
  Ỳ: 'Y',
  ỳ: 'y',
  Ỵ: 'Y',
  ỵ: 'y',
  Ỷ: 'Y',
  ỷ: 'y',
  Ỹ: 'Y',
  ỹ: 'y',
  Ỻ: 'LL',
  ỻ: 'll',
  Ỽ: 'V',
  Ỿ: 'Y',
  ỿ: 'y',
  '‐': '-',
  '‑': '-',
  '‒': '-',
  '–': '-',
  '—': '-',
  '‘': '"',
  '’': '"',
  '‚': '"',
  '‛': '"',
  '“': '"',
  '”': '"',
  '„': '"',
  '′': '"',
  '″': '"',
  '‵': '"',
  '‶': '"',
  '‸': '^',
  '‹': '"',
  '›': '"',
  '‼': '!!',
  '⁄': '/',
  '⁅': '[',
  '⁆': ']',
  '⁇': '??',
  '⁈': '?!',
  '⁉': '!?',
  '⁎': '*',
  '⁏': ';',
  '⁒': '%',
  '⁓': '~',
  '⁰': '0',
  ⁱ: 'i',
  '⁴': '4',
  '⁵': '5',
  '⁶': '6',
  '⁷': '7',
  '⁸': '8',
  '⁹': '9',
  '⁺': '+',
  '⁻': '-',
  '⁼': '=',
  '⁽': '(',
  '⁾': ')',
  ⁿ: 'n',
  '₀': '0',
  '₁': '1',
  '₂': '2',
  '₃': '3',
  '₄': '4',
  '₅': '5',
  '₆': '6',
  '₇': '7',
  '₈': '8',
  '₉': '9',
  '₊': '+',
  '₋': '-',
  '₌': '=',
  '₍': '(',
  '₎': ')',
  ₐ: 'a',
  ₑ: 'e',
  ₒ: 'o',
  ₓ: 'x',
  ₔ: 'a',
  ↄ: 'c',
  '①': '1',
  '②': '2',
  '③': '3',
  '④': '4',
  '⑤': '5',
  '⑥': '6',
  '⑦': '7',
  '⑧': '8',
  '⑨': '9',
  '⑩': '10',
  '⑪': '11',
  '⑫': '12',
  '⑬': '13',
  '⑭': '14',
  '⑮': '15',
  '⑯': '16',
  '⑰': '17',
  '⑱': '18',
  '⑲': '19',
  '⑳': '20',
  '⑴': '(1)',
  '⑵': '(2)',
  '⑶': '(3)',
  '⑷': '(4)',
  '⑸': '(5)',
  '⑹': '(6)',
  '⑺': '(7)',
  '⑻': '(8)',
  '⑼': '(9)',
  '⑽': '(10)',
  '⑾': '(11)',
  '⑿': '(12)',
  '⒀': '(13)',
  '⒁': '(14)',
  '⒂': '(15)',
  '⒃': '(16)',
  '⒄': '(17)',
  '⒅': '(18)',
  '⒆': '(19)',
  '⒇': '(20)',
  '⒈': '1.',
  '⒉': '2.',
  '⒊': '3.',
  '⒋': '4.',
  '⒌': '5.',
  '⒍': '6.',
  '⒎': '7.',
  '⒏': '8.',
  '⒐': '9.',
  '⒑': '10.',
  '⒒': '11.',
  '⒓': '12.',
  '⒔': '13.',
  '⒕': '14.',
  '⒖': '15.',
  '⒗': '16.',
  '⒘': '17.',
  '⒙': '18.',
  '⒚': '19.',
  '⒛': '20.',
  '⒜': '(a)',
  '⒝': '(b)',
  '⒞': '(c)',
  '⒟': '(d)',
  '⒠': '(e)',
  '⒡': '(f)',
  '⒢': '(g)',
  '⒣': '(h)',
  '⒤': '(i)',
  '⒥': '(j)',
  '⒦': '(k)',
  '⒧': '(l)',
  '⒨': '(m)',
  '⒩': '(n)',
  '⒪': '(o)',
  '⒫': '(p)',
  '⒬': '(q)',
  '⒭': '(r)',
  '⒮': '(s)',
  '⒯': '(t)',
  '⒰': '(u)',
  '⒱': '(v)',
  '⒲': '(w)',
  '⒳': '(x)',
  '⒴': '(y)',
  '⒵': '(z)',
  'Ⓐ': 'A',
  'Ⓑ': 'B',
  'Ⓒ': 'C',
  'Ⓓ': 'D',
  'Ⓔ': 'E',
  'Ⓕ': 'F',
  'Ⓖ': 'G',
  'Ⓗ': 'H',
  'Ⓘ': 'I',
  'Ⓙ': 'J',
  'Ⓚ': 'K',
  'Ⓛ': 'L',
  'Ⓜ': 'M',
  'Ⓝ': 'N',
  'Ⓞ': 'O',
  'Ⓟ': 'P',
  'Ⓠ': 'Q',
  'Ⓡ': 'R',
  'Ⓢ': 'S',
  'Ⓣ': 'T',
  'Ⓤ': 'U',
  'Ⓥ': 'V',
  'Ⓦ': 'W',
  'Ⓧ': 'X',
  'Ⓨ': 'Y',
  'Ⓩ': 'Z',
  'ⓐ': 'a',
  'ⓑ': 'b',
  'ⓒ': 'c',
  'ⓓ': 'd',
  'ⓔ': 'e',
  'ⓕ': 'f',
  'ⓖ': 'g',
  'ⓗ': 'h',
  'ⓘ': 'i',
  'ⓙ': 'j',
  'ⓚ': 'k',
  'ⓛ': 'l',
  'ⓜ': 'm',
  'ⓝ': 'n',
  'ⓞ': 'o',
  'ⓟ': 'p',
  'ⓠ': 'q',
  'ⓡ': 'r',
  'ⓢ': 's',
  'ⓣ': 't',
  'ⓤ': 'u',
  'ⓥ': 'v',
  'ⓦ': 'w',
  'ⓧ': 'x',
  'ⓨ': 'y',
  'ⓩ': 'z',
  '⓪': '0',
  '⓫': '11',
  '⓬': '12',
  '⓭': '13',
  '⓮': '14',
  '⓯': '15',
  '⓰': '16',
  '⓱': '17',
  '⓲': '18',
  '⓳': '19',
  '⓴': '20',
  '⓵': '1',
  '⓶': '2',
  '⓷': '3',
  '⓸': '4',
  '⓹': '5',
  '⓺': '6',
  '⓻': '7',
  '⓼': '8',
  '⓽': '9',
  '⓾': '10',
  '⓿': '0',
  '❛': '"',
  '❜': '"',
  '❝': '"',
  '❞': '"',
  '❨': '(',
  '❩': ')',
  '❪': '(',
  '❫': ')',
  '❬': '<',
  '❭': '>',
  '❮': '"',
  '❯': '"',
  '❰': '<',
  '❱': '>',
  '❲': '[',
  '❳': ']',
  '❴': '{',
  '❵': '}',
  '❶': '1',
  '❷': '2',
  '❸': '3',
  '❹': '4',
  '❺': '5',
  '❻': '6',
  '❼': '7',
  '❽': '8',
  '❾': '9',
  '❿': '10',
  '➀': '1',
  '➁': '2',
  '➂': '3',
  '➃': '4',
  '➄': '5',
  '➅': '6',
  '➆': '7',
  '➇': '8',
  '➈': '9',
  '➉': '10',
  '➊': '1',
  '➋': '2',
  '➌': '3',
  '➍': '4',
  '➎': '5',
  '➏': '6',
  '➐': '7',
  '➑': '8',
  '➒': '9',
  '➓': '10',
  Ⱡ: 'L',
  ⱡ: 'l',
  Ɫ: 'L',
  Ᵽ: 'P',
  Ɽ: 'R',
  ⱥ: 'a',
  ⱦ: 't',
  Ⱨ: 'H',
  ⱨ: 'h',
  Ⱪ: 'K',
  ⱪ: 'k',
  Ⱬ: 'Z',
  ⱬ: 'z',
  Ɱ: 'M',
  Ɐ: 'a',
  ⱱ: 'v',
  Ⱳ: 'W',
  ⱳ: 'w',
  ⱴ: 'v',
  Ⱶ: 'H',
  ⱶ: 'h',
  ⱸ: 'e',
  ⱺ: 'o',
  ⱻ: 'E',
  ⱼ: 'j',
  '⸨': '((',
  '⸩': '))',
  Ꜩ: 'TZ',
  ꜩ: 'tz',
  ꜰ: 'F',
  ꜱ: 'S',
  Ꜳ: 'AA',
  ꜳ: 'aa',
  Ꜵ: 'AO',
  ꜵ: 'ao',
  Ꜷ: 'AU',
  ꜷ: 'au',
  Ꜹ: 'AV',
  ꜹ: 'av',
  Ꜻ: 'AV',
  ꜻ: 'av',
  Ꜽ: 'AY',
  ꜽ: 'ay',
  Ꜿ: 'c',
  ꜿ: 'c',
  Ꝁ: 'K',
  ꝁ: 'k',
  Ꝃ: 'K',
  ꝃ: 'k',
  Ꝅ: 'K',
  ꝅ: 'k',
  Ꝇ: 'L',
  ꝇ: 'l',
  Ꝉ: 'L',
  ꝉ: 'l',
  Ꝋ: 'O',
  ꝋ: 'o',
  Ꝍ: 'O',
  ꝍ: 'o',
  Ꝏ: 'OO',
  ꝏ: 'oo',
  Ꝑ: 'P',
  ꝑ: 'p',
  Ꝓ: 'P',
  ꝓ: 'p',
  Ꝕ: 'P',
  ꝕ: 'p',
  Ꝗ: 'Q',
  ꝗ: 'q',
  Ꝙ: 'Q',
  ꝙ: 'q',
  Ꝛ: 'R',
  ꝛ: 'r',
  Ꝟ: 'V',
  ꝟ: 'v',
  Ꝡ: 'VY',
  ꝡ: 'vy',
  Ꝣ: 'Z',
  ꝣ: 'z',
  Ꝧ: 'TH',
  ꝧ: 'th',
  Ꝩ: 'V',
  Ꝺ: 'D',
  ꝺ: 'd',
  Ꝼ: 'F',
  ꝼ: 'f',
  Ᵹ: 'G',
  Ꝿ: 'G',
  ꝿ: 'g',
  Ꞁ: 'L',
  ꞁ: 'l',
  Ꞃ: 'R',
  ꞃ: 'r',
  Ꞅ: 's',
  ꞅ: 'S',
  Ꞇ: 'T',
  ꟻ: 'F',
  ꟼ: 'p',
  ꟽ: 'M',
  ꟾ: 'I',
  ꟿ: 'M',
  ﬀ: 'ff',
  ﬁ: 'fi',
  ﬂ: 'fl',
  ﬃ: 'ffi',
  ﬄ: 'ffl',
  ﬆ: 'st',
  '！': '!',
  '＂': '"',
  '＃': '#',
  '＄': '$',
  '％': '%',
  '＆': '&',
  '＇': '"',
  '（': '(',
  '）': ')',
  '＊': '*',
  '＋': '+',
  '，': ',',
  '－': '-',
  '．': '.',
  '／': '/',
  '０': '0',
  '１': '1',
  '２': '2',
  '３': '3',
  '４': '4',
  '５': '5',
  '６': '6',
  '７': '7',
  '８': '8',
  '９': '9',
  '：': ':',
  '；': ';',
  '＜': '<',
  '＝': '=',
  '＞': '>',
  '？': '?',
  '＠': '@',
  Ａ: 'A',
  Ｂ: 'B',
  Ｃ: 'C',
  Ｄ: 'D',
  Ｅ: 'E',
  Ｆ: 'F',
  Ｇ: 'G',
  Ｈ: 'H',
  Ｉ: 'I',
  Ｊ: 'J',
  Ｋ: 'K',
  Ｌ: 'L',
  Ｍ: 'M',
  Ｎ: 'N',
  Ｏ: 'O',
  Ｐ: 'P',
  Ｑ: 'Q',
  Ｒ: 'R',
  Ｓ: 'S',
  Ｔ: 'T',
  Ｕ: 'U',
  Ｖ: 'V',
  Ｗ: 'W',
  Ｘ: 'X',
  Ｙ: 'Y',
  Ｚ: 'Z',
  '［': '[',
  '＼': '\\',
  '］': ']',
  '＾': '^',
  '＿': '_',
  ａ: 'a',
  ｂ: 'b',
  ｃ: 'c',
  ｄ: 'd',
  ｅ: 'e',
  ｆ: 'f',
  ｇ: 'g',
  ｈ: 'h',
  ｉ: 'i',
  ｊ: 'j',
  ｋ: 'k',
  ｌ: 'l',
  ｍ: 'm',
  ｎ: 'n',
  ｏ: 'o',
  ｐ: 'p',
  ｑ: 'q',
  ｒ: 'r',
  ｓ: 's',
  ｔ: 't',
  ｕ: 'u',
  ｖ: 'v',
  ｗ: 'w',
  ｘ: 'x',
  ｙ: 'y',
  ｚ: 'z',
  '｛': '{',
  '｝': '}',
  '～': '~'
};

var _excluded$1 = ["label"];
function ownKeys$1(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$1(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$1(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$1(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

// flattens a nested array
var flatten$1 = function flatten(arr) {
  return arr.reduce(function (flat, toFlatten) {
    return flat.concat(Array.isArray(toFlatten) ? flatten(toFlatten) : toFlatten);
  }, []);
};
var extractSuggestion = function extractSuggestion(val) {
  switch (_typeof(val)) {
    case 'string':
      return val;
    case 'object':
      if (Array.isArray(val)) {
        return flatten$1(val);
      }
      return null;
    default:
      return val;
  }
};
function replaceDiacritics(s) {
  var str = s ? String(s) : '';
  for (var i = 0; i < str.length; i++) {
    var currentChar = str.charAt(i);
    if (diacritics[currentChar]) {
      str = str.replaceAll(currentChar, diacritics[currentChar]);
    }
  }
  return str;
}
function escapeRegExp() {
  var string = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return string.replace(/[.*+?^${}()|[\]\\]/g, '\\$&'); // $& means the whole matched string
}
var getPredictiveSuggestions = function getPredictiveSuggestions(_ref) {
  var suggestions = _ref.suggestions,
    currentValue = _ref.currentValue,
    wordsToShowAfterHighlight = _ref.wordsToShowAfterHighlight;
  var suggestionMap = {};
  if (currentValue) {
    var currentValueTrimmed = currentValue.trim();
    var parsedSuggestion = suggestions.reduce(function (agg, _ref2) {
      var label = _ref2.label,
        rest = _objectWithoutProperties(_ref2, _excluded$1);
      // to handle special strings with pattern '<mark>xyz</mark> <a href="test'
      var parsedContent = new DOMParser().parseFromString(label, 'text/html').documentElement.textContent;

      // to match the partial start of word.
      // example if searchTerm is `select` and string contains `selected`
      var regexString = "^(".concat(escapeRegExp(currentValueTrimmed), ")\\w+");
      var regex = new RegExp(regexString, 'i');
      var regexExecution = regex.exec(parsedContent);
      // if execution value is null it means either there is no match or there are chances
      // that exact word is present
      if (!regexExecution) {
        // regex to match exact word
        regexString = "^(".concat(escapeRegExp(currentValueTrimmed), ")");
        regex = new RegExp(regexString, 'i');
        regexExecution = regex.exec(parsedContent);
      }
      if (regexExecution) {
        var matchedString = parsedContent.slice(regexExecution.index, parsedContent.length);
        var highlightedWord = matchedString.slice(currentValueTrimmed.length).split(' ').slice(0, wordsToShowAfterHighlight + 1).join(' ');
        var suggestionPhrase = "".concat(currentValueTrimmed, "<mark class=\"highlight\">").concat(highlightedWord, "</mark>");
        var suggestionValue = "".concat(currentValueTrimmed).concat(highlightedWord);
        // to show unique results only
        if (!suggestionMap[suggestionPhrase]) {
          suggestionMap[suggestionPhrase] = 1;
          return [].concat(_toConsumableArray(agg), [_objectSpread$1(_objectSpread$1({}, rest), {}, {
            label: suggestionPhrase,
            value: suggestionValue,
            isPredictiveSuggestion: true
          })]);
        }
        return agg;
      }
      return agg;
    }, []);
    return parsedSuggestion;
  }
  return [];
};
var getSuggestions = function getSuggestions(_ref3) {
  var fields = _ref3.fields,
    suggestions = _ref3.suggestions,
    currentValue = _ref3.currentValue,
    _ref3$suggestionPrope = _ref3.suggestionProperties,
    suggestionProperties = _ref3$suggestionPrope === void 0 ? [] : _ref3$suggestionPrope,
    _ref3$showDistinctSug = _ref3.showDistinctSuggestions,
    showDistinctSuggestions = _ref3$showDistinctSug === void 0 ? false : _ref3$showDistinctSug,
    _ref3$enablePredictiv = _ref3.enablePredictiveSuggestions,
    enablePredictiveSuggestions = _ref3$enablePredictiv === void 0 ? false : _ref3$enablePredictiv,
    _ref3$wordsToShowAfte = _ref3.wordsToShowAfterHighlight,
    wordsToShowAfterHighlight = _ref3$wordsToShowAfte === void 0 ? 2 : _ref3$wordsToShowAfte,
    enableSynonyms = _ref3.enableSynonyms;
  /*
  	fields: DataFields passed on Search Components
  	suggestions: Raw Suggestions received from ES
  	currentValue: Search Term
  	skipWordMatch: Use to skip the word match logic, important for synonym
  	showDistinctSuggestions: When set to true will only return 1 suggestion per document
  */

  var suggestionsList = [];
  var labelsList = [];
  var skipWordMatch = false;
  var populateSuggestionsList = function populateSuggestionsList(val, parsedSource, source) {
    // check if the suggestion includes the current value
    // and not already included in other suggestions
    var isWordMatch = skipWordMatch || currentValue.trim().split(' ').some(function (term) {
      return replaceDiacritics(val).toLowerCase().includes(replaceDiacritics(term));
    });
    // promoted results should always include in suggestions even there is no match
    if (isWordMatch && !labelsList.includes(val) || source._promoted) {
      var defaultOption = {
        label: val,
        value: val,
        source: source
      };
      var additionalKeys = {};
      if (Array.isArray(suggestionProperties) && suggestionProperties.length > 0) {
        suggestionProperties.forEach(function (prop) {
          if (parsedSource.hasOwnProperty(prop)) {
            additionalKeys = _objectSpread$1(_objectSpread$1({}, additionalKeys), {}, _defineProperty({}, prop, parsedSource[prop]));
          }
        });
      }
      var option = _objectSpread$1(_objectSpread$1({}, defaultOption), additionalKeys);
      labelsList = [].concat(_toConsumableArray(labelsList), [val]);
      suggestionsList = [].concat(_toConsumableArray(suggestionsList), [option]);
      if (showDistinctSuggestions) {
        return true;
      }
    }
    return false;
  };
  var parseField = function parseField(parsedSource) {
    var field = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    var source = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : parsedSource;
    if (_typeof(parsedSource) === 'object') {
      var fieldNodes = field.split('.');
      var label = parsedSource[fieldNodes[0]];
      // To handle field names with dots
      // For example, if source has a top level field name is `user.name`
      // then it would extract the suggestion from parsed source
      if (parsedSource[field]) {
        var topLabel = parsedSource[field];
        var val = extractSuggestion(topLabel);
        if (val && typeof val === 'string') {
          return populateSuggestionsList(val, parsedSource, source);
        }
      }
      // if they type of field is array of strings
      // then we need to pick first matching value as the label
      if (Array.isArray(label)) {
        if (label.length > 1) {
          label = label.filter(function (i) {
            return i && i.toString().toLowerCase().includes(currentValue.toString().toLowerCase());
          });
        }
        label = label[0];
      }
      if (label) {
        if (fieldNodes.length > 1) {
          // nested fields of the 'foo.bar.zoo' variety
          var children = field.substring(fieldNodes[0].length + 1);
          parseField(label, children, source);
        } else {
          var _val = extractSuggestion(label);
          if (_val) {
            return populateSuggestionsList(_val, parsedSource, source);
          }
        }
      }
    }
    return false;
  };
  var traverseSuggestions = function traverseSuggestions() {
    suggestions.forEach(function (item) {
      fields.forEach(function (field) {
        parseField(item, field);
      });
    });
  };
  traverseSuggestions();
  if (suggestionsList.length < suggestions.length && !skipWordMatch && enableSynonyms) {
    /*
    	When we have synonym we set skipWordMatch to false as it may discard
    	the suggestion if word doesnt match term.
    	For eg: iphone, ios are synonyms and on searching iphone isWordMatch
    	in  populateSuggestionList may discard ios source which decreases no.
    	of items in suggestionsList
    */
    skipWordMatch = true;
    traverseSuggestions();
  }
  if (enablePredictiveSuggestions) {
    var predictiveSuggestions = getPredictiveSuggestions({
      suggestions: suggestionsList,
      currentValue: currentValue,
      wordsToShowAfterHighlight: wordsToShowAfterHighlight
    });
    suggestionsList = predictiveSuggestions;
  }
  if (showDistinctSuggestions) {
    var idMap = {};
    var filteredSuggestions = [];
    suggestionsList.forEach(function (suggestion) {
      if (suggestion.source && suggestion.source._id) {
        if (!idMap[suggestion.source._id]) {
          filteredSuggestions.push(suggestion);
          idMap[suggestion.source._id] = true;
        }
      }
    });
    return filteredSuggestions;
  }
  return suggestionsList;
};

var componentTypes = {
  reactiveList: 'REACTIVELIST',
  // search components
  dataSearch: 'DATASEARCH',
  categorySearch: 'CATEGORYSEARCH',
  searchBox: 'SEARCHBOX',
  // list components
  singleList: 'SINGLELIST',
  multiList: 'MULTILIST',
  singleDataList: 'SINGLEDATALIST',
  tabDataList: 'TABDATALIST',
  singleDropdownList: 'SINGLEDROPDOWNLIST',
  multiDataList: 'MULTIDATALIST',
  multiDropdownList: 'MULTIDROPDOWNLIST',
  singleDropdownRange: 'SINGLEDROPDOWNRANGE',
  treeList: 'TREELIST',
  // basic components
  numberBox: 'NUMBERBOX',
  tagCloud: 'TAGCLOUD',
  toggleButton: 'TOGGLEBUTTON',
  reactiveComponent: 'REACTIVECOMPONENT',
  // range components
  datePicker: 'DATEPICKER',
  dateRange: 'DATERANGE',
  dynamicRangeSlider: 'DYNAMICRANGESLIDER',
  multiDropdownRange: 'MULTIDROPDOWNRANGE',
  singleRange: 'SINGLERANGE',
  multiRange: 'MULTIRANGE',
  rangeSlider: 'RANGESLIDER',
  ratingsFilter: 'RATINGSFILTER',
  rangeInput: 'RANGEINPUT',
  // map components
  geoDistanceDropdown: 'GEO_DISTANCE_DROPDOWN',
  geoDistanceSlider: 'GEO_DISTANCE_SLIDER',
  reactiveMap: 'REACTIVE_MAP',
  // chart components
  reactiveChart: 'REACTIVE_CHART',
  // ai component
  AIAnswer: 'AI_ANSWER'
};

var _componentTypeToDefau;
var _excluded = ["query"],
  _excluded2 = ["query", "id", "params"],
  _excluded3 = ["query"],
  _excluded4 = ["headers", "body"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var updateCustomQuery = function updateCustomQuery(componentId, props, value) {
  if (props.customQuery && typeof props.customQuery === 'function') {
    props.setCustomQuery(componentId, props.customQuery(value, props));
  }
};
var updateDefaultQuery = function updateDefaultQuery(componentId, props, value) {
  if (props.defaultQuery && typeof props.defaultQuery === 'function') {
    props.setDefaultQuery(componentId, props.defaultQuery(value, props));
  }
};
function isEqual(x, y) {
  if (x === y) return true;
  if (!(x instanceof Object) || !(y instanceof Object)) return false;
  if (x.constructor !== y.constructor) return false;

  /* eslint-disable */
  for (var p in x) {
    if (!x.hasOwnProperty(p)) continue;
    if (!y.hasOwnProperty(p)) return false;
    if (x[p] === y[p]) continue;
    if (_typeof(x[p]) !== 'object') return false;
    if (!isEqual(x[p], y[p])) return false;
  }
  for (var _p in y) {
    if (y.hasOwnProperty(_p) && !x.hasOwnProperty(_p)) return false;
  }
  /* eslint-enable */
  return true;
}
/* eslint-enable */

function compareQueries(x, y) {
  try {
    // de-reference objects then compare
    return isEqual(JSON.parse(JSON.stringify(x)), JSON.parse(JSON.stringify(y)));
  } catch (e) {
    return false;
  }
}
function debounce(callback, wait) {
  var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this;
  if (!wait) {
    return callback;
  }
  var timeout = null;
  var callbackArgs = null;
  var later = function later() {
    return callback.apply(context, callbackArgs);
  };
  return function debouncedFunction() {
    callbackArgs = arguments; // eslint-disable-line
    clearTimeout(timeout);
    timeout = setTimeout(later, wait);
  };
}
function getQueryOptions(props) {
  var options = {};
  if (props.size !== undefined) {
    options.size = props.size;
  }
  if (props.includeFields || props.excludeFields) {
    var source = {};
    if (props.includeFields) {
      source.includes = props.includeFields;
    }
    if (props.excludeFields) {
      source.excludes = props.excludeFields;
    }
    options._source = source;
  }
  return options;
}
function getOperation(conjunction) {
  if (conjunction === 'and') {
    return 'must';
  }
  if (conjunction === 'or') {
    return 'should';
  }
  return 'must_not';
}
function createBoolQuery(operation, query) {
  var resultQuery = null;
  if (Array.isArray(query) && query.length || !Array.isArray(query) && query) {
    resultQuery = {
      bool: _defineProperty({}, operation, query)
    };
  }
  if (operation === 'should' && resultQuery) {
    resultQuery = {
      bool: _objectSpread(_objectSpread({}, resultQuery.bool), {}, {
        minimum_should_match: 1
      })
    };
  }
  return resultQuery;
}
function getQuery(react, queryList) {
  var query = [];
  Object.keys(react).forEach(function (conjunction) {
    if (Array.isArray(react[conjunction])) {
      var operation = getOperation(conjunction);
      var queryArr = react[conjunction].map(function (comp) {
        if (typeof comp !== 'string') {
          // in this case, we have { <conjunction>: <> } objects inside the array
          return getQuery(comp, queryList);
        } else if (comp in queryList) {
          if (queryList[comp] && Object.keys(queryList[comp]).length) {
            return queryList[comp];
          }
        }
        return null;
      }).filter(function (item) {
        return !!item;
      });
      var boolQuery = createBoolQuery(operation, queryArr);
      if (boolQuery && Object.keys(boolQuery).length) {
        query = [].concat(_toConsumableArray(query), [boolQuery]);
      }
    } else if (typeof react[conjunction] === 'string') {
      var _operation = getOperation(conjunction);
      var _boolQuery = createBoolQuery(_operation, queryList[react[conjunction]]);
      if (_boolQuery && Object.keys(_boolQuery).length) {
        query = [].concat(_toConsumableArray(query), [_boolQuery]);
      }
    } else if (_typeof(react[conjunction]) === 'object' && react[conjunction] !== null) {
      var _boolQuery2 = getQuery(react[conjunction], queryList);
      if (_boolQuery2 && Object.keys(_boolQuery2).length) {
        query = [].concat(_toConsumableArray(query), [_boolQuery2]);
      }
    }
  });
  if (Array.isArray(query) && query.length) {
    return {
      bool: {
        must: query
      }
    };
  }
  if (query && Object.keys(query).length) {
    return query;
  }
  return null;
}
function getExternalQueryOptions(react, options, component) {
  var queryOptions = {};
  Object.keys(react).forEach(function (conjunction) {
    if (Array.isArray(react[conjunction])) {
      react[conjunction].forEach(function (comp) {
        if (options[comp]) {
          queryOptions = _objectSpread(_objectSpread({}, queryOptions), options[comp]);
        }
      });
    } else if (typeof react[conjunction] === 'string') {
      if (options[react[conjunction]]) {
        queryOptions = _objectSpread(_objectSpread({}, queryOptions), options[react[conjunction]]);
      }
    } else if (_typeof(react[conjunction]) === 'object' && react[conjunction] !== null && !Array.isArray(react[conjunction])) {
      queryOptions = _objectSpread(_objectSpread({}, queryOptions), getExternalQueryOptions(react[conjunction], options));
    }
  });
  if (options[component]) {
    queryOptions = _objectSpread(_objectSpread({}, queryOptions), options[component]);
  }
  return queryOptions;
}
function buildQuery(component, dependencyTree, queryList, queryOptions) {
  var queryObj = null;
  var options = null;
  if (component in dependencyTree) {
    queryObj = getQuery(dependencyTree[component], queryList);
    options = getExternalQueryOptions(dependencyTree[component], queryOptions, component);
  }
  return {
    queryObj: queryObj,
    options: options
  };
}
function pushToAndClause(reactProp, component) {
  var react = Object.assign({}, reactProp);
  if (react.and) {
    if (Array.isArray(react.and)) {
      react.and = [].concat(_toConsumableArray(react.and), [component]);
      return react;
    } else if (typeof react.and === 'string') {
      react.and = [react.and, component];
      return react;
    }
    react.and = pushToAndClause(react.and, component);
    return react;
  }
  return _objectSpread(_objectSpread({}, react), {}, {
    and: component
  });
}

// checks and executes beforeValueChange for sensors
function checkValueChange(componentId, value, beforeValueChange, performUpdate) {
  var selectedValue = value;
  // To ensure that the returned values are consistent across all the components
  // null is returned in case of an empty array
  if (Array.isArray(value) && !value.length) {
    selectedValue = null;
  }
  var handleError = function handleError(e) {
    console.warn("".concat(componentId, " - beforeValueChange rejected the promise with "), e);
  };
  if (beforeValueChange) {
    try {
      var promise = beforeValueChange(selectedValue);
      if (promise instanceof Promise) {
        promise.then(performUpdate)["catch"](handleError);
      } else {
        performUpdate();
      }
    } catch (e) {
      handleError(e);
    }
  } else {
    performUpdate();
  }
}
function getAggsOrder(sortBy) {
  if (sortBy === 'count') {
    return {
      _count: 'desc'
    };
  }
  return {
    _key: sortBy
  };
}

// checks for props changes that would need to update the query via callback
var checkPropChange = function checkPropChange(prevProp, nextProp, callback) {
  if (!isEqual(prevProp, nextProp)) {
    callback();
    return true;
  }
  return false;
};

// checks for any prop change in the propsList and invokes the callback
var checkSomePropChange = function checkSomePropChange() {
  var prevProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var nextProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var propsList = arguments.length > 2 ? arguments[2] : undefined;
  var callback = arguments.length > 3 ? arguments[3] : undefined;
  propsList.some(function (prop) {
    return checkPropChange(prevProps[prop], nextProps[prop], callback);
  });
};
var getClassName = function getClassName(classMap, component) {
  return classMap && classMap[component] || '';
};
var getInnerKey = function getInnerKey(obj, key) {
  return obj && obj[key] || {};
};
var handleA11yAction = function handleA11yAction(e, callback) {
  if (e.key === 'Enter' || e.key === ' ') {
    e.preventDefault();
    callback();
  }
};
var highlightResults = function highlightResults(result) {
  var data = _objectSpread({}, result);
  if (data.highlight) {
    Object.keys(data.highlight).forEach(function (highlightItem) {
      var highlightValue = data.highlight[highlightItem][0];
      data._source = Object.assign({}, data._source, _defineProperty({}, highlightItem, highlightValue));
    });
  }
  return data;
};
var parseHits = function parseHits(hits) {
  var showHighlighted = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var results = null;
  if (hits) {
    results = _toConsumableArray(hits).map(function (item) {
      var data = _objectSpread({}, item);
      if (showHighlighted) data = highlightResults(item);
      var result = Object.keys(data).filter(function (key) {
        return key !== '_source';
      }).reduce(function (obj, key) {
        // eslint-disable-next-line
        obj[key] = data[key];
        return obj;
      }, _objectSpread({
        highlight: data.highlight || {}
      }, data._source));
      return result;
    });
  }
  return results;
};
function formatDate(date, props) {
  if (props.parseDate) {
    // We would be passing an instance of dayjs instead of xdate below. Users need to know.
    return props.parseDate(date, props);
  }
  switch (props.queryFormat) {
    case 'epoch_millis':
      return date.valueOf();
    case 'epoch_second':
      return Math.floor(date.valueOf() / 1000);
    default:
      {
        if (dateFormats[props.queryFormat]) {
          return date.format(dateFormats[props.queryFormat]);
        }
        return date.valueOf();
      }
  }
}

// Below is to convert dayjs date instance to native JS Date
function unwrapToNativeDate(wrappedDateInstance) {
  if (wrappedDateInstance) {
    return new Date(wrappedDateInstance.valueOf());
  }
  return wrappedDateInstance;
}

/**
 * To extract query options from custom or default query
 * @param {Object} customQuery
 */
var getOptionsFromQuery = function getOptionsFromQuery() {
  var customQuery = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  if (customQuery) {
    customQuery.query;
      var rest = _objectWithoutProperties(customQuery, _excluded);
    return Object.keys(rest).length ? rest : null;
  }
  return null;
};

/**
 * To extract query options from custom query
 * @param {Object} customQuery
 */
var getOptionsForCustomQuery = function getOptionsForCustomQuery() {
  var customQuery = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  if (customQuery) {
    customQuery.query;
      customQuery.id;
      customQuery.params;
      var rest = _objectWithoutProperties(customQuery, _excluded2);
    return Object.keys(rest).length ? rest : null;
  }
  return null;
};

// Returns the query key from custom query
// It handles the stored queries for Appbase which can have `id` at top-level
var extractQueryFromCustomQuery = function extractQueryFromCustomQuery(customQuery) {
  if (customQuery) {
    // handle stored queries
    if (customQuery.id) {
      return {
        id: customQuery.id,
        params: customQuery.params
      };
    }
    // else returns the query key
    return customQuery.query;
  }
  return null;
};
function computeResultStats() {
  var hits = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var searchState = arguments.length > 1 ? arguments[1] : undefined;
  var promotedResults = arguments.length > 2 ? arguments[2] : undefined;
  Object.keys(hits).forEach(function (componentId) {
    var _ref = hits[componentId] || {},
      hidden = _ref.hidden,
      total = _ref.total,
      time = _ref.time;
    // eslint-disable-next-line no-param-reassign
    searchState[componentId] = _objectSpread(_objectSpread({}, searchState[componentId]), {}, {
      resultStats: _objectSpread(_objectSpread({}, searchState[componentId].resultStats), {}, {
        numberOfResults: total,
        time: time,
        promoted: promotedResults[componentId] && promotedResults[componentId].length,
        hidden: hidden || 0
      })
    });
  });
}
var componentTypeToDefaultValue = (_componentTypeToDefau = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleList, ''), componentTypes.multiList, []), componentTypes.singleDataList, ''), componentTypes.singleDropdownList, ''), componentTypes.multiDataList, []), componentTypes.multiDropdownList, []), componentTypes.tagCloud, ''), componentTypes.toggleButton, ''), componentTypes.singleDropdownRange, ''), componentTypes.multiDropdownRange, []), _defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleRange, ''), componentTypes.multiRange, []));
var getSearchState = function getSearchState() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var forHeaders = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  var selectedValues = state.selectedValues,
    queryLog = state.queryLog,
    dependencyTree = state.dependencyTree,
    props = state.props,
    hits = state.hits,
    aggregations = state.aggregations,
    isLoading = state.isLoading,
    error = state.error,
    promotedResults = state.promotedResults,
    settings = state.settings,
    customData = state.customData,
    rawData = state.rawData;
  var searchState = {};
  var populateState = function populateState() {
    var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var key = arguments.length > 1 ? arguments[1] : undefined;
    return Object.keys(obj).forEach(function (componentId) {
      searchState[componentId] = _objectSpread(_objectSpread({}, searchState[componentId]), key ? _defineProperty({}, key, obj[componentId]) : obj[componentId]);
    });
  };
  populateState(props);
  Object.keys(selectedValues || {}).forEach(function (componentId) {
    var componentState = searchState[componentId];
    var selectedValue = selectedValues[componentId];
    var componentProps = props[componentId];
    var componentType = componentProps ? componentProps.componentType : null;
    if (selectedValue) {
      var s = _objectSpread(_objectSpread({}, componentState), _objectSpread(_objectSpread({
        title: selectedValue.label,
        componentType: selectedValue.componentType,
        value: selectedValue.value || componentTypeToDefaultValue[componentType]
      }, selectedValue.category && {
        category: selectedValue.category
      }), {}, {
        URLParams: selectedValue.URLParams
      }));
      if (Object.keys(s).length) {
        searchState[componentId] = s;
      }
    }
  });
  if (!forHeaders) {
    populateState(queryLog);
    populateState(hits, 'hits');
    populateState(aggregations, 'aggregations');
    populateState(isLoading, 'isLoading');
    populateState(error, 'error');
    populateState(promotedResults, 'promotedData');
    populateState(settings, 'settings');
    populateState(customData, 'customData');
    populateState(rawData, 'rawData');
    computeResultStats(hits, searchState, promotedResults);
  }
  populateState(dependencyTree, 'react');
  return searchState;
};
/**
 * Updates the query for the internal component
 */
var updateInternalQuery = function updateInternalQuery(componentId, queryOptions, value, props, defaultQueryToExecute, queryParams) {
  var defaultQuery = props.defaultQuery;
  var defaultQueryOptions;
  var query = defaultQueryToExecute;
  if (defaultQuery) {
    var queryTobeSet = defaultQuery(value, props);
    var _ref3 = queryTobeSet || {};
    query = _ref3.query;
    defaultQueryOptions = getOptionsFromQuery(queryTobeSet);
    // Update calculated default query in store
    updateDefaultQuery(componentId, props, value);
  }
  if (query) {
    props.setQueryOptions(componentId, _objectSpread(_objectSpread({}, defaultQueryOptions), queryOptions || defaultQueryToExecute));
    props.updateQuery(_objectSpread({
      componentId: componentId,
      query: query,
      value: value
    }, queryParams));
  } else {
    props.setQueryOptions(componentId, _objectSpread(_objectSpread({}, defaultQueryOptions), queryOptions || defaultQueryToExecute));
  }
};
// extracts query options from defaultQuery if set
var extractQueryFromDefaultQuery = function extractQueryFromDefaultQuery(props, value) {
  var queryToBeReturned = {};
  var defaultQuery = props.defaultQuery;
  /*
   do not call props.defaultQuery() directly as the client may be accessing props directly
   E.g.
   <MultiList defaultQuery={(value, props) => ({query: [props.dataField]: value})} />
  */
  if (defaultQuery) {
    var evaluateQuery = defaultQuery(value, props);
    if (evaluateQuery) {
      // we should only retrieve and set the query options here.
      // [Not implemented yet] `query` key should be handled separately for
      // adding it to `queryList` in the redux store
      evaluateQuery.query;
        var options = _objectWithoutProperties(evaluateQuery, _excluded3);
      if (options) {
        queryToBeReturned = options;
      }
    }
  }
  return queryToBeReturned;
};
var getAggsQuery = function getAggsQuery(value, query, props) {
  var clonedQuery = query;
  var dataField = props.dataField,
    size = props.size,
    sortBy = props.sortBy,
    showMissing = props.showMissing,
    missingLabel = props.missingLabel,
    aggregationSize = props.aggregationSize;
  clonedQuery.size = 0;
  if (typeof dataField === 'string') {
    clonedQuery.aggs = _defineProperty({}, dataField, {
      terms: _objectSpread({
        field: dataField,
        size: size,
        aggregationSize: aggregationSize,
        order: getAggsOrder(sortBy || 'count')
      }, showMissing ? {
        missing: missingLabel
      } : {})
    });
  } else {
    var aggs;
    _toConsumableArray(dataField).reverse().forEach(function (dataFieldItem) {
      aggs = _defineProperty({}, dataFieldItem, {
        terms: _objectSpread({
          field: dataFieldItem,
          size: size,
          aggregationSize: aggregationSize,
          order: getAggsOrder(sortBy || 'count')
        }, showMissing ? {
          missing: missingLabel
        } : {}),
        aggs: aggs
      });
    });
    clonedQuery.aggs = aggs;
  }
  if (props.nestedField) {
    clonedQuery.aggs = {
      reactivesearch_nested: {
        nested: {
          path: props.nestedField
        },
        aggs: clonedQuery.aggs
      }
    };
  }
  return _objectSpread(_objectSpread({}, clonedQuery), extractQueryFromDefaultQuery(props, value));
};
var getCompositeAggsQuery = function getCompositeAggsQuery() {
  var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    _ref4$query = _ref4.query,
    query = _ref4$query === void 0 ? {} : _ref4$query,
    props = _ref4.props,
    _ref4$after = _ref4.after,
    after = _ref4$after === void 0 ? null : _ref4$after,
    _ref4$showTopHits = _ref4.showTopHits,
    showTopHits = _ref4$showTopHits === void 0 ? false : _ref4$showTopHits,
    value = _ref4.value;
  var clonedQuery = query;
  // missing label not available in composite aggs
  var dataField = props.dataField,
    size = props.size,
    sortBy = props.sortBy,
    showMissing = props.showMissing,
    aggregationField = props.aggregationField;

  // first preference will be given to aggregationField
  var finalField = aggregationField || dataField;

  // composite aggs only allows asc and desc
  var order = sortBy === 'count' ? {} : {
    order: sortBy
  };
  clonedQuery.aggs = _defineProperty({}, finalField, _objectSpread({
    composite: _objectSpread({
      sources: [_defineProperty({}, finalField, {
        terms: _objectSpread(_objectSpread({
          field: finalField
        }, order), showMissing ? {
          missing_bucket: true
        } : {})
      })],
      size: size
    }, after)
  }, showTopHits ? {
    aggs: _defineProperty({}, finalField, {
      top_hits: {
        size: 1
      }
    })
  } : {}));
  clonedQuery.size = 0;
  if (props.nestedField) {
    clonedQuery.aggs = {
      reactivesearch_nested: {
        nested: {
          path: props.nestedField
        },
        aggs: clonedQuery.aggs
      }
    };
  }
  return _objectSpread(_objectSpread({}, clonedQuery), extractQueryFromDefaultQuery(props, value));
};
/**
 * Adds click ids in the hits(useful for trigger analytics)
 */
var withClickIds = function withClickIds() {
  var results = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return results.map(function (result, index) {
    return _objectSpread(_objectSpread({}, result), {}, {
      _click_id: index
    });
  });
};
function getResultStats(props) {
  var total = props.total,
    size = props.size,
    time = props.time,
    hidden = props.hidden,
    promotedResults = props.promotedResults;
  return _objectSpread(_objectSpread({
    numberOfResults: total
  }, size > 0 ? {
    numberOfPages: Math.ceil(total / size)
  } : null), {}, {
    time: time || 0,
    hidden: hidden,
    promoted: promotedResults ? promotedResults.length : 0
  });
}

// Util method to extract the fields from elasticsearch source object
// It can handle nested objects and arrays too.
// Example 1:
// Input: { a: 1, b: { b_1: 2, b_2: 3}}
// Output: ['a', 'b.b_1', 'b.b_2']
// Example 2:
// Input: { a: 1, b: [{c: 1}, {d: 2}, {c: 3}]}
// Output: ['a', 'b.c', 'b.d']
function extractFieldsFromSource(esSource) {
  function getFields() {
    var source = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    return Object.keys(source).reduce(function () {
      var acc = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var k = arguments.length > 1 ? arguments[1] : undefined;
      var key = prefix ? "".concat(prefix, ".").concat(k) : k;
      if (!Number.isNaN(parseInt(k, 10))) {
        key = prefix || k;
      }
      if (source[k] && _typeof(source[k]) === 'object') {
        return _objectSpread(_objectSpread({}, acc), getFields(source[k], key));
      }
      return _objectSpread(_objectSpread({}, acc), _defineProperty({}, key, true));
    }, []);
  }
  var fields = getFields(esSource);
  return Object.keys(fields);
}

// Normalizes the dataField into an array of objects
// { "field": x, "weight": y }
function normalizeDataField(dataField) {
  var fieldWeights = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  if (typeof dataField === 'string') {
    return [{
      field: dataField,
      weight: fieldWeights.length ? fieldWeights[0] : undefined
    }];
  }
  if (Array.isArray(dataField)) {
    return dataField.map(function (field, index) {
      var normalizedField = {};
      if (typeof field === 'string') {
        normalizedField.field = field;
        if (fieldWeights.length > index) {
          normalizedField.weight = fieldWeights[index];
        }
      } else if (_typeof(field) === 'object' && field && field.field) {
        normalizedField.field = field.field;
        normalizedField.weight = field.weight;
      }
      return normalizedField;
    });
  }
  if (_typeof(dataField) === 'object' && dataField) {
    return [{
      field: dataField.field,
      weight: dataField.weight
    }];
  }
  return [];
}
function handleOnSuggestions(results, currentValue, props) {
  var parseSuggestion = props.parseSuggestion,
    promotedResults = props.promotedResults,
    enablePredictiveSuggestions = props.enablePredictiveSuggestions;
  var fields = [];
  if (props.dataField) {
    fields = normalizeDataField(props.dataField).map(function (f) {
      return f.field;
    });
  } else if (results && Array.isArray(results) && results.length > 0 && results[0] && results[0]._source) {
    // Extract fields from _source
    fields = extractFieldsFromSource(results[0]._source);
  }

  // hits as flat structure
  var newResults = parseHits(results, false);
  var parsedPromotedResults = parseHits(promotedResults, false);
  if (parsedPromotedResults && parsedPromotedResults.length) {
    var ids = parsedPromotedResults.map(function (item) {
      return item._id;
    }).filter(Boolean);
    if (ids) {
      newResults = newResults.filter(function (item) {
        return !ids.includes(item._id);
      });
    }
    newResults = [].concat(_toConsumableArray(parsedPromotedResults), _toConsumableArray(newResults));
  }
  var parsedSuggestions = getSuggestions({
    fields: fields,
    suggestions: newResults,
    currentValue: currentValue.toLowerCase(),
    showDistinctSuggestions: props.showDistinctSuggestions,
    enablePredictiveSuggestions: enablePredictiveSuggestions,
    enableSynonyms: props.enableSynonyms
  });
  if (parseSuggestion) {
    return parsedSuggestions.map(function (suggestion) {
      return parseSuggestion(suggestion);
    });
  }
  return parsedSuggestions;
}
var getTopSuggestions = function getTopSuggestions(querySuggestions) {
  var currentValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var showDistinctSuggestions = arguments.length > 2 ? arguments[2] : undefined;
  var parsedSuggestions = parseHits(querySuggestions, false);
  var finalSuggestions = getSuggestions({
    fields: ['key', 'key.autosuggest', 'key.search'],
    suggestions: parsedSuggestions || [],
    currentValue: currentValue.toLowerCase(),
    showDistinctSuggestions: showDistinctSuggestions
  });
  return withClickIds(finalSuggestions);
};

/* isValidDateRangeQueryFormat() checks if the queryFormat is one of the dateFormats
	accepted by the elasticsearch or not. */
function isValidDateRangeQueryFormat(queryFormat) {
  return Object.keys(dateFormats).includes(queryFormat);
}
var suggestionTypes = {
  Popular: 'popular',
  Index: 'index',
  Recent: 'recent',
  Promoted: 'promoted',
  Featured: 'featured',
  FAQ: 'faq',
  Document: 'document'
};
var featuredSuggestionsActionTypes = {
  NAVIGATE: 'navigate',
  FUNCTION: 'function',
  SELECT: 'select'
};

// this map helps to get the interval divider
// for histogram, since the calendarinterval prop leaves
var queryFormatMillisecondsMap = {
  // the below are arranged in asscending order
  // please maintain the order if adding/ removing property(s)
  minute: 60000,
  hour: 3600000,
  day: 86400000,
  week: 604800000,
  month: 2629746000,
  quarter: 7889238000,
  year: 31556952000
};

// this function checks for subsequent calendarIntervals that would
// yield intervals well within a max cap of 100
// since displaying more than 100 bars on histogram isn't diserable
var getCalendarIntervalErrorMessage = function getCalendarIntervalErrorMessage(totalRange) {
  var calendarInterval = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'minute';
  var queryFormatMillisecondsMapKeys = Object.keys(queryFormatMillisecondsMap);
  var indexOfCurrentCalendarInterval = queryFormatMillisecondsMapKeys.indexOf(calendarInterval);
  if (indexOfCurrentCalendarInterval === -1) {
    console.error('Invalid calendarInterval Passed');
  }
  if (calendarInterval === 'year') {
    return 'Try using a shorter range of values.';
  }
  for (var index = indexOfCurrentCalendarInterval + 1; index < queryFormatMillisecondsMapKeys.length; index += 1) {
    if (totalRange / Object.values(queryFormatMillisecondsMap)[index] <= 100) {
      var calendarIntervalKey = queryFormatMillisecondsMapKeys[index];
      return {
        errorMessage: "Please pass calendarInterval prop with value greater than or equal to a `".concat(calendarIntervalKey, "` for a meaningful resolution of histogram."),
        calculatedCalendarInterval: calendarIntervalKey
      };
    }
  }
  return {
    errorMessage: 'Try using a shorter range of values.',
    calculatedCalendarInterval: 'year'
  }; // we return the highest possible interval to shorten then interval value
};
/**
 * To determine wether an element is a function
 * @param {any} element
 */
var isFunction = function isFunction(element) {
  return typeof element === 'function';
};

/**
 * Extracts the render prop from props and returns a valid React element
 * @param {Object} data
 * @param {Object} props
 */
var getComponent = function getComponent() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var children = props.children,
    render = props.render;
  // Render function as child
  if (isFunction(children)) {
    return children(data);
  }
  // Render function as render prop
  if (isFunction(render)) {
    return render(data);
  }
  return null;
};
/**
 * To determine whether a component has render prop defined or not
 * @returns {Boolean}
 */
var hasCustomRenderer = function hasCustomRenderer() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var render = props.render,
    children = props.children;
  return isFunction(children) || isFunction(render);
};

/**
 * Recursively look for a path in a nested object
 */
var recLookup = function recLookup(obj, path) {
  var separator = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '.';
  try {
    var parts = path.split(separator);
    if (parts.length === 1) {
      return obj[parts[0]];
    }
    return recLookup(obj[parts[0]], parts.slice(1).join(separator), separator);
  } catch (e) {
    return false;
  }
};

/**
 * Dynamically sets a deeply nested value in an object.
 * has been modified to comply with TreeList component implementation
 * https://stackoverflow.com/a/49754647/10822996
 */
function setDeep(obj, path, value) {
  var setrecursively = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  path.reduce(function (acc, currentItem, level) {
    if (setrecursively && _typeof(acc[currentItem]) !== 'object' && level !== path.length - 1) {
      acc[currentItem] = {};
      return acc[currentItem];
    }
    if (level === path.length - 1) {
      acc[currentItem] = value;
      return value;
    }
    return _typeof(acc[currentItem]) === 'object' ? acc[currentItem] : {};
  }, obj);
}

// transforms rawData into local state
// [
// 	{
// 		key: 'COMPACT DISC',
// 		count: 70654,
// 		level: 0,
// 		list: [
// 			{
// 				key: 'VINYL',
// 				count: 69731,
// 				level: 1,
// 				list: [
// 					{
// 						key: 'SPORTS & FITNESS',
// 						count: 12553,
// 						level: 2,
// 					},
// 				],
// 			},
// 		],
// 	},
// ];
// ⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️
// [
//     {
//         "key": "COMPACT DISC",
//         "count": 70654,
//         "level": 0,
//         "list": [
//             {
//                 "key": "VINYL",
//                 "count": 69731,
//                 "level": 1,
//                 "list": [
//                     {
//                         "key": "SPORTS & FITNESS",
//                         "count": 12553,
//                         "level": 2
//                     }
//                 ]
//             }
//         ]
//     }
// ]
var transformRawTreeListData = function transformRawTreeListData(data, dataField) {
  var level = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var newState = [];
  if (data instanceof Object) {
    var aggsKeys = Object.keys(data);
    aggsKeys.forEach(function (key) {
      if (Array.isArray(data[key].buckets)) {
        data[key].buckets.forEach(function (bucket) {
          newState.push(_objectSpread({
            key: bucket.key,
            count: bucket.doc_count,
            level: level
          }, bucket[dataField[level + 1]] instanceof Object ? {
            list: transformRawTreeListData(_defineProperty({}, dataField[level + 1], bucket[dataField[level + 1]]), dataField, level + 1)
          } : {}));
        });
      }
    });
  }
  return newState;
};

// transforms local selected data into query compatible format
// const object = {
//   "COMPACT DISC": {
//     "VINYL": {
//       "DRAMA/DR": true,
//       "MUSIC DVD": true,
//       "CHILDRENS-FAMILY": false
//     },
//     "MUSIC DVD": true,
//     "ROCK-ELECTRONIC": true
//   }
// };
// ⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️
// [
//     "COMPACT DISC > VINYL > DRAMA/DR",
//     "COMPACT DISC > VINYL > MUSIC DVD",
//     "COMPACT DISC > MUSIC DVD",
//     "COMPACT DISC > ROCK-ELECTRONIC"
// ]
var transformTreeListLocalStateIntoQueryComptaibleFormat = function transformTreeListLocalStateIntoQueryComptaibleFormat(obj) {
  var currentPath = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var result = [];
  if (obj instanceof Object) {
    if (Object.keys(obj).length) {
      Object.keys(obj).forEach(function (key) {
        if (obj[key] instanceof Object) {
          result.push.apply(result, _toConsumableArray(transformTreeListLocalStateIntoQueryComptaibleFormat(obj[key], currentPath ? "".concat(currentPath, " > ").concat(key) : key)));
        }
        if (obj[key] === true) {
          result.push(currentPath ? "".concat(currentPath, " > ").concat(key) : key);
        }
      });
    } else if (currentPath) {
      result.push(currentPath);
    }
  }
  return result;
};

// https://stackoverflow.com/a/65939108/10822996
var saveDataAsFile = function saveDataAsFile() {
  var filename = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'exportedData';
  var data = arguments.length > 1 ? arguments[1] : undefined;
  var format = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'csv';
  var dataToWrite = data;
  var dataType = "text/".concat(format);
  if (format === 'json') {
    dataToWrite = JSON.stringify(dataToWrite, 0, 4);
  }
  var blob = new Blob([dataToWrite], {
    type: dataType
  });
  var link = document.createElement('a');
  link.download = "".concat(filename, ".").concat(format);
  link.href = window.URL.createObjectURL(blob);
  link.dataset.downloadurl = [dataType, link.download, link.href].join(':');
  var evt = new MouseEvent('click', {
    view: window,
    bubbles: true,
    cancelable: true
  });
  link.dispatchEvent(evt);
  link.remove();
};

/**
 * A function to convert multilevel object to single level object
 * and use key value pairs as Column and row pairs using recursion
 */
var flatten = function flatten(data) {
  var result = {};
  function recurse(cur) {
    var prop = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    if (Object(cur) !== cur) {
      result[prop] = cur;
    } else if (Array.isArray(cur)) {
      result[prop] = JSON.stringify(cur);
    } else {
      var isEmpty = true;
      Object.keys(cur).forEach(function (p) {
        isEmpty = false;
        recurse(cur[p], prop ? "".concat(prop, ".").concat(p) : p);
      });
      if (isEmpty && prop) {
        result[prop] = {};
      }
    }
  }
  recurse(data);
  return result;
};

// transform request when endpoint prop is defined
var transformRequestUsingEndpoint = function transformRequestUsingEndpoint(request, endpointParam) {
  if (endpointParam instanceof Object) {
    var _endpointParam$header = endpointParam.headers,
      headers = _endpointParam$header === void 0 ? {} : _endpointParam$header,
      body = endpointParam.body,
      rest = _objectWithoutProperties(endpointParam, _excluded4);
    var endpointModifiedRequest = _objectSpread(_objectSpread(_objectSpread({}, request), rest), {}, {
      headers: _objectSpread(_objectSpread({}, request.headers), headers)
    }, body instanceof Object ? {
      body: JSON.stringify(body)
    } : {});
    return endpointModifiedRequest;
  }
  return request;
};

// utils/localStorage.js

var setObjectInLocalStorage = function setObjectInLocalStorage(key, value) {
  if (typeof localStorage !== 'undefined') {
    if (!key || !value) {
      throw new Error('Key and value are required for setObject');
    }
    try {
      var serializedValue = JSON.stringify(value);
      localStorage.setItem(key, serializedValue);
    } catch (error) {
      console.error('Error saving object to localStorage:', error);
    }
  } else {
    console.warn('localstorage not available');
  }
};
var getObjectFromLocalStorage = function getObjectFromLocalStorage(key) {
  if (!key) {
    throw new Error('Key is required for getObject');
  }
  try {
    var serializedValue = localStorage.getItem(key);
    if (serializedValue === null) {
      return null;
    }
    return JSON.parse(serializedValue);
  } catch (error) {
    console.error('Error retrieving object from localStorage:', error);
    return null;
  }
};

// handle converting to valid color strings in hex, rgb, rgba, hsl, and hsla formats
// useful for styles impl. using darken function from 'polished' package

var isHex = function isHex(color) {
  return /^#([A-Fa-f0-9]{3,4}){1,2}$/.test(color);
};
var isRgb = function isRgb(color) {
  return /^rgb\((\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3})\)$/.test(color);
};
var isRgba = function isRgba(color) {
  return /^rgba\((\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3}),\s*(0|1|0\.\d{1,2})\)$/.test(color);
};
var isHsl = function isHsl(color) {
  return /^hsl\(\d{1,3},\s*[\d.]+%,\s*[\d.]+%\)$/.test(color);
};
var isHsla = function isHsla(color) {
  return /^hsla\(\d{1,3},\s*[\d.]+%,\s*[\d.]+%,\s*(0|1|0\.\d{1,2})\)$/.test(color);
};
var hexToRGBA = function hexToRGBA(colorParam) {
  if (isRgb(colorParam) || isRgba(colorParam) || isHsl(colorParam) || isHsla(colorParam)) {
    return colorParam;
  }
  if (!isHex(colorParam)) {
    return null;
  }
  var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])([a-f\d])?$/i;
  var color = colorParam.replace(shorthandRegex, function (m, r, g, b, a) {
    return r + r + g + g + b + b + (a ? a + a : '');
  });
  var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})?$/i.exec(color);
  if (!result) {
    return null;
  }
  var r = parseInt(result[1], 16);
  var g = parseInt(result[2], 16);
  var b = parseInt(result[3], 16);
  var a = result[4] ? parseInt(result[4], 16) / 255 : 1;
  return "rgba(".concat(r, ", ").concat(g, ", ").concat(b, ", ").concat(a, ")");
};

// Just for debuggin
// Call this function inside the function for which
// a stack trace is needed
function getStackTrace() {
  var error = new Error();
  // eslint-disable-next-line no-console
  console.log(error.stack);
}

exports.buildQuery = buildQuery;
exports.checkPropChange = checkPropChange;
exports.checkSomePropChange = checkSomePropChange;
exports.checkValueChange = checkValueChange;
exports.compareQueries = compareQueries;
exports.componentTypeToDefaultValue = componentTypeToDefaultValue;
exports.debounce = debounce;
exports.extractFieldsFromSource = extractFieldsFromSource;
exports.extractQueryFromCustomQuery = extractQueryFromCustomQuery;
exports.extractQueryFromDefaultQuery = extractQueryFromDefaultQuery;
exports.featuredSuggestionsActionTypes = featuredSuggestionsActionTypes;
exports.flatten = flatten;
exports.formatDate = formatDate;
exports.getAggsOrder = getAggsOrder;
exports.getAggsQuery = getAggsQuery;
exports.getCalendarIntervalErrorMessage = getCalendarIntervalErrorMessage;
exports.getClassName = getClassName;
exports.getComponent = getComponent;
exports.getCompositeAggsQuery = getCompositeAggsQuery;
exports.getInnerKey = getInnerKey;
exports.getObjectFromLocalStorage = getObjectFromLocalStorage;
exports.getOptionsForCustomQuery = getOptionsForCustomQuery;
exports.getOptionsFromQuery = getOptionsFromQuery;
exports.getQueryOptions = getQueryOptions;
exports.getResultStats = getResultStats;
exports.getSearchState = getSearchState;
exports.getStackTrace = getStackTrace;
exports.getTopSuggestions = getTopSuggestions;
exports.handleA11yAction = handleA11yAction;
exports.handleOnSuggestions = handleOnSuggestions;
exports.hasCustomRenderer = hasCustomRenderer;
exports.hexToRGBA = hexToRGBA;
exports.isEqual = isEqual;
exports.isFunction = isFunction;
exports.isValidDateRangeQueryFormat = isValidDateRangeQueryFormat;
exports.normalizeDataField = normalizeDataField;
exports.parseHits = parseHits;
exports.pushToAndClause = pushToAndClause;
exports.queryFormatMillisecondsMap = queryFormatMillisecondsMap;
exports.recLookup = recLookup;
exports.saveDataAsFile = saveDataAsFile;
exports.setDeep = setDeep;
exports.setObjectInLocalStorage = setObjectInLocalStorage;
exports.suggestionTypes = suggestionTypes;
exports.transformRawTreeListData = transformRawTreeListData;
exports.transformRequestUsingEndpoint = transformRequestUsingEndpoint;
exports.transformTreeListLocalStateIntoQueryComptaibleFormat = transformTreeListLocalStateIntoQueryComptaibleFormat;
exports.unwrapToNativeDate = unwrapToNativeDate;
exports.updateCustomQuery = updateCustomQuery;
exports.updateDefaultQuery = updateDefaultQuery;
exports.updateInternalQuery = updateInternalQuery;
exports.withClickIds = withClickIds;
