'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _typeof(o) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
    return typeof o;
  } : function (o) {
    return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, _typeof(o);
}

function toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}

function toPropertyKey(t) {
  var i = toPrimitive(t, "string");
  return "symbol" == _typeof(i) ? i : String(i);
}

function _defineProperty(obj, key, value) {
  key = toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

function ownKeys$I(e, r) {
  var t = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    r && (o = o.filter(function (r) {
      return Object.getOwnPropertyDescriptor(e, r).enumerable;
    })), t.push.apply(t, o);
  }
  return t;
}
function _objectSpread2(e) {
  for (var r = 1; r < arguments.length; r++) {
    var t = null != arguments[r] ? arguments[r] : {};
    r % 2 ? ownKeys$I(Object(t), !0).forEach(function (r) {
      _defineProperty(e, r, t[r]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$I(Object(t)).forEach(function (r) {
      Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r));
    });
  }
  return e;
}

/**
 * Adapted from React: https://github.com/facebook/react/blob/master/packages/shared/formatProdErrorMessage.js
 *
 * Do not require this module directly! Use normal throw error calls. These messages will be replaced with error codes
 * during build.
 * @param {number} code
 */
function formatProdErrorMessage(code) {
  return "Minified Redux error #" + code + "; visit https://redux.js.org/Errors?code=" + code + " for the full message or " + 'use the non-minified dev environment for full errors. ';
}

// Inlined version of the `symbol-observable` polyfill
var $$observable = function () {
  return typeof Symbol === 'function' && Symbol.observable || '@@observable';
}();

/**
 * These are private action types reserved by Redux.
 * For any unknown actions, you must return the current state.
 * If the current state is undefined, you must return the initial state.
 * Do not reference these action types directly in your code.
 */
var randomString = function randomString() {
  return Math.random().toString(36).substring(7).split('').join('.');
};
var ActionTypes = {
  INIT: "@@redux/INIT" + randomString(),
  REPLACE: "@@redux/REPLACE" + randomString(),
  PROBE_UNKNOWN_ACTION: function PROBE_UNKNOWN_ACTION() {
    return "@@redux/PROBE_UNKNOWN_ACTION" + randomString();
  }
};

/**
 * @param {any} obj The object to inspect.
 * @returns {boolean} True if the argument appears to be a plain object.
 */
function isPlainObject(obj) {
  if (_typeof(obj) !== 'object' || obj === null) return false;
  var proto = obj;
  while (Object.getPrototypeOf(proto) !== null) {
    proto = Object.getPrototypeOf(proto);
  }
  return Object.getPrototypeOf(obj) === proto;
}

// Inlined / shortened version of `kindOf` from https://github.com/jonschlinkert/kind-of
function miniKindOf(val) {
  if (val === void 0) return 'undefined';
  if (val === null) return 'null';
  var type = _typeof(val);
  switch (type) {
    case 'boolean':
    case 'string':
    case 'number':
    case 'symbol':
    case 'function':
      {
        return type;
      }
  }
  if (Array.isArray(val)) return 'array';
  if (isDate(val)) return 'date';
  if (isError(val)) return 'error';
  var constructorName = ctorName(val);
  switch (constructorName) {
    case 'Symbol':
    case 'Promise':
    case 'WeakMap':
    case 'WeakSet':
    case 'Map':
    case 'Set':
      return constructorName;
  } // other

  return type.slice(8, -1).toLowerCase().replace(/\s/g, '');
}
function ctorName(val) {
  return typeof val.constructor === 'function' ? val.constructor.name : null;
}
function isError(val) {
  return val instanceof Error || typeof val.message === 'string' && val.constructor && typeof val.constructor.stackTraceLimit === 'number';
}
function isDate(val) {
  if (val instanceof Date) return true;
  return typeof val.toDateString === 'function' && typeof val.getDate === 'function' && typeof val.setDate === 'function';
}
function kindOf(val) {
  var typeOfVal = _typeof(val);
  if (process.env.NODE_ENV !== 'production') {
    typeOfVal = miniKindOf(val);
  }
  return typeOfVal;
}

/**
 * @deprecated
 *
 * **We recommend using the `configureStore` method
 * of the `@reduxjs/toolkit` package**, which replaces `createStore`.
 *
 * Redux Toolkit is our recommended approach for writing Redux logic today,
 * including store setup, reducers, data fetching, and more.
 *
 * **For more details, please read this Redux docs page:**
 * **https://redux.js.org/introduction/why-rtk-is-redux-today**
 *
 * `configureStore` from Redux Toolkit is an improved version of `createStore` that
 * simplifies setup and helps avoid common bugs.
 *
 * You should not be using the `redux` core package by itself today, except for learning purposes.
 * The `createStore` method from the core `redux` package will not be removed, but we encourage
 * all users to migrate to using Redux Toolkit for all Redux code.
 *
 * If you want to use `createStore` without this visual deprecation warning, use
 * the `legacy_createStore` import instead:
 *
 * `import { legacy_createStore as createStore} from 'redux'`
 *
 */

function createStore(reducer, preloadedState, enhancer) {
  var _ref2;
  if (typeof preloadedState === 'function' && typeof enhancer === 'function' || typeof enhancer === 'function' && typeof arguments[3] === 'function') {
    throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(0) : 'It looks like you are passing several store enhancers to ' + 'createStore(). This is not supported. Instead, compose them ' + 'together to a single function. See https://redux.js.org/tutorials/fundamentals/part-4-store#creating-a-store-with-enhancers for an example.');
  }
  if (typeof preloadedState === 'function' && typeof enhancer === 'undefined') {
    enhancer = preloadedState;
    preloadedState = undefined;
  }
  if (typeof enhancer !== 'undefined') {
    if (typeof enhancer !== 'function') {
      throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(1) : "Expected the enhancer to be a function. Instead, received: '" + kindOf(enhancer) + "'");
    }
    return enhancer(createStore)(reducer, preloadedState);
  }
  if (typeof reducer !== 'function') {
    throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(2) : "Expected the root reducer to be a function. Instead, received: '" + kindOf(reducer) + "'");
  }
  var currentReducer = reducer;
  var currentState = preloadedState;
  var currentListeners = [];
  var nextListeners = currentListeners;
  var isDispatching = false;
  /**
   * This makes a shallow copy of currentListeners so we can use
   * nextListeners as a temporary list while dispatching.
   *
   * This prevents any bugs around consumers calling
   * subscribe/unsubscribe in the middle of a dispatch.
   */

  function ensureCanMutateNextListeners() {
    if (nextListeners === currentListeners) {
      nextListeners = currentListeners.slice();
    }
  }
  /**
   * Reads the state tree managed by the store.
   *
   * @returns {any} The current state tree of your application.
   */

  function getState() {
    if (isDispatching) {
      throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(3) : 'You may not call store.getState() while the reducer is executing. ' + 'The reducer has already received the state as an argument. ' + 'Pass it down from the top reducer instead of reading it from the store.');
    }
    return currentState;
  }
  /**
   * Adds a change listener. It will be called any time an action is dispatched,
   * and some part of the state tree may potentially have changed. You may then
   * call `getState()` to read the current state tree inside the callback.
   *
   * You may call `dispatch()` from a change listener, with the following
   * caveats:
   *
   * 1. The subscriptions are snapshotted just before every `dispatch()` call.
   * If you subscribe or unsubscribe while the listeners are being invoked, this
   * will not have any effect on the `dispatch()` that is currently in progress.
   * However, the next `dispatch()` call, whether nested or not, will use a more
   * recent snapshot of the subscription list.
   *
   * 2. The listener should not expect to see all state changes, as the state
   * might have been updated multiple times during a nested `dispatch()` before
   * the listener is called. It is, however, guaranteed that all subscribers
   * registered before the `dispatch()` started will be called with the latest
   * state by the time it exits.
   *
   * @param {Function} listener A callback to be invoked on every dispatch.
   * @returns {Function} A function to remove this change listener.
   */

  function subscribe(listener) {
    if (typeof listener !== 'function') {
      throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(4) : "Expected the listener to be a function. Instead, received: '" + kindOf(listener) + "'");
    }
    if (isDispatching) {
      throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(5) : 'You may not call store.subscribe() while the reducer is executing. ' + 'If you would like to be notified after the store has been updated, subscribe from a ' + 'component and invoke store.getState() in the callback to access the latest state. ' + 'See https://redux.js.org/api/store#subscribelistener for more details.');
    }
    var isSubscribed = true;
    ensureCanMutateNextListeners();
    nextListeners.push(listener);
    return function unsubscribe() {
      if (!isSubscribed) {
        return;
      }
      if (isDispatching) {
        throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(6) : 'You may not unsubscribe from a store listener while the reducer is executing. ' + 'See https://redux.js.org/api/store#subscribelistener for more details.');
      }
      isSubscribed = false;
      ensureCanMutateNextListeners();
      var index = nextListeners.indexOf(listener);
      nextListeners.splice(index, 1);
      currentListeners = null;
    };
  }
  /**
   * Dispatches an action. It is the only way to trigger a state change.
   *
   * The `reducer` function, used to create the store, will be called with the
   * current state tree and the given `action`. Its return value will
   * be considered the **next** state of the tree, and the change listeners
   * will be notified.
   *
   * The base implementation only supports plain object actions. If you want to
   * dispatch a Promise, an Observable, a thunk, or something else, you need to
   * wrap your store creating function into the corresponding middleware. For
   * example, see the documentation for the `redux-thunk` package. Even the
   * middleware will eventually dispatch plain object actions using this method.
   *
   * @param {Object} action A plain object representing “what changed”. It is
   * a good idea to keep actions serializable so you can record and replay user
   * sessions, or use the time travelling `redux-devtools`. An action must have
   * a `type` property which may not be `undefined`. It is a good idea to use
   * string constants for action types.
   *
   * @returns {Object} For convenience, the same action object you dispatched.
   *
   * Note that, if you use a custom middleware, it may wrap `dispatch()` to
   * return something else (for example, a Promise you can await).
   */

  function dispatch(action) {
    if (!isPlainObject(action)) {
      throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(7) : "Actions must be plain objects. Instead, the actual type was: '" + kindOf(action) + "'. You may need to add middleware to your store setup to handle dispatching other values, such as 'redux-thunk' to handle dispatching functions. See https://redux.js.org/tutorials/fundamentals/part-4-store#middleware and https://redux.js.org/tutorials/fundamentals/part-6-async-logic#using-the-redux-thunk-middleware for examples.");
    }
    if (typeof action.type === 'undefined') {
      throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(8) : 'Actions may not have an undefined "type" property. You may have misspelled an action type string constant.');
    }
    if (isDispatching) {
      throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(9) : 'Reducers may not dispatch actions.');
    }
    try {
      isDispatching = true;
      currentState = currentReducer(currentState, action);
    } finally {
      isDispatching = false;
    }
    var listeners = currentListeners = nextListeners;
    for (var i = 0; i < listeners.length; i++) {
      var listener = listeners[i];
      listener();
    }
    return action;
  }
  /**
   * Replaces the reducer currently used by the store to calculate the state.
   *
   * You might need this if your app implements code splitting and you want to
   * load some of the reducers dynamically. You might also need this if you
   * implement a hot reloading mechanism for Redux.
   *
   * @param {Function} nextReducer The reducer for the store to use instead.
   * @returns {void}
   */

  function replaceReducer(nextReducer) {
    if (typeof nextReducer !== 'function') {
      throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(10) : "Expected the nextReducer to be a function. Instead, received: '" + kindOf(nextReducer));
    }
    currentReducer = nextReducer; // This action has a similiar effect to ActionTypes.INIT.
    // Any reducers that existed in both the new and old rootReducer
    // will receive the previous state. This effectively populates
    // the new state tree with any relevant data from the old one.

    dispatch({
      type: ActionTypes.REPLACE
    });
  }
  /**
   * Interoperability point for observable/reactive libraries.
   * @returns {observable} A minimal observable of state changes.
   * For more information, see the observable proposal:
   * https://github.com/tc39/proposal-observable
   */

  function observable() {
    var _ref;
    var outerSubscribe = subscribe;
    return _ref = {
      /**
       * The minimal observable subscription method.
       * @param {Object} observer Any object that can be used as an observer.
       * The observer object should have a `next` method.
       * @returns {subscription} An object with an `unsubscribe` method that can
       * be used to unsubscribe the observable from the store, and prevent further
       * emission of values from the observable.
       */
      subscribe: function subscribe(observer) {
        if (_typeof(observer) !== 'object' || observer === null) {
          throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(11) : "Expected the observer to be an object. Instead, received: '" + kindOf(observer) + "'");
        }
        function observeState() {
          if (observer.next) {
            observer.next(getState());
          }
        }
        observeState();
        var unsubscribe = outerSubscribe(observeState);
        return {
          unsubscribe: unsubscribe
        };
      }
    }, _ref[$$observable] = function () {
      return this;
    }, _ref;
  } // When a store is created, an "INIT" action is dispatched so that every
  // reducer returns their initial state. This effectively populates
  // the initial state tree.

  dispatch({
    type: ActionTypes.INIT
  });
  return _ref2 = {
    dispatch: dispatch,
    subscribe: subscribe,
    getState: getState,
    replaceReducer: replaceReducer
  }, _ref2[$$observable] = observable, _ref2;
}

/**
 * Prints a warning in the console if it exists.
 *
 * @param {String} message The warning message.
 * @returns {void}
 */
function warning(message) {
  /* eslint-disable no-console */
  if (typeof console !== 'undefined' && typeof console.error === 'function') {
    console.error(message);
  }
  /* eslint-enable no-console */

  try {
    // This error was thrown as a convenience so that if you enable
    // "break on all exceptions" in your console,
    // it would pause the execution at this line.
    throw new Error(message);
  } catch (e) {} // eslint-disable-line no-empty
}
function getUnexpectedStateShapeWarningMessage(inputState, reducers, action, unexpectedKeyCache) {
  var reducerKeys = Object.keys(reducers);
  var argumentName = action && action.type === ActionTypes.INIT ? 'preloadedState argument passed to createStore' : 'previous state received by the reducer';
  if (reducerKeys.length === 0) {
    return 'Store does not have a valid reducer. Make sure the argument passed ' + 'to combineReducers is an object whose values are reducers.';
  }
  if (!isPlainObject(inputState)) {
    return "The " + argumentName + " has unexpected type of \"" + kindOf(inputState) + "\". Expected argument to be an object with the following " + ("keys: \"" + reducerKeys.join('", "') + "\"");
  }
  var unexpectedKeys = Object.keys(inputState).filter(function (key) {
    return !reducers.hasOwnProperty(key) && !unexpectedKeyCache[key];
  });
  unexpectedKeys.forEach(function (key) {
    unexpectedKeyCache[key] = true;
  });
  if (action && action.type === ActionTypes.REPLACE) return;
  if (unexpectedKeys.length > 0) {
    return "Unexpected " + (unexpectedKeys.length > 1 ? 'keys' : 'key') + " " + ("\"" + unexpectedKeys.join('", "') + "\" found in " + argumentName + ". ") + "Expected to find one of the known reducer keys instead: " + ("\"" + reducerKeys.join('", "') + "\". Unexpected keys will be ignored.");
  }
}
function assertReducerShape(reducers) {
  Object.keys(reducers).forEach(function (key) {
    var reducer = reducers[key];
    var initialState = reducer(undefined, {
      type: ActionTypes.INIT
    });
    if (typeof initialState === 'undefined') {
      throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(12) : "The slice reducer for key \"" + key + "\" returned undefined during initialization. " + "If the state passed to the reducer is undefined, you must " + "explicitly return the initial state. The initial state may " + "not be undefined. If you don't want to set a value for this reducer, " + "you can use null instead of undefined.");
    }
    if (typeof reducer(undefined, {
      type: ActionTypes.PROBE_UNKNOWN_ACTION()
    }) === 'undefined') {
      throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(13) : "The slice reducer for key \"" + key + "\" returned undefined when probed with a random type. " + ("Don't try to handle '" + ActionTypes.INIT + "' or other actions in \"redux/*\" ") + "namespace. They are considered private. Instead, you must return the " + "current state for any unknown actions, unless it is undefined, " + "in which case you must return the initial state, regardless of the " + "action type. The initial state may not be undefined, but can be null.");
    }
  });
}
/**
 * Turns an object whose values are different reducer functions, into a single
 * reducer function. It will call every child reducer, and gather their results
 * into a single state object, whose keys correspond to the keys of the passed
 * reducer functions.
 *
 * @param {Object} reducers An object whose values correspond to different
 * reducer functions that need to be combined into one. One handy way to obtain
 * it is to use ES6 `import * as reducers` syntax. The reducers may never return
 * undefined for any action. Instead, they should return their initial state
 * if the state passed to them was undefined, and the current state for any
 * unrecognized action.
 *
 * @returns {Function} A reducer function that invokes every reducer inside the
 * passed object, and builds a state object with the same shape.
 */

function combineReducers(reducers) {
  var reducerKeys = Object.keys(reducers);
  var finalReducers = {};
  for (var i = 0; i < reducerKeys.length; i++) {
    var key = reducerKeys[i];
    if (process.env.NODE_ENV !== 'production') {
      if (typeof reducers[key] === 'undefined') {
        warning("No reducer provided for key \"" + key + "\"");
      }
    }
    if (typeof reducers[key] === 'function') {
      finalReducers[key] = reducers[key];
    }
  }
  var finalReducerKeys = Object.keys(finalReducers); // This is used to make sure we don't warn about the same
  // keys multiple times.

  var unexpectedKeyCache;
  if (process.env.NODE_ENV !== 'production') {
    unexpectedKeyCache = {};
  }
  var shapeAssertionError;
  try {
    assertReducerShape(finalReducers);
  } catch (e) {
    shapeAssertionError = e;
  }
  return function combination(state, action) {
    if (state === void 0) {
      state = {};
    }
    if (shapeAssertionError) {
      throw shapeAssertionError;
    }
    if (process.env.NODE_ENV !== 'production') {
      var warningMessage = getUnexpectedStateShapeWarningMessage(state, finalReducers, action, unexpectedKeyCache);
      if (warningMessage) {
        warning(warningMessage);
      }
    }
    var hasChanged = false;
    var nextState = {};
    for (var _i = 0; _i < finalReducerKeys.length; _i++) {
      var _key = finalReducerKeys[_i];
      var reducer = finalReducers[_key];
      var previousStateForKey = state[_key];
      var nextStateForKey = reducer(previousStateForKey, action);
      if (typeof nextStateForKey === 'undefined') {
        var actionType = action && action.type;
        throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(14) : "When called with an action of type " + (actionType ? "\"" + String(actionType) + "\"" : '(unknown type)') + ", the slice reducer for key \"" + _key + "\" returned undefined. " + "To ignore an action, you must explicitly return the previous state. " + "If you want this reducer to hold no value, you can return null instead of undefined.");
      }
      nextState[_key] = nextStateForKey;
      hasChanged = hasChanged || nextStateForKey !== previousStateForKey;
    }
    hasChanged = hasChanged || finalReducerKeys.length !== Object.keys(state).length;
    return hasChanged ? nextState : state;
  };
}

/**
 * Composes single-argument functions from right to left. The rightmost
 * function can take multiple arguments as it provides the signature for
 * the resulting composite function.
 *
 * @param {...Function} funcs The functions to compose.
 * @returns {Function} A function obtained by composing the argument functions
 * from right to left. For example, compose(f, g, h) is identical to doing
 * (...args) => f(g(h(...args))).
 */
function compose() {
  for (var _len = arguments.length, funcs = new Array(_len), _key = 0; _key < _len; _key++) {
    funcs[_key] = arguments[_key];
  }
  if (funcs.length === 0) {
    return function (arg) {
      return arg;
    };
  }
  if (funcs.length === 1) {
    return funcs[0];
  }
  return funcs.reduce(function (a, b) {
    return function () {
      return a(b.apply(void 0, arguments));
    };
  });
}

/**
 * Creates a store enhancer that applies middleware to the dispatch method
 * of the Redux store. This is handy for a variety of tasks, such as expressing
 * asynchronous actions in a concise manner, or logging every action payload.
 *
 * See `redux-thunk` package as an example of the Redux middleware.
 *
 * Because middleware is potentially asynchronous, this should be the first
 * store enhancer in the composition chain.
 *
 * Note that each middleware will be given the `dispatch` and `getState` functions
 * as named arguments.
 *
 * @param {...Function} middlewares The middleware chain to be applied.
 * @returns {Function} A store enhancer applying the middleware.
 */

function applyMiddleware() {
  for (var _len = arguments.length, middlewares = new Array(_len), _key = 0; _key < _len; _key++) {
    middlewares[_key] = arguments[_key];
  }
  return function (createStore) {
    return function () {
      var store = createStore.apply(void 0, arguments);
      var _dispatch = function dispatch() {
        throw new Error(process.env.NODE_ENV === "production" ? formatProdErrorMessage(15) : 'Dispatching while constructing your middleware is not allowed. ' + 'Other middleware would not be applied to this dispatch.');
      };
      var middlewareAPI = {
        getState: store.getState,
        dispatch: function dispatch() {
          return _dispatch.apply(void 0, arguments);
        }
      };
      var chain = middlewares.map(function (middleware) {
        return middleware(middlewareAPI);
      });
      _dispatch = compose.apply(void 0, chain)(store.dispatch);
      return _objectSpread2(_objectSpread2({}, store), {}, {
        dispatch: _dispatch
      });
    };
  };
}

/** A function that accepts a potential "extra argument" value to be injected later,
 * and returns an instance of the thunk middleware that uses that value
 */
function createThunkMiddleware(extraArgument) {
  // Standard Redux middleware definition pattern:
  // See: https://redux.js.org/tutorials/fundamentals/part-4-store#writing-custom-middleware
  var middleware = function middleware(_ref) {
    var dispatch = _ref.dispatch,
      getState = _ref.getState;
    return function (next) {
      return function (action) {
        // The thunk middleware looks for any functions that were passed to `store.dispatch`.
        // If this "action" is really a function, call it and return the result.
        if (typeof action === 'function') {
          // Inject the store's `dispatch` and `getState` methods, as well as any "extra arg"
          return action(dispatch, getState, extraArgument);
        } // Otherwise, pass the action down the middleware chain as usual

        return next(action);
      };
    };
  };
  return middleware;
}
var thunk = createThunkMiddleware(); // Attach the factory function so users can create a customized version
// with whatever "extra arg" they want to inject into their thunks

thunk.withExtraArgument = createThunkMiddleware;
var thunk$1 = thunk;

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

var ADD_COMPONENT = 'ADD_COMPONENT';
var REMOVE_COMPONENT = 'REMOVE_COMPONENT';
var WATCH_COMPONENT = 'WATCH_COMPONENT';
var SET_QUERY = 'SET_QUERY';
var SET_APPBASE_QUERY = 'SET_APPBASE_QUERY';
var SET_QUERY_OPTIONS = 'SET_QUERY_OPTIONS';
var UPDATE_HITS = 'UPDATE_HITS';
var UPDATE_AGGS = 'UPDATE_AGGS';
var UPDATE_COMPOSITE_AGGS = 'UPDATE_COMPOSITE_AGGS';
var ADD_CONFIG = 'ADD_CONFIG';
var UPDATE_CONFIG = 'UPDATE_CONFIG';
var ADD_APPBASE_REF = 'ADD_APPBASE_REF';
var ADD_ANALYTICS_REF = 'ADD_ANALYTICS_REF';
var LOG_QUERY = 'LOG_QUERY';
var LOG_COMBINED_QUERY = 'LOG_COMBINED_QUERY';
var SET_INTERNAL_VALUE = 'SET_INTERNAL_VALUE';
var PATCH_VALUE = 'PATCH_VALUE';
var CLEAR_VALUES = 'CLEAR_VALUES';
var SET_LOADING = 'SET_LOADING';
var SET_ERROR = 'SET_ERROR';
var SET_TIMESTAMP = 'SET_TIMESTAMP';
var SET_HEADERS = 'SET_HEADERS';
var SET_MAP_DATA = 'SET_MAP_DATA';
var SET_MAP_RESULTS = 'SET_MAP_RESULTS';
var SET_QUERY_LISTENER = 'SET_QUERY_LISTENER';
var STORE_KEY = '__REACTIVESEARCH__';
var SET_SEARCH_ID = 'SET_SEARCH_ID';
var SET_PROMOTED_RESULTS = 'SET_PROMOTED_RESULTS';
var SET_DEFAULT_QUERY = 'SET_DEFAULT_QUERY';
var SET_CUSTOM_QUERY = 'SET_CUSTOM_QUERY';
var SET_CUSTOM_HIGHLIGHT_OPTIONS = 'SET_CUSTOM_HIGHLIGHT_OPTIONS';
var SET_CUSTOM_DATA = 'SET_CUSTOM_DATA';
var SET_APPLIED_SETTINGS = 'SET_APPLIED_SETTINGS';
var SET_PROPS = 'SET_PROPS';
var UPDATE_PROPS = 'UPDATE_PROPS';
var REMOVE_PROPS = 'REMOVE_PROPS';
var SET_SUGGESTIONS_SEARCH_VALUE = 'SET_SUGGESTIONS_SEARCH_VALUE';
var CLEAR_SUGGESTIONS_SEARCH_VALUE = 'CLEAR_SUGGESTIONS_SEARCH_VALUE';
var SET_SUGGESTIONS_SEARCH_ID = 'SET_SUGGESTIONS_SEARCH_ID';
var UPDATE_ANALYTICS_CONFIG = 'UPDATE_ANALYTICS_CONFIG';
var SET_RAW_DATA = 'SET_RAW_DATA';
var SET_POPULAR_SUGGESTIONS = 'SET_POPULAR_SUGGESTIONS';
var SET_DEFAULT_POPULAR_SUGGESTIONS = 'SET_DEFAULT_POPULAR_SUGGESTIONS';
var SET_QUERY_TO_HITS$1 = 'SET_QUERY_TO_HITS';
var RECENT_SEARCHES_SUCCESS = 'RECENT_SEARCHES_SUCCESS';
var RECENT_SEARCHES_ERROR = 'RECENT_SEARCHES_ERROR';
var SET_VALUE = 'SET_VALUE';
var SET_VALUES = 'SET_VALUES';
var RESET_TO_DEFAULT = 'RESET_TO_DEFAULT';
var SET_GOOGLE_MAP_SCRIPT_LOADING = 'SET_GOOGLE_MAP_SCRIPT_LOADING';
var SET_GOOGLE_MAP_SCRIPT_LOADED = 'SET_GOOGLE_MAP_SCRIPT_LOADED';
var SET_GOOGLE_MAP_SCRIPT_ERROR = 'SET_GOOGLE_MAP_SCRIPT_ERROR';
var SET_REGISTERED_COMPONENT_TIMESTAMP = 'SET_REGISTERED_COMPONENT_TIMESTAMP';
var REMOVE_REGISTERED_COMPONENT_TIMESTAMP = 'REMOVE_REGISTERED_COMPONENT_TIMESTAMP';
var SET_AI_RESPONSE = 'SET_AI_RESPONSE';
var SET_AI_RESPONSE_DELAYED = 'SET_AI_RESPONSE_DELAYED';
var REMOVE_AI_RESPONSE = 'REMOVE_AI_RESPONSE';
var SET_AI_RESPONSE_ERROR = 'SET_AI_RESPONSE_ERROR';
var SET_AI_RESPONSE_LOADING = 'SET_AI_RESPONSE_LOADING';

function componentsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === ADD_COMPONENT) {
    return [].concat(_toConsumableArray(state), [action.component]);
  } else if (action.type === REMOVE_COMPONENT) {
    return state.filter(function (element) {
      return element !== action.component;
    });
  }
  return state;
}

function ownKeys$H(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$H(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$H(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$H(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function getWatchList(depTree) {
  var list = Object.values(depTree);
  var components = [];
  list.forEach(function (item) {
    if (typeof item === 'string') {
      components.push(item);
    } else if (Array.isArray(item)) {
      item.forEach(function (component) {
        if (typeof component === 'string') {
          components.push(component);
        } else {
          // in this case, we have { <conjunction>: <> } object inside the array
          components.push.apply(components, _toConsumableArray(getWatchList(component)));
        }
      });
    } else if (_typeof(item) === 'object' && item !== null) {
      components.push.apply(components, _toConsumableArray(getWatchList(item)));
    }
  });
  return components.filter(function (value, index, array) {
    return array.indexOf(value) === index;
  });
}
function watchManReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === WATCH_COMPONENT) {
    var watchList = getWatchList(action.react);
    var newState = _objectSpread$H({}, state);
    Object.keys(newState).forEach(function (key) {
      newState[key] = newState[key].filter(function (value) {
        return value !== action.component;
      });
    });
    watchList.forEach(function (item) {
      if (Array.isArray(newState[item])) {
        newState[item] = [].concat(_toConsumableArray(newState[item]), [action.component]);
      } else {
        newState[item] = [action.component];
      }
    });
    return newState;
  }
  return state;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}

function _toPropertyKey$n(t) { var i = _toPrimitive$n(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$n(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$G(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$G(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$G(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$G(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function dependencyTreeReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === WATCH_COMPONENT) {
    return _objectSpread$G(_objectSpread$G({}, state), {}, _defineProperty({}, action.component, action.react));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$n));
    return obj;
  }
  return state;
}

function _toPropertyKey$m(t) { var i = _toPrimitive$m(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$m(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$F(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$F(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$F(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$F(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function queryReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_QUERY) {
    return _objectSpread$F(_objectSpread$F({}, state), {}, _defineProperty({}, action.component, action.query));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$m));
    return obj;
  }
  return state;
}

function ownKeys$E(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$E(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$E(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$E(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function appbaseQueryReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_APPBASE_QUERY) {
    return _objectSpread$E(_objectSpread$E({}, state), action.query);
  }
  return state;
}

function _toPropertyKey$l(t) { var i = _toPrimitive$l(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$l(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$D(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$D(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$D(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$D(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function queryOptionsReducer$1() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_QUERY_OPTIONS) {
    return _objectSpread$D(_objectSpread$D({}, state), {}, _defineProperty({}, action.component, action.options));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$l));
    return obj;
  }
  return state;
}

var componentTypes = {
  reactiveList: 'REACTIVELIST',
  // search components
  dataSearch: 'DATASEARCH',
  categorySearch: 'CATEGORYSEARCH',
  searchBox: 'SEARCHBOX',
  // list components
  singleList: 'SINGLELIST',
  multiList: 'MULTILIST',
  singleDataList: 'SINGLEDATALIST',
  tabDataList: 'TABDATALIST',
  singleDropdownList: 'SINGLEDROPDOWNLIST',
  multiDataList: 'MULTIDATALIST',
  multiDropdownList: 'MULTIDROPDOWNLIST',
  singleDropdownRange: 'SINGLEDROPDOWNRANGE',
  treeList: 'TREELIST',
  // basic components
  numberBox: 'NUMBERBOX',
  tagCloud: 'TAGCLOUD',
  toggleButton: 'TOGGLEBUTTON',
  reactiveComponent: 'REACTIVECOMPONENT',
  // range components
  datePicker: 'DATEPICKER',
  dateRange: 'DATERANGE',
  dynamicRangeSlider: 'DYNAMICRANGESLIDER',
  multiDropdownRange: 'MULTIDROPDOWNRANGE',
  singleRange: 'SINGLERANGE',
  multiRange: 'MULTIRANGE',
  rangeSlider: 'RANGESLIDER',
  ratingsFilter: 'RATINGSFILTER',
  rangeInput: 'RANGEINPUT',
  // map components
  geoDistanceDropdown: 'GEO_DISTANCE_DROPDOWN',
  geoDistanceSlider: 'GEO_DISTANCE_SLIDER',
  reactiveMap: 'REACTIVE_MAP',
  // chart components
  reactiveChart: 'REACTIVE_CHART',
  // ai component
  AIAnswer: 'AI_ANSWER'
};
var queryTypes = {
  search: 'search',
  term: 'term',
  range: 'range',
  geo: 'geo',
  suggestion: 'suggestion'
};

// Props that need to be passed to the query
var validProps = [
// common
'type', 'componentType', 'aggregationField', 'aggregationSize', 'distinctField', 'distinctFieldConfig', 'index', 'aggregations', 'compoundClause',
// Specific to ReactiveList
'dataField', 'includeFields', 'excludeFields', 'size', 'candidates', 'from', 'sortBy', 'sortOptions', 'pagination',
// Specific to DataSearch
'autoFocus', 'autosuggest', 'debounce', 'defaultValue', 'defaultSuggestions', 'fieldWeights', 'filterLabel', 'fuzziness', 'highlight', 'highlightConfig', 'highlightField', 'nestedField', 'placeholder', 'queryFormat', 'searchOperators', 'enableSynonyms', 'enableQuerySuggestions', 'queryString', 'vectorDataField', 'imageValue',
// Specific to Category Search
'categoryField', 'strictSelection',
// Specific to List Components
'selectAllLabel', 'showCheckbox', 'showFilter', 'showSearch', 'showCount', 'showLoadMore', 'loadMoreLabel', 'showMissing', 'missingLabel', 'data', 'showRadio',
// TagCloud and ToggleButton
'multiSelect',
// Range Components
'includeNullValues', 'interval', 'showHistogram', 'snap', 'stepValue', 'range', 'showSlider', 'parseDate', 'calendarInterval',
// Map components
'unit',
// Specific to SearchBox
'enablePopularSuggestions', 'enableRecentSuggestions', 'popularSuggestionsConfig', 'recentSuggestionsConfig', 'indexSuggestionsConfig', 'featuredSuggestionsConfig', 'FAQSuggestionsConfig', 'documentSuggestionsConfig', 'enablePredictiveSuggestions', 'applyStopwords', 'customStopwords', 'enableIndexSuggestions', 'enableFeaturedSuggestions', 'enableFAQSuggestions', 'enableDocumentSuggestions', 'enableEndpointSuggestions', 'searchboxId', 'endpoint', 'enableAI', 'AIConfig', 'showDistinctSuggestions'];
var AI_ROLES = {
  USER: 'user',
  SYSTEM: 'system',
  ASSISTANT: 'assistant'
};
var AI_LOCAL_CACHE_KEY = 'AISessions';
var constants = true;

// defaultAnalytics Config
var defaultAnalyticsConfig = {
  emptyQuery: true,
  suggestionAnalytics: true,
  userId: null,
  customEvents: null,
  enableQueryRules: true
};

function ownKeys$C(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$C(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$C(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$C(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function configReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    analyticsConfig: defaultAnalyticsConfig,
    lock: false
  };
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === ADD_CONFIG) {
    return _objectSpread$C(_objectSpread$C({}, state), {}, {
      analyticsConfig: _objectSpread$C(_objectSpread$C({}, defaultAnalyticsConfig), action.analyticsConfig)
    });
  } else if (action.type === UPDATE_ANALYTICS_CONFIG) {
    return _objectSpread$C(_objectSpread$C({}, state), {}, {
      analyticsConfig: _objectSpread$C(_objectSpread$C({}, state.analyticsConfig), action.analyticsConfig)
    });
  } else if (action.type === UPDATE_CONFIG) {
    return _objectSpread$C(_objectSpread$C({}, state), action.config);
  }
  return state;
}

function appbaseRefReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === ADD_APPBASE_REF) {
    return action.appbaseRef;
  }
  return state;
}

function _toPropertyKey$k(t) { var i = _toPrimitive$k(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$k(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$B(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$B(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$B(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$B(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function hitsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === UPDATE_HITS) {
    if (action.append) {
      return _objectSpread$B(_objectSpread$B({}, state), {}, _defineProperty({}, action.component, {
        hits: [].concat(_toConsumableArray(state[action.component].hits), _toConsumableArray(action.hits)),
        total: action.total,
        time: action.time,
        hidden: action.hidden || 0
      }));
    }
    return _objectSpread$B(_objectSpread$B({}, state), {}, _defineProperty({}, action.component, {
      hits: action.hits,
      total: action.total,
      time: action.time,
      hidden: action.hidden || 0
    }));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$k));
    return obj;
  }
  return state;
}

function _toPropertyKey$j(t) { var i = _toPrimitive$j(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$j(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$A(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$A(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$A(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$A(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function logsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === LOG_QUERY) {
    return _objectSpread$A(_objectSpread$A({}, state), {}, _defineProperty({}, action.component, action.query));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$j));
    return obj;
  }
  return state;
}

function _toPropertyKey$i(t) { var i = _toPrimitive$i(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$i(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$z(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$z(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$z(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$z(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function combinedLogsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === LOG_COMBINED_QUERY) {
    return _objectSpread$z(_objectSpread$z({}, state), {}, _defineProperty({}, action.component, action.query));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$i));
    return obj;
  }
  return state;
}

var _excluded$5 = ["value"];
function _toPropertyKey$h(t) { var i = _toPrimitive$h(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$h(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$y(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$y(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$y(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$y(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function valueReducer$1() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case SET_VALUE:
      {
        var newState = {};
        Object.keys(action.componentsToReset || {}).forEach(function (id) {
          newState[id] = _objectSpread$y(_objectSpread$y({}, state[id]), {}, {
            value: action.componentsToReset[id]
          });
        });
        return _objectSpread$y(_objectSpread$y(_objectSpread$y({}, state), newState), {}, _defineProperty({}, action.component, {
          value: action.value,
          label: action.label || action.component,
          showFilter: action.showFilter,
          URLParams: action.URLParams,
          componentType: action.componentType,
          category: action.category,
          meta: action.meta,
          reference: action.reference
        }));
      }
    case SET_VALUES:
      {
        var componentKeys = action.componentsValues ? Object.keys(action.componentsValues) : [];
        if (componentKeys.length) {
          var _newState = {};
          componentKeys.forEach(function (component) {
            var _action$componentsVal = action.componentsValues[component],
              value = _action$componentsVal.value,
              rest = _objectWithoutProperties(_action$componentsVal, _excluded$5);
            _newState[component] = _objectSpread$y(_objectSpread$y({}, state[component]), {}, {
              value: value
            }, rest);
          });
          return _objectSpread$y(_objectSpread$y({}, state), _newState);
        }
        return state;
      }
    case PATCH_VALUE:
      return _objectSpread$y(_objectSpread$y({}, state), {}, _defineProperty({}, action.component, _objectSpread$y(_objectSpread$y({}, state[action.component]), action.payload)));
    case CLEAR_VALUES:
      {
        var nextState = {};
        if (action.resetValues) {
          Object.keys(action.resetValues).forEach(function (componentId) {
            nextState[componentId] = _objectSpread$y(_objectSpread$y({}, state[componentId]), {}, {
              value: action.resetValues[componentId]
            });
          });
        }
        // clearAllBlacklistComponents has more priority over reset values
        if (Array.isArray(action.clearAllBlacklistComponents)) {
          Object.keys(state).forEach(function (componentId) {
            if (action.clearAllBlacklistComponents.includes(componentId)) {
              nextState[componentId] = state[componentId];
            }
          });
        }
        return nextState;
      }
    case REMOVE_COMPONENT:
      {
        var _action$component = action.component;
          state[_action$component];
          var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$h));
        return obj;
      }
    case RESET_TO_DEFAULT:
      return _objectSpread$y(_objectSpread$y({}, state), action.defaultValues);
    default:
      return state;
  }
}

function _toPropertyKey$g(t) { var i = _toPrimitive$g(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$g(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$x(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$x(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$x(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$x(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function valueReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case SET_INTERNAL_VALUE:
      return _objectSpread$x(_objectSpread$x({}, state), {}, _defineProperty({}, action.component, {
        value: action.value,
        componentType: action.componentType,
        category: action.category,
        meta: action.meta
      }));
    case CLEAR_VALUES:
      {
        var nextState = {};
        if (action.resetValues) {
          Object.keys(action.resetValues).forEach(function (componentId) {
            nextState[componentId] = _objectSpread$x(_objectSpread$x({}, state[componentId]), {}, {
              value: action.resetValues[componentId]
            });
          });
        }
        // clearAllBlacklistComponents has more priority over reset values
        if (Array.isArray(action.clearAllBlacklistComponents)) {
          Object.keys(state).forEach(function (componentId) {
            if (action.clearAllBlacklistComponents.includes(componentId)) {
              nextState[componentId] = state[componentId];
            }
          });
        }
        return nextState;
      }
    case RESET_TO_DEFAULT:
      return _objectSpread$x(_objectSpread$x({}, state), action.defaultValues);
    case REMOVE_COMPONENT:
      {
        var _action$component = action.component;
          state[_action$component];
          var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$g));
        return obj;
      }
    default:
      return state;
  }
}

function _toPropertyKey$f(t) { var i = _toPrimitive$f(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$f(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$w(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$w(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$w(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$w(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function loadingReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_LOADING) {
    var requestCount = state["".concat(action.component, "_active")] || 0;
    if (action.isLoading) {
      requestCount += 1;
    } else if (requestCount) {
      requestCount -= 1;
    }
    return _objectSpread$w(_objectSpread$w({}, state), {}, _defineProperty(_defineProperty({}, action.component, action.isLoading), "".concat(action.component, "_active"), requestCount), action.isLoading ? _defineProperty({}, "".concat(action.component, "_timestamp"), new Date().getTime()) : null);
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component,
      _ref2 = "".concat(action.component, "_active");
      state[_action$component];
      state[_ref2];
      var obj = _objectWithoutProperties(state, [_action$component, _ref2].map(_toPropertyKey$f));
    return obj;
  }
  return state;
}

function _toPropertyKey$e(t) { var i = _toPrimitive$e(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$e(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$v(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$v(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$v(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$v(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function errorReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_ERROR) {
    return _objectSpread$v(_objectSpread$v({}, state), {}, _defineProperty({}, action.component, action.error));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$e));
    return obj;
  }
  return state;
}

function _toPropertyKey$d(t) { var i = _toPrimitive$d(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$d(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$u(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$u(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$u(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$u(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function timestampReducer$1() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_TIMESTAMP) {
    return _objectSpread$u(_objectSpread$u({}, state), {}, _defineProperty({}, action.component, action.timestamp));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$d));
    return obj;
  }
  return state;
}

function headersReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_HEADERS) {
    return action.headers;
  }
  return state;
}

function _toPropertyKey$c(t) { var i = _toPrimitive$c(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$c(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$t(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$t(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$t(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$t(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function mapDataReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_MAP_DATA) {
    return _objectSpread$t(_objectSpread$t({}, state), {}, _defineProperty({}, action.componentId, {
      query: action.query,
      persistMapQuery: action.persistMapQuery
    }));
  } else if (action.type === SET_MAP_RESULTS) {
    return _objectSpread$t(_objectSpread$t({}, state), {}, _defineProperty({}, action.componentId, _objectSpread$t(_objectSpread$t({}, state[action.componentId]), action.payload)));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$c));
    return obj;
  }
  return state;
}

function _toPropertyKey$b(t) { var i = _toPrimitive$b(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$b(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$s(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$s(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$s(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$s(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function queryListenerReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_QUERY_LISTENER) {
    return _objectSpread$s(_objectSpread$s({}, state), {}, _defineProperty({}, action.component, {
      onQueryChange: action.onQueryChange,
      onError: action.onError
    }));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$b));
    return obj;
  }
  return state;
}

function ownKeys$r(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$r(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$r(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$r(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var initialState = {
  searchValue: null,
  searchId: null,
  // Maintain the suggestions analytics separately
  suggestionsSearchId: null,
  suggestionsSearchValue: null
};
var searchComponents$1 = [componentTypes.dataSearch, componentTypes.categorySearch];
function analyticsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case SET_VALUE:
      if (searchComponents$1.includes(action.componentType)) {
        return {
          searchValue: action.value,
          searchId: null
        };
      }
      return state;
    case SET_SEARCH_ID:
      return _objectSpread$r(_objectSpread$r({}, state), {}, {
        searchId: action.searchId
      });
    case SET_SUGGESTIONS_SEARCH_VALUE:
      return _objectSpread$r(_objectSpread$r({}, state), {}, {
        suggestionsSearchValue: action.value,
        suggestionsSearchId: null
      });
    case SET_SUGGESTIONS_SEARCH_ID:
      return _objectSpread$r(_objectSpread$r({}, state), {}, {
        suggestionsSearchId: action.searchId
      });
    case CLEAR_SUGGESTIONS_SEARCH_VALUE:
      return _objectSpread$r(_objectSpread$r({}, state), {}, {
        suggestionsSearchValue: null,
        suggestionsSearchId: null
      });
    default:
      return state;
  }
}

function _toPropertyKey$a(t) { var i = _toPrimitive$a(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$a(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$q(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$q(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$q(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$q(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function promotedResultsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_PROMOTED_RESULTS) {
    return _objectSpread$q(_objectSpread$q({}, state), {}, _defineProperty({}, action.component, action.results.map(function (item) {
      return _objectSpread$q(_objectSpread$q({}, item), {}, {
        _promoted: true
      });
    })));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$a));
    return obj;
  }
  return state;
}

function _toPropertyKey$9(t) { var i = _toPrimitive$9(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$9(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$p(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$p(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$p(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$p(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function customDataReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_CUSTOM_DATA) {
    return _objectSpread$p(_objectSpread$p({}, state), {}, _defineProperty({}, action.component, action.data));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$9));
    return obj;
  }
  return state;
}

function _toPropertyKey$8(t) { var i = _toPrimitive$8(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$8(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$o(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$o(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$o(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$o(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function defaultQueryReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_DEFAULT_QUERY) {
    return _objectSpread$o(_objectSpread$o({}, state), {}, _defineProperty({}, action.component, action.query));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$8));
    return obj;
  }
  return state;
}

function _toPropertyKey$7(t) { var i = _toPrimitive$7(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$7(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$n(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$n(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$n(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$n(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function customQueryReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_CUSTOM_QUERY) {
    return _objectSpread$n(_objectSpread$n({}, state), {}, _defineProperty({}, action.component, action.query));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$7));
    return obj;
  }
  return state;
}

function _toPropertyKey$6(t) { var i = _toPrimitive$6(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$6(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$m(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$m(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$m(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$m(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function queryOptionsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case SET_PROPS:
      return _objectSpread$m(_objectSpread$m({}, state), {}, _defineProperty({}, action.component, action.options));
    case UPDATE_PROPS:
      return _objectSpread$m(_objectSpread$m({}, state), {}, _defineProperty({}, action.component, _objectSpread$m(_objectSpread$m({}, state[action.component]), action.options)));
    case REMOVE_PROPS:
    case REMOVE_COMPONENT:
      {
        var _action$component = action.component;
          state[_action$component];
          var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$6));
        return obj;
      }
    default:
      return state;
  }
}

var _excluded$4 = ["buckets"];
function _toPropertyKey$5(t) { var i = _toPrimitive$5(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$5(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$l(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$l(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$l(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$l(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function aggsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === UPDATE_AGGS) {
    if (action.append) {
      var field = Object.keys(state[action.component])[0];
      var _action$aggregations$ = action.aggregations[field],
        newBuckets = _action$aggregations$.buckets,
        aggsData = _objectWithoutProperties(_action$aggregations$, _excluded$4);
      // console.log('received aggs', action.aggregations);
      return _objectSpread$l(_objectSpread$l({}, state), {}, _defineProperty({}, action.component, _defineProperty({}, field, _objectSpread$l({
        buckets: [].concat(_toConsumableArray(state[action.component][field].buckets), _toConsumableArray(newBuckets))
      }, aggsData))));
    }
    return _objectSpread$l(_objectSpread$l({}, state), {}, _defineProperty({}, action.component, action.aggregations));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component2 = action.component;
      state[_action$component2];
      var obj = _objectWithoutProperties(state, [_action$component2].map(_toPropertyKey$5));
    return obj;
  }
  return state;
}

var _excluded$3 = ["_source"];
function ownKeys$k(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$k(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$k(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$k(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function compositeAggsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === UPDATE_COMPOSITE_AGGS) {
    var aggsResponse = Object.values(action.aggregations) && Object.values(action.aggregations)[0];
    var fieldName = Object.keys(action.aggregations)[0];
    if (!aggsResponse) return state;
    var buckets = [];
    if (aggsResponse.buckets && Array.isArray(aggsResponse.buckets)) {
      buckets = aggsResponse.buckets;
    }
    var parsedAggs = buckets.map(function (bucket) {
      // eslint-disable-next-line camelcase
      var doc_count = bucket.doc_count,
        key = bucket.key,
        hitsData = bucket[fieldName];
      var flatData = {};
      var _source = {};
      if (hitsData && hitsData.hits) {
        var _hitsData$hits$hits$ = hitsData.hits.hits[0];
        _source = _hitsData$hits$hits$._source;
        flatData = _objectWithoutProperties(_hitsData$hits$hits$, _excluded$3);
      }
      return _objectSpread$k(_objectSpread$k({
        _doc_count: doc_count,
        _key: typeof key === 'string' ? key : key[fieldName],
        top_hits: hitsData
      }, flatData), _source);
    });
    return _objectSpread$k(_objectSpread$k({}, state), {}, _defineProperty({}, action.component, action.append ? [].concat(_toConsumableArray(state[action.component]), _toConsumableArray(parsedAggs)) : parsedAggs));
  }
  return state;
}

function ownKeys$j(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$j(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$j(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$j(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function appliedSettingsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_APPLIED_SETTINGS) {
    return _objectSpread$j(_objectSpread$j({}, state), {}, _defineProperty({}, action.component, action.data));
  }
  return state;
}

function _toPropertyKey$4(t) { var i = _toPrimitive$4(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$4(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$i(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$i(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$i(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$i(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function customHighlightReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_CUSTOM_HIGHLIGHT_OPTIONS) {
    return _objectSpread$i(_objectSpread$i({}, state), {}, _defineProperty({}, action.component, action.data));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$4));
    return obj;
  }
  return state;
}

function _toPropertyKey$3(t) { var i = _toPrimitive$3(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$3(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$h(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$h(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$h(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$h(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function rawDataReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_RAW_DATA) {
    return _objectSpread$h(_objectSpread$h({}, state), {}, _defineProperty({}, action.component, action.response));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$3));
    return obj;
  }
  return state;
}

function ownKeys$g(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$g(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$g(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$g(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function querySuggestionsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_POPULAR_SUGGESTIONS) {
    return _objectSpread$g(_objectSpread$g({}, state), {}, _defineProperty({}, action.component, action.suggestions));
  }
  return state;
}

function ownKeys$f(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$f(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$f(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$f(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function defaultPopularSuggestions() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_DEFAULT_POPULAR_SUGGESTIONS) {
    return _objectSpread$f(_objectSpread$f({}, state), {}, _defineProperty({}, action.component, action.suggestions));
  }
  return state;
}

function _toPropertyKey$2(t) { var i = _toPrimitive$2(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$2(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$e(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$e(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$e(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$e(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function queryToHitsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_QUERY_TO_HITS$1) {
    return _objectSpread$e(_objectSpread$e({}, state), {}, _defineProperty({}, action.component, action.query));
  } else if (action.type === REMOVE_COMPONENT) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$2));
    return obj;
  }
  return state;
}

function recentSearchesReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === RECENT_SEARCHES_SUCCESS) {
    return {
      error: null,
      data: action.data
    };
  } else if (action.type === RECENT_SEARCHES_ERROR) {
    return {
      error: action.error
    };
  }
  return state;
}

function ownKeys$d(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$d(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$d(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$d(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var INITIAL_STATE = {
  loading: false,
  loaded: false,
  error: null
};
function googleMapScriptReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_STATE;
  var action = arguments.length > 1 ? arguments[1] : undefined;
  var type = action.type,
    loading = action.loading,
    loaded = action.loaded,
    error = action.error;
  if (type === SET_GOOGLE_MAP_SCRIPT_LOADING) {
    return _objectSpread$d(_objectSpread$d({}, INITIAL_STATE), {}, {
      loading: loading
    });
  } else if (type === SET_GOOGLE_MAP_SCRIPT_LOADED) {
    return _objectSpread$d(_objectSpread$d({}, INITIAL_STATE), {}, {
      loaded: loaded
    });
  } else if (type === SET_GOOGLE_MAP_SCRIPT_ERROR) {
    return _objectSpread$d(_objectSpread$d({}, INITIAL_STATE), {}, {
      error: error
    });
  }
  return state;
}

function analyticsRefReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === ADD_ANALYTICS_REF) {
    return action.analyticsRef;
  }
  return state;
}

function _toPropertyKey$1(t) { var i = _toPrimitive$1(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive$1(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$c(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$c(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$c(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$c(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function timestampReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_REGISTERED_COMPONENT_TIMESTAMP) {
    return _objectSpread$c(_objectSpread$c({}, state), {}, _defineProperty({}, action.component, action.timestamp));
  } else if (action.type === REMOVE_REGISTERED_COMPONENT_TIMESTAMP) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey$1));
    return obj;
  }
  return state;
}

var dateFormats = {
  date: 'YYYY-MM-DD',
  basic_date: 'YYYYMMDD',
  basic_date_time: 'YYYYMMDD[T]HHmmss.SSSZ',
  basic_date_time_no_millis: 'YYYYMMDD[T]HHmmssZ',
  date_time_no_millis: 'YYYY-MM-DD[T]HH:mm:ssZ',
  basic_time: 'HHmmss.SSSZ',
  basic_time_no_millis: 'HHmmssZ',
  epoch_millis: 'epoch_millis',
  epoch_second: 'epoch_second'
};

var diacritics = {
  '«': '"',
  '²': '2',
  '³': '3',
  '¹': '1',
  '»': '"',
  À: 'A',
  Á: 'A',
  Â: 'A',
  Ã: 'A',
  Ä: 'A',
  Å: 'A',
  Æ: 'AE',
  Ç: 'C',
  È: 'E',
  É: 'E',
  Ê: 'E',
  Ë: 'E',
  Ì: 'I',
  Í: 'I',
  Î: 'I',
  Ï: 'I',
  Ð: 'D',
  Ñ: 'N',
  Ò: 'O',
  Ó: 'O',
  Ô: 'O',
  Õ: 'O',
  Ö: 'O',
  Ø: 'O',
  Ù: 'U',
  Ú: 'U',
  Û: 'U',
  Ü: 'U',
  Ý: 'Y',
  Þ: 'TH',
  ß: 'ss',
  à: 'a',
  á: 'a',
  â: 'a',
  ã: 'a',
  ä: 'a',
  å: 'a',
  æ: 'ae',
  ç: 'c',
  è: 'e',
  é: 'e',
  ê: 'e',
  ë: 'e',
  ì: 'i',
  í: 'i',
  î: 'i',
  ï: 'i',
  ð: 'd',
  ñ: 'n',
  ò: 'o',
  ó: 'o',
  ô: 'o',
  õ: 'o',
  ö: 'o',
  ø: 'o',
  ù: 'u',
  ú: 'u',
  û: 'u',
  ü: 'u',
  ý: 'y',
  þ: 'th',
  ÿ: 'y',
  Ā: 'A',
  ā: 'a',
  Ă: 'A',
  ă: 'a',
  Ą: 'A',
  ą: 'a',
  Ć: 'C',
  ć: 'c',
  Ĉ: 'C',
  ĉ: 'c',
  Ċ: 'C',
  ċ: 'c',
  Č: 'C',
  č: 'c',
  Ď: 'D',
  ď: 'd',
  Đ: 'D',
  đ: 'd',
  Ē: 'E',
  ē: 'e',
  Ĕ: 'E',
  ĕ: 'e',
  Ė: 'E',
  ė: 'e',
  Ę: 'E',
  ę: 'e',
  Ě: 'E',
  ě: 'e',
  Ĝ: 'G',
  ĝ: 'g',
  Ğ: 'G',
  ğ: 'g',
  Ġ: 'G',
  ġ: 'g',
  Ģ: 'G',
  ģ: 'g',
  Ĥ: 'H',
  ĥ: 'h',
  Ħ: 'H',
  ħ: 'h',
  Ĩ: 'I',
  ĩ: 'i',
  Ī: 'I',
  ī: 'i',
  Ĭ: 'I',
  ĭ: 'i',
  Į: 'I',
  į: 'i',
  İ: 'I',
  ı: 'i',
  Ĳ: 'IJ',
  ĳ: 'ij',
  Ĵ: 'J',
  ĵ: 'j',
  Ķ: 'K',
  ķ: 'k',
  ĸ: 'q',
  Ĺ: 'L',
  ĺ: 'l',
  Ļ: 'L',
  ļ: 'l',
  Ľ: 'L',
  ľ: 'l',
  Ŀ: 'L',
  ŀ: 'l',
  Ł: 'L',
  ł: 'l',
  Ń: 'N',
  ń: 'n',
  Ņ: 'N',
  ņ: 'n',
  Ň: 'N',
  ň: 'n',
  ŉ: 'n',
  Ŋ: 'N',
  ŋ: 'n',
  Ō: 'O',
  ō: 'o',
  Ŏ: 'O',
  ŏ: 'o',
  Ő: 'O',
  ő: 'o',
  Œ: 'OE',
  œ: 'oe',
  Ŕ: 'R',
  ŕ: 'r',
  Ŗ: 'R',
  ŗ: 'r',
  Ř: 'R',
  ř: 'r',
  Ś: 'S',
  ś: 's',
  Ŝ: 'S',
  ŝ: 's',
  Ş: 'S',
  ş: 's',
  Š: 'S',
  š: 's',
  Ţ: 'T',
  ţ: 't',
  Ť: 'T',
  ť: 't',
  Ŧ: 'T',
  ŧ: 't',
  Ũ: 'U',
  ũ: 'u',
  Ū: 'U',
  ū: 'u',
  Ŭ: 'U',
  ŭ: 'u',
  Ů: 'U',
  ů: 'u',
  Ű: 'U',
  ű: 'u',
  Ų: 'U',
  ų: 'u',
  Ŵ: 'W',
  ŵ: 'w',
  Ŷ: 'Y',
  ŷ: 'y',
  Ÿ: 'Y',
  Ź: 'Z',
  ź: 'z',
  Ż: 'Z',
  ż: 'z',
  Ž: 'Z',
  ž: 'z',
  ſ: 's',
  ƀ: 'b',
  Ɓ: 'B',
  Ƃ: 'B',
  ƃ: 'b',
  Ɔ: 'O',
  Ƈ: 'C',
  ƈ: 'c',
  Ɖ: 'D',
  Ɗ: 'D',
  Ƌ: 'D',
  ƌ: 'd',
  Ǝ: 'E',
  Ə: 'A',
  Ɛ: 'E',
  Ƒ: 'F',
  ƒ: 'f',
  Ɠ: 'G',
  ƕ: 'hv',
  Ɩ: 'I',
  Ɨ: 'I',
  Ƙ: 'K',
  ƙ: 'k',
  ƚ: 'l',
  Ɯ: 'M',
  Ɲ: 'N',
  ƞ: 'n',
  Ɵ: 'O',
  Ơ: 'O',
  ơ: 'o',
  Ƥ: 'P',
  ƥ: 'p',
  ƫ: 't',
  Ƭ: 'T',
  ƭ: 't',
  Ʈ: 'T',
  Ư: 'U',
  ư: 'u',
  Ʋ: 'V',
  Ƴ: 'Y',
  ƴ: 'y',
  Ƶ: 'Z',
  ƶ: 'z',
  ƿ: 'w',
  Ǆ: 'DZ',
  ǅ: 'Dz',
  ǆ: 'dz',
  Ǉ: 'LJ',
  ǈ: 'Lj',
  ǉ: 'lj',
  Ǌ: 'NJ',
  ǋ: 'Nj',
  ǌ: 'nj',
  Ǎ: 'A',
  ǎ: 'a',
  Ǐ: 'I',
  ǐ: 'i',
  Ǒ: 'O',
  ǒ: 'o',
  Ǔ: 'U',
  ǔ: 'u',
  Ǖ: 'U',
  ǖ: 'u',
  Ǘ: 'U',
  ǘ: 'u',
  Ǚ: 'U',
  ǚ: 'u',
  Ǜ: 'U',
  ǜ: 'u',
  ǝ: 'e',
  Ǟ: 'A',
  ǟ: 'a',
  Ǡ: 'A',
  ǡ: 'a',
  Ǣ: 'AE',
  ǣ: 'ae',
  Ǥ: 'G',
  ǥ: 'G',
  Ǧ: 'G',
  ǧ: 'G',
  Ǩ: 'K',
  ǩ: 'k',
  Ǫ: 'O',
  ǫ: 'o',
  Ǭ: 'O',
  ǭ: 'o',
  ǰ: 'j',
  Ǳ: 'DZ',
  ǲ: 'Dz',
  ǳ: 'dz',
  Ǵ: 'G',
  ǵ: 'g',
  Ƕ: 'HV',
  Ƿ: 'W',
  Ǹ: 'N',
  ǹ: 'n',
  Ǻ: 'A',
  ǻ: 'a',
  Ǽ: 'AE',
  ǽ: 'ae',
  Ǿ: 'O',
  ǿ: 'o',
  Ȁ: 'A',
  ȁ: 'a',
  Ȃ: 'A',
  ȃ: 'a',
  Ȅ: 'E',
  ȅ: 'e',
  Ȇ: 'E',
  ȇ: 'e',
  Ȉ: 'I',
  ȉ: 'i',
  Ȋ: 'I',
  ȋ: 'i',
  Ȍ: 'O',
  ȍ: 'o',
  Ȏ: 'O',
  ȏ: 'o',
  Ȑ: 'R',
  ȑ: 'r',
  Ȓ: 'R',
  ȓ: 'r',
  Ȕ: 'U',
  ȕ: 'u',
  Ȗ: 'U',
  ȗ: 'u',
  Ș: 'S',
  ș: 's',
  Ț: 'T',
  ț: 't',
  Ȝ: 'Z',
  ȝ: 'z',
  Ȟ: 'H',
  ȟ: 'h',
  Ƞ: 'N',
  ȡ: 'd',
  Ȣ: 'OU',
  ȣ: 'ou',
  Ȥ: 'Z',
  ȥ: 'z',
  Ȧ: 'A',
  ȧ: 'a',
  Ȩ: 'E',
  ȩ: 'e',
  Ȫ: 'O',
  ȫ: 'o',
  Ȭ: 'O',
  ȭ: 'o',
  Ȯ: 'O',
  ȯ: 'o',
  Ȱ: 'O',
  ȱ: 'o',
  Ȳ: 'Y',
  ȳ: 'y',
  ȴ: 'l',
  ȵ: 'n',
  ȶ: 't',
  ȷ: 'j',
  ȸ: 'db',
  ȹ: 'qp',
  Ⱥ: 'A',
  Ȼ: 'C',
  ȼ: 'c',
  Ƚ: 'L',
  Ⱦ: 'T',
  ȿ: 's',
  ɀ: 'z',
  Ƀ: 'B',
  Ʉ: 'U',
  Ʌ: 'V',
  Ɇ: 'E',
  ɇ: 'e',
  Ɉ: 'J',
  ɉ: 'j',
  Ɋ: 'Q',
  ɋ: 'q',
  Ɍ: 'R',
  ɍ: 'r',
  Ɏ: 'Y',
  ɏ: 'y',
  ɐ: 'a',
  ɓ: 'b',
  ɔ: 'o',
  ɕ: 'c',
  ɖ: 'd',
  ɗ: 'd',
  ɘ: 'e',
  ə: 'a',
  ɚ: 'a',
  ɛ: 'e',
  ɜ: 'e',
  ɝ: 'e',
  ɞ: 'e',
  ɟ: 'j',
  ɠ: 'g',
  ɡ: 'g',
  ɢ: 'G',
  ɥ: 'h',
  ɦ: 'h',
  ɨ: 'i',
  ɪ: 'I',
  ɫ: 'l',
  ɬ: 'l',
  ɭ: 'l',
  ɯ: 'm',
  ɰ: 'm',
  ɱ: 'm',
  ɲ: 'n',
  ɳ: 'n',
  ɴ: 'N',
  ɵ: 'o',
  ɶ: 'OE',
  ɼ: 'r',
  ɽ: 'r',
  ɾ: 'r',
  ɿ: 'r',
  ʀ: 'R',
  ʁ: 'R',
  ʂ: 's',
  ʄ: 'j',
  ʇ: 't',
  ʈ: 't',
  ʉ: 'u',
  ʋ: 'v',
  ʌ: 'v',
  ʍ: 'w',
  ʎ: 'y',
  ʏ: 'Y',
  ʐ: 'z',
  ʑ: 'z',
  ʗ: 'C',
  ʙ: 'B',
  ʚ: 'e',
  ʛ: 'G',
  ʜ: 'H',
  ʝ: 'j',
  ʞ: 'k',
  ʟ: 'L',
  ʠ: 'q',
  ʣ: 'dz',
  ʥ: 'dz',
  ʦ: 'ts',
  ʨ: 'tc',
  ʪ: 'ls',
  ʫ: 'lz',
  ʮ: 'h',
  ʯ: 'h',
  ᴀ: 'A',
  ᴁ: 'AE',
  ᴂ: 'ae',
  ᴃ: 'B',
  ᴄ: 'C',
  ᴅ: 'D',
  ᴆ: 'D',
  ᴇ: 'E',
  ᴈ: 'e',
  ᴉ: 'i',
  ᴊ: 'J',
  ᴋ: 'K',
  ᴌ: 'L',
  ᴍ: 'M',
  ᴎ: 'N',
  ᴏ: 'O',
  ᴐ: 'O',
  ᴔ: 'oe',
  ᴕ: 'OU',
  ᴖ: 'o',
  ᴗ: 'o',
  ᴘ: 'P',
  ᴙ: 'R',
  ᴚ: 'R',
  ᴛ: 'T',
  ᴜ: 'U',
  ᴠ: 'V',
  ᴡ: 'W',
  ᴢ: 'Z',
  ᵢ: 'i',
  ᵣ: 'r',
  ᵤ: 'u',
  ᵥ: 'v',
  ᵫ: 'ue',
  ᵬ: 'b',
  ᵭ: 'd',
  ᵮ: 'f',
  ᵯ: 'm',
  ᵰ: 'n',
  ᵱ: 'p',
  ᵲ: 'r',
  ᵳ: 'r',
  ᵴ: 's',
  ᵵ: 't',
  ᵶ: 'z',
  ᵷ: 'g',
  ᵹ: 'g',
  ᵺ: 'th',
  ᵻ: 'I',
  ᵼ: 'i',
  ᵽ: 'p',
  ᵾ: 'U',
  ᶀ: 'b',
  ᶁ: 'd',
  ᶂ: 'f',
  ᶃ: 'g',
  ᶄ: 'k',
  ᶅ: 'l',
  ᶆ: 'm',
  ᶇ: 'n',
  ᶈ: 'p',
  ᶉ: 'r',
  ᶊ: 's',
  ᶌ: 'v',
  ᶍ: 'x',
  ᶎ: 'z',
  ᶏ: 'a',
  ᶑ: 'd',
  ᶒ: 'e',
  ᶓ: 'e',
  ᶔ: 'e',
  ᶕ: 'a',
  ᶖ: 'i',
  ᶗ: 'o',
  ᶙ: 'u',
  Ḁ: 'A',
  ḁ: 'a',
  Ḃ: 'B',
  ḃ: 'b',
  Ḅ: 'B',
  ḅ: 'b',
  Ḇ: 'B',
  ḇ: 'b',
  Ḉ: 'C',
  ḉ: 'c',
  Ḋ: 'D',
  ḋ: 'd',
  Ḍ: 'D',
  ḍ: 'd',
  Ḏ: 'D',
  ḏ: 'd',
  Ḑ: 'D',
  ḑ: 'd',
  Ḓ: 'D',
  ḓ: 'd',
  Ḕ: 'E',
  ḕ: 'e',
  Ḗ: 'E',
  ḗ: 'e',
  Ḙ: 'E',
  ḙ: 'e',
  Ḛ: 'E',
  ḛ: 'e',
  Ḝ: 'E',
  ḝ: 'e',
  Ḟ: 'F',
  ḟ: 'f',
  Ḡ: 'G',
  ḡ: 'g',
  Ḣ: 'H',
  ḣ: 'h',
  Ḥ: 'H',
  ḥ: 'h',
  Ḧ: 'H',
  ḧ: 'h',
  Ḩ: 'H',
  ḩ: 'h',
  Ḫ: 'H',
  ḫ: 'h',
  Ḭ: 'I',
  ḭ: 'i',
  Ḯ: 'I',
  ḯ: 'i',
  Ḱ: 'K',
  ḱ: 'k',
  Ḳ: 'K',
  ḳ: 'k',
  Ḵ: 'K',
  ḵ: 'k',
  Ḷ: 'L',
  ḷ: 'l',
  Ḹ: 'L',
  ḹ: 'l',
  Ḻ: 'L',
  ḻ: 'l',
  Ḽ: 'L',
  ḽ: 'l',
  Ḿ: 'M',
  ḿ: 'm',
  Ṁ: 'M',
  ṁ: 'm',
  Ṃ: 'M',
  ṃ: 'm',
  Ṅ: 'N',
  ṅ: 'n',
  Ṇ: 'N',
  ṇ: 'n',
  Ṉ: 'N',
  ṉ: 'n',
  Ṋ: 'N',
  ṋ: 'n',
  Ṍ: 'O',
  ṍ: 'o',
  Ṏ: 'O',
  ṏ: 'o',
  Ṑ: 'O',
  ṑ: 'o',
  Ṓ: 'O',
  ṓ: 'o',
  Ṕ: 'P',
  ṕ: 'p',
  Ṗ: 'P',
  ṗ: 'p',
  Ṙ: 'R',
  ṙ: 'r',
  Ṛ: 'R',
  ṛ: 'r',
  Ṝ: 'R',
  ṝ: 'r',
  Ṟ: 'R',
  ṟ: 'r',
  Ṡ: 'S',
  ṡ: 's',
  Ṣ: 'S',
  ṣ: 's',
  Ṥ: 'S',
  ṥ: 's',
  Ṧ: 'S',
  ṧ: 's',
  Ṩ: 'S',
  ṩ: 's',
  Ṫ: 'T',
  ṫ: 't',
  Ṭ: 'T',
  ṭ: 't',
  Ṯ: 'T',
  ṯ: 't',
  Ṱ: 'T',
  ṱ: 't',
  Ṳ: 'U',
  ṳ: 'u',
  Ṵ: 'U',
  ṵ: 'u',
  Ṷ: 'U',
  ṷ: 'u',
  Ṹ: 'U',
  ṹ: 'u',
  Ṻ: 'U',
  ṻ: 'u',
  Ṽ: 'V',
  ṽ: 'v',
  Ṿ: 'V',
  ṿ: 'v',
  Ẁ: 'W',
  ẁ: 'w',
  Ẃ: 'W',
  ẃ: 'w',
  Ẅ: 'W',
  ẅ: 'w',
  Ẇ: 'W',
  ẇ: 'w',
  Ẉ: 'W',
  ẉ: 'w',
  Ẋ: 'X',
  ẋ: 'x',
  Ẍ: 'X',
  ẍ: 'x',
  Ẏ: 'Y',
  ẏ: 'y',
  Ẑ: 'Z',
  ẑ: 'z',
  Ẓ: 'Z',
  ẓ: 'z',
  Ẕ: 'Z',
  ẕ: 'z',
  ẖ: 'h',
  ẗ: 't',
  ẘ: 'w',
  ẙ: 'y',
  ẚ: 'a',
  ẛ: 'f',
  ẜ: 's',
  ẝ: 's',
  ẞ: 'SS',
  Ạ: 'A',
  ạ: 'a',
  Ả: 'A',
  ả: 'a',
  Ấ: 'A',
  ấ: 'a',
  Ầ: 'A',
  ầ: 'a',
  Ẩ: 'A',
  ẩ: 'a',
  Ẫ: 'A',
  ẫ: 'a',
  Ậ: 'A',
  ậ: 'a',
  Ắ: 'A',
  ắ: 'a',
  Ằ: 'A',
  ằ: 'a',
  Ẳ: 'A',
  ẳ: 'a',
  Ẵ: 'A',
  ẵ: 'a',
  Ặ: 'A',
  ặ: 'a',
  Ẹ: 'E',
  ẹ: 'e',
  Ẻ: 'E',
  ẻ: 'e',
  Ẽ: 'E',
  ẽ: 'e',
  Ế: 'E',
  ế: 'e',
  Ề: 'E',
  ề: 'e',
  Ể: 'E',
  ể: 'e',
  Ễ: 'E',
  ễ: 'e',
  Ệ: 'E',
  ệ: 'e',
  Ỉ: 'I',
  ỉ: 'i',
  Ị: 'I',
  ị: 'i',
  Ọ: 'O',
  ọ: 'o',
  Ỏ: 'O',
  ỏ: 'o',
  Ố: 'O',
  ố: 'o',
  Ồ: 'O',
  ồ: 'o',
  Ổ: 'O',
  ổ: 'o',
  Ỗ: 'O',
  ỗ: 'o',
  Ộ: 'O',
  ộ: 'o',
  Ớ: 'O',
  ớ: 'o',
  Ờ: 'O',
  ờ: 'o',
  Ở: 'O',
  ở: 'o',
  Ỡ: 'O',
  ỡ: 'o',
  Ợ: 'O',
  ợ: 'o',
  Ụ: 'U',
  ụ: 'u',
  Ủ: 'U',
  ủ: 'u',
  Ứ: 'U',
  ứ: 'u',
  Ừ: 'U',
  ừ: 'u',
  Ử: 'U',
  ử: 'u',
  Ữ: 'U',
  ữ: 'u',
  Ự: 'U',
  ự: 'u',
  Ỳ: 'Y',
  ỳ: 'y',
  Ỵ: 'Y',
  ỵ: 'y',
  Ỷ: 'Y',
  ỷ: 'y',
  Ỹ: 'Y',
  ỹ: 'y',
  Ỻ: 'LL',
  ỻ: 'll',
  Ỽ: 'V',
  Ỿ: 'Y',
  ỿ: 'y',
  '‐': '-',
  '‑': '-',
  '‒': '-',
  '–': '-',
  '—': '-',
  '‘': '"',
  '’': '"',
  '‚': '"',
  '‛': '"',
  '“': '"',
  '”': '"',
  '„': '"',
  '′': '"',
  '″': '"',
  '‵': '"',
  '‶': '"',
  '‸': '^',
  '‹': '"',
  '›': '"',
  '‼': '!!',
  '⁄': '/',
  '⁅': '[',
  '⁆': ']',
  '⁇': '??',
  '⁈': '?!',
  '⁉': '!?',
  '⁎': '*',
  '⁏': ';',
  '⁒': '%',
  '⁓': '~',
  '⁰': '0',
  ⁱ: 'i',
  '⁴': '4',
  '⁵': '5',
  '⁶': '6',
  '⁷': '7',
  '⁸': '8',
  '⁹': '9',
  '⁺': '+',
  '⁻': '-',
  '⁼': '=',
  '⁽': '(',
  '⁾': ')',
  ⁿ: 'n',
  '₀': '0',
  '₁': '1',
  '₂': '2',
  '₃': '3',
  '₄': '4',
  '₅': '5',
  '₆': '6',
  '₇': '7',
  '₈': '8',
  '₉': '9',
  '₊': '+',
  '₋': '-',
  '₌': '=',
  '₍': '(',
  '₎': ')',
  ₐ: 'a',
  ₑ: 'e',
  ₒ: 'o',
  ₓ: 'x',
  ₔ: 'a',
  ↄ: 'c',
  '①': '1',
  '②': '2',
  '③': '3',
  '④': '4',
  '⑤': '5',
  '⑥': '6',
  '⑦': '7',
  '⑧': '8',
  '⑨': '9',
  '⑩': '10',
  '⑪': '11',
  '⑫': '12',
  '⑬': '13',
  '⑭': '14',
  '⑮': '15',
  '⑯': '16',
  '⑰': '17',
  '⑱': '18',
  '⑲': '19',
  '⑳': '20',
  '⑴': '(1)',
  '⑵': '(2)',
  '⑶': '(3)',
  '⑷': '(4)',
  '⑸': '(5)',
  '⑹': '(6)',
  '⑺': '(7)',
  '⑻': '(8)',
  '⑼': '(9)',
  '⑽': '(10)',
  '⑾': '(11)',
  '⑿': '(12)',
  '⒀': '(13)',
  '⒁': '(14)',
  '⒂': '(15)',
  '⒃': '(16)',
  '⒄': '(17)',
  '⒅': '(18)',
  '⒆': '(19)',
  '⒇': '(20)',
  '⒈': '1.',
  '⒉': '2.',
  '⒊': '3.',
  '⒋': '4.',
  '⒌': '5.',
  '⒍': '6.',
  '⒎': '7.',
  '⒏': '8.',
  '⒐': '9.',
  '⒑': '10.',
  '⒒': '11.',
  '⒓': '12.',
  '⒔': '13.',
  '⒕': '14.',
  '⒖': '15.',
  '⒗': '16.',
  '⒘': '17.',
  '⒙': '18.',
  '⒚': '19.',
  '⒛': '20.',
  '⒜': '(a)',
  '⒝': '(b)',
  '⒞': '(c)',
  '⒟': '(d)',
  '⒠': '(e)',
  '⒡': '(f)',
  '⒢': '(g)',
  '⒣': '(h)',
  '⒤': '(i)',
  '⒥': '(j)',
  '⒦': '(k)',
  '⒧': '(l)',
  '⒨': '(m)',
  '⒩': '(n)',
  '⒪': '(o)',
  '⒫': '(p)',
  '⒬': '(q)',
  '⒭': '(r)',
  '⒮': '(s)',
  '⒯': '(t)',
  '⒰': '(u)',
  '⒱': '(v)',
  '⒲': '(w)',
  '⒳': '(x)',
  '⒴': '(y)',
  '⒵': '(z)',
  'Ⓐ': 'A',
  'Ⓑ': 'B',
  'Ⓒ': 'C',
  'Ⓓ': 'D',
  'Ⓔ': 'E',
  'Ⓕ': 'F',
  'Ⓖ': 'G',
  'Ⓗ': 'H',
  'Ⓘ': 'I',
  'Ⓙ': 'J',
  'Ⓚ': 'K',
  'Ⓛ': 'L',
  'Ⓜ': 'M',
  'Ⓝ': 'N',
  'Ⓞ': 'O',
  'Ⓟ': 'P',
  'Ⓠ': 'Q',
  'Ⓡ': 'R',
  'Ⓢ': 'S',
  'Ⓣ': 'T',
  'Ⓤ': 'U',
  'Ⓥ': 'V',
  'Ⓦ': 'W',
  'Ⓧ': 'X',
  'Ⓨ': 'Y',
  'Ⓩ': 'Z',
  'ⓐ': 'a',
  'ⓑ': 'b',
  'ⓒ': 'c',
  'ⓓ': 'd',
  'ⓔ': 'e',
  'ⓕ': 'f',
  'ⓖ': 'g',
  'ⓗ': 'h',
  'ⓘ': 'i',
  'ⓙ': 'j',
  'ⓚ': 'k',
  'ⓛ': 'l',
  'ⓜ': 'm',
  'ⓝ': 'n',
  'ⓞ': 'o',
  'ⓟ': 'p',
  'ⓠ': 'q',
  'ⓡ': 'r',
  'ⓢ': 's',
  'ⓣ': 't',
  'ⓤ': 'u',
  'ⓥ': 'v',
  'ⓦ': 'w',
  'ⓧ': 'x',
  'ⓨ': 'y',
  'ⓩ': 'z',
  '⓪': '0',
  '⓫': '11',
  '⓬': '12',
  '⓭': '13',
  '⓮': '14',
  '⓯': '15',
  '⓰': '16',
  '⓱': '17',
  '⓲': '18',
  '⓳': '19',
  '⓴': '20',
  '⓵': '1',
  '⓶': '2',
  '⓷': '3',
  '⓸': '4',
  '⓹': '5',
  '⓺': '6',
  '⓻': '7',
  '⓼': '8',
  '⓽': '9',
  '⓾': '10',
  '⓿': '0',
  '❛': '"',
  '❜': '"',
  '❝': '"',
  '❞': '"',
  '❨': '(',
  '❩': ')',
  '❪': '(',
  '❫': ')',
  '❬': '<',
  '❭': '>',
  '❮': '"',
  '❯': '"',
  '❰': '<',
  '❱': '>',
  '❲': '[',
  '❳': ']',
  '❴': '{',
  '❵': '}',
  '❶': '1',
  '❷': '2',
  '❸': '3',
  '❹': '4',
  '❺': '5',
  '❻': '6',
  '❼': '7',
  '❽': '8',
  '❾': '9',
  '❿': '10',
  '➀': '1',
  '➁': '2',
  '➂': '3',
  '➃': '4',
  '➄': '5',
  '➅': '6',
  '➆': '7',
  '➇': '8',
  '➈': '9',
  '➉': '10',
  '➊': '1',
  '➋': '2',
  '➌': '3',
  '➍': '4',
  '➎': '5',
  '➏': '6',
  '➐': '7',
  '➑': '8',
  '➒': '9',
  '➓': '10',
  Ⱡ: 'L',
  ⱡ: 'l',
  Ɫ: 'L',
  Ᵽ: 'P',
  Ɽ: 'R',
  ⱥ: 'a',
  ⱦ: 't',
  Ⱨ: 'H',
  ⱨ: 'h',
  Ⱪ: 'K',
  ⱪ: 'k',
  Ⱬ: 'Z',
  ⱬ: 'z',
  Ɱ: 'M',
  Ɐ: 'a',
  ⱱ: 'v',
  Ⱳ: 'W',
  ⱳ: 'w',
  ⱴ: 'v',
  Ⱶ: 'H',
  ⱶ: 'h',
  ⱸ: 'e',
  ⱺ: 'o',
  ⱻ: 'E',
  ⱼ: 'j',
  '⸨': '((',
  '⸩': '))',
  Ꜩ: 'TZ',
  ꜩ: 'tz',
  ꜰ: 'F',
  ꜱ: 'S',
  Ꜳ: 'AA',
  ꜳ: 'aa',
  Ꜵ: 'AO',
  ꜵ: 'ao',
  Ꜷ: 'AU',
  ꜷ: 'au',
  Ꜹ: 'AV',
  ꜹ: 'av',
  Ꜻ: 'AV',
  ꜻ: 'av',
  Ꜽ: 'AY',
  ꜽ: 'ay',
  Ꜿ: 'c',
  ꜿ: 'c',
  Ꝁ: 'K',
  ꝁ: 'k',
  Ꝃ: 'K',
  ꝃ: 'k',
  Ꝅ: 'K',
  ꝅ: 'k',
  Ꝇ: 'L',
  ꝇ: 'l',
  Ꝉ: 'L',
  ꝉ: 'l',
  Ꝋ: 'O',
  ꝋ: 'o',
  Ꝍ: 'O',
  ꝍ: 'o',
  Ꝏ: 'OO',
  ꝏ: 'oo',
  Ꝑ: 'P',
  ꝑ: 'p',
  Ꝓ: 'P',
  ꝓ: 'p',
  Ꝕ: 'P',
  ꝕ: 'p',
  Ꝗ: 'Q',
  ꝗ: 'q',
  Ꝙ: 'Q',
  ꝙ: 'q',
  Ꝛ: 'R',
  ꝛ: 'r',
  Ꝟ: 'V',
  ꝟ: 'v',
  Ꝡ: 'VY',
  ꝡ: 'vy',
  Ꝣ: 'Z',
  ꝣ: 'z',
  Ꝧ: 'TH',
  ꝧ: 'th',
  Ꝩ: 'V',
  Ꝺ: 'D',
  ꝺ: 'd',
  Ꝼ: 'F',
  ꝼ: 'f',
  Ᵹ: 'G',
  Ꝿ: 'G',
  ꝿ: 'g',
  Ꞁ: 'L',
  ꞁ: 'l',
  Ꞃ: 'R',
  ꞃ: 'r',
  Ꞅ: 's',
  ꞅ: 'S',
  Ꞇ: 'T',
  ꟻ: 'F',
  ꟼ: 'p',
  ꟽ: 'M',
  ꟾ: 'I',
  ꟿ: 'M',
  ﬀ: 'ff',
  ﬁ: 'fi',
  ﬂ: 'fl',
  ﬃ: 'ffi',
  ﬄ: 'ffl',
  ﬆ: 'st',
  '！': '!',
  '＂': '"',
  '＃': '#',
  '＄': '$',
  '％': '%',
  '＆': '&',
  '＇': '"',
  '（': '(',
  '）': ')',
  '＊': '*',
  '＋': '+',
  '，': ',',
  '－': '-',
  '．': '.',
  '／': '/',
  '０': '0',
  '１': '1',
  '２': '2',
  '３': '3',
  '４': '4',
  '５': '5',
  '６': '6',
  '７': '7',
  '８': '8',
  '９': '9',
  '：': ':',
  '；': ';',
  '＜': '<',
  '＝': '=',
  '＞': '>',
  '？': '?',
  '＠': '@',
  Ａ: 'A',
  Ｂ: 'B',
  Ｃ: 'C',
  Ｄ: 'D',
  Ｅ: 'E',
  Ｆ: 'F',
  Ｇ: 'G',
  Ｈ: 'H',
  Ｉ: 'I',
  Ｊ: 'J',
  Ｋ: 'K',
  Ｌ: 'L',
  Ｍ: 'M',
  Ｎ: 'N',
  Ｏ: 'O',
  Ｐ: 'P',
  Ｑ: 'Q',
  Ｒ: 'R',
  Ｓ: 'S',
  Ｔ: 'T',
  Ｕ: 'U',
  Ｖ: 'V',
  Ｗ: 'W',
  Ｘ: 'X',
  Ｙ: 'Y',
  Ｚ: 'Z',
  '［': '[',
  '＼': '\\',
  '］': ']',
  '＾': '^',
  '＿': '_',
  ａ: 'a',
  ｂ: 'b',
  ｃ: 'c',
  ｄ: 'd',
  ｅ: 'e',
  ｆ: 'f',
  ｇ: 'g',
  ｈ: 'h',
  ｉ: 'i',
  ｊ: 'j',
  ｋ: 'k',
  ｌ: 'l',
  ｍ: 'm',
  ｎ: 'n',
  ｏ: 'o',
  ｐ: 'p',
  ｑ: 'q',
  ｒ: 'r',
  ｓ: 's',
  ｔ: 't',
  ｕ: 'u',
  ｖ: 'v',
  ｗ: 'w',
  ｘ: 'x',
  ｙ: 'y',
  ｚ: 'z',
  '｛': '{',
  '｝': '}',
  '～': '~'
};

var _excluded$2 = ["label"];
function ownKeys$b(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$b(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$b(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$b(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

// flattens a nested array
var flatten$1 = function flatten(arr) {
  return arr.reduce(function (flat, toFlatten) {
    return flat.concat(Array.isArray(toFlatten) ? flatten(toFlatten) : toFlatten);
  }, []);
};
var extractSuggestion = function extractSuggestion(val) {
  switch (_typeof(val)) {
    case 'string':
      return val;
    case 'object':
      if (Array.isArray(val)) {
        return flatten$1(val);
      }
      return null;
    default:
      return val;
  }
};
function replaceDiacritics(s) {
  var str = s ? String(s) : '';
  for (var i = 0; i < str.length; i++) {
    var currentChar = str.charAt(i);
    if (diacritics[currentChar]) {
      str = str.replaceAll(currentChar, diacritics[currentChar]);
    }
  }
  return str;
}
function escapeRegExp() {
  var string = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return string.replace(/[.*+?^${}()|[\]\\]/g, '\\$&'); // $& means the whole matched string
}
var getPredictiveSuggestions = function getPredictiveSuggestions(_ref) {
  var suggestions = _ref.suggestions,
    currentValue = _ref.currentValue,
    wordsToShowAfterHighlight = _ref.wordsToShowAfterHighlight;
  var suggestionMap = {};
  if (currentValue) {
    var currentValueTrimmed = currentValue.trim();
    var parsedSuggestion = suggestions.reduce(function (agg, _ref2) {
      var label = _ref2.label,
        rest = _objectWithoutProperties(_ref2, _excluded$2);
      // to handle special strings with pattern '<mark>xyz</mark> <a href="test'
      var parsedContent = new DOMParser().parseFromString(label, 'text/html').documentElement.textContent;

      // to match the partial start of word.
      // example if searchTerm is `select` and string contains `selected`
      var regexString = "^(".concat(escapeRegExp(currentValueTrimmed), ")\\w+");
      var regex = new RegExp(regexString, 'i');
      var regexExecution = regex.exec(parsedContent);
      // if execution value is null it means either there is no match or there are chances
      // that exact word is present
      if (!regexExecution) {
        // regex to match exact word
        regexString = "^(".concat(escapeRegExp(currentValueTrimmed), ")");
        regex = new RegExp(regexString, 'i');
        regexExecution = regex.exec(parsedContent);
      }
      if (regexExecution) {
        var matchedString = parsedContent.slice(regexExecution.index, parsedContent.length);
        var highlightedWord = matchedString.slice(currentValueTrimmed.length).split(' ').slice(0, wordsToShowAfterHighlight + 1).join(' ');
        var suggestionPhrase = "".concat(currentValueTrimmed, "<mark class=\"highlight\">").concat(highlightedWord, "</mark>");
        var suggestionValue = "".concat(currentValueTrimmed).concat(highlightedWord);
        // to show unique results only
        if (!suggestionMap[suggestionPhrase]) {
          suggestionMap[suggestionPhrase] = 1;
          return [].concat(_toConsumableArray(agg), [_objectSpread$b(_objectSpread$b({}, rest), {}, {
            label: suggestionPhrase,
            value: suggestionValue,
            isPredictiveSuggestion: true
          })]);
        }
        return agg;
      }
      return agg;
    }, []);
    return parsedSuggestion;
  }
  return [];
};
var getSuggestions = function getSuggestions(_ref3) {
  var fields = _ref3.fields,
    suggestions = _ref3.suggestions,
    currentValue = _ref3.currentValue,
    _ref3$suggestionPrope = _ref3.suggestionProperties,
    suggestionProperties = _ref3$suggestionPrope === void 0 ? [] : _ref3$suggestionPrope,
    _ref3$showDistinctSug = _ref3.showDistinctSuggestions,
    showDistinctSuggestions = _ref3$showDistinctSug === void 0 ? false : _ref3$showDistinctSug,
    _ref3$enablePredictiv = _ref3.enablePredictiveSuggestions,
    enablePredictiveSuggestions = _ref3$enablePredictiv === void 0 ? false : _ref3$enablePredictiv,
    _ref3$wordsToShowAfte = _ref3.wordsToShowAfterHighlight,
    wordsToShowAfterHighlight = _ref3$wordsToShowAfte === void 0 ? 2 : _ref3$wordsToShowAfte,
    enableSynonyms = _ref3.enableSynonyms;
  /*
  	fields: DataFields passed on Search Components
  	suggestions: Raw Suggestions received from ES
  	currentValue: Search Term
  	skipWordMatch: Use to skip the word match logic, important for synonym
  	showDistinctSuggestions: When set to true will only return 1 suggestion per document
  */

  var suggestionsList = [];
  var labelsList = [];
  var skipWordMatch = false;
  var populateSuggestionsList = function populateSuggestionsList(val, parsedSource, source) {
    // check if the suggestion includes the current value
    // and not already included in other suggestions
    var isWordMatch = skipWordMatch || currentValue.trim().split(' ').some(function (term) {
      return replaceDiacritics(val).toLowerCase().includes(replaceDiacritics(term));
    });
    // promoted results should always include in suggestions even there is no match
    if (isWordMatch && !labelsList.includes(val) || source._promoted) {
      var defaultOption = {
        label: val,
        value: val,
        source: source
      };
      var additionalKeys = {};
      if (Array.isArray(suggestionProperties) && suggestionProperties.length > 0) {
        suggestionProperties.forEach(function (prop) {
          if (parsedSource.hasOwnProperty(prop)) {
            additionalKeys = _objectSpread$b(_objectSpread$b({}, additionalKeys), {}, _defineProperty({}, prop, parsedSource[prop]));
          }
        });
      }
      var option = _objectSpread$b(_objectSpread$b({}, defaultOption), additionalKeys);
      labelsList = [].concat(_toConsumableArray(labelsList), [val]);
      suggestionsList = [].concat(_toConsumableArray(suggestionsList), [option]);
      if (showDistinctSuggestions) {
        return true;
      }
    }
    return false;
  };
  var parseField = function parseField(parsedSource) {
    var field = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    var source = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : parsedSource;
    if (_typeof(parsedSource) === 'object') {
      var fieldNodes = field.split('.');
      var label = parsedSource[fieldNodes[0]];
      // To handle field names with dots
      // For example, if source has a top level field name is `user.name`
      // then it would extract the suggestion from parsed source
      if (parsedSource[field]) {
        var topLabel = parsedSource[field];
        var val = extractSuggestion(topLabel);
        if (val && typeof val === 'string') {
          return populateSuggestionsList(val, parsedSource, source);
        }
      }
      // if they type of field is array of strings
      // then we need to pick first matching value as the label
      if (Array.isArray(label)) {
        if (label.length > 1) {
          label = label.filter(function (i) {
            return i && i.toString().toLowerCase().includes(currentValue.toString().toLowerCase());
          });
        }
        label = label[0];
      }
      if (label) {
        if (fieldNodes.length > 1) {
          // nested fields of the 'foo.bar.zoo' variety
          var children = field.substring(fieldNodes[0].length + 1);
          parseField(label, children, source);
        } else {
          var _val = extractSuggestion(label);
          if (_val) {
            return populateSuggestionsList(_val, parsedSource, source);
          }
        }
      }
    }
    return false;
  };
  var traverseSuggestions = function traverseSuggestions() {
    suggestions.forEach(function (item) {
      fields.forEach(function (field) {
        parseField(item, field);
      });
    });
  };
  traverseSuggestions();
  if (suggestionsList.length < suggestions.length && !skipWordMatch && enableSynonyms) {
    /*
    	When we have synonym we set skipWordMatch to false as it may discard
    	the suggestion if word doesnt match term.
    	For eg: iphone, ios are synonyms and on searching iphone isWordMatch
    	in  populateSuggestionList may discard ios source which decreases no.
    	of items in suggestionsList
    */
    skipWordMatch = true;
    traverseSuggestions();
  }
  if (enablePredictiveSuggestions) {
    var predictiveSuggestions = getPredictiveSuggestions({
      suggestions: suggestionsList,
      currentValue: currentValue,
      wordsToShowAfterHighlight: wordsToShowAfterHighlight
    });
    suggestionsList = predictiveSuggestions;
  }
  if (showDistinctSuggestions) {
    var idMap = {};
    var filteredSuggestions = [];
    suggestionsList.forEach(function (suggestion) {
      if (suggestion.source && suggestion.source._id) {
        if (!idMap[suggestion.source._id]) {
          filteredSuggestions.push(suggestion);
          idMap[suggestion.source._id] = true;
        }
      }
    });
    return filteredSuggestions;
  }
  return suggestionsList;
};

var _componentTypeToDefau;
var _excluded$1 = ["query"],
  _excluded2 = ["query", "id", "params"],
  _excluded3 = ["query"],
  _excluded4 = ["headers", "body"];
function ownKeys$a(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$a(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$a(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$a(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var updateCustomQuery = function updateCustomQuery(componentId, props, value) {
  if (props.customQuery && typeof props.customQuery === 'function') {
    props.setCustomQuery(componentId, props.customQuery(value, props));
  }
};
var updateDefaultQuery = function updateDefaultQuery(componentId, props, value) {
  if (props.defaultQuery && typeof props.defaultQuery === 'function') {
    props.setDefaultQuery(componentId, props.defaultQuery(value, props));
  }
};
function isEqual(x, y) {
  if (x === y) return true;
  if (!(x instanceof Object) || !(y instanceof Object)) return false;
  if (x.constructor !== y.constructor) return false;

  /* eslint-disable */
  for (var p in x) {
    if (!x.hasOwnProperty(p)) continue;
    if (!y.hasOwnProperty(p)) return false;
    if (x[p] === y[p]) continue;
    if (_typeof(x[p]) !== 'object') return false;
    if (!isEqual(x[p], y[p])) return false;
  }
  for (var _p in y) {
    if (y.hasOwnProperty(_p) && !x.hasOwnProperty(_p)) return false;
  }
  /* eslint-enable */
  return true;
}
/* eslint-enable */

function compareQueries(x, y) {
  try {
    // de-reference objects then compare
    return isEqual(JSON.parse(JSON.stringify(x)), JSON.parse(JSON.stringify(y)));
  } catch (e) {
    return false;
  }
}
function debounce(callback, wait) {
  var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this;
  if (!wait) {
    return callback;
  }
  var timeout = null;
  var callbackArgs = null;
  var later = function later() {
    return callback.apply(context, callbackArgs);
  };
  return function debouncedFunction() {
    callbackArgs = arguments; // eslint-disable-line
    clearTimeout(timeout);
    timeout = setTimeout(later, wait);
  };
}
function getQueryOptions(props) {
  var options = {};
  if (props.size !== undefined) {
    options.size = props.size;
  }
  if (props.includeFields || props.excludeFields) {
    var source = {};
    if (props.includeFields) {
      source.includes = props.includeFields;
    }
    if (props.excludeFields) {
      source.excludes = props.excludeFields;
    }
    options._source = source;
  }
  return options;
}
function getOperation(conjunction) {
  if (conjunction === 'and') {
    return 'must';
  }
  if (conjunction === 'or') {
    return 'should';
  }
  return 'must_not';
}
function createBoolQuery(operation, query) {
  var resultQuery = null;
  if (Array.isArray(query) && query.length || !Array.isArray(query) && query) {
    resultQuery = {
      bool: _defineProperty({}, operation, query)
    };
  }
  if (operation === 'should' && resultQuery) {
    resultQuery = {
      bool: _objectSpread$a(_objectSpread$a({}, resultQuery.bool), {}, {
        minimum_should_match: 1
      })
    };
  }
  return resultQuery;
}
function getQuery(react, queryList) {
  var query = [];
  Object.keys(react).forEach(function (conjunction) {
    if (Array.isArray(react[conjunction])) {
      var operation = getOperation(conjunction);
      var queryArr = react[conjunction].map(function (comp) {
        if (typeof comp !== 'string') {
          // in this case, we have { <conjunction>: <> } objects inside the array
          return getQuery(comp, queryList);
        } else if (comp in queryList) {
          if (queryList[comp] && Object.keys(queryList[comp]).length) {
            return queryList[comp];
          }
        }
        return null;
      }).filter(function (item) {
        return !!item;
      });
      var boolQuery = createBoolQuery(operation, queryArr);
      if (boolQuery && Object.keys(boolQuery).length) {
        query = [].concat(_toConsumableArray(query), [boolQuery]);
      }
    } else if (typeof react[conjunction] === 'string') {
      var _operation = getOperation(conjunction);
      var _boolQuery = createBoolQuery(_operation, queryList[react[conjunction]]);
      if (_boolQuery && Object.keys(_boolQuery).length) {
        query = [].concat(_toConsumableArray(query), [_boolQuery]);
      }
    } else if (_typeof(react[conjunction]) === 'object' && react[conjunction] !== null) {
      var _boolQuery2 = getQuery(react[conjunction], queryList);
      if (_boolQuery2 && Object.keys(_boolQuery2).length) {
        query = [].concat(_toConsumableArray(query), [_boolQuery2]);
      }
    }
  });
  if (Array.isArray(query) && query.length) {
    return {
      bool: {
        must: query
      }
    };
  }
  if (query && Object.keys(query).length) {
    return query;
  }
  return null;
}
function getExternalQueryOptions(react, options, component) {
  var queryOptions = {};
  Object.keys(react).forEach(function (conjunction) {
    if (Array.isArray(react[conjunction])) {
      react[conjunction].forEach(function (comp) {
        if (options[comp]) {
          queryOptions = _objectSpread$a(_objectSpread$a({}, queryOptions), options[comp]);
        }
      });
    } else if (typeof react[conjunction] === 'string') {
      if (options[react[conjunction]]) {
        queryOptions = _objectSpread$a(_objectSpread$a({}, queryOptions), options[react[conjunction]]);
      }
    } else if (_typeof(react[conjunction]) === 'object' && react[conjunction] !== null && !Array.isArray(react[conjunction])) {
      queryOptions = _objectSpread$a(_objectSpread$a({}, queryOptions), getExternalQueryOptions(react[conjunction], options));
    }
  });
  if (options[component]) {
    queryOptions = _objectSpread$a(_objectSpread$a({}, queryOptions), options[component]);
  }
  return queryOptions;
}
function buildQuery(component, dependencyTree, queryList, queryOptions) {
  var queryObj = null;
  var options = null;
  if (component in dependencyTree) {
    queryObj = getQuery(dependencyTree[component], queryList);
    options = getExternalQueryOptions(dependencyTree[component], queryOptions, component);
  }
  return {
    queryObj: queryObj,
    options: options
  };
}
function pushToAndClause(reactProp, component) {
  var react = Object.assign({}, reactProp);
  if (react.and) {
    if (Array.isArray(react.and)) {
      react.and = [].concat(_toConsumableArray(react.and), [component]);
      return react;
    } else if (typeof react.and === 'string') {
      react.and = [react.and, component];
      return react;
    }
    react.and = pushToAndClause(react.and, component);
    return react;
  }
  return _objectSpread$a(_objectSpread$a({}, react), {}, {
    and: component
  });
}

// checks and executes beforeValueChange for sensors
function checkValueChange(componentId, value, beforeValueChange, performUpdate) {
  var selectedValue = value;
  // To ensure that the returned values are consistent across all the components
  // null is returned in case of an empty array
  if (Array.isArray(value) && !value.length) {
    selectedValue = null;
  }
  var handleError = function handleError(e) {
    console.warn("".concat(componentId, " - beforeValueChange rejected the promise with "), e);
  };
  if (beforeValueChange) {
    try {
      var promise = beforeValueChange(selectedValue);
      if (promise instanceof Promise) {
        promise.then(performUpdate)["catch"](handleError);
      } else {
        performUpdate();
      }
    } catch (e) {
      handleError(e);
    }
  } else {
    performUpdate();
  }
}
function getAggsOrder(sortBy) {
  if (sortBy === 'count') {
    return {
      _count: 'desc'
    };
  }
  return {
    _key: sortBy
  };
}

// checks for props changes that would need to update the query via callback
var checkPropChange = function checkPropChange(prevProp, nextProp, callback) {
  if (!isEqual(prevProp, nextProp)) {
    callback();
    return true;
  }
  return false;
};

// checks for any prop change in the propsList and invokes the callback
var checkSomePropChange = function checkSomePropChange() {
  var prevProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var nextProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var propsList = arguments.length > 2 ? arguments[2] : undefined;
  var callback = arguments.length > 3 ? arguments[3] : undefined;
  propsList.some(function (prop) {
    return checkPropChange(prevProps[prop], nextProps[prop], callback);
  });
};
var getClassName = function getClassName(classMap, component) {
  return classMap && classMap[component] || '';
};
var getInnerKey = function getInnerKey(obj, key) {
  return obj && obj[key] || {};
};
var handleA11yAction = function handleA11yAction(e, callback) {
  if (e.key === 'Enter' || e.key === ' ') {
    e.preventDefault();
    callback();
  }
};
var highlightResults = function highlightResults(result) {
  var data = _objectSpread$a({}, result);
  if (data.highlight) {
    Object.keys(data.highlight).forEach(function (highlightItem) {
      var highlightValue = data.highlight[highlightItem][0];
      data._source = Object.assign({}, data._source, _defineProperty({}, highlightItem, highlightValue));
    });
  }
  return data;
};
var parseHits = function parseHits(hits) {
  var showHighlighted = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var results = null;
  if (hits) {
    results = _toConsumableArray(hits).map(function (item) {
      var data = _objectSpread$a({}, item);
      if (showHighlighted) data = highlightResults(item);
      var result = Object.keys(data).filter(function (key) {
        return key !== '_source';
      }).reduce(function (obj, key) {
        // eslint-disable-next-line
        obj[key] = data[key];
        return obj;
      }, _objectSpread$a({
        highlight: data.highlight || {}
      }, data._source));
      return result;
    });
  }
  return results;
};
function formatDate(date, props) {
  if (props.parseDate) {
    // We would be passing an instance of dayjs instead of xdate below. Users need to know.
    return props.parseDate(date, props);
  }
  switch (props.queryFormat) {
    case 'epoch_millis':
      return date.valueOf();
    case 'epoch_second':
      return Math.floor(date.valueOf() / 1000);
    default:
      {
        if (dateFormats[props.queryFormat]) {
          return date.format(dateFormats[props.queryFormat]);
        }
        return date.valueOf();
      }
  }
}

// Below is to convert dayjs date instance to native JS Date
function unwrapToNativeDate(wrappedDateInstance) {
  if (wrappedDateInstance) {
    return new Date(wrappedDateInstance.valueOf());
  }
  return wrappedDateInstance;
}

/**
 * To extract query options from custom or default query
 * @param {Object} customQuery
 */
var getOptionsFromQuery = function getOptionsFromQuery() {
  var customQuery = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  if (customQuery) {
    customQuery.query;
      var rest = _objectWithoutProperties(customQuery, _excluded$1);
    return Object.keys(rest).length ? rest : null;
  }
  return null;
};

/**
 * To extract query options from custom query
 * @param {Object} customQuery
 */
var getOptionsForCustomQuery = function getOptionsForCustomQuery() {
  var customQuery = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  if (customQuery) {
    customQuery.query;
      customQuery.id;
      customQuery.params;
      var rest = _objectWithoutProperties(customQuery, _excluded2);
    return Object.keys(rest).length ? rest : null;
  }
  return null;
};

// Returns the query key from custom query
// It handles the stored queries for Appbase which can have `id` at top-level
var extractQueryFromCustomQuery = function extractQueryFromCustomQuery(customQuery) {
  if (customQuery) {
    // handle stored queries
    if (customQuery.id) {
      return {
        id: customQuery.id,
        params: customQuery.params
      };
    }
    // else returns the query key
    return customQuery.query;
  }
  return null;
};
function computeResultStats() {
  var hits = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var searchState = arguments.length > 1 ? arguments[1] : undefined;
  var promotedResults = arguments.length > 2 ? arguments[2] : undefined;
  Object.keys(hits).forEach(function (componentId) {
    var _ref = hits[componentId] || {},
      hidden = _ref.hidden,
      total = _ref.total,
      time = _ref.time;
    // eslint-disable-next-line no-param-reassign
    searchState[componentId] = _objectSpread$a(_objectSpread$a({}, searchState[componentId]), {}, {
      resultStats: _objectSpread$a(_objectSpread$a({}, searchState[componentId].resultStats), {}, {
        numberOfResults: total,
        time: time,
        promoted: promotedResults[componentId] && promotedResults[componentId].length,
        hidden: hidden || 0
      })
    });
  });
}
var componentTypeToDefaultValue = (_componentTypeToDefau = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleList, ''), componentTypes.multiList, []), componentTypes.singleDataList, ''), componentTypes.singleDropdownList, ''), componentTypes.multiDataList, []), componentTypes.multiDropdownList, []), componentTypes.tagCloud, ''), componentTypes.toggleButton, ''), componentTypes.singleDropdownRange, ''), componentTypes.multiDropdownRange, []), _defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleRange, ''), componentTypes.multiRange, []));
var getSearchState = function getSearchState() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var forHeaders = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  var selectedValues = state.selectedValues,
    queryLog = state.queryLog,
    dependencyTree = state.dependencyTree,
    props = state.props,
    hits = state.hits,
    aggregations = state.aggregations,
    isLoading = state.isLoading,
    error = state.error,
    promotedResults = state.promotedResults,
    settings = state.settings,
    customData = state.customData,
    rawData = state.rawData;
  var searchState = {};
  var populateState = function populateState() {
    var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var key = arguments.length > 1 ? arguments[1] : undefined;
    return Object.keys(obj).forEach(function (componentId) {
      searchState[componentId] = _objectSpread$a(_objectSpread$a({}, searchState[componentId]), key ? _defineProperty({}, key, obj[componentId]) : obj[componentId]);
    });
  };
  populateState(props);
  Object.keys(selectedValues || {}).forEach(function (componentId) {
    var componentState = searchState[componentId];
    var selectedValue = selectedValues[componentId];
    var componentProps = props[componentId];
    var componentType = componentProps ? componentProps.componentType : null;
    if (selectedValue) {
      var s = _objectSpread$a(_objectSpread$a({}, componentState), _objectSpread$a(_objectSpread$a({
        title: selectedValue.label,
        componentType: selectedValue.componentType,
        value: selectedValue.value || componentTypeToDefaultValue[componentType]
      }, selectedValue.category && {
        category: selectedValue.category
      }), {}, {
        URLParams: selectedValue.URLParams
      }));
      if (Object.keys(s).length) {
        searchState[componentId] = s;
      }
    }
  });
  if (!forHeaders) {
    populateState(queryLog);
    populateState(hits, 'hits');
    populateState(aggregations, 'aggregations');
    populateState(isLoading, 'isLoading');
    populateState(error, 'error');
    populateState(promotedResults, 'promotedData');
    populateState(settings, 'settings');
    populateState(customData, 'customData');
    populateState(rawData, 'rawData');
    computeResultStats(hits, searchState, promotedResults);
  }
  populateState(dependencyTree, 'react');
  return searchState;
};
/**
 * Updates the query for the internal component
 */
var updateInternalQuery = function updateInternalQuery(componentId, queryOptions, value, props, defaultQueryToExecute, queryParams) {
  var defaultQuery = props.defaultQuery;
  var defaultQueryOptions;
  var query = defaultQueryToExecute;
  if (defaultQuery) {
    var queryTobeSet = defaultQuery(value, props);
    var _ref3 = queryTobeSet || {};
    query = _ref3.query;
    defaultQueryOptions = getOptionsFromQuery(queryTobeSet);
    // Update calculated default query in store
    updateDefaultQuery(componentId, props, value);
  }
  if (query) {
    props.setQueryOptions(componentId, _objectSpread$a(_objectSpread$a({}, defaultQueryOptions), queryOptions || defaultQueryToExecute));
    props.updateQuery(_objectSpread$a({
      componentId: componentId,
      query: query,
      value: value
    }, queryParams));
  } else {
    props.setQueryOptions(componentId, _objectSpread$a(_objectSpread$a({}, defaultQueryOptions), queryOptions || defaultQueryToExecute));
  }
};
// extracts query options from defaultQuery if set
var extractQueryFromDefaultQuery = function extractQueryFromDefaultQuery(props, value) {
  var queryToBeReturned = {};
  var defaultQuery = props.defaultQuery;
  /*
   do not call props.defaultQuery() directly as the client may be accessing props directly
   E.g.
   <MultiList defaultQuery={(value, props) => ({query: [props.dataField]: value})} />
  */
  if (defaultQuery) {
    var evaluateQuery = defaultQuery(value, props);
    if (evaluateQuery) {
      // we should only retrieve and set the query options here.
      // [Not implemented yet] `query` key should be handled separately for
      // adding it to `queryList` in the redux store
      evaluateQuery.query;
        var options = _objectWithoutProperties(evaluateQuery, _excluded3);
      if (options) {
        queryToBeReturned = options;
      }
    }
  }
  return queryToBeReturned;
};
var getAggsQuery = function getAggsQuery(value, query, props) {
  var clonedQuery = query;
  var dataField = props.dataField,
    size = props.size,
    sortBy = props.sortBy,
    showMissing = props.showMissing,
    missingLabel = props.missingLabel,
    aggregationSize = props.aggregationSize;
  clonedQuery.size = 0;
  if (typeof dataField === 'string') {
    clonedQuery.aggs = _defineProperty({}, dataField, {
      terms: _objectSpread$a({
        field: dataField,
        size: size,
        aggregationSize: aggregationSize,
        order: getAggsOrder(sortBy || 'count')
      }, showMissing ? {
        missing: missingLabel
      } : {})
    });
  } else {
    var aggs;
    _toConsumableArray(dataField).reverse().forEach(function (dataFieldItem) {
      aggs = _defineProperty({}, dataFieldItem, {
        terms: _objectSpread$a({
          field: dataFieldItem,
          size: size,
          aggregationSize: aggregationSize,
          order: getAggsOrder(sortBy || 'count')
        }, showMissing ? {
          missing: missingLabel
        } : {}),
        aggs: aggs
      });
    });
    clonedQuery.aggs = aggs;
  }
  if (props.nestedField) {
    clonedQuery.aggs = {
      reactivesearch_nested: {
        nested: {
          path: props.nestedField
        },
        aggs: clonedQuery.aggs
      }
    };
  }
  return _objectSpread$a(_objectSpread$a({}, clonedQuery), extractQueryFromDefaultQuery(props, value));
};
var getCompositeAggsQuery = function getCompositeAggsQuery() {
  var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    _ref4$query = _ref4.query,
    query = _ref4$query === void 0 ? {} : _ref4$query,
    props = _ref4.props,
    _ref4$after = _ref4.after,
    after = _ref4$after === void 0 ? null : _ref4$after,
    _ref4$showTopHits = _ref4.showTopHits,
    showTopHits = _ref4$showTopHits === void 0 ? false : _ref4$showTopHits,
    value = _ref4.value;
  var clonedQuery = query;
  // missing label not available in composite aggs
  var dataField = props.dataField,
    size = props.size,
    sortBy = props.sortBy,
    showMissing = props.showMissing,
    aggregationField = props.aggregationField;

  // first preference will be given to aggregationField
  var finalField = aggregationField || dataField;

  // composite aggs only allows asc and desc
  var order = sortBy === 'count' ? {} : {
    order: sortBy
  };
  clonedQuery.aggs = _defineProperty({}, finalField, _objectSpread$a({
    composite: _objectSpread$a({
      sources: [_defineProperty({}, finalField, {
        terms: _objectSpread$a(_objectSpread$a({
          field: finalField
        }, order), showMissing ? {
          missing_bucket: true
        } : {})
      })],
      size: size
    }, after)
  }, showTopHits ? {
    aggs: _defineProperty({}, finalField, {
      top_hits: {
        size: 1
      }
    })
  } : {}));
  clonedQuery.size = 0;
  if (props.nestedField) {
    clonedQuery.aggs = {
      reactivesearch_nested: {
        nested: {
          path: props.nestedField
        },
        aggs: clonedQuery.aggs
      }
    };
  }
  return _objectSpread$a(_objectSpread$a({}, clonedQuery), extractQueryFromDefaultQuery(props, value));
};
/**
 * Adds click ids in the hits(useful for trigger analytics)
 */
var withClickIds = function withClickIds() {
  var results = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return results.map(function (result, index) {
    return _objectSpread$a(_objectSpread$a({}, result), {}, {
      _click_id: index
    });
  });
};
function getResultStats(props) {
  var total = props.total,
    size = props.size,
    time = props.time,
    hidden = props.hidden,
    promotedResults = props.promotedResults;
  return _objectSpread$a(_objectSpread$a({
    numberOfResults: total
  }, size > 0 ? {
    numberOfPages: Math.ceil(total / size)
  } : null), {}, {
    time: time || 0,
    hidden: hidden,
    promoted: promotedResults ? promotedResults.length : 0
  });
}

// Util method to extract the fields from elasticsearch source object
// It can handle nested objects and arrays too.
// Example 1:
// Input: { a: 1, b: { b_1: 2, b_2: 3}}
// Output: ['a', 'b.b_1', 'b.b_2']
// Example 2:
// Input: { a: 1, b: [{c: 1}, {d: 2}, {c: 3}]}
// Output: ['a', 'b.c', 'b.d']
function extractFieldsFromSource(esSource) {
  function getFields() {
    var source = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    return Object.keys(source).reduce(function () {
      var acc = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var k = arguments.length > 1 ? arguments[1] : undefined;
      var key = prefix ? "".concat(prefix, ".").concat(k) : k;
      if (!Number.isNaN(parseInt(k, 10))) {
        key = prefix || k;
      }
      if (source[k] && _typeof(source[k]) === 'object') {
        return _objectSpread$a(_objectSpread$a({}, acc), getFields(source[k], key));
      }
      return _objectSpread$a(_objectSpread$a({}, acc), _defineProperty({}, key, true));
    }, []);
  }
  var fields = getFields(esSource);
  return Object.keys(fields);
}

// Normalizes the dataField into an array of objects
// { "field": x, "weight": y }
function normalizeDataField(dataField) {
  var fieldWeights = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  if (typeof dataField === 'string') {
    return [{
      field: dataField,
      weight: fieldWeights.length ? fieldWeights[0] : undefined
    }];
  }
  if (Array.isArray(dataField)) {
    return dataField.map(function (field, index) {
      var normalizedField = {};
      if (typeof field === 'string') {
        normalizedField.field = field;
        if (fieldWeights.length > index) {
          normalizedField.weight = fieldWeights[index];
        }
      } else if (_typeof(field) === 'object' && field && field.field) {
        normalizedField.field = field.field;
        normalizedField.weight = field.weight;
      }
      return normalizedField;
    });
  }
  if (_typeof(dataField) === 'object' && dataField) {
    return [{
      field: dataField.field,
      weight: dataField.weight
    }];
  }
  return [];
}
function handleOnSuggestions(results, currentValue, props) {
  var parseSuggestion = props.parseSuggestion,
    promotedResults = props.promotedResults,
    enablePredictiveSuggestions = props.enablePredictiveSuggestions;
  var fields = [];
  if (props.dataField) {
    fields = normalizeDataField(props.dataField).map(function (f) {
      return f.field;
    });
  } else if (results && Array.isArray(results) && results.length > 0 && results[0] && results[0]._source) {
    // Extract fields from _source
    fields = extractFieldsFromSource(results[0]._source);
  }

  // hits as flat structure
  var newResults = parseHits(results, false);
  var parsedPromotedResults = parseHits(promotedResults, false);
  if (parsedPromotedResults && parsedPromotedResults.length) {
    var ids = parsedPromotedResults.map(function (item) {
      return item._id;
    }).filter(Boolean);
    if (ids) {
      newResults = newResults.filter(function (item) {
        return !ids.includes(item._id);
      });
    }
    newResults = [].concat(_toConsumableArray(parsedPromotedResults), _toConsumableArray(newResults));
  }
  var parsedSuggestions = getSuggestions({
    fields: fields,
    suggestions: newResults,
    currentValue: currentValue.toLowerCase(),
    showDistinctSuggestions: props.showDistinctSuggestions,
    enablePredictiveSuggestions: enablePredictiveSuggestions,
    enableSynonyms: props.enableSynonyms
  });
  if (parseSuggestion) {
    return parsedSuggestions.map(function (suggestion) {
      return parseSuggestion(suggestion);
    });
  }
  return parsedSuggestions;
}
var getTopSuggestions = function getTopSuggestions(querySuggestions) {
  var currentValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var showDistinctSuggestions = arguments.length > 2 ? arguments[2] : undefined;
  var parsedSuggestions = parseHits(querySuggestions, false);
  var finalSuggestions = getSuggestions({
    fields: ['key', 'key.autosuggest', 'key.search'],
    suggestions: parsedSuggestions || [],
    currentValue: currentValue.toLowerCase(),
    showDistinctSuggestions: showDistinctSuggestions
  });
  return withClickIds(finalSuggestions);
};

/* isValidDateRangeQueryFormat() checks if the queryFormat is one of the dateFormats
	accepted by the elasticsearch or not. */
function isValidDateRangeQueryFormat(queryFormat) {
  return Object.keys(dateFormats).includes(queryFormat);
}
var suggestionTypes = {
  Popular: 'popular',
  Index: 'index',
  Recent: 'recent',
  Promoted: 'promoted',
  Featured: 'featured',
  FAQ: 'faq',
  Document: 'document'
};
var featuredSuggestionsActionTypes = {
  NAVIGATE: 'navigate',
  FUNCTION: 'function',
  SELECT: 'select'
};

// this map helps to get the interval divider
// for histogram, since the calendarinterval prop leaves
var queryFormatMillisecondsMap = {
  // the below are arranged in asscending order
  // please maintain the order if adding/ removing property(s)
  minute: 60000,
  hour: 3600000,
  day: 86400000,
  week: 604800000,
  month: 2629746000,
  quarter: 7889238000,
  year: 31556952000
};

// this function checks for subsequent calendarIntervals that would
// yield intervals well within a max cap of 100
// since displaying more than 100 bars on histogram isn't diserable
var getCalendarIntervalErrorMessage = function getCalendarIntervalErrorMessage(totalRange) {
  var calendarInterval = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'minute';
  var queryFormatMillisecondsMapKeys = Object.keys(queryFormatMillisecondsMap);
  var indexOfCurrentCalendarInterval = queryFormatMillisecondsMapKeys.indexOf(calendarInterval);
  if (indexOfCurrentCalendarInterval === -1) {
    console.error('Invalid calendarInterval Passed');
  }
  if (calendarInterval === 'year') {
    return 'Try using a shorter range of values.';
  }
  for (var index = indexOfCurrentCalendarInterval + 1; index < queryFormatMillisecondsMapKeys.length; index += 1) {
    if (totalRange / Object.values(queryFormatMillisecondsMap)[index] <= 100) {
      var calendarIntervalKey = queryFormatMillisecondsMapKeys[index];
      return {
        errorMessage: "Please pass calendarInterval prop with value greater than or equal to a `".concat(calendarIntervalKey, "` for a meaningful resolution of histogram."),
        calculatedCalendarInterval: calendarIntervalKey
      };
    }
  }
  return {
    errorMessage: 'Try using a shorter range of values.',
    calculatedCalendarInterval: 'year'
  }; // we return the highest possible interval to shorten then interval value
};
/**
 * To determine wether an element is a function
 * @param {any} element
 */
var isFunction = function isFunction(element) {
  return typeof element === 'function';
};

/**
 * Extracts the render prop from props and returns a valid React element
 * @param {Object} data
 * @param {Object} props
 */
var getComponent = function getComponent() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var children = props.children,
    render = props.render;
  // Render function as child
  if (isFunction(children)) {
    return children(data);
  }
  // Render function as render prop
  if (isFunction(render)) {
    return render(data);
  }
  return null;
};
/**
 * To determine whether a component has render prop defined or not
 * @returns {Boolean}
 */
var hasCustomRenderer = function hasCustomRenderer() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var render = props.render,
    children = props.children;
  return isFunction(children) || isFunction(render);
};

/**
 * Recursively look for a path in a nested object
 */
var recLookup = function recLookup(obj, path) {
  var separator = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '.';
  try {
    var parts = path.split(separator);
    if (parts.length === 1) {
      return obj[parts[0]];
    }
    return recLookup(obj[parts[0]], parts.slice(1).join(separator), separator);
  } catch (e) {
    return false;
  }
};

/**
 * Dynamically sets a deeply nested value in an object.
 * has been modified to comply with TreeList component implementation
 * https://stackoverflow.com/a/49754647/10822996
 */
function setDeep(obj, path, value) {
  var setrecursively = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  path.reduce(function (acc, currentItem, level) {
    if (setrecursively && _typeof(acc[currentItem]) !== 'object' && level !== path.length - 1) {
      acc[currentItem] = {};
      return acc[currentItem];
    }
    if (level === path.length - 1) {
      acc[currentItem] = value;
      return value;
    }
    return _typeof(acc[currentItem]) === 'object' ? acc[currentItem] : {};
  }, obj);
}

// transforms rawData into local state
// [
// 	{
// 		key: 'COMPACT DISC',
// 		count: 70654,
// 		level: 0,
// 		list: [
// 			{
// 				key: 'VINYL',
// 				count: 69731,
// 				level: 1,
// 				list: [
// 					{
// 						key: 'SPORTS & FITNESS',
// 						count: 12553,
// 						level: 2,
// 					},
// 				],
// 			},
// 		],
// 	},
// ];
// ⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️
// [
//     {
//         "key": "COMPACT DISC",
//         "count": 70654,
//         "level": 0,
//         "list": [
//             {
//                 "key": "VINYL",
//                 "count": 69731,
//                 "level": 1,
//                 "list": [
//                     {
//                         "key": "SPORTS & FITNESS",
//                         "count": 12553,
//                         "level": 2
//                     }
//                 ]
//             }
//         ]
//     }
// ]
var transformRawTreeListData = function transformRawTreeListData(data, dataField) {
  var level = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var newState = [];
  if (data instanceof Object) {
    var aggsKeys = Object.keys(data);
    aggsKeys.forEach(function (key) {
      if (Array.isArray(data[key].buckets)) {
        data[key].buckets.forEach(function (bucket) {
          newState.push(_objectSpread$a({
            key: bucket.key,
            count: bucket.doc_count,
            level: level
          }, bucket[dataField[level + 1]] instanceof Object ? {
            list: transformRawTreeListData(_defineProperty({}, dataField[level + 1], bucket[dataField[level + 1]]), dataField, level + 1)
          } : {}));
        });
      }
    });
  }
  return newState;
};

// transforms local selected data into query compatible format
// const object = {
//   "COMPACT DISC": {
//     "VINYL": {
//       "DRAMA/DR": true,
//       "MUSIC DVD": true,
//       "CHILDRENS-FAMILY": false
//     },
//     "MUSIC DVD": true,
//     "ROCK-ELECTRONIC": true
//   }
// };
// ⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️⬇️
// [
//     "COMPACT DISC > VINYL > DRAMA/DR",
//     "COMPACT DISC > VINYL > MUSIC DVD",
//     "COMPACT DISC > MUSIC DVD",
//     "COMPACT DISC > ROCK-ELECTRONIC"
// ]
var transformTreeListLocalStateIntoQueryComptaibleFormat = function transformTreeListLocalStateIntoQueryComptaibleFormat(obj) {
  var currentPath = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var result = [];
  if (obj instanceof Object) {
    if (Object.keys(obj).length) {
      Object.keys(obj).forEach(function (key) {
        if (obj[key] instanceof Object) {
          result.push.apply(result, _toConsumableArray(transformTreeListLocalStateIntoQueryComptaibleFormat(obj[key], currentPath ? "".concat(currentPath, " > ").concat(key) : key)));
        }
        if (obj[key] === true) {
          result.push(currentPath ? "".concat(currentPath, " > ").concat(key) : key);
        }
      });
    } else if (currentPath) {
      result.push(currentPath);
    }
  }
  return result;
};

// https://stackoverflow.com/a/65939108/10822996
var saveDataAsFile = function saveDataAsFile() {
  var filename = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'exportedData';
  var data = arguments.length > 1 ? arguments[1] : undefined;
  var format = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'csv';
  var dataToWrite = data;
  var dataType = "text/".concat(format);
  if (format === 'json') {
    dataToWrite = JSON.stringify(dataToWrite, 0, 4);
  }
  var blob = new Blob([dataToWrite], {
    type: dataType
  });
  var link = document.createElement('a');
  link.download = "".concat(filename, ".").concat(format);
  link.href = window.URL.createObjectURL(blob);
  link.dataset.downloadurl = [dataType, link.download, link.href].join(':');
  var evt = new MouseEvent('click', {
    view: window,
    bubbles: true,
    cancelable: true
  });
  link.dispatchEvent(evt);
  link.remove();
};

/**
 * A function to convert multilevel object to single level object
 * and use key value pairs as Column and row pairs using recursion
 */
var flatten = function flatten(data) {
  var result = {};
  function recurse(cur) {
    var prop = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    if (Object(cur) !== cur) {
      result[prop] = cur;
    } else if (Array.isArray(cur)) {
      result[prop] = JSON.stringify(cur);
    } else {
      var isEmpty = true;
      Object.keys(cur).forEach(function (p) {
        isEmpty = false;
        recurse(cur[p], prop ? "".concat(prop, ".").concat(p) : p);
      });
      if (isEmpty && prop) {
        result[prop] = {};
      }
    }
  }
  recurse(data);
  return result;
};

// transform request when endpoint prop is defined
var transformRequestUsingEndpoint = function transformRequestUsingEndpoint(request, endpointParam) {
  if (endpointParam instanceof Object) {
    var _endpointParam$header = endpointParam.headers,
      headers = _endpointParam$header === void 0 ? {} : _endpointParam$header,
      body = endpointParam.body,
      rest = _objectWithoutProperties(endpointParam, _excluded4);
    var endpointModifiedRequest = _objectSpread$a(_objectSpread$a(_objectSpread$a({}, request), rest), {}, {
      headers: _objectSpread$a(_objectSpread$a({}, request.headers), headers)
    }, body instanceof Object ? {
      body: JSON.stringify(body)
    } : {});
    return endpointModifiedRequest;
  }
  return request;
};

// utils/localStorage.js

var setObjectInLocalStorage = function setObjectInLocalStorage(key, value) {
  if (typeof localStorage !== 'undefined') {
    if (!key || !value) {
      throw new Error('Key and value are required for setObject');
    }
    try {
      var serializedValue = JSON.stringify(value);
      localStorage.setItem(key, serializedValue);
    } catch (error) {
      console.error('Error saving object to localStorage:', error);
    }
  } else {
    console.warn('localstorage not available');
  }
};
var getObjectFromLocalStorage = function getObjectFromLocalStorage(key) {
  if (!key) {
    throw new Error('Key is required for getObject');
  }
  try {
    var serializedValue = localStorage.getItem(key);
    if (serializedValue === null) {
      return null;
    }
    return JSON.parse(serializedValue);
  } catch (error) {
    console.error('Error retrieving object from localStorage:', error);
    return null;
  }
};

// handle converting to valid color strings in hex, rgb, rgba, hsl, and hsla formats
// useful for styles impl. using darken function from 'polished' package

var isHex = function isHex(color) {
  return /^#([A-Fa-f0-9]{3,4}){1,2}$/.test(color);
};
var isRgb = function isRgb(color) {
  return /^rgb\((\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3})\)$/.test(color);
};
var isRgba = function isRgba(color) {
  return /^rgba\((\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3}),\s*(0|1|0\.\d{1,2})\)$/.test(color);
};
var isHsl = function isHsl(color) {
  return /^hsl\(\d{1,3},\s*[\d.]+%,\s*[\d.]+%\)$/.test(color);
};
var isHsla = function isHsla(color) {
  return /^hsla\(\d{1,3},\s*[\d.]+%,\s*[\d.]+%,\s*(0|1|0\.\d{1,2})\)$/.test(color);
};
var hexToRGBA = function hexToRGBA(colorParam) {
  if (isRgb(colorParam) || isRgba(colorParam) || isHsl(colorParam) || isHsla(colorParam)) {
    return colorParam;
  }
  if (!isHex(colorParam)) {
    return null;
  }
  var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])([a-f\d])?$/i;
  var color = colorParam.replace(shorthandRegex, function (m, r, g, b, a) {
    return r + r + g + g + b + b + (a ? a + a : '');
  });
  var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})?$/i.exec(color);
  if (!result) {
    return null;
  }
  var r = parseInt(result[1], 16);
  var g = parseInt(result[2], 16);
  var b = parseInt(result[3], 16);
  var a = result[4] ? parseInt(result[4], 16) / 255 : 1;
  return "rgba(".concat(r, ", ").concat(g, ", ").concat(b, ", ").concat(a, ")");
};

// Just for debuggin
// Call this function inside the function for which
// a stack trace is needed
function getStackTrace() {
  var error = new Error();
  // eslint-disable-next-line no-console
  console.log(error.stack);
}

var helper = /*#__PURE__*/Object.freeze({
  __proto__: null,
  buildQuery: buildQuery,
  checkPropChange: checkPropChange,
  checkSomePropChange: checkSomePropChange,
  checkValueChange: checkValueChange,
  compareQueries: compareQueries,
  componentTypeToDefaultValue: componentTypeToDefaultValue,
  debounce: debounce,
  extractFieldsFromSource: extractFieldsFromSource,
  extractQueryFromCustomQuery: extractQueryFromCustomQuery,
  extractQueryFromDefaultQuery: extractQueryFromDefaultQuery,
  featuredSuggestionsActionTypes: featuredSuggestionsActionTypes,
  flatten: flatten,
  formatDate: formatDate,
  getAggsOrder: getAggsOrder,
  getAggsQuery: getAggsQuery,
  getCalendarIntervalErrorMessage: getCalendarIntervalErrorMessage,
  getClassName: getClassName,
  getComponent: getComponent,
  getCompositeAggsQuery: getCompositeAggsQuery,
  getInnerKey: getInnerKey,
  getObjectFromLocalStorage: getObjectFromLocalStorage,
  getOptionsForCustomQuery: getOptionsForCustomQuery,
  getOptionsFromQuery: getOptionsFromQuery,
  getQueryOptions: getQueryOptions,
  getResultStats: getResultStats,
  getSearchState: getSearchState,
  getStackTrace: getStackTrace,
  getTopSuggestions: getTopSuggestions,
  handleA11yAction: handleA11yAction,
  handleOnSuggestions: handleOnSuggestions,
  hasCustomRenderer: hasCustomRenderer,
  hexToRGBA: hexToRGBA,
  isEqual: isEqual,
  isFunction: isFunction,
  isValidDateRangeQueryFormat: isValidDateRangeQueryFormat,
  normalizeDataField: normalizeDataField,
  parseHits: parseHits,
  pushToAndClause: pushToAndClause,
  queryFormatMillisecondsMap: queryFormatMillisecondsMap,
  recLookup: recLookup,
  saveDataAsFile: saveDataAsFile,
  setDeep: setDeep,
  setObjectInLocalStorage: setObjectInLocalStorage,
  suggestionTypes: suggestionTypes,
  transformRawTreeListData: transformRawTreeListData,
  transformRequestUsingEndpoint: transformRequestUsingEndpoint,
  transformTreeListLocalStateIntoQueryComptaibleFormat: transformTreeListLocalStateIntoQueryComptaibleFormat,
  unwrapToNativeDate: unwrapToNativeDate,
  updateCustomQuery: updateCustomQuery,
  updateDefaultQuery: updateDefaultQuery,
  updateInternalQuery: updateInternalQuery,
  withClickIds: withClickIds
});

function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys$9(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$9(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$9(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$9(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function aiReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_AI_RESPONSE) {
    setObjectInLocalStorage('AISessions', _objectSpread$9(_objectSpread$9({}, getObjectFromLocalStorage(AI_LOCAL_CACHE_KEY) || {}), {}, _defineProperty({}, action.component, _objectSpread$9(_objectSpread$9({}, state[action.component] || {}), action.payload))));
    return _objectSpread$9(_objectSpread$9({}, state), {}, _defineProperty({}, action.component, _objectSpread$9(_objectSpread$9({}, state[action.component] ? state[action.component] : {}), {}, {
      response: _objectSpread$9(_objectSpread$9({}, state[action.component] ? state[action.component].response : {}), action.payload),
      isLoading: false,
      error: null
    })));
  } else if (action.type === REMOVE_AI_RESPONSE) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey));
    return obj;
  } else if (action.type === SET_AI_RESPONSE_ERROR) {
    return _objectSpread$9(_objectSpread$9({}, state), {}, _defineProperty({}, action.component, _objectSpread$9(_objectSpread$9({}, state[action.component] ? state[action.component] : {}), {}, {
      error: action.error,
      isLoading: false,
      response: null
    }, action.meta || {})));
  } else if (action.type === SET_AI_RESPONSE_LOADING) {
    return _objectSpread$9(_objectSpread$9({}, state), {}, _defineProperty({}, action.component, _objectSpread$9(_objectSpread$9({}, state[action.component] ? state[action.component] : {}), {}, {
      isLoading: action.isLoading
    })));
  }
  return state;
}

var rootReducer = combineReducers({
  components: componentsReducer,
  customQueries: customQueryReducer,
  defaultQueries: defaultQueryReducer,
  customHighlightOptions: customHighlightReducer,
  settings: appliedSettingsReducer,
  watchMan: watchManReducer,
  // contains the list of subscribers
  queryList: queryReducer,
  queryOptions: queryOptionsReducer$1,
  dependencyTree: dependencyTreeReducer,
  appbaseRef: appbaseRefReducer,
  analyticsRef: analyticsRefReducer,
  config: configReducer,
  hits: hitsReducer,
  promotedResults: promotedResultsReducer,
  customData: customDataReducer,
  aggregations: aggsReducer,
  compositeAggregations: compositeAggsReducer,
  queryLog: logsReducer,
  combinedLog: combinedLogsReducer,
  selectedValues: valueReducer$1,
  internalValues: valueReducer,
  isLoading: loadingReducer,
  error: errorReducer,
  timestamp: timestampReducer$1,
  headers: headersReducer,
  mapData: mapDataReducer,
  // holds the map id and boolean to execute geo-bound-query
  queryListener: queryListenerReducer,
  analytics: analyticsReducer,
  props: queryOptionsReducer,
  rawData: rawDataReducer,
  querySuggestions: querySuggestionsReducer,
  defaultPopularSuggestions: defaultPopularSuggestions,
  queryToHits: queryToHitsReducer,
  // holds the query value for last fetched `hits`
  recentSearches: recentSearchesReducer,
  urlValues: function urlValues() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    return state;
  },
  googleMapScriptStatus: googleMapScriptReducer,
  lastUsedAppbaseQuery: appbaseQueryReducer,
  registeredComponentsTimestamps: timestampReducer,
  AIResponses: aiReducer
});

function ownKeys$8(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$8(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$8(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$8(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var aiResponseMiddleware = function aiResponseMiddleware(store) {
  return function (next) {
    var pendingActions = {};
    var isDispatching = {};
    var dispatchNextAction = function dispatchNextAction(componentId) {
      if (pendingActions[componentId].length === 0 || isDispatching[componentId]) {
        return;
      }
      isDispatching[componentId] = true;
      var action = pendingActions[componentId].shift();
      requestAnimationFrame(function () {
        store.dispatch(action);
        isDispatching[componentId] = false;
        dispatchNextAction(componentId);
      });
    };
    return function (action) {
      if (action.type === SET_AI_RESPONSE_DELAYED) {
        var component = action.component;
        if (!pendingActions[component]) {
          pendingActions[component] = [];
          isDispatching[component] = false;
        }
        pendingActions[component].push(_objectSpread$8(_objectSpread$8({}, action), {}, {
          type: SET_AI_RESPONSE
        }));
        dispatchNextAction(component);
      } else if (action.type === SET_AI_RESPONSE_LOADING && action.isLoading) {
        var _component = action.component;
        if (pendingActions[_component]) {
          pendingActions[_component] = [];
          isDispatching[_component] = false;
        }
      }
      return next(action);
    };
  };
};

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var dayjs_min = {exports: {}};

(function (module, exports) {
  !function (t, e) {
    module.exports = e() ;
  }(commonjsGlobal, function () {

    var t = 1e3,
      e = 6e4,
      n = 36e5,
      r = "millisecond",
      i = "second",
      s = "minute",
      u = "hour",
      a = "day",
      o = "week",
      c = "month",
      f = "quarter",
      h = "year",
      d = "date",
      l = "Invalid Date",
      $ = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/,
      y = /\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g,
      M = {
        name: "en",
        weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),
        months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_"),
        ordinal: function ordinal(t) {
          var e = ["th", "st", "nd", "rd"],
            n = t % 100;
          return "[" + t + (e[(n - 20) % 10] || e[n] || e[0]) + "]";
        }
      },
      m = function m(t, e, n) {
        var r = String(t);
        return !r || r.length >= e ? t : "" + Array(e + 1 - r.length).join(n) + t;
      },
      v = {
        s: m,
        z: function z(t) {
          var e = -t.utcOffset(),
            n = Math.abs(e),
            r = Math.floor(n / 60),
            i = n % 60;
          return (e <= 0 ? "+" : "-") + m(r, 2, "0") + ":" + m(i, 2, "0");
        },
        m: function t(e, n) {
          if (e.date() < n.date()) return -t(n, e);
          var r = 12 * (n.year() - e.year()) + (n.month() - e.month()),
            i = e.clone().add(r, c),
            s = n - i < 0,
            u = e.clone().add(r + (s ? -1 : 1), c);
          return +(-(r + (n - i) / (s ? i - u : u - i)) || 0);
        },
        a: function a(t) {
          return t < 0 ? Math.ceil(t) || 0 : Math.floor(t);
        },
        p: function p(t) {
          return {
            M: c,
            y: h,
            w: o,
            d: a,
            D: d,
            h: u,
            m: s,
            s: i,
            ms: r,
            Q: f
          }[t] || String(t || "").toLowerCase().replace(/s$/, "");
        },
        u: function u(t) {
          return void 0 === t;
        }
      },
      g = "en",
      D = {};
    D[g] = M;
    var p = "$isDayjsObject",
      S = function S(t) {
        return t instanceof _ || !(!t || !t[p]);
      },
      w = function t(e, n, r) {
        var i;
        if (!e) return g;
        if ("string" == typeof e) {
          var s = e.toLowerCase();
          D[s] && (i = s), n && (D[s] = n, i = s);
          var u = e.split("-");
          if (!i && u.length > 1) return t(u[0]);
        } else {
          var a = e.name;
          D[a] = e, i = a;
        }
        return !r && i && (g = i), i || !r && g;
      },
      O = function O(t, e) {
        if (S(t)) return t.clone();
        var n = "object" == _typeof(e) ? e : {};
        return n.date = t, n.args = arguments, new _(n);
      },
      b = v;
    b.l = w, b.i = S, b.w = function (t, e) {
      return O(t, {
        locale: e.$L,
        utc: e.$u,
        x: e.$x,
        $offset: e.$offset
      });
    };
    var _ = function () {
        function M(t) {
          this.$L = w(t.locale, null, !0), this.parse(t), this.$x = this.$x || t.x || {}, this[p] = !0;
        }
        var m = M.prototype;
        return m.parse = function (t) {
          this.$d = function (t) {
            var e = t.date,
              n = t.utc;
            if (null === e) return new Date(NaN);
            if (b.u(e)) return new Date();
            if (e instanceof Date) return new Date(e);
            if ("string" == typeof e && !/Z$/i.test(e)) {
              var r = e.match($);
              if (r) {
                var i = r[2] - 1 || 0,
                  s = (r[7] || "0").substring(0, 3);
                return n ? new Date(Date.UTC(r[1], i, r[3] || 1, r[4] || 0, r[5] || 0, r[6] || 0, s)) : new Date(r[1], i, r[3] || 1, r[4] || 0, r[5] || 0, r[6] || 0, s);
              }
            }
            return new Date(e);
          }(t), this.init();
        }, m.init = function () {
          var t = this.$d;
          this.$y = t.getFullYear(), this.$M = t.getMonth(), this.$D = t.getDate(), this.$W = t.getDay(), this.$H = t.getHours(), this.$m = t.getMinutes(), this.$s = t.getSeconds(), this.$ms = t.getMilliseconds();
        }, m.$utils = function () {
          return b;
        }, m.isValid = function () {
          return !(this.$d.toString() === l);
        }, m.isSame = function (t, e) {
          var n = O(t);
          return this.startOf(e) <= n && n <= this.endOf(e);
        }, m.isAfter = function (t, e) {
          return O(t) < this.startOf(e);
        }, m.isBefore = function (t, e) {
          return this.endOf(e) < O(t);
        }, m.$g = function (t, e, n) {
          return b.u(t) ? this[e] : this.set(n, t);
        }, m.unix = function () {
          return Math.floor(this.valueOf() / 1e3);
        }, m.valueOf = function () {
          return this.$d.getTime();
        }, m.startOf = function (t, e) {
          var n = this,
            r = !!b.u(e) || e,
            f = b.p(t),
            l = function l(t, e) {
              var i = b.w(n.$u ? Date.UTC(n.$y, e, t) : new Date(n.$y, e, t), n);
              return r ? i : i.endOf(a);
            },
            $ = function $(t, e) {
              return b.w(n.toDate()[t].apply(n.toDate("s"), (r ? [0, 0, 0, 0] : [23, 59, 59, 999]).slice(e)), n);
            },
            y = this.$W,
            M = this.$M,
            m = this.$D,
            v = "set" + (this.$u ? "UTC" : "");
          switch (f) {
            case h:
              return r ? l(1, 0) : l(31, 11);
            case c:
              return r ? l(1, M) : l(0, M + 1);
            case o:
              var g = this.$locale().weekStart || 0,
                D = (y < g ? y + 7 : y) - g;
              return l(r ? m - D : m + (6 - D), M);
            case a:
            case d:
              return $(v + "Hours", 0);
            case u:
              return $(v + "Minutes", 1);
            case s:
              return $(v + "Seconds", 2);
            case i:
              return $(v + "Milliseconds", 3);
            default:
              return this.clone();
          }
        }, m.endOf = function (t) {
          return this.startOf(t, !1);
        }, m.$set = function (t, e) {
          var n,
            o = b.p(t),
            f = "set" + (this.$u ? "UTC" : ""),
            l = (n = {}, n[a] = f + "Date", n[d] = f + "Date", n[c] = f + "Month", n[h] = f + "FullYear", n[u] = f + "Hours", n[s] = f + "Minutes", n[i] = f + "Seconds", n[r] = f + "Milliseconds", n)[o],
            $ = o === a ? this.$D + (e - this.$W) : e;
          if (o === c || o === h) {
            var y = this.clone().set(d, 1);
            y.$d[l]($), y.init(), this.$d = y.set(d, Math.min(this.$D, y.daysInMonth())).$d;
          } else l && this.$d[l]($);
          return this.init(), this;
        }, m.set = function (t, e) {
          return this.clone().$set(t, e);
        }, m.get = function (t) {
          return this[b.p(t)]();
        }, m.add = function (r, f) {
          var d,
            l = this;
          r = Number(r);
          var $ = b.p(f),
            y = function y(t) {
              var e = O(l);
              return b.w(e.date(e.date() + Math.round(t * r)), l);
            };
          if ($ === c) return this.set(c, this.$M + r);
          if ($ === h) return this.set(h, this.$y + r);
          if ($ === a) return y(1);
          if ($ === o) return y(7);
          var M = (d = {}, d[s] = e, d[u] = n, d[i] = t, d)[$] || 1,
            m = this.$d.getTime() + r * M;
          return b.w(m, this);
        }, m.subtract = function (t, e) {
          return this.add(-1 * t, e);
        }, m.format = function (t) {
          var e = this,
            n = this.$locale();
          if (!this.isValid()) return n.invalidDate || l;
          var r = t || "YYYY-MM-DDTHH:mm:ssZ",
            i = b.z(this),
            s = this.$H,
            u = this.$m,
            a = this.$M,
            o = n.weekdays,
            c = n.months,
            f = n.meridiem,
            h = function h(t, n, i, s) {
              return t && (t[n] || t(e, r)) || i[n].slice(0, s);
            },
            d = function d(t) {
              return b.s(s % 12 || 12, t, "0");
            },
            $ = f || function (t, e, n) {
              var r = t < 12 ? "AM" : "PM";
              return n ? r.toLowerCase() : r;
            };
          return r.replace(y, function (t, r) {
            return r || function (t) {
              switch (t) {
                case "YY":
                  return String(e.$y).slice(-2);
                case "YYYY":
                  return b.s(e.$y, 4, "0");
                case "M":
                  return a + 1;
                case "MM":
                  return b.s(a + 1, 2, "0");
                case "MMM":
                  return h(n.monthsShort, a, c, 3);
                case "MMMM":
                  return h(c, a);
                case "D":
                  return e.$D;
                case "DD":
                  return b.s(e.$D, 2, "0");
                case "d":
                  return String(e.$W);
                case "dd":
                  return h(n.weekdaysMin, e.$W, o, 2);
                case "ddd":
                  return h(n.weekdaysShort, e.$W, o, 3);
                case "dddd":
                  return o[e.$W];
                case "H":
                  return String(s);
                case "HH":
                  return b.s(s, 2, "0");
                case "h":
                  return d(1);
                case "hh":
                  return d(2);
                case "a":
                  return $(s, u, !0);
                case "A":
                  return $(s, u, !1);
                case "m":
                  return String(u);
                case "mm":
                  return b.s(u, 2, "0");
                case "s":
                  return String(e.$s);
                case "ss":
                  return b.s(e.$s, 2, "0");
                case "SSS":
                  return b.s(e.$ms, 3, "0");
                case "Z":
                  return i;
              }
              return null;
            }(t) || i.replace(":", "");
          });
        }, m.utcOffset = function () {
          return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
        }, m.diff = function (r, d, l) {
          var $,
            y = this,
            M = b.p(d),
            m = O(r),
            v = (m.utcOffset() - this.utcOffset()) * e,
            g = this - m,
            D = function D() {
              return b.m(y, m);
            };
          switch (M) {
            case h:
              $ = D() / 12;
              break;
            case c:
              $ = D();
              break;
            case f:
              $ = D() / 3;
              break;
            case o:
              $ = (g - v) / 6048e5;
              break;
            case a:
              $ = (g - v) / 864e5;
              break;
            case u:
              $ = g / n;
              break;
            case s:
              $ = g / e;
              break;
            case i:
              $ = g / t;
              break;
            default:
              $ = g;
          }
          return l ? $ : b.a($);
        }, m.daysInMonth = function () {
          return this.endOf(c).$D;
        }, m.$locale = function () {
          return D[this.$L];
        }, m.locale = function (t, e) {
          if (!t) return this.$L;
          var n = this.clone(),
            r = w(t, e, !0);
          return r && (n.$L = r), n;
        }, m.clone = function () {
          return b.w(this.$d, this);
        }, m.toDate = function () {
          return new Date(this.valueOf());
        }, m.toJSON = function () {
          return this.isValid() ? this.toISOString() : null;
        }, m.toISOString = function () {
          return this.$d.toISOString();
        }, m.toString = function () {
          return this.$d.toUTCString();
        }, M;
      }(),
      k = _.prototype;
    return O.prototype = k, [["$ms", r], ["$s", i], ["$m", s], ["$H", u], ["$W", a], ["$M", c], ["$y", h], ["$D", d]].forEach(function (t) {
      k[t[1]] = function (e) {
        return this.$g(e, t[0], t[1]);
      };
    }), O.extend = function (t, e) {
      return t.$i || (t(e, _, O), t.$i = !0), O;
    }, O.locale = w, O.isDayjs = S, O.unix = function (t) {
      return O(1e3 * t);
    }, O.en = D[g], O.Ls = D, O.p = {}, O;
  });
})(dayjs_min);
var dayjs_minExports = dayjs_min.exports;
var dayjs = /*@__PURE__*/getDefaultExportFromCjs(dayjs_minExports);

var _componentToTypeMap;
function ownKeys$7(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$7(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$7(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$7(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var componentToTypeMap = (_componentToTypeMap = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.reactiveList, queryTypes.search), componentTypes.dataSearch, queryTypes.search), componentTypes.categorySearch, queryTypes.search), componentTypes.searchBox, queryTypes.suggestion), componentTypes.AIAnswer, queryTypes.search), componentTypes.singleList, queryTypes.term), componentTypes.multiList, queryTypes.term), componentTypes.singleDataList, queryTypes.term), componentTypes.singleDropdownList, queryTypes.term), componentTypes.multiDataList, queryTypes.term), _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.multiDropdownList, queryTypes.term), componentTypes.tagCloud, queryTypes.term), componentTypes.toggleButton, queryTypes.term), componentTypes.reactiveChart, queryTypes.term), componentTypes.treeList, queryTypes.term), componentTypes.numberBox, queryTypes.term), componentTypes.datePicker, queryTypes.range), componentTypes.dateRange, queryTypes.range), componentTypes.dynamicRangeSlider, queryTypes.range), componentTypes.singleDropdownRange, queryTypes.range), _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.multiDropdownRange, queryTypes.range), componentTypes.singleRange, queryTypes.range), componentTypes.multiRange, queryTypes.range), componentTypes.rangeSlider, queryTypes.range), componentTypes.ratingsFilter, queryTypes.range), componentTypes.rangeInput, queryTypes.range), componentTypes.geoDistanceDropdown, queryTypes.geo), componentTypes.geoDistanceSlider, queryTypes.geo), componentTypes.reactiveMap, queryTypes.geo));
var multiRangeComponents = [componentTypes.multiRange, componentTypes.multiDropdownRange];
var dateRangeComponents = [componentTypes.dateRange, componentTypes.datePicker];
var searchComponents = [componentTypes.categorySearch, componentTypes.dataSearch, componentTypes.searchBox];
var listComponentsWithPagination = [componentTypes.singleList, componentTypes.multiList, componentTypes.singleDropdownList, componentTypes.multiDropdownList];
var getNormalizedField = function getNormalizedField(field) {
  if (field && !Array.isArray(field)) {
    return [field];
  }
  return field;
};
var isInternalComponent = function isInternalComponent() {
  var componentID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return componentID.endsWith('__internal');
};
var getInternalComponentID = function getInternalComponentID() {
  var componentID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return "".concat(componentID, "__internal");
};
var getHistogramComponentID = function getHistogramComponentID() {
  var componentID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return "".concat(componentID, "__histogram__internal");
};
var isDRSRangeComponent = function isDRSRangeComponent() {
  var componentID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return componentID.endsWith('__range__internal');
};
var isSearchComponent = function isSearchComponent() {
  var componentType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return searchComponents.includes(componentType);
};
var isComponentUsesLabelAsValue = function isComponentUsesLabelAsValue() {
  var componentType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return componentType === componentTypes.multiDataList || componentType === componentTypes.singleDataList || componentType === componentTypes.tabDataList;
};
var hasPaginationSupport = function hasPaginationSupport() {
  var componentType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return listComponentsWithPagination.includes(componentType);
};
var getRSQuery = function getRSQuery(componentId, props) {
  var execute = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  if (props && componentId) {
    var queryType = props.type ? props.type : componentToTypeMap[props.componentType];
    // dataField is a required field for components other than search
    // TODO: Revisit this logic based on the Appbase version
    // dataField is no longer a required field in RS API
    if (props.componentType !== componentTypes.AIAnswer && !isSearchComponent(props.componentType) && !props.dataField && !props.vectorDataField) {
      return null;
    }
    var endpoint;
    var compoundClause = props.compoundClause;
    if (props.endpoint instanceof Object) {
      endpoint = props.endpoint;
    }
    var featuredSuggestionsProps = {
      enableFeaturedSuggestions: props.enableFeaturedSuggestions,
      featuredSuggestionsConfig: props.featuredSuggestionsConfig
    };
    var faqSuggestionsProps = {
      enableFAQSuggestions: props.enableFAQSuggestions,
      FAQSuggestionsConfig: props.FAQSuggestionsConfig
    };
    if (props.enableFAQSuggestions && !props.searchboxId) {
      faqSuggestionsProps = {};
      console.error('Reactivesearch Error: You should also pass a searchboxId when passing enableFAQSuggestions as true.\nRefer to Searchbox component documentation specific to frontend frameworks.\n\nReact(https://docs.reactivesearch.io/docs/reactivesearch/react/search/searchbox/)\n\nVue(https://docs.reactivesearch.io/docs/reactivesearch/vue/search/SearchBox/).');
    }
    if (props.enableFeaturedSuggestions && !props.searchboxId) {
      featuredSuggestionsProps = {};
      console.error('Reactivesearch Error: You should also pass a searchboxId when passing enableFeaturedSuggestions.\nRefer to Searchbox component documentation specific to frontend frameworks.\n\nReact(https://docs.reactivesearch.io/docs/reactivesearch/react/search/searchbox/)\n\nVue(https://docs.reactivesearch.io/docs/reactivesearch/vue/search/SearchBox/).');
    }
    if (compoundClause && !['filter', 'must'].includes(compoundClause)) {
      console.error("Reactivesearch Error: Invalid prop supplied - compoundClause. Prop can be one of ['filter', 'must']");
      compoundClause = undefined;
    }
    return _objectSpread$7(_objectSpread$7(_objectSpread$7({
      id: componentId,
      type: queryType || queryTypes.search,
      dataField: getNormalizedField(props.dataField),
      execute: execute,
      react: props.react,
      highlight: props.highlight,
      highlightField: getNormalizedField(props.highlightField),
      fuzziness: props.fuzziness,
      searchOperators: props.searchOperators,
      includeFields: props.includeFields,
      excludeFields: props.excludeFields,
      size: props.size,
      aggregationSize: props.aggregationSize,
      from: props.from || undefined,
      // Need to maintain for RL
      queryFormat: props.queryFormat,
      sortBy: props.sortBy,
      fieldWeights: getNormalizedField(props.fieldWeights),
      includeNullValues: props.includeNullValues,
      aggregationField: props.aggregationField || undefined,
      categoryField: props.categoryField || undefined,
      missingLabel: props.missingLabel || undefined,
      showMissing: props.showMissing,
      nestedField: props.nestedField || undefined,
      interval: props.interval,
      highlightConfig: props.customHighlight || props.highlightConfig,
      customQuery: props.customQuery,
      defaultQuery: props.defaultQuery,
      value: props.value,
      categoryValue: props.categoryValue || undefined,
      after: props.after || undefined,
      aggregations: props.aggregations || undefined,
      enableSynonyms: props.enableSynonyms,
      selectAllLabel: props.selectAllLabel,
      pagination: props.pagination,
      queryString: props.queryString,
      distinctField: props.distinctField,
      distinctFieldConfig: props.distinctFieldConfig,
      index: props.index,
      compoundClause: compoundClause
    }, queryType === queryTypes.suggestion ? _objectSpread$7(_objectSpread$7(_objectSpread$7({
      enablePopularSuggestions: props.enablePopularSuggestions,
      enableEndpointSuggestions: props.enableEndpointSuggestions,
      enableRecentSuggestions: props.enableRecentSuggestions,
      popularSuggestionsConfig: props.popularSuggestionsConfig,
      recentSuggestionsConfig: props.recentSuggestionsConfig,
      applyStopwords: props.applyStopwords,
      customStopwords: props.customStopwords,
      enablePredictiveSuggestions: props.enablePredictiveSuggestions,
      indexSuggestionsConfig: props.indexSuggestionsConfig,
      enableDocumentSuggestions: props.enableDocumentSuggestions,
      showDistinctSuggestions: props.showDistinctSuggestions,
      documentSuggestionsConfig: props.enableDocumentSuggestions ? props.documentSuggestionsConfig : undefined
    }, featuredSuggestionsProps), faqSuggestionsProps), {}, {
      enableIndexSuggestions: props.enableIndexSuggestions
    }, props.searchboxId ? {
      searchboxId: props.searchboxId
    } : {}) : {}), {}, {
      calendarInterval: props.calendarInterval,
      endpoint: endpoint,
      range: props.range
    }, queryType !== queryTypes.suggestion && props.enableAI && execute ? _objectSpread$7(_objectSpread$7({
      enableAI: true
    }, props.AIConfig ? {
      AIConfig: props.AIConfig
    } : {}), {}, {
      execute: true
    }) : {}), queryType !== queryTypes.suggestion ? {
      vectorDataField: props.vectorDataField || undefined,
      imageValue: props.imageValue || undefined,
      candidates: props.candidates || props.size || undefined
    } : {});
  }
  return null;
};
var extractPropsFromState = function extractPropsFromState(store, component, customOptions) {
  var componentProps = store.props[component];
  if (!componentProps) {
    return null;
  }
  var queryType = componentProps.type ? componentProps.type : componentToTypeMap[componentProps.componentType];
  var calcValues = store.selectedValues[component];
  var value = calcValues !== undefined && calcValues !== null ? calcValues.value : undefined;
  var queryFormat = componentProps.queryFormat;
  // calendarInterval only supported when using date types
  var calendarInterval;
  var interval = componentProps.interval;
  var type = queryType;
  var dataField = componentProps.dataField;
  var aggregations = componentProps.aggregations;
  var pagination; // pagination for `term` type of queries
  var from = componentProps.from; // offset for RL
  var range; // applicable for range components supporting histogram

  // For term queries i.e list component `dataField` will be treated as aggregationField
  if (queryType === queryTypes.term) {
    // Only apply pagination prop for the components which supports it otherwise it can break the UI
    if (componentProps.showLoadMore && hasPaginationSupport(componentProps.componentType)) {
      pagination = true;
    }
    // Extract values from components that are type of objects
    // This code handles the controlled behavior in list components for e.g ToggleButton
    if (value != null && _typeof(value) === 'object' && value.value) {
      value = value.value;
    } else if (Array.isArray(value)) {
      var parsedValue = [];
      value.forEach(function (val) {
        if (val != null && _typeof(val) === 'object' && val.value) {
          parsedValue.push(val.value);
        } else {
          parsedValue.push(val);
        }
      });
      value = parsedValue;
    }
  }
  if (queryType === queryTypes.range) {
    if (Array.isArray(value)) {
      if (multiRangeComponents.includes(componentProps.componentType)) {
        value = value.map(function (_ref) {
          var start = _ref.start,
            end = _ref.end;
          return {
            start: start,
            end: end
          };
        });
      } else {
        value = {
          start: value[0],
          end: value[1]
        };
      }
    } else if (componentProps.showHistogram) {
      var internalComponentID = getInternalComponentID(component);
      var internalComponentValue = store.internalValues[internalComponentID];
      if (!internalComponentValue) {
        // Handle dynamic range slider
        var histogramComponentID = getHistogramComponentID(component);
        internalComponentValue = store.internalValues[histogramComponentID];
      }
      if (internalComponentValue && Array.isArray(internalComponentValue.value)) {
        value = {
          start: internalComponentValue.value[0],
          end: internalComponentValue.value[1]
        };
      }
    }
    if (isDRSRangeComponent(component)) {
      aggregations = ['min', 'max'];
    } else if (componentProps.showHistogram) {
      aggregations = ['histogram'];
    }

    // handle number box, number box query changes based on the `queryFormat` value
    if (componentProps.componentType === componentTypes.dynamicRangeSlider || componentProps.componentType === componentTypes.rangeSlider) {
      calendarInterval = Object.keys(dateFormats).includes(queryFormat) ? componentProps.calendarInterval : undefined;

      // Set value
      if (value) {
        if (isValidDateRangeQueryFormat(componentProps.queryFormat)) {
          // check if date types are dealt with
          value = {
            start: formatDate(dayjs(new Date(value.start)), componentProps),
            end: formatDate(dayjs(new Date(value.end)), componentProps)
          };
        } else {
          value = {
            start: parseFloat(value.start),
            end: parseFloat(value.end)
          };
        }
      }
      var rangeValue;
      if (componentProps.componentType === componentTypes.dynamicRangeSlider) {
        rangeValue = store.aggregations["".concat(component, "__range__internal")];
        if (componentProps.nestedField) {
          rangeValue = rangeValue && store.aggregations["".concat(component, "__range__internal")][componentProps.nestedField].min ? {
            start: store.aggregations["".concat(component, "__range__internal")][componentProps.nestedField].min.value,
            end: store.aggregations["".concat(component, "__range__internal")][componentProps.nestedField].max.value
          } // prettier-ignore
          : null;
        } else {
          rangeValue = rangeValue && store.aggregations["".concat(component, "__range__internal")].min && store.aggregations["".concat(component, "__range__internal")].min.value ? {
            start: store.aggregations["".concat(component, "__range__internal")].min.value,
            end: store.aggregations["".concat(component, "__range__internal")].max.value
          } // prettier-ignore
          : null;
        }
      } else {
        rangeValue = componentProps.range;
      }
      if (rangeValue) {
        if (isValidDateRangeQueryFormat(componentProps.queryFormat)) {
          // check if date types are dealt with
          range = {
            start: formatDate(dayjs(rangeValue.start), componentProps),
            end: formatDate(dayjs(rangeValue.end), componentProps)
          };
        } else {
          range = {
            start: parseFloat(rangeValue.start),
            end: parseFloat(rangeValue.end)
          };
        }
      }
    }

    // handle date components
    if (dateRangeComponents.includes(componentProps.componentType)) {
      // Set value
      if (value) {
        if (isValidDateRangeQueryFormat(componentProps.queryFormat)) {
          if (typeof value === 'string') {
            value = {
              // value would be an ISO Date string
              start: formatDate(dayjs(value).subtract(24, 'hour'), componentProps),
              end: formatDate(dayjs(value), componentProps)
            };
          } else if (Array.isArray(value)) {
            value = value.map(function (val) {
              return {
                // value would be one of ISO Date string, number, native date
                start: formatDate(dayjs(val).subtract(24, 'hour'), componentProps),
                end: formatDate(dayjs(val), componentProps)
              };
            });
          } else {
            value = {
              start: formatDate(dayjs(value.start).subtract(24, 'hour'), componentProps),
              end: formatDate(dayjs(value.end), componentProps)
            };
          }
        }
      }
    }
  }
  if (queryType === queryTypes.geo) {
    // override the value extracted from selectedValues reducer
    value = undefined;
    var geoCalcValues = store.selectedValues[component] || store.internalValues[component] || store.internalValues[getInternalComponentID(component)];
    if (geoCalcValues && geoCalcValues.meta) {
      if (geoCalcValues.meta.distance && geoCalcValues.meta.coordinates) {
        value = {
          distance: geoCalcValues.meta.distance,
          location: geoCalcValues.meta.coordinates
        };
        if (componentProps.unit) {
          value.unit = componentProps.unit;
        }
      }
      if (geoCalcValues.meta.mapBoxBounds && geoCalcValues.meta.mapBoxBounds.top_left && geoCalcValues.meta.mapBoxBounds.bottom_right) {
        value = {
          // Note: format will be reverse of what we're using now
          geoBoundingBox: {
            topLeft: "".concat(geoCalcValues.meta.mapBoxBounds.top_left[1], ", ").concat(geoCalcValues.meta.mapBoxBounds.top_left[0]),
            bottomRight: "".concat(geoCalcValues.meta.mapBoxBounds.bottom_right[1], ", ").concat(geoCalcValues.meta.mapBoxBounds.bottom_right[0])
          }
        };
      }
    }
  }
  // handle number box, number box query changes based on the `queryFormat` value
  if (componentProps.componentType === componentTypes.numberBox) {
    if (queryFormat === 'exact') {
      type = 'term';
    } else {
      type = 'range';
      if (queryFormat === 'lte') {
        value = {
          end: value,
          boost: 2.0
        };
      } else {
        value = {
          start: value,
          boost: 2.0
        };
      }
    }
    // Remove query format
    queryFormat = 'or';
  }
  // Fake dataField for ReactiveComponent
  // TODO: Remove it after some time. The `dataField` is no longer required
  if (componentProps.componentType === componentTypes.reactiveComponent) {
    // Set the type to `term`
    type = 'term';
    dataField = 'reactive_component_field';
    // Don't set value property for ReactiveComponent
    // since it is driven by `defaultQuery` and `customQuery`
    value = undefined;
  }
  // Assign default value as an empty string for search components so search relevancy can work
  if (isSearchComponent(componentProps.componentType) && !value) {
    value = '';
  }

  // Handle components which uses label instead of value as the selected value
  if (isComponentUsesLabelAsValue(componentProps.componentType)) {
    var data = componentProps.data,
      selectAllLabel = componentProps.selectAllLabel;
    var absValue = [];
    if (value && Array.isArray(value)) {
      absValue = value;
    } else if (value && typeof value === 'string') {
      absValue = [value];
    }
    var normalizedValue = [];
    if (absValue.length) {
      if (data && Array.isArray(data)) {
        absValue.forEach(function (val) {
          var dataItem = data.find(function (o) {
            return o.label === val;
          });
          if (dataItem && dataItem.value) {
            normalizedValue.push(dataItem.value);
          }
        });
      }
    }
    if (selectAllLabel && absValue.length && absValue.includes(selectAllLabel)) {
      normalizedValue = absValue;
    }
    if (normalizedValue.length) {
      value = normalizedValue;
    } else {
      value = undefined;
    }
  }
  if (componentProps.componentType === componentTypes.reactiveList) {
    // We set selected page as the value in the redux store for RL.
    // It's complex to change this logic in the component so changed it here.
    if (value > 0) {
      from = (value - 1) * (componentProps.size || 10);
    }
    value = undefined;
  }
  var queryValue = value || undefined;
  if (componentProps.componentType === componentTypes.searchBox) {
    if (Array.isArray(queryValue)) {
      queryValue = undefined;
    }
  }
  var endpoint;
  if (componentProps.endpoint instanceof Object) {
    endpoint = _objectSpread$7(_objectSpread$7({}, endpoint || {}), componentProps.endpoint);
  }
  return _objectSpread$7(_objectSpread$7({}, componentProps), {}, {
    endpoint: endpoint,
    calendarInterval: calendarInterval,
    dataField: dataField,
    queryFormat: queryFormat,
    type: type,
    aggregations: aggregations,
    interval: interval,
    react: store.dependencyTree ? store.dependencyTree[component] : undefined,
    customQuery: store.customQueries ? store.customQueries[component] : undefined,
    defaultQuery: store.defaultQueries ? store.defaultQueries[component] : undefined,
    customHighlight: store.customHighlightOptions ? store.customHighlightOptions[component] : undefined,
    categoryValue: store.internalValues[component] ? store.internalValues[component].category : undefined,
    value: queryValue,
    pagination: pagination,
    from: from,
    range: range
  }, customOptions);
};
function flatReactProp(reactProp, componentID) {
  var flattenReact = [];
  var flatReact = function flatReact(react) {
    if (react && Object.keys(react)) {
      Object.keys(react).forEach(function (r) {
        if (react[r]) {
          if (typeof react[r] === 'string') {
            flattenReact = [].concat(_toConsumableArray(flattenReact), [react[r]]);
          } else if (Array.isArray(react[r])) {
            flattenReact = [].concat(_toConsumableArray(flattenReact), _toConsumableArray(react[r]));
          } else if (_typeof(react[r]) === 'object') {
            flatReact(react[r]);
          }
        }
      });
    }
  };
  flatReact(reactProp);
  // Remove cyclic dependencies
  flattenReact = flattenReact.filter(function (react) {
    return react !== componentID;
  });
  return flattenReact;
}
var getDependentQueries = function getDependentQueries(store, componentID) {
  var orderOfQueries = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var finalQuery = {};
  var react = flatReactProp(store.dependencyTree[componentID], componentID);
  react.forEach(function (componentObject) {
    var component = componentObject;
    var customQuery = store.customQueries[component];
    if (!isInternalComponent(component)) {
      var calcValues = store.selectedValues[component] || store.internalValues[component];
      var imageValue = calcValues && calcValues.meta && calcValues.meta.imageValue;
      // Only include queries for that component that has `customQuery` or `value` or
      // `imageValue` incase of searchbox defined
      if ((calcValues && (calcValues.value || imageValue) || customQuery) && !finalQuery[component]) {
        var execute = false;
        var componentProps = store.props[component];
        if (Array.isArray(orderOfQueries) && orderOfQueries.includes(component) && !(componentProps.componentType === componentTypes.searchBox
        /**
         * We want to fire a search query,
         * 	when enableAI
         * 	OR
         * 	when autosuggest is false
         */ && (componentProps.enableAI || componentProps.autosuggest === false))) {
          execute = true;
        }
        // build query
        var dependentQuery = getRSQuery(component, extractPropsFromState(store, component, _objectSpread$7({}, componentProps && _objectSpread$7(_objectSpread$7({}, componentProps.componentType === componentTypes.searchBox ? _objectSpread$7(_objectSpread$7(_objectSpread$7(_objectSpread$7({}, execute === false ? {
          type: queryTypes.search
        } : {}), calcValues.category ? {
          categoryValue: calcValues.category
        } : {
          categoryValue: undefined
        }), calcValues.value ? {
          value: calcValues.value
        } : {}), imageValue ? {
          imageValue: imageValue
        } : {}) : {}), componentProps.componentType === componentTypes.categorySearch ? _objectSpread$7({}, calcValues.category ? {
          categoryValue: calcValues.category
        } : {
          categoryValue: undefined
        }) : {}))), execute);
        if (dependentQuery) {
          finalQuery[component] = dependentQuery;
        }
      }
    }
  });
  return finalQuery;
};
var transformValueToComponentStateFormat = function transformValueToComponentStateFormat(value, componentProps) {
  var componentType = componentProps.componentType,
    data = componentProps.data,
    queryFormat = componentProps.queryFormat;
  var transformedValue = value;
  var meta = {};
  if (value) {
    switch (componentType) {
      case componentTypes.singleDataList:
      case componentTypes.tabDataList:
        transformedValue = '';
        if (Array.isArray(value) && typeof value[0] === 'string') {
          transformedValue = value[0];
        } else if (_typeof(value) === 'object' && value.label) {
          transformedValue = value.label;
        } else {
          transformedValue = value;
        }
        break;
      case componentTypes.multiDataList:
        transformedValue = [];
        if (Array.isArray(value)) {
          value.forEach(function (valObj) {
            if (_typeof(valObj) === 'object' && (valObj.label || valObj.value)) {
              transformedValue.push(valObj.label || valObj.value);
            } else if (typeof valObj === 'string') {
              transformedValue.push(valObj);
            }
          });
        }
        break;
      case componentTypes.toggleButton:
        transformedValue = []; // array of objects

        if (Array.isArray(value)) {
          value.forEach(function (valObj) {
            if (_typeof(valObj) === 'object' && valObj.label && valObj.value) {
              transformedValue.push(valObj);
            } else if (typeof valObj === 'string') {
              var findDataObj = data.find(function (item) {
                return item.label.trim() === valObj.trim() || item.value.trim() === valObj.trim();
              });
              transformedValue.push(findDataObj);
            }
          });
        } else if (_typeof(value) === 'object' && value.label && value.value) {
          transformedValue = value.value;
        } else if (typeof value === 'string') {
          var findDataObj = data.find(function (item) {
            return item.label.trim() === value.trim() || item.value.trim() === value.trim();
          });
          transformedValue = findDataObj.value;
        }
        break;
      case componentTypes.singleRange:
      case componentTypes.singleDropdownRange:
        transformedValue = {};
        if (!Array.isArray(value) && _typeof(value) === 'object') {
          transformedValue = _objectSpread$7({}, value);
        } else if (typeof value === 'string') {
          var _findDataObj = data.find(function (item) {
            return item.label.trim() === value.trim();
          });
          transformedValue = _objectSpread$7({}, _findDataObj);
        }
        break;
      case componentTypes.multiDropdownRange:
      case componentTypes.multiRange:
        transformedValue = []; // array of objects

        if (Array.isArray(value)) {
          value.forEach(function (valObj) {
            if (_typeof(valObj) === 'object' && typeof valObj.start === 'number' && typeof valObj.end === 'number') {
              var _findDataObj2 = _objectSpread$7({}, valObj);
              if (!_findDataObj2.label) {
                _findDataObj2 = data.find(function (item) {
                  return item.start === valObj.start && item.end === valObj.end;
                });
              }
              transformedValue.push(_findDataObj2);
            } else if (typeof valObj === 'string') {
              var _findDataObj3 = data.find(function (item) {
                return item.label.trim() === valObj.trim();
              });
              transformedValue.push(_findDataObj3);
            }
          });
        } else if (typeof value === 'string') {
          var _findDataObj4 = data.find(function (item) {
            return item.label.trim() === value.trim();
          });
          transformedValue.push(_findDataObj4);
        }
        break;
      case componentTypes.rangeSlider:
      case componentTypes.ratingsFilter:
      case componentTypes.dynamicRangeSlider:
      case componentTypes.reactiveChart:
        transformedValue = [];
        if (queryFormat) {
          if (Array.isArray(value)) {
            transformedValue = value.map(function (item) {
              return formatDate(dayjs(item), componentProps);
            });
          } else if (_typeof(value) === 'object') {
            transformedValue = [formatDate(dayjs(value.start), componentProps), formatDate(dayjs(value.end), componentProps)];
          }
        } else if (Array.isArray(value)) {
          transformedValue = _toConsumableArray(value);
        } else if (_typeof(value) === 'object') {
          transformedValue = [value.start, value.end];
        } else {
          transformedValue = value;
        }
        break;
      case componentTypes.numberBox:
        transformedValue = [];
        if (!Array.isArray(value) && _typeof(value) === 'object') {
          transformedValue = value.start;
        } else if (typeof value === 'number') {
          transformedValue = value;
        }
        break;
      case componentTypes.datePicker:
        transformedValue = '';
        if (_typeof(value) !== 'object') {
          transformedValue = dayjs(value).format('YYYY-MM-DD');
        } else if (value.end) {
          transformedValue = dayjs(value.end).format('YYYY-MM-DD');
        } else if (value.start) {
          transformedValue = dayjs(value.start).add(24, 'hour').format('YYYY-MM-DD');
        }
        break;
      case componentTypes.dateRange:
        transformedValue = []; // array of strings
        if (Array.isArray(value)) {
          transformedValue = value.map(function (t) {
            return dayjs(t).format('YYYY-MM-DD');
          });
        } else if (_typeof(value) === 'object') {
          transformedValue = [dayjs(value.start).format('YYYY-MM-DD'), dayjs(value.end).format('YYYY-MM-DD')];
        }
        break;
      case componentTypes.categorySearch:
        transformedValue = '';
        if (_typeof(value) === 'object') {
          transformedValue = value.value;
          if (value.category !== undefined) {
            meta.category = value.category;
          }
        } else if (typeof value === 'string') {
          transformedValue = value;
        }
        break;
    }
  }
  return {
    value: transformedValue,
    meta: meta
  };
};

var SET_QUERY_TO_HITS = 'SET_QUERY_TO_HITS';

function updateAggs(component, aggregations) {
  var append = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return {
    type: UPDATE_AGGS,
    component: component,
    aggregations: aggregations,
    append: append
  };
}
function updateCompositeAggs(component, aggregations) {
  var append = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return {
    type: UPDATE_COMPOSITE_AGGS,
    component: component,
    aggregations: aggregations,
    append: append
  };
}
function updateHits(component, hits, time, hidden) {
  var append = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  return {
    type: UPDATE_HITS,
    component: component,
    hits: hits.hits,
    // make compatible with es7
    total: _typeof(hits.total) === 'object' ? hits.total.value : hits.total,
    hidden: hidden,
    time: time,
    append: append
  };
}
function saveQueryToHits(component, query) {
  return {
    type: SET_QUERY_TO_HITS,
    component: component,
    query: query
  };
}
function mockDataForTesting(component, data) {
  return function (dispatch) {
    if (data.hasOwnProperty('error')) {
      dispatch(setError(component, data.error));
    }
    if (data.hasOwnProperty('aggregations')) {
      // set aggs
      dispatch(updateAggs(component, data.aggregations));
    }
    if (data.hasOwnProperty('hits')) {
      // set hits
      dispatch(updateHits(component, data, data.time || undefined));
    }
    if (data.hasOwnProperty('rawData')) {
      dispatch(setRawData(component, data.rawData));
    }
    if (data.hasOwnProperty('AI_RESPONSE')) {
      // set AI response
      dispatch(setAIResponse(component, data.AI_RESPONSE));
      // set rawData
    }
  };
}

function ownKeys$6(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$6(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$6(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$6(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function setRawData(component, response) {
  return {
    type: SET_RAW_DATA,
    component: component,
    response: response
  };
}
function setLoading(component, isLoading) {
  return {
    type: SET_LOADING,
    component: component,
    isLoading: isLoading
  };
}
function setError(component, error) {
  return {
    type: SET_ERROR,
    component: component,
    error: error
  };
}
function setTimestamp(component, timestamp) {
  return {
    type: SET_TIMESTAMP,
    component: component,
    timestamp: timestamp
  };
}
function setSearchId() {
  var searchId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  return {
    type: SET_SEARCH_ID,
    searchId: searchId
  };
}
function setSuggestionsSearchId() {
  var searchId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  return {
    type: SET_SUGGESTIONS_SEARCH_ID,
    searchId: searchId
  };
}
function setQuery(component, query) {
  return {
    type: SET_QUERY,
    component: component,
    query: query
  };
}
function setCustomQuery(component, query) {
  return {
    type: SET_CUSTOM_QUERY,
    component: component,
    query: query
  };
}
function setDefaultQuery(component, query) {
  return {
    type: SET_DEFAULT_QUERY,
    component: component,
    query: query
  };
}
function setCustomHighlightOptions(component, data) {
  return {
    type: SET_CUSTOM_HIGHLIGHT_OPTIONS,
    component: component,
    data: data
  };
}
function updateQueryOptions(component, options) {
  return {
    type: SET_QUERY_OPTIONS,
    component: component,
    options: options
  };
}

// gatekeeping for normal queries
function logQuery(component, query) {
  return {
    type: LOG_QUERY,
    component: component,
    query: query
  };
}

// gatekeeping for queries combined with map queries
function logCombinedQuery(component, query) {
  return {
    type: LOG_COMBINED_QUERY,
    component: component,
    query: query
  };
}
function setHeaders(headers) {
  return {
    type: SET_HEADERS,
    headers: headers
  };
}
function setPromotedResults() {
  var results = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_PROMOTED_RESULTS,
    results: results,
    component: component
  };
}
function setPopularSuggestions() {
  var suggestions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_POPULAR_SUGGESTIONS,
    suggestions: suggestions,
    component: component
  };
}
function setDefaultPopularSuggestions() {
  var suggestions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_DEFAULT_POPULAR_SUGGESTIONS,
    suggestions: suggestions,
    component: component
  };
}
function setCustomData() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_CUSTOM_DATA,
    data: data,
    component: component
  };
}
function setAppliedSettings() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_APPLIED_SETTINGS,
    data: data,
    component: component
  };
}
function setQueryListener(component, onQueryChange, onError) {
  return {
    type: SET_QUERY_LISTENER,
    component: component,
    onQueryChange: onQueryChange,
    onError: onError
  };
}
function setGoogleMapScriptLoading(bool) {
  return {
    type: SET_GOOGLE_MAP_SCRIPT_LOADING,
    loading: bool
  };
}
function setGoogleMapScriptLoaded(bool) {
  return {
    type: SET_GOOGLE_MAP_SCRIPT_LOADED,
    loaded: bool
  };
}
function setGoogleMapScriptError(error) {
  return {
    type: SET_GOOGLE_MAP_SCRIPT_ERROR,
    error: error
  };
}
function resetStoreForComponent(componentId) {
  return function (dispatch) {
    dispatch(setRawData(componentId, null));
    dispatch(setCustomData(null, componentId));
    dispatch(setPromotedResults([], componentId));
    dispatch(setPopularSuggestions([], componentId));
    dispatch(setDefaultPopularSuggestions([], componentId));
    dispatch(updateAggs(componentId, null));
    dispatch(updateCompositeAggs(componentId, {}));
    dispatch(updateHits(componentId, {
      hits: [],
      total: 0
    }, 0));
  };
}
function setLastUsedAppbaseQuery(query) {
  return {
    type: SET_APPBASE_QUERY,
    query: query
  };
}
function setSearchState() {
  var componentsValueAndTypeMap = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function (dispatch) {
    var componentValues = {};
    Object.keys(componentsValueAndTypeMap).forEach(function (componentId) {
      var _componentsValueAndTy = componentsValueAndTypeMap[componentId],
        value = _componentsValueAndTy.value,
        componentProps = _componentsValueAndTy.componentProps;
      var _transformValueToComp = transformValueToComponentStateFormat(value, componentProps),
        transformedValue = _transformValueToComp.value,
        _transformValueToComp2 = _transformValueToComp.meta,
        meta = _transformValueToComp2 === void 0 ? {} : _transformValueToComp2;
      componentValues[componentId] = _objectSpread$6({
        value: transformedValue
      }, meta);
    });
    dispatch(setValues(componentValues));
  };
}
function setAIResponse(component, payload) {
  return {
    type: SET_AI_RESPONSE,
    component: component,
    payload: payload
  };
}
function setAIResponseDelayed(component, payload) {
  return {
    type: SET_AI_RESPONSE_DELAYED,
    component: component,
    payload: payload
  };
}
function removeAIResponse(component) {
  return {
    type: REMOVE_AI_RESPONSE,
    component: component
  };
}
function setAIResponseError(component, error) {
  var meta = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return {
    type: SET_AI_RESPONSE_ERROR,
    component: component,
    error: error,
    meta: meta
  };
}
function setAIResponseLoading(component, isLoading) {
  return {
    type: SET_AI_RESPONSE_LOADING,
    component: component,
    isLoading: isLoading
  };
}

function ownKeys$5(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$5(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$5(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$5(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var handleTransformResponse = function handleTransformResponse() {
  var res = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var component = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  if (config.transformResponse && typeof config.transformResponse === 'function') {
    return config.transformResponse(res, component);
  }
  return new Promise(function (resolve) {
    return resolve(res);
  });
};

// Checks if a component is active or not at a particular time
var isComponentActive = function isComponentActive() {
  var getState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
  var componentId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var _getState = getState(),
    components = _getState.components;
  if (components.includes(componentId)) {
    return true;
  }
  return false;
};
var getQuerySuggestionsId = function getQuerySuggestionsId() {
  var componentId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return "".concat(componentId, "__suggestions");
};
var handleError = function handleError() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    _ref$orderOfQueries = _ref.orderOfQueries,
    orderOfQueries = _ref$orderOfQueries === void 0 ? [] : _ref$orderOfQueries,
    _ref$error = _ref.error,
    error = _ref$error === void 0 ? null : _ref$error;
  var getState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
  var dispatch = arguments.length > 2 ? arguments[2] : undefined;
  var _getState2 = getState(),
    queryListener = _getState2.queryListener;
  try {
    console.error(JSON.stringify(error));
  } catch (e) {
    console.error(error);
  }
  orderOfQueries.forEach(function (component) {
    if (isComponentActive(getState, component)) {
      // Only update state for active components
      if (queryListener[component] && queryListener[component].onError) {
        queryListener[component].onError(error);
      }
      dispatch(setError(component, error));
      dispatch(setLoading(component, false));
    }
  });
};
var handleResponse = function handleResponse() {
  var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    res = _ref2.res,
    _ref2$orderOfQueries = _ref2.orderOfQueries,
    orderOfQueries = _ref2$orderOfQueries === void 0 ? [] : _ref2$orderOfQueries,
    _ref2$appendToHits = _ref2.appendToHits,
    appendToHits = _ref2$appendToHits === void 0 ? false : _ref2$appendToHits,
    _ref2$appendToAggs = _ref2.appendToAggs,
    appendToAggs = _ref2$appendToAggs === void 0 ? false : _ref2$appendToAggs,
    _ref2$isSuggestionsQu = _ref2.isSuggestionsQuery,
    isSuggestionsQuery = _ref2$isSuggestionsQu === void 0 ? false : _ref2$isSuggestionsQu,
    query = _ref2.query,
    queryId = _ref2.queryId;
  var getState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
  var dispatch = arguments.length > 2 ? arguments[2] : undefined;
  var _getState3 = getState(),
    config = _getState3.config,
    internalValues = _getState3.internalValues,
    lastUsedAppbaseQuery = _getState3.lastUsedAppbaseQuery,
    analyticsRef = _getState3.analyticsRef;
  var searchId = res._headers ? res._headers.get('X-Search-Id') : null;
  if (searchId) {
    if (isSuggestionsQuery) {
      // set suggestions search id for internal request of search components
      dispatch(setSuggestionsSearchId(searchId));
    } else {
      // if search id was updated set it in store
      dispatch(setSearchId(searchId));
      if (analyticsRef) {
        analyticsRef.queryID = searchId;
      }
    }
  }

  // handle promoted results
  orderOfQueries.forEach(function (component) {
    // Only update state for active components
    if (isComponentActive(getState, component)) {
      // Avoid settings stale results
      if (lastUsedAppbaseQuery[component] && lastUsedAppbaseQuery[component].queryId && queryId && lastUsedAppbaseQuery[component].queryId !== queryId) {
        return;
      }
      // Update applied settings
      if (res.settings) {
        dispatch(setAppliedSettings(res.settings, component));
      }
      handleTransformResponse(res[component], config, component).then(function (response) {
        if (response) {
          var _getState4 = getState(),
            timestamp = _getState4.timestamp,
            props = _getState4.props;
          if (timestamp[component] === undefined || timestamp[component] < res._timestamp || response.AISessionId && props[component].enableAI && props[component].componentType === componentTypes.searchBox) {
            var promotedResults = response.promoted;
            if (promotedResults) {
              var parsedPromotedResults = promotedResults.map(function (promoted) {
                return _objectSpread$5(_objectSpread$5({}, promoted.doc), {}, {
                  _position: promoted.position
                });
              });
              dispatch(setPromotedResults(parsedPromotedResults, component));
            } else {
              dispatch(setPromotedResults([], component));
            }
            // set raw response in rawData
            dispatch(setRawData(component, response));
            if (response.AIAnswer) {
              if (response.AIAnswer.error) {
                dispatch(setAIResponseError(component, {
                  message: response.AIAnswer.error
                }));
                dispatch(setLoading(component, false));
                return;
              }
              var input = response.AIAnswer;
              // store direct answer returned from API call
              var finalResponse = {
                answer: {
                  documentIds: input.documentIds,
                  model: input.model,
                  text: input.choices[0].message.content
                }
              };
              var finalResponseObj = {
                response: finalResponse,
                meta: response.hits,
                isTyping: false
              };
              if (response.AISessionId) {
                finalResponseObj.sessionId = response.AISessionId;
              }
              dispatch(setAIResponse(component, finalResponseObj));
            } else if (response.AISessionId) {
              var localCache = (getObjectFromLocalStorage(AI_LOCAL_CACHE_KEY) || {})[props.componentId];
              if (localCache && localCache.sessionId && localCache.sessionId === response.AISessionId) {
                // hydrate the store from cache
                dispatch(setAIResponse(component, localCache));
              } else {
                // delete localCache
                setObjectInLocalStorage('AISessions', _defineProperty({}, component, {}));

                // rely on trigger from within the component
                // to fetch initial result for AIAnswer component
                if (props[component].componentType === componentTypes.AIAnswer) {
                  dispatch(setAIResponse(component, {
                    sessionId: response.AISessionId,
                    meta: {
                      hits: response.hits || {}
                    }
                  }));
                } else {
                  // fetch initial AIResponse
                  dispatch(fetchAIResponse(response.AISessionId, component, '', {
                    hits: response.hits || {}
                  }, props[component].componentType === componentTypes.searchBox || props[component].componentType === componentTypes.AIAnswer // make extra GET call to fetch meta info
                  ));
                }
              }
            }

            // Update custom data
            dispatch(setCustomData(response.customData, component));
            if (response.hits && !((response.AIAnswer || response.AISessionId) && props[component].componentType === componentTypes.searchBox)) {
              dispatch(setTimestamp(component, res._timestamp));
              // store last used query for REACTIVE_LIST only

              if (props[component].componentType === componentTypes.reactiveList && query.find(function (queryItem) {
                return queryItem.id === component;
              }).execute) {
                dispatch(setLastUsedAppbaseQuery(_defineProperty({}, component, query)));
              }
              dispatch(updateHits(component, response.hits, response.took, response.hits && response.hits.hidden, appendToHits));
              // get query value
              var internalComponentID = getInternalComponentID(component);
              // Store the last query value associated with `hits`
              if (internalValues[internalComponentID]) {
                dispatch(saveQueryToHits(component, internalValues[internalComponentID].value));
              }
            }
            if (response.aggregations) {
              dispatch(updateAggs(component, response.aggregations, appendToAggs));
              dispatch(updateCompositeAggs(component, response.aggregations, appendToAggs));
            }
          }
          dispatch(setLoading(component, false));
        }
      })["catch"](function (err) {
        handleError({
          orderOfQueries: orderOfQueries,
          error: err
        }, getState, dispatch);
      });
    }
    // }
  });
};
var isPropertyDefined = function isPropertyDefined(property) {
  return property !== undefined && property !== null;
};
var getSuggestionQuery = function getSuggestionQuery() {
  var getState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
  var componentId = arguments.length > 1 ? arguments[1] : undefined;
  var _getState5 = getState(),
    internalValues = _getState5.internalValues;
  var internalValue = internalValues[componentId];
  var value = internalValue && internalValue.value || '';
  return [{
    id: getQuerySuggestionsId(componentId),
    dataField: ['key', 'key.autosuggest'],
    size: 5,
    value: value,
    defaultQuery: {
      query: {
        bool: {
          minimum_should_match: 1,
          should: [{
            function_score: {
              field_value_factor: {
                field: 'count',
                modifier: 'sqrt',
                missing: 1
              }
            }
          }, {
            multi_match: {
              fields: ['key^9', 'key.autosuggest^1', 'key.keyword^10'],
              fuzziness: 0,
              operator: 'or',
              query: value,
              type: 'best_fields'
            }
          }, {
            multi_match: {
              fields: ['key^9', 'key.autosuggest^1', 'key.keyword^10'],
              operator: 'or',
              query: value,
              type: 'phrase'
            }
          }, {
            multi_match: {
              fields: ['key^9'],
              operator: 'or',
              query: value,
              type: 'phrase_prefix'
            }
          }]
        }
      }
    }
  }];
};
function executeQueryListener(listener, oldQuery, newQuery) {
  if (listener && listener.onQueryChange) {
    listener.onQueryChange(oldQuery, newQuery);
  }
}
function updateStoreConfig(payload) {
  return function (dispatch) {
    dispatch({
      type: UPDATE_CONFIG,
      config: payload
    });
  };
}

function ownKeys$4(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$4(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$4(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$4(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function setValue(component, value, label, showFilter, URLParams, componentType, category, meta, updateSource // valid values => 'URL'
) {
  return function (dispatch, getState) {
    var _getState = getState(),
      urlValues = _getState.urlValues,
      selectedValues = _getState.selectedValues,
      watchMan = _getState.watchMan,
      props = _getState.props;
    // set the value reference
    var reference = updateSource;
    if (isEqual(urlValues[component], value)) {
      reference = 'URL';
    }
    // Clear pagination state for result components
    // Only clear when value is not set by URL params
    var componentsToReset = {};
    var isResultComponent = [componentTypes.reactiveList, componentTypes.reactiveMap].includes(props[component] && props[component].componentType);
    var previousValue = selectedValues[component] && selectedValues[component].value;
    // Incase of searchbox .meta.imageValue can be modified although .value is not modified.
    var isImageValueEqual = true;
    // SelectedFilters may not have componentType but they need to clear the value
    if (componentType === componentTypes.searchBox || componentType === undefined) {
      var previousImageValue = selectedValues[component] && selectedValues[component].meta && selectedValues[component].meta.imageValue;
      isImageValueEqual = isEqual(previousImageValue, meta && meta.imageValue);
    }
    if ((!isEqual(previousValue, value) || !isImageValueEqual) && props[component] && !isResultComponent) {
      var componentList = [component];
      var watchList = watchMan[component] || [];
      componentList = [].concat(_toConsumableArray(componentList), _toConsumableArray(watchList));
      componentList.forEach(function (comp) {
        // Clear pagination state for result components
        // Only clear when value is not set by URL params
        var componentProps = props[comp];
        if (reference !== 'URL' && componentProps
        // eslint-disable-next-line max-len
        && [componentTypes.reactiveList, componentTypes.reactiveMap].includes(componentProps.componentType)) {
          if (selectedValues[comp] !== null) {
            componentsToReset[comp] = null;
          }
        }
      });
    }
    if (isResultComponent) {
      // reject default page requests
      if (value < 2 && (!previousValue || previousValue < 2)) {
        return;
      }
    }
    dispatch({
      type: SET_VALUE,
      component: component,
      reference: reference,
      value: value,
      label: label,
      showFilter: showFilter,
      URLParams: URLParams,
      componentType: componentType,
      category: category,
      meta: meta,
      componentsToReset: componentsToReset
    });
  };
}
function resetValuesToDefault(clearAllBlacklistComponents) {
  return function (dispatch, getState) {
    var _getState2 = getState(),
      selectedValues = _getState2.selectedValues,
      componentProps = _getState2.props;
    var defaultValues = {
      // componentName: defaultValue,
    };
    var valueToSet;
    Object.keys(selectedValues).forEach(function (component) {
      if (!(Array.isArray(clearAllBlacklistComponents) && clearAllBlacklistComponents.includes(component))) {
        if (!componentProps[component] || !componentProps[component].componentType || !componentProps[component].defaultValue) {
          valueToSet = null;
        } else if ([componentTypes.rangeSlider, componentTypes.rangeInput, componentTypes.ratingsFilter, componentTypes.dateRange].includes(componentProps[component].componentType)) {
          valueToSet = _typeof(componentProps[component].defaultValue) === 'object' ? [componentProps[component].defaultValue.start, componentProps[component].defaultValue.end] : null;
        } else if ([componentTypes.multiDropdownList, componentTypes.multiDataList, componentTypes.multiList, componentTypes.singleDataList, componentTypes.singleDropdownList, componentTypes.singleList, componentTypes.tagCloud, componentTypes.toggleButton, componentTypes.multiDropdownRange, componentTypes.multiRange, componentTypes.singleDropdownRange, componentTypes.singleRange, componentTypes.dataSearch, componentTypes.datePicker, componentTypes.treeList].includes(componentProps[component].componentType)) {
          valueToSet = componentProps[component].defaultValue;
        } else if ([componentTypes.categorySearch].includes(componentProps[component].componentType)) {
          valueToSet = componentProps[component].defaultValue ? componentProps[component].defaultValue.term : '';
        }
        if (!isEqual(selectedValues[component].value, valueToSet)) {
          defaultValues = _objectSpread$4(_objectSpread$4({}, defaultValues), {}, _defineProperty({}, component, _objectSpread$4(_objectSpread$4({}, selectedValues[component]), {}, {
            value: valueToSet
          })));
        }
      }
    });
    dispatch({
      type: RESET_TO_DEFAULT,
      defaultValues: defaultValues
    });
  };
}
function setInternalValue(component, value, componentType, category, meta) {
  return {
    type: SET_INTERNAL_VALUE,
    component: component,
    value: value,
    componentType: componentType,
    category: category,
    meta: meta
  };
}
/**
 * Patches the properties of the component
 * @param {String} component
 * @param {Object} payload
 */
function patchValue(component, payload) {
  return {
    type: PATCH_VALUE,
    component: component,
    payload: payload
  };
}
function clearValues() {
  var resetValues = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var clearAllBlacklistComponents = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return {
    type: CLEAR_VALUES,
    resetValues: resetValues,
    clearAllBlacklistComponents: clearAllBlacklistComponents
  };
}
function setValues(componentsValues) {
  return function (dispatch) {
    dispatch(updateStoreConfig({
      queryLockConfig: {
        initialTimestamp: new Date().getTime(),
        lockTime: 300
      }
    }));
    dispatch({
      type: SET_VALUES,
      componentsValues: componentsValues
    });
  };
}

function updateMapData(componentId, query, persistMapQuery) {
  return {
    type: SET_MAP_DATA,
    componentId: componentId,
    query: query,
    persistMapQuery: persistMapQuery
  };
}
function setMapData(componentId, query, persistMapQuery, forceExecute) {
  var meta = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
  var queryId = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : '';
  return function (dispatch) {
    dispatch(updateMapData(componentId, query, persistMapQuery));
    // Set meta properties for internal component to make geo bounding box work
    dispatch(setInternalValue(getInternalComponentID(componentId), undefined, undefined, undefined, meta));
    if (forceExecute) {
      var executeWatchList = false;
      // force execute the map query
      var mustExecuteMapQuery = true;
      dispatch(executeQuery(componentId, executeWatchList, mustExecuteMapQuery, componentTypes.reactiveMap, {}, queryId));
    }
  };
}
function setMapResults(componentId, _ref) {
  var center = _ref.center,
    zoom = _ref.zoom,
    markers = _ref.markers;
  return {
    type: SET_MAP_RESULTS,
    componentId: componentId,
    payload: {
      center: center,
      zoom: zoom,
      markers: markers
    }
  };
}

var _excluded = ["value"];
function ownKeys$3(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$3(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$3(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$3(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function loadPopularSuggestions(componentId) {
  return function (dispatch, getState) {
    var _getState = getState(),
      config = _getState.config,
      appbaseRef = _getState.appbaseRef,
      props = _getState.props,
      internalValues = _getState.internalValues;
    var componentProps = props[componentId] || {};
    var internalValue = internalValues[componentId];
    var value = internalValue && internalValue.value || '';
    if (componentProps.enablePopularSuggestions) {
      if (config.mongodb) {
        dispatch(setDefaultPopularSuggestions([], componentId.split('__internal')[0]));
        return;
      }
      var suggQuery = getSuggestionQuery(getState, componentId);
      appbaseRef.getQuerySuggestions(suggQuery).then(function (suggestions) {
        var querySuggestion = suggestions[getQuerySuggestionsId(componentId)];
        if (value) {
          // update query suggestions for search components
          dispatch(setPopularSuggestions(querySuggestion && querySuggestion.hits && querySuggestion.hits.hits, componentId.split('__internal')[0]));
        } else {
          dispatch(setDefaultPopularSuggestions(querySuggestion && querySuggestion.hits && querySuggestion.hits.hits, componentId.split('__internal')[0]));
          // dispatch default popular suggestions
        }
      })["catch"](function (e) {
        handleError({
          orderOfQueries: [componentId],
          error: e
        }, getState, dispatch);
      });
    }
  };
}
function appbaseSearch() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    queryId = _ref.queryId,
    query = _ref.query,
    orderOfQueries = _ref.orderOfQueries,
    _ref$appendToHits = _ref.appendToHits,
    appendToHits = _ref$appendToHits === void 0 ? false : _ref$appendToHits,
    _ref$isSuggestionsQue = _ref.isSuggestionsQuery,
    isSuggestionsQuery = _ref$isSuggestionsQue === void 0 ? false : _ref$isSuggestionsQue,
    searchComponentID = _ref.searchComponentID,
    _ref$appendToAggs = _ref.appendToAggs,
    appendToAggs = _ref$appendToAggs === void 0 ? false : _ref$appendToAggs;
  return function (dispatch, getState) {
    var _getState2 = getState(),
      appbaseRef = _getState2.appbaseRef,
      config = _getState2.config,
      headers = _getState2.headers,
      props = _getState2.props;
    var isAnalyticsEnabled = false;
    if (config) {
      if (isPropertyDefined(config.analytics)) {
        isAnalyticsEnabled = config.analytics;
      } else if (config.analyticsConfig) {
        if (isPropertyDefined(config.analyticsConfig.recordAnalytics)) {
          isAnalyticsEnabled = config.analyticsConfig.recordAnalytics;
        } else if (isPropertyDefined(config.analyticsConfig.analytics)) {
          isAnalyticsEnabled = config.analyticsConfig.analytics;
        }
      }
    }
    var settings = {
      recordAnalytics: isAnalyticsEnabled
    };
    if (config.analyticsConfig) {
      settings.userId = isPropertyDefined(config.analyticsConfig.userId) ? config.analyticsConfig.userId : undefined;
      settings.enableQueryRules = isPropertyDefined(config.analyticsConfig.enableQueryRules) ? config.analyticsConfig.enableQueryRules : undefined;
      settings.customEvents = isPropertyDefined(config.analyticsConfig.customEvents) ? config.analyticsConfig.customEvents : undefined;
      settings.emptyQuery = isPropertyDefined(config.analyticsConfig.emptyQuery) ? config.analyticsConfig.emptyQuery : undefined;
      var searchRelevancy = config.analyticsConfig.enableSearchRelevancy;
      settings.enableSearchRelevancy = isPropertyDefined(searchRelevancy) ? searchRelevancy : undefined;
      settings.suggestionAnalytics = isPropertyDefined(config.analyticsConfig.suggestionAnalytics) ? config.analyticsConfig.suggestionAnalytics : undefined;
      settings.useCache = isPropertyDefined(config.analyticsConfig.useCache) ? config.analyticsConfig.useCache : undefined;
      settings.queryParams = isPropertyDefined(config.analyticsConfig.queryParams) ? config.analyticsConfig.queryParams : undefined;
    }

    // set loading as active for the given component
    orderOfQueries.forEach(function (component) {
      dispatch(setLoading(component, true));
      if (props[component] && props[component].enableAI) {
        dispatch(removeAIResponse(component));
      }
      // reset error
      dispatch(setError(component, null));
    });
    appbaseRef.setHeaders(_objectSpread$3({}, headers));
    if (isSuggestionsQuery && searchComponentID) {
      dispatch(loadPopularSuggestions(searchComponentID));
    }
    appbaseRef.reactiveSearch(query, settings, settings.queryParams).then(function (res) {
      handleResponse({
        res: res,
        orderOfQueries: orderOfQueries,
        appendToHits: appendToHits,
        appendToAggs: appendToAggs,
        query: query,
        queryId: queryId
      }, getState, dispatch);
    })["catch"](function (err) {
      handleError({
        orderOfQueries: orderOfQueries,
        error: err,
        queryId: queryId
      }, getState, dispatch);
    });
  };
}

// latest request would be at the end
var requestStack = [];
function executeQuery(componentId) {
  var executeWatchList = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  var mustExecuteMapQuery = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var componentType = arguments.length > 3 ? arguments[3] : undefined;
  var metaOptions = arguments.length > 4 ? arguments[4] : undefined;
  var
  // A unique identifier for map query to recognize
  // the results for latest requests
  requestId = arguments.length > 5 ? arguments[5] : undefined;
  return function (dispatch, getState) {
    var _getState3 = getState(),
      queryLog = _getState3.queryLog,
      config = _getState3.config,
      mapData = _getState3.mapData,
      watchMan = _getState3.watchMan,
      queryListener = _getState3.queryListener,
      props = _getState3.props,
      internalValues = _getState3.internalValues,
      lock = _getState3.lock,
      dependencyTree = _getState3.dependencyTree,
      queryList = _getState3.queryList,
      queryOptions = _getState3.queryOptions;
    var lockTime = config.initialQueriesSyncTime || 100;
    var initialTimestamp = config.initialTimestamp;
    var queryId = requestId || new Date().getTime();

    // override logic for locking queries for a period of time
    // The block only runs when setSearchState method of StateProvider sets the
    // queryLockConfig property in then store
    if (config.queryLockConfig instanceof Object) {
      lockTime = config.queryLockConfig.lockTime;
      initialTimestamp = config.queryLockConfig.initialTimestamp;
    }
    var componentList = [componentId];
    var finalQuery = [];
    var appbaseQuery = {}; // Use object to prevent duplicate query added by react prop
    var orderOfQueries = [];
    if (executeWatchList) {
      var watchList = watchMan[componentId] || [];
      componentList = [].concat(_toConsumableArray(componentList), _toConsumableArray(watchList));
    }

    // console.log('EXECUTE QUERY FOR COMPONENT', componentId);

    componentList.forEach(function (component) {
      // Just to wait for the `react` dependencies
      var _buildQuery = buildQuery(component, dependencyTree, queryList, queryOptions),
        queryObj = _buildQuery.queryObj,
        options = _buildQuery.options;
      if (!queryObj && !options) {
        return;
      }
      // use internal value for suggestions query
      var value;
      var isInternalComponent = componentId.endsWith('__internal');
      var mainComponentProps = props[componentId];
      if (isInternalComponent && mainComponentProps && isSearchComponent(mainComponentProps.componentType)) {
        value = internalValues[componentId] && internalValues[componentId].value;
      }
      // build query
      var query = getRSQuery(component, extractPropsFromState(getState(), component, _objectSpread$3(_objectSpread$3({}, value ? {
        value: value
      } : null), metaOptions ? _objectSpread$3({
        from: metaOptions.from
      }, value && metaOptions.enableAI === true ? _objectSpread$3(_objectSpread$3({}, metaOptions), {}, {
        enableAI: true,
        type: 'search'
      }) : {}) : null)));
      // check if query or options are non-empty
      if (query && !!Object.keys(query).length) {
        var currentQuery = query;
        var oldQuery = queryLog[component];
        var componentProps = props[component];
        var dependentQueries = getDependentQueries(getState(), component, orderOfQueries);
        var queryToLog = _objectSpread$3(_objectSpread$3({}, _defineProperty({}, component, currentQuery)), Object.keys(dependentQueries).reduce(function (acc, q) {
          return _objectSpread$3(_objectSpread$3({}, acc), {}, _defineProperty({}, q, _objectSpread$3(_objectSpread$3({}, dependentQueries[q]), {}, {
            execute: false
          }, dependentQueries[q].type === queryTypes.suggestion ? {
            type: 'search'
          } : {})));
        }, {}));
        var queryType = componentToTypeMap[componentProps && componentProps.componentType];
        if ([queryTypes.range, queryTypes.term].includes(queryType)) {
          // Avoid logging `value` for term type of components
          // eslint-disable-next-line
          currentQuery.value;
            var rest = _objectWithoutProperties(currentQuery, _excluded);
          queryToLog = _objectSpread$3(_objectSpread$3({}, _defineProperty({}, component, rest)), Object.keys(dependentQueries).reduce(function (acc, q) {
            return _objectSpread$3(_objectSpread$3({}, acc), {}, _defineProperty({}, q, _objectSpread$3(_objectSpread$3(_objectSpread$3({}, dependentQueries[q]), {
              execute: false
            }), dependentQueries[q].type === queryTypes.suggestion ? {
              type: 'search'
            } : {})));
          }, {}));
        }
        if (mustExecuteMapQuery || !compareQueries(queryToLog, oldQuery)) {
          orderOfQueries = [].concat(_toConsumableArray(orderOfQueries), [component]);
          var isMapComponent = Object.keys(mapData).includes(component);
          if (isMapComponent) {
            dispatch(setLastUsedAppbaseQuery(_defineProperty({}, component, {
              queryId: queryId
            })));
          }

          // log query before adding the map query,
          // since we don't do gatekeeping on the map query in the `queryLog`
          dispatch(logQuery(component, queryToLog));
          if (isMapComponent && mapData[component].query) {
            // attach mapQuery to exisiting query via "must" type
            var existingQuery = currentQuery.query;
            // TODO: Check
            currentQuery.query = {
              bool: {
                must: [existingQuery, mapData[component].query]
              }
            };
            if (!mapData[component].persistMapQuery) {
              // clear mapQuery if we don't want it to persist
              dispatch(updateMapData(componentId, null, false));
            }

            // skip the query execution if the combined query [component + map Query]
            // matches the logged combined query
            var _getState4 = getState(),
              combinedLog = _getState4.combinedLog;
            if (compareQueries(combinedLog[component], currentQuery)) {
              return;
            }

            // log query after adding the map query,
            // to separately support gatekeeping for combined map queries
            dispatch(logCombinedQuery(component, currentQuery));
          }
          executeQueryListener(queryListener[component], oldQuery, currentQuery);
          if (query) {
            // Apply dependent queries
            appbaseQuery = _objectSpread$3(_objectSpread$3(_objectSpread$3({}, appbaseQuery), _defineProperty({}, component, query)), getDependentQueries(getState(), component, orderOfQueries));
          }
          if (isMapComponent) {
            var internalComponent = getInternalComponentID(component);
            var internalQuery = getRSQuery(internalComponent, extractPropsFromState(getState(), internalComponent, metaOptions ? {
              from: metaOptions.from
            } : null));
            if (internalQuery) {
              appbaseQuery[internalComponent] = _objectSpread$3(_objectSpread$3({}, internalQuery), {}, {
                execute: false
              });
            }
          }
        }
      }
    });
    finalQuery = Object.keys(appbaseQuery).map(function (component) {
      return appbaseQuery[component];
    });
    if (finalQuery.length) {
      var suggestionsComponents = [componentTypes.dataSearch, componentTypes.categorySearch];
      var isInternalComponent = componentId.endsWith('__internal');
      var isSuggestionsQuery = isInternalComponent && suggestionsComponents.indexOf(componentType) !== -1;
      var currentTime = new Date().getTime();
      if (currentTime - initialTimestamp < lockTime) {
        // set timeout if lock is not false
        if (!lock || config.queryLockConfig) {
          setTimeout(function () {
            var finalOrderOfQueries = [];
            var finalIsSuggestionsQuery = false;
            var finalSearchComponentID = '';
            var orderOfQueriesMap = {};
            var processedQueriesMap = {};
            var queryExecutionMap = {};

            // construct the request body with latest requests
            // dispatch the `appbaseSearch` action with a single request
            requestStack.forEach(function (request) {
              if (!finalIsSuggestionsQuery) {
                finalIsSuggestionsQuery = request.isSuggestionsQuery;
              }
              if (!finalSearchComponentID) {
                finalSearchComponentID = request.searchComponentID;
              }
              if (Array.isArray(request.query)) {
                request.query.forEach(function (query) {
                  if (query.execute) {
                    queryExecutionMap[query.id] = query.execute;
                  }
                  var newQuery = query;
                  // override by the latest query
                  // set the query execution to true if map has value
                  if (queryExecutionMap[query.id]) {
                    newQuery.execute = true;
                  }
                  if (processedQueriesMap[query.id] && processedQueriesMap[query.id].type === queryTypes.suggestion && newQuery.type !== queryTypes.suggestion) {
                    processedQueriesMap["".concat(query.id, "__suggestion_type")] = _objectSpread$3({}, processedQueriesMap[query.id]);
                    processedQueriesMap[query.id] = _objectSpread$3(_objectSpread$3({}, newQuery), {}, {
                      execute: false
                    });
                    return;
                  }
                  processedQueriesMap[query.id] = newQuery;
                });
              }
              if (Array.isArray(request.orderOfQueries)) {
                request.orderOfQueries.forEach(function (query) {
                  if (!orderOfQueriesMap[query.id]) {
                    finalOrderOfQueries = [query].concat(_toConsumableArray(finalOrderOfQueries));
                  } else {
                    orderOfQueriesMap[query.id] = true;
                  }
                });
              }
            });
            var finalCombinedQuery = Object.values(processedQueriesMap);
            if (finalCombinedQuery.length) {
              dispatch(appbaseSearch({
                query: finalCombinedQuery,
                orderOfQueries: finalOrderOfQueries,
                isSuggestionsQuery: finalIsSuggestionsQuery,
                searchComponentID: finalSearchComponentID
              }));
            }
            // empty the request stack
            requestStack = [];
            dispatch(updateStoreConfig({
              queryLockConfig: undefined
            }));
          }, lockTime);
        }
        dispatch(updateStoreConfig({
          lock: true
        }));
        requestStack.push({
          query: finalQuery,
          orderOfQueries: orderOfQueries,
          isSuggestionsQuery: isSuggestionsQuery,
          searchComponentID: componentId
        });
      } else {
        dispatch(appbaseSearch({
          queryId: queryId,
          query: finalQuery,
          orderOfQueries: orderOfQueries,
          isSuggestionsQuery: isSuggestionsQuery,
          searchComponentID: componentId
        }));
      }
    }
  };
}
function setQueryOptions(component, queryOptions) {
  var execute = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  return function (dispatch) {
    dispatch(updateQueryOptions(component, queryOptions));
    if (execute) {
      dispatch(executeQuery(component, true));
    }
  };
}
function updateQuery(_ref2) {
  var componentId = _ref2.componentId,
    query = _ref2.query,
    value = _ref2.value,
    _ref2$label = _ref2.label,
    label = _ref2$label === void 0 ? null : _ref2$label,
    _ref2$showFilter = _ref2.showFilter,
    showFilter = _ref2$showFilter === void 0 ? true : _ref2$showFilter,
    _ref2$URLParams = _ref2.URLParams,
    URLParams = _ref2$URLParams === void 0 ? false : _ref2$URLParams,
    _ref2$componentType = _ref2.componentType,
    componentType = _ref2$componentType === void 0 ? null : _ref2$componentType,
    _ref2$category = _ref2.category,
    category = _ref2$category === void 0 ? null : _ref2$category,
    _ref2$meta = _ref2.meta,
    meta = _ref2$meta === void 0 ? {} : _ref2$meta;
  var execute = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var shouldSetInternalValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  return function (dispatch) {
    // eslint-disable-next-line
    var queryToDispatch = query;
    if (query && query.query) {
      queryToDispatch = query.query;
    }
    // don't set filters for internal components
    if (!componentId.endsWith('__internal')) {
      dispatch(setValue(componentId, value, label, showFilter, URLParams, componentType, category, meta));
      if (shouldSetInternalValue) {
        if (componentType === componentTypes.dynamicRangeSlider) {
          // Dynamic Range Slider has a dependency on histogram which uses different ID
          dispatch(setInternalValue(getHistogramComponentID(componentId), value, componentType, category, meta));
        } else {
          dispatch(setInternalValue("".concat(componentId, "__internal"), value, componentType, category, meta));
        }
      }
    } else {
      dispatch(setInternalValue(componentId, value, componentType, category, meta));
    }
    dispatch(setQuery(componentId, queryToDispatch));
    if (execute) {
      dispatch(executeQuery(componentId, true, false, componentType, componentType === componentTypes.searchBox && meta && typeof meta.enableAI === 'boolean' ? _objectSpread$3(_objectSpread$3({}, meta), {}, {
        enableAI: meta.enableAI
      }) : undefined));
    }
  };
}
function loadMore(component, newOptions) {
  var appendToHits = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  var appendToAggs = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  // `appendToAggs` will be `true` in case of consecutive loading
  // of data-driven components via composite aggregations.

  // This approach will enable us to reset the component's query (aggs)
  // whenever there is a change in the component's subscribed source.
  return function (dispatch, getState) {
    var store = getState();
    var _buildQuery2 = buildQuery(component, store.dependencyTree, store.queryList, store.queryOptions),
      queryObj = _buildQuery2.queryObj,
      options = _buildQuery2.options;
    var queryLog = store.queryLog;
    if (!options) options = {};
    options = _objectSpread$3(_objectSpread$3({}, options), newOptions);
    if (!queryObj || queryObj && !Object.keys(queryObj).length) {
      queryObj = {
        match_all: {}
      };
    }
    var appbaseQuery = {};
    var componentProps = store.props[component] || {};
    var compositeAggregationField = componentProps.aggregationField;
    var queryType = componentToTypeMap[componentProps.componentType];
    // For term queries i.e list component `dataField` will be treated as aggregationField
    if (queryType === queryTypes.term) {
      compositeAggregationField = componentProps.dataField;
    }
    // build query
    var query = getRSQuery(component, extractPropsFromState(store, component, {
      from: options.from,
      after: store.aggregations[component] && store.aggregations[component][compositeAggregationField] && store.aggregations[component][compositeAggregationField].after_key || undefined
    }));
    // Apply dependent queries
    appbaseQuery = _objectSpread$3(_objectSpread$3({}, _defineProperty({}, component, query)), getDependentQueries(getState(), component, []));

    // query gatekeeping
    if (compareQueries(queryLog[component], appbaseQuery)) return;
    dispatch(logQuery(component, appbaseQuery));
    var finalQuery = Object.keys(appbaseQuery).map(function (c) {
      return appbaseQuery[c];
    });
    dispatch(appbaseSearch({
      query: finalQuery,
      orderOfQueries: [component],
      appendToHits: appendToHits,
      appendToAggs: appendToAggs
    }));
  };
}
function loadDataToExport(componentId) {
  var deepPaginationCursor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var totalResults = arguments.length > 2 ? arguments[2] : undefined;
  var data = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];
  return function (dispatch, getState) {
    var _getState5 = getState(),
      appbaseRef = _getState5.appbaseRef,
      lastUsedAppbaseQuery = _getState5.lastUsedAppbaseQuery;
    var queryFromStore = lastUsedAppbaseQuery[componentId];
    if (queryFromStore) {
      var query = queryFromStore.map(function (queryItem) {
        if (queryItem.id === componentId) {
          var finalQueryItem = _objectSpread$3(_objectSpread$3({}, queryItem), {}, {
            deepPaginationConfig: {
              cursor: deepPaginationCursor
            },
            deepPagination: true,
            size: totalResults < 1000 ? totalResults : 1000,
            sortField: '_id',
            sortBy: 'asc'
          });
          delete finalQueryItem.from;
          return finalQueryItem;
        }
        return queryItem;
      });
      if (totalResults && Array.isArray(data) && totalResults <= data.length) {
        return data;
      }
      return appbaseRef.reactiveSearchv3(query).then(function (res) {
        var newDataChunk = res[componentId].hits.hits;
        if (!Array.isArray(newDataChunk) || newDataChunk.length === 0) {
          return data;
        }
        return dispatch(loadDataToExport(componentId, newDataChunk[newDataChunk.length - 1]._id, res[componentId].hits.total.value, [].concat(_toConsumableArray(data), _toConsumableArray(newDataChunk))));
      })["catch"](function (err) {
        console.error('Error fetching data to export! ', err);
      });
    }
    return console.error('Error fetching data to export!');
  };
}
function processJSONResponse(dispatch, componentId, AIAnswerKey, localCache, parsedRes) {
  var meta = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
  try {
    var finalResponse = _objectSpread$3({}, parsedRes);
    if (finalResponse.answer) {
      finalResponse.answer.role = AI_ROLES.ASSISTANT;
    }
    dispatch(setAIResponse(componentId, {
      meta: meta,
      sessionId: AIAnswerKey,
      messages: [].concat(_toConsumableArray(localCache && localCache.messages || []), _toConsumableArray(finalResponse.question ? [{
        content: finalResponse.question,
        role: AI_ROLES.USER
      }] : []), _toConsumableArray(finalResponse.answer ? [{
        content: finalResponse.answer.text,
        role: AI_ROLES.ASSISTANT
      }] : [])),
      response: _objectSpread$3({}, finalResponse)
    }));
  } catch (e) {
    getStackTrace();
    dispatch(setAIResponseError(componentId, e, {
      sessionId: AIAnswerKey
    }));
  }
}
function processStream(res, dispatch, componentId, AIAnswerKey) {
  var meta = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
  var question = arguments.length > 5 ? arguments[5] : undefined;
  var metaInfoPromise = arguments.length > 6 ? arguments[6] : undefined;
  var reader = res.body.getReader();
  var decoder = new TextDecoder();
  var responseText = '';
  var answerIndex;
  var questionMessage = question ? {
    content: question,
    role: AI_ROLES.USER
  } : null;
  var updateMessage = function updateMessage(content) {
    responseText += content;
    var localCache = (getObjectFromLocalStorage(AI_LOCAL_CACHE_KEY) || {})[componentId];
    var messages = _toConsumableArray(localCache && localCache.messages || localCache && localCache.response && localCache.response.messages || []);
    if (questionMessage && messages.findIndex(function (msg) {
      return msg.content === questionMessage.content && msg.role === questionMessage.role;
    }) === -1) {
      messages.push(questionMessage);
    }
    if (answerIndex === undefined) {
      answerIndex = messages.length;
      messages.push({
        content: responseText,
        role: AI_ROLES.ASSISTANT
      });
    } else {
      messages[answerIndex] = {
        content: responseText,
        role: AI_ROLES.ASSISTANT
      };
    }
    dispatch(setAIResponseDelayed(componentId, {
      meta: meta,
      sessionId: AIAnswerKey,
      isTyping: true,
      messages: messages,
      response: {
        answer: {
          text: responseText,
          role: AI_ROLES.ASSISTANT
        }
      }
    }));
  };
  function readStream() {
    reader.read().then(function (_ref3) {
      var value = _ref3.value,
        done = _ref3.done;
      if (done) {
        reader.releaseLock();
        return;
      }
      var chunk = decoder.decode(value, {
        stream: true
      });
      var regex = /\n\n(?=data:|$)/;
      var lines = chunk.split(regex);
      var shouldStop = false;
      for (var i = 0; i < lines.length; i++) {
        var line = lines[i];
        if (line.startsWith('data: ')) {
          var content = line.slice(6);
          if (content === '[DONE]') {
            shouldStop = true;
            if (Promise.resolve(metaInfoPromise) === metaInfoPromise) {
              metaInfoPromise.then(function (resMeta) {
                return resMeta.json();
              })
              // eslint-disable-next-line no-loop-func
              .then(function (parsedRes) {
                var messagesArr = [];
                if (parsedRes.question && parsedRes.answer) {
                  messagesArr.push.apply(messagesArr, [{
                    content: parsedRes.question,
                    role: AI_ROLES.USER
                  }, {
                    content: parsedRes.answer.text,
                    role: AI_ROLES.ASSISTANT
                  }]);
                }
                dispatch(setAIResponseDelayed(componentId, {
                  meta: meta,
                  sessionId: AIAnswerKey,
                  response: _objectSpread$3({}, parsedRes),
                  messages: messagesArr,
                  isTyping: false
                }));
              })["catch"](function (e) {
                console.error("Error fetching meta details for sessionId: ".concat(AIAnswerKey), e);
              });
            } else {
              dispatch(setAIResponseDelayed(componentId, {
                isTyping: false
              }));
            }
            break;
          }
          updateMessage(content);
        }
      }
      if (shouldStop) {
        reader.releaseLock();
      } else {
        readStream();
      }
    })["catch"](function (e) {
      reader.releaseLock();
      dispatch(setAIResponseError(componentId, e, {
        sessionId: AIAnswerKey,
        isTyping: false
      }));
    });
  }
  readStream();
}
var cancellationTokens = {}; // initialize cancellationTokens map

function fetchAIResponse(AIAnswerKey, componentId, question) {
  var meta = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  var shouldFetchMetaInfoUsingGET = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  return function (dispatch, getState) {
    var isPostRequest = !!question;
    dispatch(setAIResponseLoading(componentId, true));
    var _getState6 = getState(),
      _getState6$config = _getState6.config,
      url = _getState6$config.url,
      configCredentials = _getState6$config.credentials,
      endpoint = _getState6$config.endpoint;
    var regex = /https:\/\/[^/]+/;
    var urlObj = new URL(url.match(regex)[0]);
    var credentials = configCredentials;
    if (urlObj.username && urlObj.password) {
      credentials = "".concat(urlObj.username, ":").concat(urlObj.password);
      urlObj.username = '';
      urlObj.password = '';
    }
    var fetchUrl = "".concat(urlObj.toString(), "_ai/").concat(AIAnswerKey);
    var ssefetchUrl = "".concat(fetchUrl, "/sse");
    var headers = new Headers();
    if (credentials) {
      var encodedCredentials = btoa(credentials);
      headers.append('Authorization', "Basic ".concat(encodedCredentials));
    } else if (endpoint && endpoint.headers && endpoint.headers.Authorization) {
      headers.append('Authorization', endpoint.headers.Authorization);
    }
    var method = isPostRequest ? 'POST' : 'GET';
    var localCache = (getObjectFromLocalStorage(AI_LOCAL_CACHE_KEY) || {})[componentId];
    var requestOptions = {
      headers: headers,
      method: method,
      body: isPostRequest ? JSON.stringify({
        question: question
      }) : undefined
    };
    var attempt = 1; // initialize attempt number
    var maxAttempts = 2; // set max number of attempts

    var doFetch = function doFetch() {
      // Create a new cancellation token for this componentId
      // and abort any previous requests for this componentId
      var controller = new AbortController();
      if (cancellationTokens[componentId]) {
        cancellationTokens[componentId].abort();
      }
      cancellationTokens[componentId] = controller;
      fetch(ssefetchUrl, _objectSpread$3(_objectSpread$3({}, requestOptions), {}, {
        signal: controller.signal
      })).then(function (res) {
        if (!res.ok) {
          if (attempt < maxAttempts) {
            // retry on 400 error, up to maxAttempts times
            attempt++;
            setTimeout(doFetch, 1000); // retry
            return;
          }
        }
        var contentType = res.headers.get('content-type');
        if (contentType && contentType.startsWith('application/json')) {
          res.json().then(function (parsedRes) {
            if (parsedRes.error) {
              dispatch(setAIResponseError(componentId, parsedRes.error));
            } else {
              processJSONResponse(dispatch, componentId, AIAnswerKey, localCache, parsedRes, meta);
            }
          });
        } else {
          var metaInfoPromise;
          if (shouldFetchMetaInfoUsingGET) {
            metaInfoPromise = fetch(fetchUrl, _objectSpread$3(_objectSpread$3({}, requestOptions.headers ? {
              headers: requestOptions.headers
            } : {}), {}, {
              method: 'GET'
            }));
          }
          processStream(res, dispatch, componentId, AIAnswerKey, meta, question, metaInfoPromise);
        }
      })["catch"](function (e) {
        // Ignore abort errors
        if (e.name === 'AbortError') {
          return;
        }
        dispatch(setAIResponseError(componentId, e, {
          sessionId: AIAnswerKey
        }));
      });
    };
    doFetch();
  };
}
function createAISession() {
  var question = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Reactivesearch';
  return function (dispatch, getState) {
    var _getState7 = getState(),
      _getState7$config = _getState7.config,
      url = _getState7$config.url,
      configCredentials = _getState7$config.credentials,
      endpoint = _getState7$config.endpoint;
    var regex = /https:\/\/[^/]+/;
    var urlObj = new URL(url.match(regex)[0]);
    var credentials = configCredentials;
    if (urlObj.username && urlObj.password) {
      credentials = "".concat(urlObj.username, ":").concat(urlObj.password);
      urlObj.username = '';
      urlObj.password = '';
    }
    var fetchUrl = "".concat(urlObj.toString(), "_ai");
    var headers = new Headers();
    if (credentials) {
      var encodedCredentials = btoa(credentials);
      headers.append('Authorization', "Basic ".concat(encodedCredentials));
    } else if (endpoint && endpoint.headers && endpoint.headers.Authorization) {
      headers.append('Authorization', endpoint.headers.Authorization);
    }
    var requestOptions = {
      headers: headers,
      method: 'POST',
      body: JSON.stringify({
        question: question
      })
    };
    return fetch(fetchUrl, _objectSpread$3({}, requestOptions)).then(function (res) {
      return res.json();
    }).then(function (parsedRes) {
      return parsedRes;
    })["catch"](function (e) {
      // Ignore abort errors
      console.error('Error creating an AI session: ', e);
    });
  };
}

function addComponentToList(component) {
  return {
    type: ADD_COMPONENT,
    component: component
  };
}
function addComponentTimestamp(component, timestamp) {
  return {
    type: SET_REGISTERED_COMPONENT_TIMESTAMP,
    component: component,
    timestamp: timestamp
  };
}
function addComponent(component, timestamp) {
  return function (dispatch) {
    dispatch(addComponentToList(component));
    dispatch(addComponentTimestamp(component, timestamp));
  };
}
function removeComponent(component) {
  return {
    type: REMOVE_COMPONENT,
    component: component
  };
}
function updateWatchman(component, react) {
  return {
    type: WATCH_COMPONENT,
    component: component,
    react: react
  };
}
function watchComponent(component, react) {
  var execute = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  return function (dispatch) {
    dispatch(updateWatchman(component, react));
    if (execute) dispatch(executeQuery(component));
  };
}

function ownKeys$2(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$2(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$2(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$2(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var getfilteredOptions = function getfilteredOptions() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var filteredOptions = {};
  Object.keys(options).forEach(function (option) {
    if (validProps.includes(option)) {
      filteredOptions[option] = options[option];
    }
  });
  return filteredOptions;
};
/**
 * Sets the external props for a component
 * @param {String} component
 * @param {Object} options
 */
function setComponentProps(component, options, componentType) {
  return {
    type: SET_PROPS,
    component: component,
    options: getfilteredOptions(_objectSpread$2(_objectSpread$2({}, options), {}, {
      componentType: componentType
    }))
  };
}

/**
 * Updates the external props for a component, overrides the duplicates
 * @param {String} component
 * @param {Object} options
 */
function updateComponentProps(component, options, componentType) {
  return {
    type: UPDATE_PROPS,
    component: component,
    options: getfilteredOptions(_objectSpread$2(_objectSpread$2({}, options), {}, {
      componentType: componentType
    }))
  };
}

/**
 * Remove the external props for a component
 * @param {String} component
 * @param {Object} options
 */
function removeComponentProps(component) {
  return {
    type: REMOVE_PROPS,
    component: component
  };
}

function ownKeys$1(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$1(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$1(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$1(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

/**
 * Sets the suggestionsSearchValue in analytics
 * @param {String} value
 */
function setSuggestionsSearchValue(value) {
  return {
    type: SET_SUGGESTIONS_SEARCH_VALUE,
    value: value
  };
}

/**
 * Clears the suggestionsSearchValue in analytics
 * @param {String} value
 */
function clearSuggestionsSearchValue() {
  return {
    type: CLEAR_SUGGESTIONS_SEARCH_VALUE
  };
}

/**
 * Updates the analytics config object
 * @param {Object} analyticsConfig
 */
function updateAnalyticsConfig(analyticsConfig) {
  return {
    type: UPDATE_ANALYTICS_CONFIG,
    analyticsConfig: analyticsConfig
  };
}
function getRecentSearches() {
  var queryOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    size: 5,
    minChars: 3
  };
  return function (dispatch, getState) {
    var _getState = getState(),
      config = _getState.config,
      headers = _getState.headers,
      _getState$appbaseRef = _getState.appbaseRef,
      url = _getState$appbaseRef.url,
      protocol = _getState$appbaseRef.protocol,
      credentials = _getState$appbaseRef.credentials;
    var app = config.app,
      mongodb = config.mongodb;
    var esURL = "".concat(protocol, "://").concat(url);
    var parsedURL = (esURL || '').replace(/\/+$/, '');
    var requestOptions = {
      headers: _objectSpread$1(_objectSpread$1({}, headers), {}, {
        'Content-Type': 'application/json',
        Authorization: "Basic ".concat(btoa(credentials))
      })
    };
    var queryString = '';
    var addParam = function addParam(key, value) {
      if (queryString) {
        queryString += "&".concat(key, "=").concat(value);
      } else {
        queryString += "".concat(key, "=").concat(value);
      }
    };
    // Add user id in query param if defined
    if (config.analyticsConfig && config.analyticsConfig.userId) {
      addParam('user_id', config.analyticsConfig.userId);
    }
    if (queryOptions) {
      if (queryOptions.size) {
        addParam('size', String(queryOptions.size));
      }
      if (queryOptions.from) {
        addParam('from', queryOptions.from);
      }
      if (queryOptions.to) {
        addParam('to', queryOptions.to);
      }
      if (queryOptions.minChars) {
        addParam('min_chars', String(queryOptions.minChars));
      }
      if (queryOptions.customEvents) {
        Object.keys(queryOptions.customEvents).forEach(function (key) {
          addParam(key, queryOptions.customEvents[key]);
        });
      }
    }
    if (mongodb) {
      return dispatch({
        type: RECENT_SEARCHES_SUCCESS,
        data: []
      });
    }
    return fetch("".concat(parsedURL, "/_analytics/").concat(app, "/recent-searches?").concat(queryString), requestOptions).then(function (res) {
      if (res.status >= 500 || res.status >= 400) {
        return dispatch({
          type: RECENT_SEARCHES_ERROR,
          error: res
        });
      }
      return res.json().then(function (recentSearches) {
        return dispatch({
          type: RECENT_SEARCHES_SUCCESS,
          data: recentSearches
        });
      })["catch"](function (e) {
        return dispatch({
          type: RECENT_SEARCHES_ERROR,
          error: e
        });
      });
    })["catch"](function (e) {
      return dispatch({
        type: RECENT_SEARCHES_ERROR,
        error: e
      });
    });
  };
}
function recordClick(_ref) {
  var documentId = _ref.documentId,
    clickPosition = _ref.clickPosition,
    analyticsInstance = _ref.analyticsInstance,
    isSuggestionClick = _ref.isSuggestionClick;
  if (!documentId) {
    console.warn('ReactiveSearch: document id is required to record the click analytics');
  } else {
    analyticsInstance.click({
      queryID: analyticsInstance.getQueryID(),
      objects: _defineProperty({}, documentId, clickPosition + 1),
      isSuggestionClick: isSuggestionClick
    });
  }
}
function recordResultClick(searchPosition, documentId) {
  return function (dispatch, getState) {
    var _getState2 = getState(),
      config = _getState2.config,
      searchId = _getState2.analytics.searchId,
      headers = _getState2.headers,
      _getState2$appbaseRef = _getState2.appbaseRef,
      url = _getState2$appbaseRef.url,
      protocol = _getState2$appbaseRef.protocol,
      credentials = _getState2$appbaseRef.credentials,
      analyticsInstance = _getState2.analyticsRef;
    var app = config.app;
    var esURL = "".concat(protocol, "://").concat(url);
    if (config.analytics && searchId) {
      var parsedHeaders = headers;
      delete parsedHeaders['X-Search-Query'];
      var parsedURL = (esURL || '').replace(/\/+$/, '');
      if (parsedURL.includes('scalr.api.appbase.io')) {
        fetch("".concat(parsedURL, "/").concat(app, "/_analytics"), {
          method: 'POST',
          headers: _objectSpread$1(_objectSpread$1({}, parsedHeaders), {}, {
            'Content-Type': 'application/json',
            Authorization: "Basic ".concat(btoa(credentials)),
            'X-Search-Id': searchId,
            'X-Search-Click': true,
            'X-Search-ClickPosition': searchPosition + 1
          })
        });
      } else {
        recordClick({
          documentId: documentId,
          clickPosition: searchPosition,
          analyticsInstance: analyticsInstance
        });
      }
    }
  };
}
function recordSuggestionClick(searchPosition, documentId) {
  return function (dispatch, getState) {
    var _getState3 = getState(),
      config = _getState3.config,
      suggestionsSearchId = _getState3.analytics.suggestionsSearchId,
      headers = _getState3.headers,
      _getState3$appbaseRef = _getState3.appbaseRef,
      url = _getState3$appbaseRef.url,
      protocol = _getState3$appbaseRef.protocol,
      credentials = _getState3$appbaseRef.credentials,
      analyticsInstance = _getState3.analyticsRef;
    var app = config.app;
    var esURL = "".concat(protocol, "://").concat(url);
    if (config.analytics && (config.analyticsConfig === undefined || config.analyticsConfig.suggestionAnalytics === undefined || config.analyticsConfig.suggestionAnalytics)) {
      var parsedHeaders = headers;
      delete parsedHeaders['X-Search-Query'];
      var parsedURL = (esURL || '').replace(/\/+$/, '');
      if (parsedURL.includes('scalr.api.appbase.io') && searchPosition !== undefined && suggestionsSearchId) {
        fetch("".concat(parsedURL, "/").concat(app, "/_analytics"), {
          method: 'POST',
          headers: _objectSpread$1(_objectSpread$1({}, parsedHeaders), {}, {
            'Content-Type': 'application/json',
            Authorization: "Basic ".concat(btoa(credentials)),
            'X-Search-Id': suggestionsSearchId,
            'X-Search-Suggestions-Click': true,
            'X-Search-Suggestions-ClickPosition': searchPosition + 1
          })
        });
      } else if (searchPosition !== undefined) {
        recordClick({
          documentId: documentId,
          clickPosition: searchPosition,
          analyticsInstance: analyticsInstance,
          isSuggestionClick: true
        });
      }
    }
  };
}

// impressions represents an array of impression objects, for e.g {"index": "test", "id": 1213}
function recordImpressions(queryId) {
  var impressions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return function (dispatch, getState) {
    var _getState4 = getState(),
      _getState4$appbaseRef = _getState4.appbaseRef,
      url = _getState4$appbaseRef.url,
      protocol = _getState4$appbaseRef.protocol,
      analyticsInstance = _getState4.analyticsRef,
      config = _getState4.config;
    var esURL = "".concat(protocol, "://").concat(url);
    var parsedURL = esURL.replace(/\/+$/, '');
    if (config.analytics && !parsedURL.includes('scalr.api.appbase.io') && queryId && impressions.length) {
      analyticsInstance.search({
        queryID: analyticsInstance.getQueryID(),
        impressions: impressions
      });
    }
  };
}
function recordAISessionUsefulness(sessionId, otherInfo) {
  return function (dispatch, getState) {
    var _getState5 = getState(),
      analyticsInstance = _getState5.analyticsRef,
      config = _getState5.config;
    if (!config || !config.analyticsConfig || !config.analyticsConfig.recordAnalytics) {
      console.warn('ReactiveSearch: Unable to record usefulness of session. To enable analytics, make sure to include the following prop on your <ReactiveBase> component: reactivesearchAPIConfig={{ recordAnalytics: true }}');
      return;
    }
    var userID = config && config.analyticsConfig && config.analyticsConfig.userId;
    if (!sessionId) {
      console.warn('ReactiveSearch: AI sessionID is required to record the usefulness of session.');
      return;
    }
    // Save session usefulness
    analyticsInstance.saveSessionUsefulness(sessionId, _objectSpread$1(_objectSpread$1({}, otherInfo), {}, {
      userID: userID
    }), function (err, res) {
      // eslint-disable-next-line no-console

      res._bodyBlob.text().then(function (textData) {
        try {
          var parsedErrorRes = JSON.parse(textData);
          if (parsedErrorRes.error) {
            var errorCode = parsedErrorRes.error.code;
            var errorMessage = parsedErrorRes.error.message;
            var finalErrorMessage = 'There was an error recording the usefulness of the session. \n\n';
            if (errorCode) {
              finalErrorMessage += errorCode;
            }
            if (errorMessage) {
              finalErrorMessage += "".concat(errorCode ? ': ' : '').concat(errorMessage);
            }
            console.error(finalErrorMessage);
          }
        } catch (error) {
          console.error('There was an error recording the usefulness of the session. \n\n');
        }
      })["catch"](function (error) {
        console.error('Error reading  component error text data:', error);
      });
    });
  };
}

var index = /*#__PURE__*/Object.freeze({
  __proto__: null,
  addComponent: addComponent,
  clearSuggestionsSearchValue: clearSuggestionsSearchValue,
  clearValues: clearValues,
  createAISession: createAISession,
  executeQuery: executeQuery,
  fetchAIResponse: fetchAIResponse,
  getRecentSearches: getRecentSearches,
  loadDataToExport: loadDataToExport,
  loadMore: loadMore,
  loadPopularSuggestions: loadPopularSuggestions,
  logCombinedQuery: logCombinedQuery,
  logQuery: logQuery,
  mockDataForTesting: mockDataForTesting,
  patchValue: patchValue,
  recordAISessionUsefulness: recordAISessionUsefulness,
  recordImpressions: recordImpressions,
  recordResultClick: recordResultClick,
  recordSuggestionClick: recordSuggestionClick,
  removeAIResponse: removeAIResponse,
  removeComponent: removeComponent,
  removeComponentProps: removeComponentProps,
  resetStoreForComponent: resetStoreForComponent,
  resetValuesToDefault: resetValuesToDefault,
  saveQueryToHits: saveQueryToHits,
  setAIResponse: setAIResponse,
  setAIResponseDelayed: setAIResponseDelayed,
  setAIResponseError: setAIResponseError,
  setAIResponseLoading: setAIResponseLoading,
  setAppliedSettings: setAppliedSettings,
  setComponentProps: setComponentProps,
  setCustomData: setCustomData,
  setCustomHighlightOptions: setCustomHighlightOptions,
  setCustomQuery: setCustomQuery,
  setDefaultPopularSuggestions: setDefaultPopularSuggestions,
  setDefaultQuery: setDefaultQuery,
  setError: setError,
  setGoogleMapScriptError: setGoogleMapScriptError,
  setGoogleMapScriptLoaded: setGoogleMapScriptLoaded,
  setGoogleMapScriptLoading: setGoogleMapScriptLoading,
  setHeaders: setHeaders,
  setInternalValue: setInternalValue,
  setLastUsedAppbaseQuery: setLastUsedAppbaseQuery,
  setLoading: setLoading,
  setMapData: setMapData,
  setMapResults: setMapResults,
  setPopularSuggestions: setPopularSuggestions,
  setPromotedResults: setPromotedResults,
  setQuery: setQuery,
  setQueryListener: setQueryListener,
  setQueryOptions: setQueryOptions,
  setRawData: setRawData,
  setSearchId: setSearchId,
  setSearchState: setSearchState,
  setSuggestionsSearchId: setSuggestionsSearchId,
  setSuggestionsSearchValue: setSuggestionsSearchValue,
  setTimestamp: setTimestamp,
  setValue: setValue,
  setValues: setValues,
  updateAggs: updateAggs,
  updateAnalyticsConfig: updateAnalyticsConfig,
  updateComponentProps: updateComponentProps,
  updateCompositeAggs: updateCompositeAggs,
  updateHits: updateHits,
  updateMapData: updateMapData,
  updateQuery: updateQuery,
  updateQueryOptions: updateQueryOptions,
  watchComponent: watchComponent
});

/* eslint-disable */

// https://tc39.github.io/ecma262/#sec-array.prototype.find

if (!Array.prototype.find) {
  Object.defineProperty(Array.prototype, 'find', {
    value: function value(predicate) {
      // 1. Let O be ? ToObject(this value).
      if (this == null) {
        throw new TypeError('"this" is null or not defined');
      }
      var o = Object(this);

      // 2. Let len be ? ToLength(? Get(O, "length")).
      var len = o.length >>> 0;

      // 3. If IsCallable(predicate) is false, throw a TypeError exception.
      if (typeof predicate !== 'function') {
        throw new TypeError('predicate must be a function');
      }

      // 4. If thisArg was supplied, let T be thisArg; else let T be undefined.
      var thisArg = arguments[1];

      // 5. Let k be 0.
      var k = 0;

      // 6. Repeat, while k < len
      while (k < len) {
        // a. Let Pk be ! ToString(k).
        // b. Let kValue be ? Get(O, Pk).
        // c. Let testResult be ToBoolean(? Call(predicate, T, « kValue, k, O »)).
        // d. If testResult is true, return kValue.
        var kValue = o[k];
        if (predicate.call(thisArg, kValue, k, o)) {
          return kValue;
        }
        // e. Increase k by 1.
        k++;
      }

      // 7. Return undefined.
      return undefined;
    },
    configurable: true,
    writable: true
  });
}
if (!String.prototype.endsWith) {
  String.prototype.endsWith = function (pattern) {
    var d = this.length - pattern.length;
    return d >= 0 && this.lastIndexOf(pattern) === d;
  };
}
if (typeof Event !== 'function') {
  var _Event = function _Event(event) {
    var evt = document.createEvent('Event');
    evt.initEvent(event, true, true);
    return evt;
  };
  if (typeof window !== 'undefined') {
    window.Event = _Event;
  }
}
var polyfills = true;

// A map of causes leading to changes in components

var ENTER_PRESS = 'ENTER_PRESS';
var SUGGESTION_SELECT = 'SUGGESTION_SELECT';
var CLEAR_VALUE = 'CLEAR_VALUE';
var SEARCH_ICON_CLICK = 'SEARCH_ICON_CLICK';
var CLEAR_ALL_TAGS = 'CLEAR_ALL_TAGS';
var causes$1 = {
  ENTER_PRESS: ENTER_PRESS,
  SUGGESTION_SELECT: SUGGESTION_SELECT,
  CLEAR_VALUE: CLEAR_VALUE,
  SEARCH_ICON_CLICK: SEARCH_ICON_CLICK,
  CLEAR_ALL_TAGS: CLEAR_ALL_TAGS
};

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var storeKey = STORE_KEY;
var suggestions = getSuggestions;
var causes = causes$1;
var Reducers = {
  valueReducer: valueReducer$1,
  queryOptionsReducer: queryOptionsReducer$1,
  queryReducer: queryReducer,
  dependencyTreeReducer: dependencyTreeReducer,
  propsReducer: queryOptionsReducer
};
var composeEnhancers = (typeof window === "undefined" ? "undefined" : _typeof(window)) === 'object' && window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__ ? window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__({}) : compose;
var enhancer = composeEnhancers(applyMiddleware(thunk$1, aiResponseMiddleware));
function configureStore(initialState) {
  var finalInitialState = _objectSpread(_objectSpread({}, initialState), {}, {
    config: _objectSpread(_objectSpread({}, initialState.config), {}, {
      lock: false,
      analyticsConfig: initialState.config && initialState.config.analyticsConfig ? _objectSpread(_objectSpread({}, defaultAnalyticsConfig), initialState.config.analyticsConfig) : defaultAnalyticsConfig
    })
  });
  return createStore(rootReducer, finalInitialState, enhancer);
}

exports.Actions = index;
exports.Reducers = Reducers;
exports.causes = causes;
exports.constants = constants;
exports.default = configureStore;
exports.helper = helper;
exports.polyfills = polyfills;
exports.storeKey = storeKey;
exports.suggestions = suggestions;
